/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 695
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 90
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 92
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 92
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 691
      || GET_MODE (x9) != E_DImode)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 89
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x8, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 89
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 0
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 14
      || GET_MODE (x15) != E_DImode)
    return -1;
  x16 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 15
      || GET_MODE (x17) != E_DImode)
    return -1;
  x18 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 16
      || GET_MODE (x19) != E_DImode)
    return -1;
  x20 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 17
      || GET_MODE (x21) != E_DImode)
    return -1;
  x22 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 18
      || GET_MODE (x23) != E_DImode)
    return -1;
  x24 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x24) != CLOBBER)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 30
      || GET_MODE (x25) != E_DImode)
    return -1;
  x26 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x26) != CLOBBER)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 66
      || GET_MODE (x27) != E_CCmode)
    return -1;
  x28 = XVECEXP (x3, 0, 0);
  operands[0] = x28;
  if (!pmode_register_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 307
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  return pattern51 (x1); /* [-1, 1] */
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 4;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern71 (x3); /* [-1, 2] */
}

int
pattern75 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BFmode:
      return pattern81 (x1, 
E_VNx8BFmode, 
E_VNx16BFmode); /* [-1, 0] */

    case E_VNx32BFmode:
      if (pattern81 (x1, 
E_VNx8BFmode, 
E_VNx32BFmode) != 0)
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (pattern81 (x1, 
E_VNx8HFmode, 
E_VNx16HFmode) != 0)
        return -1;
      return 2;

    case E_VNx8SFmode:
      if (pattern81 (x1, 
E_VNx4SFmode, 
E_VNx8SFmode) != 0)
        return -1;
      return 3;

    case E_VNx4DFmode:
      if (pattern81 (x1, 
E_VNx2DFmode, 
E_VNx4DFmode) != 0)
        return -1;
      return 4;

    case E_VNx32HFmode:
      if (pattern81 (x1, 
E_VNx8HFmode, 
E_VNx32HFmode) != 0)
        return -1;
      return 5;

    case E_VNx16SFmode:
      if (pattern81 (x1, 
E_VNx4SFmode, 
E_VNx16SFmode) != 0)
        return -1;
      return 6;

    case E_VNx8DFmode:
      if (pattern81 (x1, 
E_VNx2DFmode, 
E_VNx8DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern79 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern79 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern79 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern79 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern79 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern92 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_SFmode:
      if (pattern92 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_DFmode:
      if (pattern92 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern103 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_shift_imm_hi (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern79 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern79 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern79 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern79 (x3, 
E_VNx8QImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern79 (x3, 
E_VNx4QImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern79 (x3, 
E_VNx2QImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern79 (x3, 
E_VNx8HImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern79 (x3, 
E_VNx4HImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern79 (x3, 
E_VNx2HImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern79 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern79 (x3, 
E_VNx2SImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern79 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 9;

    case E_VNx2HFmode:
      if (pattern79 (x3, 
E_VNx2HFmode) != 0)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (pattern79 (x3, 
E_VNx4HFmode) != 0)
        return -1;
      return 11;

    case E_VNx2SFmode:
      if (pattern79 (x3, 
E_VNx2SFmode) != 0)
        return -1;
      return 12;

    case E_VNx8HFmode:
      if (pattern79 (x3, 
E_VNx8HFmode) != 0)
        return -1;
      return 13;

    case E_VNx4SFmode:
      if (pattern79 (x3, 
E_VNx4SFmode) != 0)
        return -1;
      return 14;

    case E_VNx2DFmode:
      if (pattern79 (x3, 
E_VNx2DFmode) != 0)
        return -1;
      return 15;

    case E_VNx2BFmode:
      if (pattern79 (x3, 
E_VNx2BFmode) != 0)
        return -1;
      return 16;

    case E_VNx4BFmode:
      if (pattern79 (x3, 
E_VNx4BFmode) != 0)
        return -1;
      return 17;

    case E_VNx8BFmode:
      if (pattern79 (x3, 
E_VNx8BFmode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern146 (rtx x1, unsigned int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || pattern85 (x1, 
E_DImode, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!aarch64_simd_shift_imm_offset_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern178 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx2HFmode:
      if (!register_operand (operands[2], E_VNx2HFmode))
        return -1;
      return 0;

    case E_VNx4HFmode:
      if (!register_operand (operands[2], E_VNx4HFmode))
        return -1;
      return 1;

    case E_VNx2SFmode:
      if (!register_operand (operands[2], E_VNx2SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern184 (x3, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern184 (x3, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern184 (x3, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (pattern184 (x3, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern196 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern196 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern196 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern196 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          return pattern193 (x2, 
E_V16QImode, 
E_V4SFmode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern193 (x2, 
E_VNx16QImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern205 (x2, 
E_V4SFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern211 (x3); /* [-1, 3] */

    case UNSPEC:
      if (XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 351)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 351)
        return -1;
      x9 = XVECEXP (x8, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      res = pattern215 (x3);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[1], E_VNx8SFmode))
            return -1;
          return 0;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[1], E_VNx16SFmode))
            return -1;
          return 1;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[1], E_VNx4DFmode))
            return -1;
          return 2;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[1], E_VNx8DFmode))
            return -1;
          return 3;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[1], E_VNx16HFmode))
            return -1;
          return 4;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[1], E_VNx32HFmode))
            return -1;
          return 5;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[1], E_VNx16BFmode))
            return -1;
          return 6;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[1], E_VNx32BFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[2], E_VNx8SFmode))
            return -1;
          return 8;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[2], E_VNx16SFmode))
            return -1;
          return 9;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[2], E_VNx4DFmode))
            return -1;
          return 10;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[2], E_VNx8DFmode))
            return -1;
          return 11;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[2], E_VNx16HFmode))
            return -1;
          return 12;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[2], E_VNx32HFmode))
            return -1;
          return 13;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[2], E_VNx16BFmode))
            return -1;
          return 14;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[2], E_VNx32BFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 86
      || GET_MODE (x4) != E_VNx16BImode)
    return -1;
  return 0;
}

int
pattern268 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx4SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93
      || GET_MODE (x3) != E_VNx4SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93
      || GET_MODE (x5) != E_VNx4SImode)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  if (!register_operand (operands[1], E_VNx4BImode))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  if (!register_operand (operands[2], E_VNx4BImode))
    return -1;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  if (!register_operand (operands[3], E_VNx4SImode))
    return -1;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  if (!register_operand (operands[4], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 3);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern276 (x2, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern276 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern276 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern276 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx1TImode:
          if (pattern276 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x8, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern277 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 5;

        case E_VNx8HImode:
          if (pattern277 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern277 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2DImode:
          if (pattern277 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx1TImode:
          if (pattern277 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern295 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern294 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x2) != E_SFmode
          || !aarch64_fp_pow2_recip (operands[2], E_SFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x2) != E_DFmode
          || !aarch64_fp_pow2_recip (operands[2], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern312 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern314 (x1, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern314 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern314 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern314 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x1, 1);
      if (GET_CODE (x5) != VEC_DUPLICATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx32QImode:
          if (pattern315 (x1, 
E_VNx16QImode, 
E_VNx32QImode) != 0)
            return -1;
          return 4;

        case E_VNx16HImode:
          if (pattern315 (x1, 
E_VNx8HImode, 
E_VNx16HImode) != 0)
            return -1;
          return 5;

        case E_VNx8SImode:
          if (pattern315 (x1, 
E_VNx4SImode, 
E_VNx8SImode) != 0)
            return -1;
          return 6;

        case E_VNx4DImode:
          if (pattern315 (x1, 
E_VNx2DImode, 
E_VNx4DImode) != 0)
            return -1;
          return 7;

        case E_VNx64QImode:
          if (pattern315 (x1, 
E_VNx16QImode, 
E_VNx64QImode) != 0)
            return -1;
          return 8;

        case E_VNx32HImode:
          if (pattern315 (x1, 
E_VNx8HImode, 
E_VNx32HImode) != 0)
            return -1;
          return 9;

        case E_VNx16SImode:
          if (pattern315 (x1, 
E_VNx4SImode, 
E_VNx16SImode) != 0)
            return -1;
          return 10;

        case E_VNx8DImode:
          if (pattern315 (x1, 
E_VNx2DImode, 
E_VNx8DImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern337 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode)
      || !aarch64_simd_shift_imm_offset_si (operands[2], i1))
    return -1;
  return 0;
}

int
pattern339 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return pattern338 (x1); /* [-1, 2] */
}

int
pattern346 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_VNx16BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x5) != E_VNx16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!aarch64_sve_dup_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x5) != E_VNx8QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 2;

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x5) != E_VNx4QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 3;

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x5) != E_VNx2QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 4;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x5) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!aarch64_sve_dup_operand (operands[1], E_HImode))
            return -1;
          return 5;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x5) != E_VNx4HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode))
        return -1;
      return 7;

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x5) != E_VNx2HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode))
        return -1;
      return 8;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x5) != E_VNx4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!aarch64_sve_dup_operand (operands[1], E_SImode))
            return -1;
          return 9;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x5) != E_VNx2SImode
          || !aarch64_sve_dup_operand (operands[1], E_SImode))
        return -1;
      return 11;

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x5) != E_VNx2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!aarch64_sve_dup_operand (operands[1], E_DImode))
            return -1;
          return 12;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x5) != E_VNx2HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode))
        return -1;
      return 14;

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x5) != E_VNx4HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode))
        return -1;
      return 15;

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x5) != E_VNx2SFmode
          || !aarch64_sve_dup_operand (operands[1], E_SFmode))
        return -1;
      return 16;

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x5) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_HFmode))
            return -1;
          return 17;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x5) != E_VNx4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_SFmode))
            return -1;
          return 19;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 20;

        default:
          return -1;
        }

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x5) != E_VNx2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_DFmode))
            return -1;
          return 21;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode))
            return -1;
          return 22;

        default:
          return -1;
        }

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x5) != E_VNx2BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode))
        return -1;
      return 23;

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x5) != E_VNx4BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode))
        return -1;
      return 24;

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x5) != E_VNx8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_BFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_BFmode))
            return -1;
          return 25;

        case E_V8BFmode:
          if (!nonimmediate_operand (operands[1], E_V8BFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XVECEXP (x3, 0, 0);
  operands[4] = x5;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x1, 1);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern405 (x1, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern405 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern405 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern405 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case XOR:
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern406 (x1, 
E_VNx16QImode) != 0)
            return -1;
          return 4;

        case E_VNx8HImode:
          if (pattern406 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 5;

        case E_VNx4SImode:
          if (pattern406 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 6;

        case E_VNx2DImode:
          if (pattern406 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern420 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern424 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern429 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern323 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern323 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern323 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern323 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern323 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern438 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HImode)
      || GET_MODE (x1) != E_V8HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode))
    return -1;
  return 0;
}

int
pattern443 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || pattern440 (x3, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || pattern441 (x3, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || pattern442 (x3, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern454 (rtx x1, unsigned int i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern458 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern462 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 351)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 351)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[4] = x7;
  if (!aarch64_sve_ptrue_flag (operands[4], E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 0);
  operands[5] = x8;
  x9 = XVECEXP (x2, 0, 2);
  operands[2] = x9;
  x10 = XVECEXP (x4, 0, 0);
  operands[6] = x10;
  x11 = XVECEXP (x4, 0, 2);
  operands[3] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern461 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern461 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern461 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern474 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern482 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern490 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern503 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern508 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  return pattern507 (x1); /* [-1, 4] */
}

int
pattern511 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[4] = x7;
  x8 = XEXP (x3, 1);
  operands[3] = x8;
  switch (GET_CODE (operands[3]))
    {
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x1) != E_V8QImode
              || pattern440 (x2, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 0;

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x1) != E_V16QImode
              || GET_MODE (x2) != E_V16QImode
              || GET_MODE (x3) != E_V16HImode
              || GET_MODE (x4) != E_V16HImode
              || GET_MODE (x5) != E_V16HImode
              || !register_operand (operands[2], E_V16QImode)
              || !aarch64_int_rnd_operand (operands[4], E_V16HImode)
              || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x1) != E_V4HImode
              || pattern441 (x2, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || GET_MODE (x2) != E_V8HImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode
              || GET_MODE (x5) != E_V8SImode
              || !register_operand (operands[2], E_V8HImode)
              || !aarch64_int_rnd_operand (operands[4], E_V8SImode)
              || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V8HImode)
              || !register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x1) != E_V2SImode
              || pattern442 (x2, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_V4DImode
              || GET_MODE (x4) != E_V4DImode
              || GET_MODE (x5) != E_V4DImode
              || !register_operand (operands[2], E_V4SImode)
              || !aarch64_int_rnd_operand (operands[4], E_V4DImode)
              || !aarch64_simd_shift_imm_vec_si (operands[3], E_V4SImode)
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          return 5;

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_V2TImode
              || GET_MODE (x4) != E_V2TImode
              || GET_MODE (x5) != E_V2TImode
              || !register_operand (operands[2], E_V2DImode)
              || !aarch64_int_rnd_operand (operands[4], E_V2TImode)
              || !aarch64_simd_shift_imm_vec_di (operands[3], E_V2DImode)
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case CONST_INT:
      if (!aarch64_simd_shift_imm_offset_di (operands[3], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_TImode
          || GET_MODE (x4) != E_TImode
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[2], E_DImode)
          || !aarch64_int_rnd_operand (operands[4], E_TImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern556 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern556 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern556 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern565 (x5, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern565 (x5, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern576 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  x11 = XVECEXP (x3, 0, 2);
  operands[3] = x11;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  return pattern360 (x1); /* [-1, 3] */
}

int
pattern590 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != AND)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  return 0;
}

int
pattern596 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_VNx2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_VNx2SImode)
    return -1;
  return 0;
}

int
pattern603 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return pattern329 (x3); /* [-1, 4] */
}

int
pattern607 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern606 (x1, 
E_SImode); /* [-1, 5] */

    case E_DImode:
      res = pattern606 (x1, 
E_DImode);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern610 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return pattern305 (); /* [-1, 2] */
}

int
pattern616 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3)
      || !vect_par_cnst_hi_half (operands[4], i3))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern626 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern628 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern632 (x1, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern632 (x1, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern632 (x1, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_vsm_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern645 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 1);
      operands[2] = x8;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[4] = x10;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x6) != E_V4SImode
              || GET_MODE (x7) != E_V4HImode
              || !register_operand (operands[1], E_V8HImode)
              || !vect_par_cnst_hi_half (operands[2], E_V8HImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 0;

            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x6) != E_V2DImode
              || GET_MODE (x7) != E_V2SImode
              || !register_operand (operands[1], E_V4SImode)
              || !vect_par_cnst_hi_half (operands[2], E_V4SImode)
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 2;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x4;
      x6 = XEXP (x1, 0);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern644 (x1, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern644 (x1, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern681 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CC_NZCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern680 (x5, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern680 (x5, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern680 (x5, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (pattern680 (x5, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern689 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 93)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 89
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x3, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != UNSPEC
      || XVECLEN (x8, 0) != 5
      || XINT (x8, 1) != i1)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 93)
    return -1;
  x10 = XVECEXP (x8, 0, 1);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 89
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XVECEXP (x8, 0, 4);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XEXP (x7, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 93)
    return -1;
  x13 = XVECEXP (x3, 0, 2);
  operands[1] = x13;
  if (!const_int_operand (operands[1], E_DImode))
    return -1;
  x14 = XVECEXP (x8, 0, 2);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XVECEXP (x3, 0, 3);
  switch (GET_CODE (x15))
    {
    case REG:
    case SUBREG:
      operands[2] = x15;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XVECEXP (x8, 0, 3);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      switch (XWINT (x11, 0))
        {
        case 1L:
          return pattern688 (x1); /* [-1, 23] */

        case 0L:
          if (GET_MODE (x4) != E_VNx1TImode
              || GET_MODE (x12) != E_VNx1TImode
              || GET_MODE (x8) != E_VNx1TImode
              || GET_MODE (x9) != E_VNx1TImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[0], E_VNx16QImode)
                  || GET_MODE (x3) != E_VNx16QImode)
                return -1;
              return 24;

            case E_VNx8HImode:
              if (!register_operand (operands[0], E_VNx8HImode)
                  || GET_MODE (x3) != E_VNx8HImode)
                return -1;
              return 25;

            case E_VNx4SImode:
              if (!register_operand (operands[0], E_VNx4SImode)
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 26;

            case E_VNx2DImode:
              if (!register_operand (operands[0], E_VNx2DImode)
                  || GET_MODE (x3) != E_VNx2DImode)
                return -1;
              return 27;

            case E_VNx8BFmode:
              if (!register_operand (operands[0], E_VNx8BFmode)
                  || GET_MODE (x3) != E_VNx8BFmode)
                return -1;
              return 28;

            case E_VNx8HFmode:
              if (!register_operand (operands[0], E_VNx8HFmode)
                  || GET_MODE (x3) != E_VNx8HFmode)
                return -1;
              return 29;

            case E_VNx4SFmode:
              if (!register_operand (operands[0], E_VNx4SFmode)
                  || GET_MODE (x3) != E_VNx4SFmode)
                return -1;
              return 30;

            case E_VNx2DFmode:
              if (!register_operand (operands[0], E_VNx2DFmode)
                  || GET_MODE (x3) != E_VNx2DFmode)
                return -1;
              return 31;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XVECEXP (x8, 0, 3);
      if (GET_CODE (x16) != PLUS
          || GET_MODE (x16) != E_SImode
          || XWINT (x11, 0) != 1L)
        return -1;
      x17 = XEXP (x15, 0);
      operands[2] = x17;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x18 = XEXP (x15, 1);
      operands[3] = x18;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x16, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x20 = XEXP (x16, 1);
      if (!rtx_equal_p (x20, operands[3]))
        return -1;
      res = pattern688 (x1);
      if (res >= 0)
        return res + 32; /* [32, 55] */
      return -1;

    default:
      return -1;
    }
}

int
pattern728 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx8BImode)
      || !aarch64_sve_ld1ro_operand_h (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern734 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!register_operand (x2, i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern741 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern744 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern753 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern756 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[3], i1))
    return -1;
  return 0;
}

int
pattern762 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sminmax_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern766 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern765 (x1, 
E_V4HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern765 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern773 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern780 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern784 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CC_Zmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_Zmode
      || !register_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern796 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern803 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern811 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern825 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern832 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x4, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern831 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern831 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern831 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern850 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern849 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern849 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern849 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern860 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x2, operands[2]))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x2;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HImode:
          if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SImode:
          if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DImode:
          if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern881 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern886 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  return pattern885 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern892 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_plus_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_plus_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern899 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern904 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_orr_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern909 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_V2SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2SFmode)
    return -1;
  return 0;
}

int
pattern917 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  return 0;
}

int
pattern922 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != NEG)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x7, 1);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  switch (GET_MODE (x9))
    {
    case E_SImode:
      if (GET_MODE (x10) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || GET_MODE (x7) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x10) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode
          || GET_MODE (x7) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern938 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[3], E_SImode)
          || !aarch64_simd_shift_imm_si (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[3], E_DImode)
          || !aarch64_simd_shift_imm_di (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern952 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern959 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern963 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern968 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern975 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case VEC_SELECT:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 1)
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[3] = x2;
      return 1;

    default:
      return -1;
    }
}

int
pattern981 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern986 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern867 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern867 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern867 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 393)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern994 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8BImode:
      if (!register_operand (operands[1], E_VNx8BImode))
        return -1;
      return 0;

    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode))
        return -1;
      return 1;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1001 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1006 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1014 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2TImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2TImode
      || !register_operand (operands[1], E_V2DImode)
      || !aarch64_int_rnd_operand (operands[3], E_V2TImode)
      || !aarch64_simd_shift_imm_vec_di (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern1024 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HFmode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[2], E_V4HFmode)
          || !register_operand (operands[1], E_V4HFmode)
          || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 0;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[2], E_V2SFmode)
          || !register_operand (operands[3], E_V2SFmode)
          || !register_operand (operands[1], E_V2SFmode)
          || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1042 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_maxmin_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1050 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1056 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_lshift_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1063 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 0;

    case E_VNx4SFmode:
      if (!register_operand (operands[2], E_VNx4SFmode))
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1069 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1078 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_int_rnd_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1088 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1096 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx8BImode:
      if (!aarch64_simd_imm_zero (operands[5], E_VNx8BImode))
        return -1;
      return 0;

    case E_VNx4BImode:
      if (!aarch64_simd_imm_zero (operands[5], E_VNx4BImode))
        return -1;
      return 1;

    case E_VNx2BImode:
      if (!aarch64_simd_imm_zero (operands[5], E_VNx2BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1103 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_arith_with_sub_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1039 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1039 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1039 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1039 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1106 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SFmode:
          if (pattern1106 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2DFmode:
          if (pattern1106 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1110 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1110 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1110 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1110 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1110 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1110 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1145 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern1076 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1156 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  switch (GET_CODE (x11))
    {
    case AND:
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != NOT)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      x15 = XEXP (x13, 1);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x11, 1);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || GET_MODE (x6) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !aarch64_shift_imm_si (operands[2], E_QImode)
              || !register_operand (operands[3], E_SImode)
              || pattern1155 (x11, 
E_SImode) != 0)
            return -1;
          return 0;

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_shift_imm_di (operands[2], E_QImode)
              || !register_operand (operands[3], E_DImode)
              || pattern1155 (x11, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != AND
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != NOT
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != i1
          || GET_MODE (x14) != E_SImode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x14, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x12, 1);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1194 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1205 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern1215 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i5
      || !register_operand (operands[2], i4)
      || !vect_par_cnst_hi_half (operands[4], i4))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1224 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern1232 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_w (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1238 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1246 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (GET_MODE (x4) != E_VNx16BImode)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!aarch64_simd_imm_zero (operands[3], E_VNx16BImode))
    return -1;
  return pattern1245 (x1, 
i1); /* [-1, 1] */
}

int
pattern1255 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1258 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_mul_immediate (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1265 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!aarch64_valid_symref (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], E_VNx2BImode)
      || !aarch64_sve_gather_offset_d (operands[1], E_DImode)
      || !register_operand (operands[2], E_VNx2DImode)
      || !aarch64_gather_scale_operand_d (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern1291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16BImode)
      || !register_operand (operands[4], E_VNx2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern1290 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern1290 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern1290 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1302 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1306 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1311 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  operands[7] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return pattern1310 (x1); /* [-1, 7] */

        case TRUNCATE:
          if (GET_MODE (x5) != E_VNx2SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_VNx2DImode))
            return -1;
          res = pattern1309 (x1);
          if (res >= 0)
            return res + 8; /* [8, 15] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern1310 (x1);
      if (res >= 0)
        return res + 16; /* [16, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1323 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !aarch64_borrow_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1333 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 3
          || XINT (x9, 1) != 126)
        return -1;
      x10 = XVECEXP (x9, 0, 2);
      if (GET_CODE (x10) != i1)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      x12 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x12, operands[6]))
        return -1;
      x13 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x13, operands[7]))
        return -1;
      x14 = XEXP (x10, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x10, 1);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (GET_MODE (x5) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
              || !register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x9) != E_VNx16BImode
              || GET_MODE (x10) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (GET_MODE (x5) != E_VNx8BImode
              || !register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x9) != E_VNx8BImode
              || GET_MODE (x10) != E_VNx8BImode)
            return -1;
          res = pattern1330 ();
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_VNx4BImode:
          if (GET_MODE (x5) != E_VNx4BImode
              || !register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x9) != E_VNx4BImode
              || GET_MODE (x10) != E_VNx4BImode)
            return -1;
          res = pattern1331 ();
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        case E_VNx2BImode:
          if (GET_MODE (x5) != E_VNx2BImode
              || !register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x9) != E_VNx2BImode
              || GET_MODE (x10) != E_VNx2BImode)
            return -1;
          res = pattern1332 ();
          if (res >= 0)
            return res + 6; /* [6, 9] */
          return -1;

        default:
          return -1;
        }

    case CLOBBER:
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (GET_MODE (x5) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 10;

        case E_VNx8BImode:
          if (GET_MODE (x5) != E_VNx8BImode
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          res = pattern1330 ();
          if (res >= 0)
            return res + 11; /* [11, 12] */
          return -1;

        case E_VNx4BImode:
          if (GET_MODE (x5) != E_VNx4BImode
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          res = pattern1331 ();
          if (res >= 0)
            return res + 13; /* [13, 15] */
          return -1;

        case E_VNx2BImode:
          if (GET_MODE (x5) != E_VNx2BImode
              || !scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          res = pattern1332 ();
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case EQ:
      switch (pattern586 (x2, pnum_clobbers))
        {
        case 0:
          x6 = XEXP (x5, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x7 = XEXP (x2, 1);
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && 
#line 802 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return 7; /* aarch64_cbzeqsi1 */
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && 
#line 802 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return 9; /* aarch64_cbzeqdi1 */
                  break;

                default:
                  break;
                }
            }
          operands[1] = x6;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && aarch64_reg_or_zero (operands[1], E_QImode)
                  && 
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
                return 41; /* aarch64_cbeqqi */
              break;

            case E_HImode:
              if (register_operand (operands[0], E_HImode)
                  && aarch64_reg_or_zero (operands[1], E_HImode)
                  && 
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
                return 51; /* aarch64_cbeqhi */
              break;

            default:
              break;
            }
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !nonmemory_operand (operands[1], E_SImode)
                  || !
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (EQ, operands[1])))
                return -1;
              return 21; /* aarch64_cbeqsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !nonmemory_operand (operands[1], E_DImode)
                  || !
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (EQ, operands[1])))
                return -1;
              return 31; /* aarch64_cbeqdi */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 68; /* aarch64_tbzeqqisi */

        case 2:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 72; /* aarch64_tbzeqhisi */

        case 3:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 76; /* aarch64_tbzeqsisi */

        case 4:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 80; /* aarch64_tbzeqdisi */

        case 5:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 70; /* aarch64_tbzeqqidi */

        case 6:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 74; /* aarch64_tbzeqhidi */

        case 7:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 78; /* aarch64_tbzeqsidi */

        case 8:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 82; /* aarch64_tbzeqdidi */

        default:
          return -1;
        }

    case NE:
      switch (pattern586 (x2, pnum_clobbers))
        {
        case 0:
          x6 = XEXP (x5, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x7 = XEXP (x2, 1);
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && 
#line 802 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return 8; /* aarch64_cbznesi1 */
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && 
#line 802 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return 10; /* aarch64_cbznedi1 */
                  break;

                default:
                  break;
                }
            }
          operands[1] = x6;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && aarch64_reg_or_zero (operands[1], E_QImode)
                  && 
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
                return 42; /* aarch64_cbneqi */
              break;

            case E_HImode:
              if (register_operand (operands[0], E_HImode)
                  && aarch64_reg_or_zero (operands[1], E_HImode)
                  && 
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
                return 52; /* aarch64_cbnehi */
              break;

            default:
              break;
            }
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !nonmemory_operand (operands[1], E_SImode)
                  || !
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (NE, operands[1])))
                return -1;
              return 22; /* aarch64_cbnesi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !nonmemory_operand (operands[1], E_DImode)
                  || !
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (NE, operands[1])))
                return -1;
              return 32; /* aarch64_cbnedi */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 69; /* aarch64_tbzneqisi */

        case 2:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 73; /* aarch64_tbznehisi */

        case 3:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 77; /* aarch64_tbznesisi */

        case 4:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 81; /* aarch64_tbznedisi */

        case 5:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 71; /* aarch64_tbzneqidi */

        case 6:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 75; /* aarch64_tbznehidi */

        case 7:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 79; /* aarch64_tbznesidi */

        case 8:
          if (!
#line 1038 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 83; /* aarch64_tbznedidi */

        default:
          return -1;
        }

    case LT:
      if (pnum_clobbers != NULL)
        {
          switch (pattern707 (x2))
            {
            case 0:
              if (
#line 833 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                {
                  *pnum_clobbers = 1;
                  return 11; /* *aarch64_tbzltqi1 */
                }
              break;

            case 1:
              if (
#line 833 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                {
                  *pnum_clobbers = 1;
                  return 13; /* *aarch64_tbzlthi1 */
                }
              break;

            case 2:
              if (
#line 833 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                {
                  *pnum_clobbers = 1;
                  return 15; /* *aarch64_tbzltsi1 */
                }
              break;

            case 3:
              if (
#line 833 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                {
                  *pnum_clobbers = 1;
                  return 17; /* *aarch64_tbzltdi1 */
                }
              break;

            default:
              break;
            }
        }
      x9 = XEXP (x5, 0);
      operands[0] = x9;
      x6 = XEXP (x5, 1);
      operands[1] = x6;
      x7 = XEXP (x2, 1);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (register_operand (operands[0], E_QImode)
              && aarch64_reg_or_zero (operands[1], E_QImode)
              && 
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return 39; /* aarch64_cbltqi */
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && aarch64_reg_or_zero (operands[1], E_HImode)
              && 
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return 49; /* aarch64_cblthi */
          break;

        default:
          break;
        }
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !nonmemory_operand (operands[1], E_SImode)
              || !
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (LT, operands[1])))
            return -1;
          return 19; /* aarch64_cbltsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !nonmemory_operand (operands[1], E_DImode)
              || !
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (LT, operands[1])))
            return -1;
          return 29; /* aarch64_cbltdi */

        default:
          return -1;
        }

    case GE:
      if (pnum_clobbers != NULL)
        {
          switch (pattern707 (x2))
            {
            case 0:
              if (
#line 833 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                {
                  *pnum_clobbers = 1;
                  return 12; /* *aarch64_tbzgeqi1 */
                }
              break;

            case 1:
              if (
#line 833 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                {
                  *pnum_clobbers = 1;
                  return 14; /* *aarch64_tbzgehi1 */
                }
              break;

            case 2:
              if (
#line 833 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                {
                  *pnum_clobbers = 1;
                  return 16; /* *aarch64_tbzgesi1 */
                }
              break;

            case 3:
              if (
#line 833 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                {
                  *pnum_clobbers = 1;
                  return 18; /* *aarch64_tbzgedi1 */
                }
              break;

            default:
              break;
            }
        }
      x9 = XEXP (x5, 0);
      operands[0] = x9;
      x6 = XEXP (x5, 1);
      operands[1] = x6;
      x7 = XEXP (x2, 1);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (register_operand (operands[0], E_QImode)
              && aarch64_reg_or_zero (operands[1], E_QImode)
              && 
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return 43; /* aarch64_cbgeqi */
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && aarch64_reg_or_zero (operands[1], E_HImode)
              && 
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return 53; /* aarch64_cbgehi */
          break;

        default:
          break;
        }
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !nonmemory_operand (operands[1], E_SImode)
              || !
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (GE, operands[1])))
            return -1;
          return 23; /* aarch64_cbgesi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !nonmemory_operand (operands[1], E_DImode)
              || !
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (GE, operands[1])))
            return -1;
          return 33; /* aarch64_cbgedi */

        default:
          return -1;
        }

    case LE:
      switch (pattern587 (x2))
        {
        case 0:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (LE, operands[1])))
            return -1;
          return 20; /* aarch64_cblesi */

        case 1:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (LE, operands[1])))
            return -1;
          return 30; /* aarch64_cbledi */

        case 2:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 40; /* aarch64_cbleqi */

        case 3:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 50; /* aarch64_cblehi */

        default:
          return -1;
        }

    case GT:
      switch (pattern587 (x2))
        {
        case 0:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (GT, operands[1])))
            return -1;
          return 24; /* aarch64_cbgtsi */

        case 1:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (GT, operands[1])))
            return -1;
          return 34; /* aarch64_cbgtdi */

        case 2:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 44; /* aarch64_cbgtqi */

        case 3:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 54; /* aarch64_cbgthi */

        default:
          return -1;
        }

    case LTU:
      switch (pattern587 (x2))
        {
        case 0:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (LTU, operands[1])))
            return -1;
          return 25; /* aarch64_cbltusi */

        case 1:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (LTU, operands[1])))
            return -1;
          return 35; /* aarch64_cbltudi */

        case 2:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 45; /* aarch64_cbltuqi */

        case 3:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 55; /* aarch64_cbltuhi */

        default:
          return -1;
        }

    case LEU:
      switch (pattern587 (x2))
        {
        case 0:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (LEU, operands[1])))
            return -1;
          return 26; /* aarch64_cbleusi */

        case 1:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (LEU, operands[1])))
            return -1;
          return 36; /* aarch64_cbleudi */

        case 2:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 46; /* aarch64_cbleuqi */

        case 3:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 56; /* aarch64_cbleuhi */

        default:
          return -1;
        }

    case GEU:
      switch (pattern587 (x2))
        {
        case 0:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (GEU, operands[1])))
            return -1;
          return 27; /* aarch64_cbgeusi */

        case 1:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (GEU, operands[1])))
            return -1;
          return 37; /* aarch64_cbgeudi */

        case 2:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 47; /* aarch64_cbgeuqi */

        case 3:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 57; /* aarch64_cbgeuhi */

        default:
          return -1;
        }

    case GTU:
      switch (pattern587 (x2))
        {
        case 0:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (GTU, operands[1])))
            return -1;
          return 28; /* aarch64_cbgtusi */

        case 1:
          if (!
#line 881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR && aarch64_cb_rhs (GTU, operands[1])))
            return -1;
          return 38; /* aarch64_cbgtudi */

        case 2:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 48; /* aarch64_cbgtuqi */

        case 3:
          if (!
#line 912 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CMPBR))
            return -1;
          return 58; /* aarch64_cbgtuhi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 8897 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 5207; /* aarch64_frecpxhf */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 8897 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5208; /* aarch64_frecpxsf */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 8897 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5209; /* aarch64_frecpxdf */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern57 (x1))
    {
    case 0:
      if (!(
#line 7009 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 940; /* floorhf2 */

    case 1:
      if (!
#line 7009 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 947; /* floorsf2 */

    case 2:
      if (!
#line 7009 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 954; /* floordf2 */

    case 3:
      if (!(
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2535; /* floorv4hf2 */

    case 4:
      if (!(
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2552; /* floorv8hf2 */

    case 5:
      if (!
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2563; /* floorv2sf2 */

    case 6:
      if (!
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2580; /* floorv4sf2 */

    case 7:
      if (!
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2587; /* floorv2df2 */

    case 8:
      if (!
#line 700 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11603; /* floorvnx8sf2 */

    case 9:
      if (!
#line 700 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11607; /* floorvnx16sf2 */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 3431 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2782; /* reduc_plus_scal_v2sf */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 3431 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2783; /* reduc_plus_scal_v2df */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern70 (x1))
    {
    case 0:
      if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10899; /* aarch64_sve_uunpklo_vnx16qi */

    case 1:
      if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10903; /* aarch64_sve_uunpklo_vnx8hi */

    case 2:
      if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10907; /* aarch64_sve_uunpklo_vnx4si */

    case 3:
      if (!
#line 10310 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 11138; /* aarch64_sve_punpklo_vnx16bi */

    case 4:
      if (!
#line 10310 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 11140; /* aarch64_sve_punpklo_vnx8bi */

    case 5:
      if (!
#line 10310 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 11142; /* aarch64_sve_punpklo_vnx4bi */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern715 (x2))
    {
    case 0:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6630; /* aarch64_pred_qnegvnx16qi */

    case 1:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6639; /* aarch64_pred_qnegvnx8qi */

    case 2:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6648; /* aarch64_pred_qnegvnx4qi */

    case 3:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6657; /* aarch64_pred_qnegvnx2qi */

    case 4:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6666; /* aarch64_pred_qnegvnx8hi */

    case 5:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6675; /* aarch64_pred_qnegvnx4hi */

    case 6:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6684; /* aarch64_pred_qnegvnx2hi */

    case 7:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6693; /* aarch64_pred_qnegvnx4si */

    case 8:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6702; /* aarch64_pred_qnegvnx2si */

    case 9:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6711; /* aarch64_pred_qnegvnx2di */

    case 10:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6720; /* aarch64_pred_qnegv8qi */

    case 11:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6729; /* aarch64_pred_qnegv16qi */

    case 12:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6738; /* aarch64_pred_qnegv4hi */

    case 13:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6747; /* aarch64_pred_qnegv8hi */

    case 14:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6756; /* aarch64_pred_qnegv2si */

    case 15:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6765; /* aarch64_pred_qnegv4si */

    case 16:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6774; /* aarch64_pred_qnegv2di */

    case 17:
      if (!(
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2845 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6783; /* aarch64_pred_qnegv1di */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern79 (x3, 
E_V8QImode) != 0
          || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4889; /* aarch64_zip1v8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4907; /* aarch64_zip1v16qi */

        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode)
              || !register_operand (operands[2], E_V8QImode)
              || !
#line 8696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5045; /* aarch64_zip1v16qi_low */

        default:
          return -1;
        }

    case E_V4HImode:
      if (pattern79 (x3, 
E_V4HImode) != 0
          || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4913; /* aarch64_zip1v4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4931; /* aarch64_zip1v8hi */

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || !
#line 8696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5046; /* aarch64_zip1v8hi_low */

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern79 (x3, 
E_V2SImode) != 0
          || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4937; /* aarch64_zip1v2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4955; /* aarch64_zip1v4si */

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode)
              || !
#line 8696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5047; /* aarch64_zip1v4si_low */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4961; /* aarch64_zip1v2di */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !
#line 8696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5048; /* aarch64_zip1v2di_low */

        default:
          return -1;
        }

    case E_V4HFmode:
      if (pattern79 (x3, 
E_V4HFmode) != 0
          || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4967; /* aarch64_zip1v4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !register_operand (operands[2], E_V8HFmode)
              || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4985; /* aarch64_zip1v8hf */

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !register_operand (operands[2], E_V4HFmode)
              || !
#line 8696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5049; /* aarch64_zip1v8hf_low */

        default:
          return -1;
        }

    case E_V4BFmode:
      if (pattern79 (x3, 
E_V4BFmode) != 0
          || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4991; /* aarch64_zip1v4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !register_operand (operands[2], E_V8BFmode)
              || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5009; /* aarch64_zip1v8bf */

        case E_V4BFmode:
          if (!register_operand (operands[1], E_V4BFmode)
              || !register_operand (operands[2], E_V4BFmode)
              || !
#line 8696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5052; /* aarch64_zip1v8bf_low */

        default:
          return -1;
        }

    case E_V2SFmode:
      if (pattern79 (x3, 
E_V2SFmode) != 0
          || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5015; /* aarch64_zip1v2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !register_operand (operands[2], E_V4SFmode)
              || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5033; /* aarch64_zip1v4sf */

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !register_operand (operands[2], E_V2SFmode)
              || !
#line 8696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5050; /* aarch64_zip1v4sf_low */

        default:
          return -1;
        }

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !register_operand (operands[2], E_V2DFmode)
              || !
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5039; /* aarch64_zip1v2df */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !register_operand (operands[2], E_DFmode)
              || !
#line 8696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5051; /* aarch64_zip1v2df_low */

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (pattern79 (x3, 
E_VNx16QImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10593; /* aarch64_sve_zip1vnx16qi */

    case E_VNx8QImode:
      if (pattern79 (x3, 
E_VNx8QImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10603; /* aarch64_sve_zip1vnx8qi */

    case E_VNx4QImode:
      if (pattern79 (x3, 
E_VNx4QImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10613; /* aarch64_sve_zip1vnx4qi */

    case E_VNx2QImode:
      if (pattern79 (x3, 
E_VNx2QImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10623; /* aarch64_sve_zip1vnx2qi */

    case E_VNx8HImode:
      if (pattern79 (x3, 
E_VNx8HImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10633; /* aarch64_sve_zip1vnx8hi */

    case E_VNx4HImode:
      if (pattern79 (x3, 
E_VNx4HImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10643; /* aarch64_sve_zip1vnx4hi */

    case E_VNx2HImode:
      if (pattern79 (x3, 
E_VNx2HImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10653; /* aarch64_sve_zip1vnx2hi */

    case E_VNx4SImode:
      if (pattern79 (x3, 
E_VNx4SImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10663; /* aarch64_sve_zip1vnx4si */

    case E_VNx2SImode:
      if (pattern79 (x3, 
E_VNx2SImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10673; /* aarch64_sve_zip1vnx2si */

    case E_VNx2DImode:
      if (pattern79 (x3, 
E_VNx2DImode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10683; /* aarch64_sve_zip1vnx2di */

    case E_VNx2HFmode:
      if (pattern79 (x3, 
E_VNx2HFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10693; /* aarch64_sve_zip1vnx2hf */

    case E_VNx4HFmode:
      if (pattern79 (x3, 
E_VNx4HFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10703; /* aarch64_sve_zip1vnx4hf */

    case E_VNx2SFmode:
      if (pattern79 (x3, 
E_VNx2SFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10713; /* aarch64_sve_zip1vnx2sf */

    case E_VNx8HFmode:
      if (pattern79 (x3, 
E_VNx8HFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10723; /* aarch64_sve_zip1vnx8hf */

    case E_VNx4SFmode:
      if (pattern79 (x3, 
E_VNx4SFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10733; /* aarch64_sve_zip1vnx4sf */

    case E_VNx2DFmode:
      if (pattern79 (x3, 
E_VNx2DFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10743; /* aarch64_sve_zip1vnx2df */

    case E_VNx2BFmode:
      if (pattern79 (x3, 
E_VNx2BFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10753; /* aarch64_sve_zip1vnx2bf */

    case E_VNx4BFmode:
      if (pattern79 (x3, 
E_VNx4BFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10763; /* aarch64_sve_zip1vnx4bf */

    case E_VNx8BFmode:
      if (pattern79 (x3, 
E_VNx8BFmode) != 0
          || !
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10773; /* aarch64_sve_zip1vnx8bf */

    case E_VNx16BImode:
      if (pattern79 (x3, 
E_VNx16BImode) != 0
          || !
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10854; /* aarch64_sve_zip1vnx16bi */

    case E_VNx8BImode:
      if (pattern79 (x3, 
E_VNx8BImode) != 0
          || !
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10860; /* aarch64_sve_zip1vnx8bi */

    case E_VNx4BImode:
      if (pattern79 (x3, 
E_VNx4BImode) != 0
          || !
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10866; /* aarch64_sve_zip1vnx4bi */

    case E_VNx2BImode:
      if (pattern79 (x3, 
E_VNx2BImode) != 0
          || !
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10872; /* aarch64_sve_zip1vnx2bi */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (pattern733 (x3, 
E_VNx16BImode, 
E_VNx32QImode, 
E_VNx2TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11320; /* aarch64_sve_ldnqvnx32qi */

    case E_VNx16HImode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx16HImode, 
E_VNx2TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11321; /* aarch64_sve_ldnqvnx16hi */

    case E_VNx8SImode:
      if (pattern733 (x3, 
E_VNx4BImode, 
E_VNx8SImode, 
E_VNx2TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11322; /* aarch64_sve_ldnqvnx8si */

    case E_VNx4DImode:
      if (pattern733 (x3, 
E_VNx2BImode, 
E_VNx4DImode, 
E_VNx2TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11323; /* aarch64_sve_ldnqvnx4di */

    case E_VNx16BFmode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx16BFmode, 
E_VNx2TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11324; /* aarch64_sve_ldnqvnx16bf */

    case E_VNx16HFmode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx16HFmode, 
E_VNx2TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11325; /* aarch64_sve_ldnqvnx16hf */

    case E_VNx8SFmode:
      if (pattern733 (x3, 
E_VNx4BImode, 
E_VNx8SFmode, 
E_VNx2TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11326; /* aarch64_sve_ldnqvnx8sf */

    case E_VNx4DFmode:
      if (pattern733 (x3, 
E_VNx2BImode, 
E_VNx4DFmode, 
E_VNx2TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11327; /* aarch64_sve_ldnqvnx4df */

    case E_VNx48QImode:
      if (pattern733 (x3, 
E_VNx16BImode, 
E_VNx48QImode, 
E_VNx3TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11328; /* aarch64_sve_ldnqvnx48qi */

    case E_VNx24HImode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx24HImode, 
E_VNx3TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11329; /* aarch64_sve_ldnqvnx24hi */

    case E_VNx12SImode:
      if (pattern733 (x3, 
E_VNx4BImode, 
E_VNx12SImode, 
E_VNx3TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11330; /* aarch64_sve_ldnqvnx12si */

    case E_VNx6DImode:
      if (pattern733 (x3, 
E_VNx2BImode, 
E_VNx6DImode, 
E_VNx3TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11331; /* aarch64_sve_ldnqvnx6di */

    case E_VNx24BFmode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx24BFmode, 
E_VNx3TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11332; /* aarch64_sve_ldnqvnx24bf */

    case E_VNx24HFmode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx24HFmode, 
E_VNx3TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11333; /* aarch64_sve_ldnqvnx24hf */

    case E_VNx12SFmode:
      if (pattern733 (x3, 
E_VNx4BImode, 
E_VNx12SFmode, 
E_VNx3TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11334; /* aarch64_sve_ldnqvnx12sf */

    case E_VNx6DFmode:
      if (pattern733 (x3, 
E_VNx2BImode, 
E_VNx6DFmode, 
E_VNx3TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11335; /* aarch64_sve_ldnqvnx6df */

    case E_VNx64QImode:
      if (pattern733 (x3, 
E_VNx16BImode, 
E_VNx64QImode, 
E_VNx4TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11336; /* aarch64_sve_ldnqvnx64qi */

    case E_VNx32HImode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx32HImode, 
E_VNx4TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11337; /* aarch64_sve_ldnqvnx32hi */

    case E_VNx16SImode:
      if (pattern733 (x3, 
E_VNx4BImode, 
E_VNx16SImode, 
E_VNx4TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11338; /* aarch64_sve_ldnqvnx16si */

    case E_VNx8DImode:
      if (pattern733 (x3, 
E_VNx2BImode, 
E_VNx8DImode, 
E_VNx4TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11339; /* aarch64_sve_ldnqvnx8di */

    case E_VNx32BFmode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx32BFmode, 
E_VNx4TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11340; /* aarch64_sve_ldnqvnx32bf */

    case E_VNx32HFmode:
      if (pattern733 (x3, 
E_VNx8BImode, 
E_VNx32HFmode, 
E_VNx4TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11341; /* aarch64_sve_ldnqvnx32hf */

    case E_VNx16SFmode:
      if (pattern733 (x3, 
E_VNx4BImode, 
E_VNx16SFmode, 
E_VNx4TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11342; /* aarch64_sve_ldnqvnx16sf */

    case E_VNx8DFmode:
      if (pattern733 (x3, 
E_VNx2BImode, 
E_VNx8DFmode, 
E_VNx4TImode) != 0
          || !
#line 249 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11343; /* aarch64_sve_ldnqvnx8df */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern108 (x1))
    {
    case 0:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4892; /* aarch64_zip2v8qi */

    case 1:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4908; /* aarch64_zip2v16qi */

    case 2:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4916; /* aarch64_zip2v4hi */

    case 3:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4932; /* aarch64_zip2v8hi */

    case 4:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4940; /* aarch64_zip2v2si */

    case 5:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4956; /* aarch64_zip2v4si */

    case 6:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4962; /* aarch64_zip2v2di */

    case 7:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4970; /* aarch64_zip2v4hf */

    case 8:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4986; /* aarch64_zip2v8hf */

    case 9:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4994; /* aarch64_zip2v4bf */

    case 10:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5010; /* aarch64_zip2v8bf */

    case 11:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5018; /* aarch64_zip2v2sf */

    case 12:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5034; /* aarch64_zip2v4sf */

    case 13:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5040; /* aarch64_zip2v2df */

    case 14:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10594; /* aarch64_sve_zip2vnx16qi */

    case 15:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10604; /* aarch64_sve_zip2vnx8qi */

    case 16:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10614; /* aarch64_sve_zip2vnx4qi */

    case 17:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10624; /* aarch64_sve_zip2vnx2qi */

    case 18:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10634; /* aarch64_sve_zip2vnx8hi */

    case 19:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10644; /* aarch64_sve_zip2vnx4hi */

    case 20:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10654; /* aarch64_sve_zip2vnx2hi */

    case 21:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10664; /* aarch64_sve_zip2vnx4si */

    case 22:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10674; /* aarch64_sve_zip2vnx2si */

    case 23:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10684; /* aarch64_sve_zip2vnx2di */

    case 24:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10694; /* aarch64_sve_zip2vnx2hf */

    case 25:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10704; /* aarch64_sve_zip2vnx4hf */

    case 26:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10714; /* aarch64_sve_zip2vnx2sf */

    case 27:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10724; /* aarch64_sve_zip2vnx8hf */

    case 28:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10734; /* aarch64_sve_zip2vnx4sf */

    case 29:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10744; /* aarch64_sve_zip2vnx2df */

    case 30:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10754; /* aarch64_sve_zip2vnx2bf */

    case 31:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10764; /* aarch64_sve_zip2vnx4bf */

    case 32:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10774; /* aarch64_sve_zip2vnx8bf */

    case 33:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10855; /* aarch64_sve_zip2vnx16bi */

    case 34:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10861; /* aarch64_sve_zip2vnx8bi */

    case 35:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10867; /* aarch64_sve_zip2vnx4bi */

    case 36:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10873; /* aarch64_sve_zip2vnx2bi */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2024; /* vec_shr_v8qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2027; /* vec_shr_v4hi */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2030; /* vec_shr_v4hf */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2033; /* vec_shr_v2si */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2036; /* vec_shr_v2sf */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !register_operand (operands[1], E_V4BFmode)
          || !
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2039; /* vec_shr_v4bf */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern83 (x1))
    {
    case 0:
      if (!(
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1140; /* fmax_nanhf3 */

    case 1:
      if (!
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1144; /* fmax_nansf3 */

    case 2:
      if (!
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1148; /* fmax_nandf3 */

    case 3:
      if (!(
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2722; /* fmax_nanv4hf3 */

    case 4:
      if (!(
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2734; /* fmax_nanv8hf3 */

    case 5:
      if (!
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2738; /* fmax_nanv2sf3 */

    case 6:
      if (!
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2750; /* fmax_nanv4sf3 */

    case 7:
      if (!
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2754; /* fmax_nanv2df3 */

    case 8:
      if (!(
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12447; /* *aarch64_sve_fmaxvnx16bf */

    case 9:
      if (!(
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12451; /* *aarch64_sve_fmaxvnx32bf */

    case 10:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12455; /* *aarch64_sve_fmaxvnx16hf */

    case 11:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12459; /* *aarch64_sve_fmaxvnx8sf */

    case 12:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12463; /* *aarch64_sve_fmaxvnx4df */

    case 13:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12467; /* *aarch64_sve_fmaxvnx32hf */

    case 14:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12471; /* *aarch64_sve_fmaxvnx16sf */

    case 15:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12475; /* *aarch64_sve_fmaxvnx8df */

    case 16:
      if (!(
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12479; /* aarch64_sve_single_fmaxvnx16bf */

    case 17:
      if (!(
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12483; /* aarch64_sve_single_fmaxvnx32bf */

    case 18:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12487; /* aarch64_sve_single_fmaxvnx16hf */

    case 19:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12491; /* aarch64_sve_single_fmaxvnx8sf */

    case 20:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12495; /* aarch64_sve_single_fmaxvnx4df */

    case 21:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12499; /* aarch64_sve_single_fmaxvnx32hf */

    case 22:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12503; /* aarch64_sve_single_fmaxvnx16sf */

    case 23:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12507; /* aarch64_sve_single_fmaxvnx8df */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[2], E_VNx16BImode)
          || !aarch64_sve_ld1ro_operand_b (operands[1], E_OImode)
          || !
#line 2871 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6516; /* aarch64_sve_ld1rovnx16qi */

    case E_VNx8HImode:
      if (pattern728 (x3, 
E_VNx8HImode) != 0
          || !
#line 2871 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6517; /* aarch64_sve_ld1rovnx8hi */

    case E_VNx4SImode:
      if (pattern729 (x3, 
E_VNx4SImode) != 0
          || !
#line 2871 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6518; /* aarch64_sve_ld1rovnx4si */

    case E_VNx2DImode:
      if (pattern730 (x3, 
E_VNx2DImode) != 0
          || !
#line 2871 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6519; /* aarch64_sve_ld1rovnx2di */

    case E_VNx8BFmode:
      if (pattern728 (x3, 
E_VNx8BFmode) != 0
          || !
#line 2871 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6520; /* aarch64_sve_ld1rovnx8bf */

    case E_VNx8HFmode:
      if (pattern728 (x3, 
E_VNx8HFmode) != 0
          || !
#line 2871 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6521; /* aarch64_sve_ld1rovnx8hf */

    case E_VNx4SFmode:
      if (pattern729 (x3, 
E_VNx4SFmode) != 0
          || !
#line 2871 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6522; /* aarch64_sve_ld1rovnx4sf */

    case E_VNx2DFmode:
      if (pattern730 (x3, 
E_VNx2DFmode) != 0
          || !
#line 2871 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6523; /* aarch64_sve_ld1rovnx2df */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern79 (x3, 
E_VNx16QImode) != 0
          || !(
#line 9240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3302 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10520; /* aarch64_sve_tblqvnx16qi */

    case E_VNx8HImode:
      if (pattern79 (x3, 
E_VNx8HImode) != 0
          || !(
#line 9240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3302 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10522; /* aarch64_sve_tblqvnx8hi */

    case E_VNx4SImode:
      if (pattern79 (x3, 
E_VNx4SImode) != 0
          || !(
#line 9240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3302 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10524; /* aarch64_sve_tblqvnx4si */

    case E_VNx2DImode:
      if (pattern79 (x3, 
E_VNx2DImode) != 0
          || !(
#line 9240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3302 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10526; /* aarch64_sve_tblqvnx2di */

    case E_VNx8BFmode:
      if (pattern117 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !(
#line 9240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3302 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10528; /* aarch64_sve_tblqvnx8bf */

    case E_VNx8HFmode:
      if (pattern117 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !(
#line 9240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3302 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10530; /* aarch64_sve_tblqvnx8hf */

    case E_VNx4SFmode:
      if (pattern117 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !(
#line 9240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3302 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10532; /* aarch64_sve_tblqvnx4sf */

    case E_VNx2DFmode:
      if (pattern117 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !(
#line 9240 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3302 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10534; /* aarch64_sve_tblqvnx2df */

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern117 (x3, 
E_V4HImode, 
E_V4HFmode) != 0
          || !(
#line 10211 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5375; /* aarch64_fscalev4hf */

    case E_V8HFmode:
      if (pattern117 (x3, 
E_V8HImode, 
E_V8HFmode) != 0
          || !(
#line 10211 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5376; /* aarch64_fscalev8hf */

    case E_V2SFmode:
      if (pattern117 (x3, 
E_V2SImode, 
E_V2SFmode) != 0
          || !
#line 10211 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5377; /* aarch64_fscalev2sf */

    case E_V4SFmode:
      if (pattern117 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 10211 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5378; /* aarch64_fscalev4sf */

    case E_V2DFmode:
      if (pattern117 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 10211 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5379; /* aarch64_fscalev2df */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern119 (x1))
    {
    case 0:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9078; /* *andvnx2hf3 */

    case 1:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9081; /* *andvnx4hf3 */

    case 2:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9084; /* *andvnx2sf3 */

    case 3:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9087; /* *andvnx8hf3 */

    case 4:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9090; /* *andvnx4sf3 */

    case 5:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9093; /* *andvnx2df3 */

    case 6:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9096; /* *andvnx2bf3 */

    case 7:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9099; /* *andvnx4bf3 */

    case 8:
      if (!
#line 6726 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9102; /* *andvnx8bf3 */

    default:
      return -1;
    }
}

 int
recog_138 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern123 (x1))
    {
    case 0:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10784; /* aarch64_sve_zip2qvnx16qi */

    case 1:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10790; /* aarch64_sve_zip2qvnx8hi */

    case 2:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10796; /* aarch64_sve_zip2qvnx4si */

    case 3:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10802; /* aarch64_sve_zip2qvnx2di */

    case 4:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10808; /* aarch64_sve_zip2qvnx8bf */

    case 5:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10814; /* aarch64_sve_zip2qvnx8hf */

    case 6:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10820; /* aarch64_sve_zip2qvnx4sf */

    case 7:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10826; /* aarch64_sve_zip2qvnx2df */

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || pattern145 (x1, 
E_CCmode, 
66) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!memory_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
        return -1;
      *pnum_clobbers = 2;
      return 1215; /* stack_protect_test_si */

    case E_DImode:
      if (!memory_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode)
          || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
        return -1;
      *pnum_clobbers = 2;
      return 1216; /* stack_protect_test_di */

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 88
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 90
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!pmode_register_operand (operands[0], E_VOIDmode))
    return -1;
  return 13154; /* aarch64_write_tpidr2 */
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x4QImode:
      if (pattern710 (x3, 
E_SImode, 
E_V2x4QImode) != 0)
        return -1;
      return 131; /* *store_pair_4 */

    case E_V2x8QImode:
      if (pattern710 (x3, 
E_DImode, 
E_V2x8QImode) != 0)
        return -1;
      return 132; /* *store_pair_8 */

    case E_V2x16QImode:
      if (!aarch64_mem_pair_lanes_operand (operands[0], E_V2x16QImode)
          || GET_MODE (x3) != E_V2x16QImode
          || !aarch64_ldp_reg_operand (operands[1], E_TImode)
          || !aarch64_ldp_reg_operand (operands[2], E_TImode)
          || !
#line 2262 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 133; /* *store_pair_16 */

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern89 (x1))
    {
    case 0:
      if (!(
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5327; /* aarch64_faminv4hf */

    case 1:
      if (!(
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5329; /* aarch64_faminv8hf */

    case 2:
      if (!
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5331; /* aarch64_faminv2sf */

    case 3:
      if (!
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5333; /* aarch64_faminv4sf */

    case 4:
      if (!
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5335; /* aarch64_faminv2df */

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern141 (x1))
    {
    case 0:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12929; /* aarch64_pred_reduc_smaxqv_vnx16qi */

    case 1:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12937; /* aarch64_pred_reduc_smaxqv_vnx8hi */

    case 2:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12945; /* aarch64_pred_reduc_smaxqv_vnx4si */

    case 3:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12953; /* aarch64_pred_reduc_smaxqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern121 (x1))
    {
    case 0:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10474; /* aarch64_pred_reduc_ior_vnx16qi */

    case 1:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10481; /* aarch64_pred_reduc_ior_vnx8hi */

    case 2:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10488; /* aarch64_pred_reduc_ior_vnx4si */

    case 3:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10495; /* aarch64_pred_reduc_ior_vnx2di */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      res = recog_194 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 1L:
      x5 = XVECEXP (x3, 0, 2);
      operands[2] = x5;
      switch (pattern868 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3841 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7315; /* *cond_absvnx8hf_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              && 
#line 3890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7381; /* *cond_absvnx8hf_any_strict */
          break;

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3841 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7326; /* *cond_absvnx4sf_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              && 
#line 3890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7392; /* *cond_absvnx4sf_any_strict */
          break;

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3841 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7337; /* *cond_absvnx2df_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              && 
#line 3890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7403; /* *cond_absvnx2df_any_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[4] = x4;
  if (aarch64_sve_gp_strictness (operands[4], E_SImode))
    {
      res = recog_195 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 4
      || XINT (x5, 1) != 393)
    return -1;
  x7 = XVECEXP (x5, 0, 2);
  operands[2] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[3] = x8;
  x6 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x6, operands[3]))
    {
      res = recog_196 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[4] = x6;
  if (XWINT (x4, 0) == 0L)
    {
      x9 = XVECEXP (x5, 0, 1);
      if (x9 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x10 = XVECEXP (x3, 0, 0);
          operands[5] = x10;
          x11 = XVECEXP (x5, 0, 0);
          operands[6] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1304 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) == 0
                  && 
#line 6555 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 9065; /* *aarch64_cond_abdvnx8hf_any_relaxed */
              break;

            case E_VNx4SFmode:
              if (pattern1304 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) == 0
                  && 
#line 6555 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 9066; /* *aarch64_cond_abdvnx4sf_any_relaxed */
              break;

            case E_VNx2DFmode:
              if (pattern1304 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) == 0
                  && 
#line 6555 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 9067; /* *aarch64_cond_abdvnx2df_any_relaxed */
              break;

            default:
              break;
            }
        }
    }
  operands[5] = x4;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x9 = XVECEXP (x5, 0, 1);
  operands[6] = x9;
  if (!aarch64_sve_gp_strictness (operands[6], E_SImode))
    return -1;
  switch (pattern1305 (x2))
    {
    case 0:
      if (!
#line 6603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 9068; /* *aarch64_cond_abdvnx8hf_any_strict */

    case 1:
      if (!
#line 6603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 9069; /* *aarch64_cond_abdvnx4sf_any_strict */

    case 2:
      if (!
#line 6603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 9070; /* *aarch64_cond_abdvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11983; /* *cond_sqshlvnx4si_2 */
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11991; /* *cond_sqshlvnx4si_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11999; /* *cond_sqshlvnx4si_any */
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11854; /* *cond_urhaddvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11897; /* *cond_urhaddvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11937; /* *cond_urhaddvnx4si_any */
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11840; /* *cond_uhsubvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11885; /* *cond_uhsubvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11925; /* *cond_uhsubvnx8hi_any */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11860; /* *cond_srhaddvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11902; /* *cond_srhaddvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11942; /* *cond_srhaddvnx2di_any */
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11834; /* *cond_shsubvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11880; /* *cond_shsubvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11920; /* *cond_shsubvnx8hi_any */
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1059 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8597; /* *cond_fmin_nanvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8743; /* *cond_fmin_nanvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8847; /* *cond_fmin_nanvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8610; /* *cond_fmin_nanvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8756; /* *cond_fmin_nanvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8860; /* *cond_fmin_nanvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8623; /* *cond_fmin_nanvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8769; /* *cond_fmin_nanvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8873; /* *cond_fmin_nanvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8636; /* *cond_fmin_nanvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8782; /* *cond_fmin_nanvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8886; /* *cond_fmin_nanvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8697; /* *cond_fmin_nanvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8947; /* *cond_fmin_nanvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8704; /* *cond_fmin_nanvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8954; /* *cond_fmin_nanvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8711; /* *cond_fmin_nanvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8961; /* *cond_fmin_nanvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8649; /* *cond_fmin_nanvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8795; /* *cond_fmin_nanvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8899; /* *cond_fmin_nanvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8662; /* *cond_fmin_nanvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8808; /* *cond_fmin_nanvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8912; /* *cond_fmin_nanvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8675; /* *cond_fmin_nanvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8821; /* *cond_fmin_nanvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8925; /* *cond_fmin_nanvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8688; /* *cond_fmin_nanvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8834; /* *cond_fmin_nanvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8938; /* *cond_fmin_nanvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5687 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8718; /* *cond_fmin_nanvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8968; /* *cond_fmin_nanvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5687 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8725; /* *cond_fmin_nanvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8975; /* *cond_fmin_nanvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5687 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8732; /* *cond_fmin_nanvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8982; /* *cond_fmin_nanvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1127 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9327; /* *cond_fnmsvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9355; /* *cond_fnmsvnx8hf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9387; /* *cond_fnmsvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9331; /* *cond_fnmsvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9359; /* *cond_fnmsvnx4sf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9391; /* *cond_fnmsvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9335; /* *cond_fnmsvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9363; /* *cond_fnmsvnx2df_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9395; /* *cond_fnmsvnx2df_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9351; /* *cond_fnmsvnx8bf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9383; /* *cond_fnmsvnx8bf_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9339; /* *cond_fnmsvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9371; /* *cond_fnmsvnx8hf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9403; /* *cond_fnmsvnx8hf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9343; /* *cond_fnmsvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9375; /* *cond_fnmsvnx4sf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9407; /* *cond_fnmsvnx4sf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9347; /* *cond_fnmsvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9379; /* *cond_fnmsvnx2df_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9411; /* *cond_fnmsvnx2df_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9367; /* *cond_fnmsvnx8bf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9399; /* *cond_fnmsvnx8bf_any_strict */

    default:
      return -1;
    }
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern599 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7543; /* *cond_ashlvnx16qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7713; /* *cond_ashlvnx16qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7883; /* *cond_ashlvnx16qi_any */

        case E_VNx8QImode:
          if (pattern599 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7560; /* *cond_ashlvnx8qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7730; /* *cond_ashlvnx8qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7900; /* *cond_ashlvnx8qi_any */

        case E_VNx4QImode:
          if (pattern599 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7577; /* *cond_ashlvnx4qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7747; /* *cond_ashlvnx4qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7917; /* *cond_ashlvnx4qi_any */

        case E_VNx2QImode:
          if (pattern599 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7594; /* *cond_ashlvnx2qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7764; /* *cond_ashlvnx2qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7934; /* *cond_ashlvnx2qi_any */

        case E_VNx8HImode:
          if (pattern599 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7611; /* *cond_ashlvnx8hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7781; /* *cond_ashlvnx8hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7951; /* *cond_ashlvnx8hi_any */

        case E_VNx4HImode:
          if (pattern599 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7628; /* *cond_ashlvnx4hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7798; /* *cond_ashlvnx4hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7968; /* *cond_ashlvnx4hi_any */

        case E_VNx2HImode:
          if (pattern599 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7645; /* *cond_ashlvnx2hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7815; /* *cond_ashlvnx2hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7985; /* *cond_ashlvnx2hi_any */

        case E_VNx4SImode:
          if (pattern599 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7662; /* *cond_ashlvnx4si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7832; /* *cond_ashlvnx4si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 8002; /* *cond_ashlvnx4si_any */

        case E_VNx2SImode:
          if (pattern599 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7679; /* *cond_ashlvnx2si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7849; /* *cond_ashlvnx2si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 8019; /* *cond_ashlvnx2si_any */

        case E_VNx2DImode:
          if (pattern599 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7696; /* *cond_ashlvnx2di_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7866; /* *cond_ashlvnx2di_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 8036; /* *cond_ashlvnx2di_any */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern997 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8352; /* *cond_ashlvnx16qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8382; /* *cond_ashlvnx16qi_any_const */

        case E_VNx8QImode:
          if (pattern997 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8355; /* *cond_ashlvnx8qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8385; /* *cond_ashlvnx8qi_any_const */

        case E_VNx4QImode:
          if (pattern997 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8358; /* *cond_ashlvnx4qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8388; /* *cond_ashlvnx4qi_any_const */

        case E_VNx2QImode:
          if (pattern997 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8361; /* *cond_ashlvnx2qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8391; /* *cond_ashlvnx2qi_any_const */

        case E_VNx8HImode:
          if (pattern997 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8364; /* *cond_ashlvnx8hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8394; /* *cond_ashlvnx8hi_any_const */

        case E_VNx4HImode:
          if (pattern997 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8367; /* *cond_ashlvnx4hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8397; /* *cond_ashlvnx4hi_any_const */

        case E_VNx2HImode:
          if (pattern997 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8370; /* *cond_ashlvnx2hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8400; /* *cond_ashlvnx2hi_any_const */

        case E_VNx4SImode:
          if (pattern997 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8373; /* *cond_ashlvnx4si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8403; /* *cond_ashlvnx4si_any_const */

        case E_VNx2SImode:
          if (pattern997 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8376; /* *cond_ashlvnx2si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8406; /* *cond_ashlvnx2si_any_const */

        case E_VNx2DImode:
          if (pattern997 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 5084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8379; /* *cond_ashlvnx2di_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8409; /* *cond_ashlvnx2di_any_const */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x4, 1))
        {
        case 316:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1057 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 7034; /* cond_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern1057 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 7037; /* cond_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern1057 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 7040; /* cond_revbvnx4si */

            case E_VNx2DImode:
              if (pattern1057 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 7043; /* cond_revbvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1057 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 7035; /* cond_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern1057 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 7038; /* cond_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern1057 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 7041; /* cond_revhvnx4si */

            case E_VNx2DImode:
              if (pattern1057 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 7044; /* cond_revhvnx2di */

            default:
              return -1;
            }

        case 319:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1057 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 7036; /* cond_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern1057 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 7039; /* cond_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern1057 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 7042; /* cond_revwvnx4si */

            case E_VNx2DImode:
              if (pattern1057 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3422 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 7045; /* cond_revwvnx2di */

            default:
              return -1;
            }

        case 317:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1121 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12980; /* cond_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern1121 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12981; /* cond_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern1121 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12982; /* cond_revdvnx4si */

            case E_VNx2DImode:
              if (pattern1121 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12983; /* cond_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern1121 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12984; /* cond_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern1121 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12985; /* cond_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern1121 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12986; /* cond_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern1121 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3767 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12987; /* cond_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      return recog_270 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x4, 1))
        {
        case 321:
          switch (pattern872 (x2))
            {
            case 0:
              if (!
#line 4675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8196; /* *cond_smulhvnx16qi_2 */

            case 1:
              if (!
#line 4675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8198; /* *cond_smulhvnx8hi_2 */

            case 2:
              if (!
#line 4675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8200; /* *cond_smulhvnx4si_2 */

            case 3:
              if (!
#line 4675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8202; /* *cond_smulhvnx2di_2 */

            case 4:
              if (!
#line 4693 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8204; /* *cond_smulhvnx16qi_z */

            case 5:
              if (!
#line 4693 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8206; /* *cond_smulhvnx8hi_z */

            case 6:
              if (!
#line 4693 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8208; /* *cond_smulhvnx4si_z */

            case 7:
              if (!
#line 4693 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8210; /* *cond_smulhvnx2di_z */

            default:
              return -1;
            }

        case 322:
          switch (pattern872 (x2))
            {
            case 0:
              if (!
#line 4675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8197; /* *cond_umulhvnx16qi_2 */

            case 1:
              if (!
#line 4675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8199; /* *cond_umulhvnx8hi_2 */

            case 2:
              if (!
#line 4675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8201; /* *cond_umulhvnx4si_2 */

            case 3:
              if (!
#line 4675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8203; /* *cond_umulhvnx2di_2 */

            case 4:
              if (!
#line 4693 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8205; /* *cond_umulhvnx16qi_z */

            case 5:
              if (!
#line 4693 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8207; /* *cond_umulhvnx8hi_z */

            case 6:
              if (!
#line 4693 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8209; /* *cond_umulhvnx4si_z */

            case 7:
              if (!
#line 4693 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8211; /* *cond_umulhvnx2di_z */

            default:
              return -1;
            }

        case 400:
          switch (pattern875 (x2))
            {
            case 0:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8421; /* *cond_lslvnx16qi_m */

            case 1:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8424; /* *cond_lslvnx8hi_m */

            case 2:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8427; /* *cond_lslvnx4si_m */

            case 3:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8430; /* *cond_lslvnx16qi_z */

            case 4:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8433; /* *cond_lslvnx8hi_z */

            case 5:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8436; /* *cond_lslvnx4si_z */

            default:
              return -1;
            }

        case 401:
          switch (pattern875 (x2))
            {
            case 0:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8422; /* *cond_asrvnx16qi_m */

            case 1:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8425; /* *cond_asrvnx8hi_m */

            case 2:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8428; /* *cond_asrvnx4si_m */

            case 3:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8431; /* *cond_asrvnx16qi_z */

            case 4:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8434; /* *cond_asrvnx8hi_z */

            case 5:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8437; /* *cond_asrvnx4si_z */

            default:
              return -1;
            }

        case 402:
          switch (pattern875 (x2))
            {
            case 0:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8423; /* *cond_lsrvnx16qi_m */

            case 1:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8426; /* *cond_lsrvnx8hi_m */

            case 2:
              if (!
#line 5155 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8429; /* *cond_lsrvnx4si_m */

            case 3:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8432; /* *cond_lsrvnx16qi_z */

            case 4:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8435; /* *cond_lsrvnx8hi_z */

            case 5:
              if (!
#line 5173 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8438; /* *cond_lsrvnx4si_z */

            default:
              return -1;
            }

        case 125:
          return recog_254 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 4:
      return recog_269 (x1, insn, pnum_clobbers);

    case 5:
      return recog_268 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern598 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6791; /* *cond_qabsvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6881; /* *cond_qabsvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6800; /* *cond_qabsvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6890; /* *cond_qabsvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6809; /* *cond_qabsvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6899; /* *cond_qabsvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6818; /* *cond_qabsvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6908; /* *cond_qabsvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6827; /* *cond_qabsvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6917; /* *cond_qabsvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6836; /* *cond_qabsvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6926; /* *cond_qabsvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6845; /* *cond_qabsvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6935; /* *cond_qabsvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6854; /* *cond_qabsvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6944; /* *cond_qabsvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6863; /* *cond_qabsvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6953; /* *cond_qabsvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6872; /* *cond_qabsvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !(
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6962; /* *cond_qabsvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx2TImode:
      switch (pattern805 (x3, 
E_VNx32QImode, 
E_VNx2TImode))
        {
        case 0:
          if (!
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11441; /* aarch64_sve_stnqvnx32qi */

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16HImode:
              if (!register_operand (operands[1], E_VNx16HImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11442; /* aarch64_sve_stnqvnx16hi */

            case E_VNx16BFmode:
              if (!register_operand (operands[1], E_VNx16BFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11445; /* aarch64_sve_stnqvnx16bf */

            case E_VNx16HFmode:
              if (!register_operand (operands[1], E_VNx16HFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11446; /* aarch64_sve_stnqvnx16hf */

            default:
              return -1;
            }

        case 2:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx8SImode:
              if (!register_operand (operands[1], E_VNx8SImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11443; /* aarch64_sve_stnqvnx8si */

            case E_VNx8SFmode:
              if (!register_operand (operands[1], E_VNx8SFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11447; /* aarch64_sve_stnqvnx8sf */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx4DImode:
              if (!register_operand (operands[1], E_VNx4DImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11444; /* aarch64_sve_stnqvnx4di */

            case E_VNx4DFmode:
              if (!register_operand (operands[1], E_VNx4DFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11448; /* aarch64_sve_stnqvnx4df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_VNx3TImode:
      switch (pattern805 (x3, 
E_VNx48QImode, 
E_VNx3TImode))
        {
        case 0:
          if (!
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11449; /* aarch64_sve_stnqvnx48qi */

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx24HImode:
              if (!register_operand (operands[1], E_VNx24HImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11450; /* aarch64_sve_stnqvnx24hi */

            case E_VNx24BFmode:
              if (!register_operand (operands[1], E_VNx24BFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11453; /* aarch64_sve_stnqvnx24bf */

            case E_VNx24HFmode:
              if (!register_operand (operands[1], E_VNx24HFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11454; /* aarch64_sve_stnqvnx24hf */

            default:
              return -1;
            }

        case 2:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx12SImode:
              if (!register_operand (operands[1], E_VNx12SImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11451; /* aarch64_sve_stnqvnx12si */

            case E_VNx12SFmode:
              if (!register_operand (operands[1], E_VNx12SFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11455; /* aarch64_sve_stnqvnx12sf */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx6DImode:
              if (!register_operand (operands[1], E_VNx6DImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11452; /* aarch64_sve_stnqvnx6di */

            case E_VNx6DFmode:
              if (!register_operand (operands[1], E_VNx6DFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11456; /* aarch64_sve_stnqvnx6df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_VNx4TImode:
      switch (pattern805 (x3, 
E_VNx64QImode, 
E_VNx4TImode))
        {
        case 0:
          if (!
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11457; /* aarch64_sve_stnqvnx64qi */

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx32HImode:
              if (!register_operand (operands[1], E_VNx32HImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11458; /* aarch64_sve_stnqvnx32hi */

            case E_VNx32BFmode:
              if (!register_operand (operands[1], E_VNx32BFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11461; /* aarch64_sve_stnqvnx32bf */

            case E_VNx32HFmode:
              if (!register_operand (operands[1], E_VNx32HFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11462; /* aarch64_sve_stnqvnx32hf */

            default:
              return -1;
            }

        case 2:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16SImode:
              if (!register_operand (operands[1], E_VNx16SImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11459; /* aarch64_sve_stnqvnx16si */

            case E_VNx16SFmode:
              if (!register_operand (operands[1], E_VNx16SFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11463; /* aarch64_sve_stnqvnx16sf */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx8DImode:
              if (!register_operand (operands[1], E_VNx8DImode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11460; /* aarch64_sve_stnqvnx8di */

            case E_VNx8DFmode:
              if (!register_operand (operands[1], E_VNx8DFmode)
                  || !
#line 455 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11464; /* aarch64_sve_stnqvnx8df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern177 (x1))
    {
    case 0:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10390; /* fold_extract_last_vnx16qi */

    case 1:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10392; /* fold_extract_last_vnx8qi */

    case 2:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10394; /* fold_extract_last_vnx4qi */

    case 3:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10396; /* fold_extract_last_vnx2qi */

    case 4:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10398; /* fold_extract_last_vnx8hi */

    case 5:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10400; /* fold_extract_last_vnx4hi */

    case 6:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10402; /* fold_extract_last_vnx2hi */

    case 7:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10404; /* fold_extract_last_vnx4si */

    case 8:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10406; /* fold_extract_last_vnx2si */

    case 9:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10408; /* fold_extract_last_vnx2di */

    case 10:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10410; /* fold_extract_last_vnx2hf */

    case 11:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10412; /* fold_extract_last_vnx4hf */

    case 12:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10416; /* fold_extract_last_vnx8hf */

    case 13:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10414; /* fold_extract_last_vnx2sf */

    case 14:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10418; /* fold_extract_last_vnx4sf */

    case 15:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10420; /* fold_extract_last_vnx2df */

    case 16:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10422; /* fold_extract_last_vnx2bf */

    case 17:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10424; /* fold_extract_last_vnx4bf */

    case 18:
      if (!
#line 9051 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10426; /* fold_extract_last_vnx8bf */

    case 19:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10428; /* aarch64_fold_extract_vector_last_vnx16qi */

    case 20:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10430; /* aarch64_fold_extract_vector_last_vnx8qi */

    case 21:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10432; /* aarch64_fold_extract_vector_last_vnx4qi */

    case 22:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10434; /* aarch64_fold_extract_vector_last_vnx2qi */

    case 23:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10436; /* aarch64_fold_extract_vector_last_vnx8hi */

    case 24:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10438; /* aarch64_fold_extract_vector_last_vnx4hi */

    case 25:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10440; /* aarch64_fold_extract_vector_last_vnx2hi */

    case 26:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10442; /* aarch64_fold_extract_vector_last_vnx4si */

    case 27:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10444; /* aarch64_fold_extract_vector_last_vnx2si */

    case 28:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10446; /* aarch64_fold_extract_vector_last_vnx2di */

    case 29:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10448; /* aarch64_fold_extract_vector_last_vnx2hf */

    case 30:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10450; /* aarch64_fold_extract_vector_last_vnx4hf */

    case 31:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10452; /* aarch64_fold_extract_vector_last_vnx2sf */

    case 32:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10454; /* aarch64_fold_extract_vector_last_vnx8hf */

    case 33:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10456; /* aarch64_fold_extract_vector_last_vnx4sf */

    case 34:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10458; /* aarch64_fold_extract_vector_last_vnx2df */

    case 35:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10460; /* aarch64_fold_extract_vector_last_vnx2bf */

    case 36:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10462; /* aarch64_fold_extract_vector_last_vnx4bf */

    case 37:
      if (!
#line 9065 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10464; /* aarch64_fold_extract_vector_last_vnx8bf */

    default:
      return -1;
    }
}

 int
recog_320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern173 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10042; /* while_wrsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10052; /* while_wrdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10062; /* while_wrsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10072; /* while_wrdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10082; /* while_wrsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10092; /* while_wrdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10102; /* while_wrsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10112; /* while_wrdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern173 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10036; /* while_ltsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10046; /* while_ltdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10056; /* while_ltsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10066; /* while_ltdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10076; /* while_ltsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10086; /* while_ltdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10096; /* while_ltsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10106; /* while_ltdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern188 (x1))
    {
    case 0:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11466; /* aarch64_stnt1vnx32qi */

    case 1:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11468; /* aarch64_stnt1vnx16hi */

    case 2:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11470; /* aarch64_stnt1vnx8si */

    case 3:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11472; /* aarch64_stnt1vnx4di */

    case 4:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11474; /* aarch64_stnt1vnx16bf */

    case 5:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11476; /* aarch64_stnt1vnx16hf */

    case 6:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11478; /* aarch64_stnt1vnx8sf */

    case 7:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11480; /* aarch64_stnt1vnx4df */

    case 8:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11482; /* aarch64_stnt1vnx64qi */

    case 9:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11484; /* aarch64_stnt1vnx32hi */

    case 10:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11486; /* aarch64_stnt1vnx16si */

    case 11:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11488; /* aarch64_stnt1vnx8di */

    case 12:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11490; /* aarch64_stnt1vnx32bf */

    case 13:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11492; /* aarch64_stnt1vnx32hf */

    case 14:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11494; /* aarch64_stnt1vnx16sf */

    case 15:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11496; /* aarch64_stnt1vnx8df */

    default:
      return -1;
    }
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern942 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5978; /* aarch64_ldff1vnx16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern942 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5980; /* aarch64_ldff1vnx8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern942 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5982; /* aarch64_ldff1vnx4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern942 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5984; /* aarch64_ldff1vnx2di */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern942 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5986; /* aarch64_ldff1vnx8bf */

    case 5:
      x2 = XEXP (x1, 1);
      if (pattern942 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5988; /* aarch64_ldff1vnx8hf */

    case 6:
      x2 = XEXP (x1, 1);
      if (pattern942 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5990; /* aarch64_ldff1vnx4sf */

    case 7:
      x2 = XEXP (x1, 1);
      if (pattern942 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5992; /* aarch64_ldff1vnx2df */

    default:
      return -1;
    }
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern79 (x3, 
E_VNx8HFmode) != 0
          || !
#line 8082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9489; /* aarch64_sve_tmadvnx8hf */

    case E_VNx4SFmode:
      if (pattern79 (x3, 
E_VNx4SFmode) != 0
          || !
#line 8082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9490; /* aarch64_sve_tmadvnx4sf */

    case E_VNx2DFmode:
      if (pattern79 (x3, 
E_VNx2DFmode) != 0
          || !
#line 8082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9491; /* aarch64_sve_tmadvnx2df */

    default:
      return -1;
    }
}

 int
recog_364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12719; /* aarch64_sve_cmlavnx16qi */

    case 1:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12727; /* aarch64_sve_cmlavnx8hi */

    case 2:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12735; /* aarch64_sve_cmlavnx4si */

    case 3:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12743; /* aarch64_sve_cmlavnx2di */

    case 4:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12751; /* aarch64_cmla_lane_vnx8hi */

    case 5:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12759; /* aarch64_cmla_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_372 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3080 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12768; /* aarch64_sve_cdot90vnx4si */

    case 1:
      if (!
#line 3080 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12772; /* aarch64_sve_cdot90vnx2di */

    case 2:
      if (!
#line 3097 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12776; /* aarch64_cdot90_lane_vnx4si */

    case 3:
      if (!
#line 3097 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12780; /* aarch64_cdot90_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12032; /* aarch64_sve_eortbvnx16qi */

    case 1:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12040; /* aarch64_sve_eortbvnx8hi */

    case 2:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12048; /* aarch64_sve_eortbvnx4si */

    case 3:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12056; /* aarch64_sve_eortbvnx2di */

    default:
      return -1;
    }
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern170 (x1))
    {
    case 0:
      if (!(
#line 7831 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9414; /* aarch64_fnma_lane_vnx8bf */

    case 1:
      if (!
#line 7831 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9416; /* aarch64_fnma_lane_vnx8hf */

    case 2:
      if (!
#line 7831 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9418; /* aarch64_fnma_lane_vnx4sf */

    case 3:
      if (!
#line 7831 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9420; /* aarch64_fnma_lane_vnx2df */

    default:
      return -1;
    }
}

 int
recog_400 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          switch (pattern1170 (
E_V8QImode))
            {
            case 0:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (8)))
                return -1;
              return 5346; /* aarch64_lutv8qiv8qi */

            case 1:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (8)))
                return -1;
              return 5351; /* aarch64_lutv8qiv16qi */

            default:
              return -1;
            }

        case E_V16QImode:
          switch (pattern1170 (
E_V16QImode))
            {
            case 0:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (16)))
                return -1;
              return 5347; /* aarch64_lutv16qiv8qi */

            case 1:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (16)))
                return -1;
              return 5352; /* aarch64_lutv16qiv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          switch (pattern1170 (
E_V4HImode))
            {
            case 0:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5348; /* aarch64_lutv4hiv8qi */

            case 1:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5353; /* aarch64_lutv4hiv16qi */

            default:
              return -1;
            }

        case E_V2x8HImode:
          switch (pattern1170 (
E_V2x8HImode))
            {
            case 0:
              if (!
#line 10138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5356; /* aarch64_lutv2x8hiv8qi */

            case 1:
              if (!
#line 10138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5359; /* aarch64_lutv2x8hiv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          switch (pattern1170 (
E_V4HFmode))
            {
            case 0:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5349; /* aarch64_lutv4hfv8qi */

            case 1:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5354; /* aarch64_lutv4hfv16qi */

            default:
              return -1;
            }

        case E_V2x8HFmode:
          switch (pattern1170 (
E_V2x8HFmode))
            {
            case 0:
              if (!
#line 10138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5357; /* aarch64_lutv2x8hfv8qi */

            case 1:
              if (!
#line 10138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5360; /* aarch64_lutv2x8hfv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          switch (pattern1170 (
E_V4BFmode))
            {
            case 0:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5350; /* aarch64_lutv4bfv8qi */

            case 1:
              if (!
#line 10125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5355; /* aarch64_lutv4bfv16qi */

            default:
              return -1;
            }

        case E_V2x8BFmode:
          switch (pattern1170 (
E_V2x8BFmode))
            {
            case 0:
              if (!
#line 10138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5358; /* aarch64_lutv2x8bfv8qi */

            case 1:
              if (!
#line 10138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5361; /* aarch64_lutv2x8bfv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern230 (x1))
    {
    case 0:
      if (!
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13602; /* aarch64_sme_fsubvnx8sf */

    case 1:
      if (!
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13604; /* aarch64_sme_fsubvnx16sf */

    case 2:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 751 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13606; /* aarch64_sme_fsubvnx4df */

    case 3:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 752 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13608; /* aarch64_sme_fsubvnx8df */

    case 4:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 753 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13610; /* aarch64_sme_fsubvnx16hf */

    case 5:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 754 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13612; /* aarch64_sme_fsubvnx32hf */

    case 6:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 755 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13614; /* aarch64_sme_fsubvnx16bf */

    case 7:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 756 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13616; /* aarch64_sme_fsubvnx32bf */

    case 8:
      if (!
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13618; /* *aarch64_sme_fsubvnx8sf_plus */

    case 9:
      if (!
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13620; /* *aarch64_sme_fsubvnx16sf_plus */

    case 10:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 751 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13622; /* *aarch64_sme_fsubvnx4df_plus */

    case 11:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 752 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13624; /* *aarch64_sme_fsubvnx8df_plus */

    case 12:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 753 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13626; /* *aarch64_sme_fsubvnx16hf_plus */

    case 13:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 754 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13628; /* *aarch64_sme_fsubvnx32hf_plus */

    case 14:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 755 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13630; /* *aarch64_sme_fsubvnx16bf_plus */

    case 15:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 756 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13632; /* *aarch64_sme_fsubvnx32bf_plus */

    default:
      return -1;
    }
}

 int
recog_416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern220 (x1))
    {
    case 0:
      if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10277; /* aarch64_pred_fcmltvnx8hf */

    case 1:
      if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10283; /* aarch64_pred_fcmltvnx4sf */

    case 2:
      if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10289; /* aarch64_pred_fcmltvnx2df */

    case 3:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 2);
      x4 = XVECEXP (x3, 0, 1);
      if (XWINT (x4, 0) == 0L)
        {
          switch (pattern1262 (x2))
            {
            case 0:
              if (
#line 8932 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10360; /* *aarch64_pred_facltvnx8hf_relaxed */
              break;

            case 1:
              if (
#line 8932 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10364; /* *aarch64_pred_facltvnx4sf_relaxed */
              break;

            case 2:
              if (
#line 8932 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10368; /* *aarch64_pred_facltvnx2df_relaxed */
              break;

            default:
              break;
            }
        }
      operands[5] = x4;
      switch (pattern1263 (x2))
        {
        case 0:
          if (!
#line 8958 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10372; /* *aarch64_pred_facltvnx8hf_strict */

        case 1:
          if (!
#line 8958 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10376; /* *aarch64_pred_facltvnx4sf_strict */

        case 2:
          if (!
#line 8958 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10380; /* *aarch64_pred_facltvnx2df_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_423 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern948 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6218 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9032; /* aarch64_pred_subvnx8hf */

    case E_VNx4SFmode:
      if (pattern948 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6218 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9033; /* aarch64_pred_subvnx4sf */

    case E_VNx2DFmode:
      if (pattern948 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6218 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9034; /* aarch64_pred_subvnx2df */

    case E_VNx8BFmode:
      if (pattern208 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
        return -1;
      return 12010; /* aarch64_pred_subvnx8bf */

    default:
      return -1;
    }
}

 int
recog_431 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern254 (x1))
    {
    case 0:
      if (!
#line 1431 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13894; /* aarch64_sme_smlsvnx4sivnx16qi */

    case 1:
      if (!
#line 1431 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13898; /* aarch64_sme_smlsvnx4sivnx8hi */

    case 2:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13910; /* aarch64_sme_smlsvnx4sivnx32qi */

    case 3:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13914; /* aarch64_sme_smlsvnx4sivnx64qi */

    case 4:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13918; /* aarch64_sme_smlsvnx4sivnx16hi */

    case 5:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13922; /* aarch64_sme_smlsvnx4sivnx32hi */

    case 6:
      if (!
#line 1559 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14022; /* aarch64_sme_smlsvnx2divnx8hi */

    case 7:
      if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14030; /* aarch64_sme_smlsvnx2divnx16hi */

    case 8:
      if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14034; /* aarch64_sme_smlsvnx2divnx32hi */

    case 9:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13942; /* aarch64_sme_single_smlsvnx4sivnx32qi */

    case 10:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13946; /* aarch64_sme_single_smlsvnx4sivnx64qi */

    case 11:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13950; /* aarch64_sme_single_smlsvnx4sivnx16hi */

    case 12:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13954; /* aarch64_sme_single_smlsvnx4sivnx32hi */

    case 13:
      if (!
#line 1620 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14046; /* aarch64_sme_single_smlsvnx2divnx16hi */

    case 14:
      if (!
#line 1620 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14050; /* aarch64_sme_single_smlsvnx2divnx32hi */

    case 15:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13974; /* aarch64_sme_lane_smlsvnx4sivnx16qi */

    case 16:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13978; /* aarch64_sme_lane_smlsvnx4sivnx32qi */

    case 17:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13982; /* aarch64_sme_lane_smlsvnx4sivnx64qi */

    case 18:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13986; /* aarch64_sme_lane_smlsvnx4sivnx8hi */

    case 19:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13990; /* aarch64_sme_lane_smlsvnx4sivnx16hi */

    case 20:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13994; /* aarch64_sme_lane_smlsvnx4sivnx32hi */

    case 21:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14062; /* aarch64_sme_lane_smlsvnx2divnx8hi */

    case 22:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14066; /* aarch64_sme_lane_smlsvnx2divnx16hi */

    case 23:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14070; /* aarch64_sme_lane_smlsvnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1445 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13902; /* *aarch64_sme_smlsvnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1445 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13906; /* *aarch64_sme_smlsvnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1325 ())
            {
            case 0:
              if (
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13926; /* *aarch64_sme_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13930; /* *aarch64_sme_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13934; /* *aarch64_sme_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13938; /* *aarch64_sme_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1573 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 14026; /* *aarch64_sme_smlsvnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1603 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 14038; /* *aarch64_sme_smlsvnx2divnx16hi_plus */

        case 1:
          if (!
#line 1603 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 14042; /* *aarch64_sme_smlsvnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1327 (x3))
            {
            case 0:
              if (
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13958; /* *aarch64_sme_single_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13962; /* *aarch64_sme_single_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13966; /* *aarch64_sme_single_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13970; /* *aarch64_sme_single_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1635 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14054; /* *aarch64_sme_single_smlsvnx2divnx16hi_plus */

    case 28:
      if (!
#line 1635 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14058; /* *aarch64_sme_single_smlsvnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13998; /* *aarch64_sme_lane_smlsvnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1368 (x3))
                {
                case 0:
                  if (
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 14002; /* *aarch64_sme_lane_smlsvnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 14006; /* *aarch64_sme_lane_smlsvnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 14010; /* *aarch64_sme_lane_smlsvnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1369 (x3))
        {
        case 0:
          if (!
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14014; /* *aarch64_sme_lane_smlsvnx4sivnx16hi */

        case 1:
          if (!
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14018; /* *aarch64_sme_lane_smlsvnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 14074; /* *aarch64_sme_lane_smlsvnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1369 (x3))
        {
        case 0:
          if (!
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 14078; /* *aarch64_sme_lane_smlsvnx2divnx16hi */

        case 1:
          if (!
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 14082; /* *aarch64_sme_lane_smlsvnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_439 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern237 (x1))
    {
    case 0:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13491; /* aarch64_sme_write_horvnx32qivnx32qi */

    case 1:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13493; /* aarch64_sme_write_horvnx16hivnx16hi */

    case 2:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13495; /* aarch64_sme_write_horvnx8sivnx8si */

    case 3:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13497; /* aarch64_sme_write_horvnx4divnx4di */

    case 4:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13499; /* aarch64_sme_write_horvnx16bfvnx16bf */

    case 5:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13501; /* aarch64_sme_write_horvnx16hfvnx16hf */

    case 6:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13503; /* aarch64_sme_write_horvnx8sfvnx8sf */

    case 7:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13505; /* aarch64_sme_write_horvnx4dfvnx4df */

    case 8:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13507; /* aarch64_sme_write_horvnx64qivnx64qi */

    case 9:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13509; /* aarch64_sme_write_horvnx32hivnx32hi */

    case 10:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13511; /* aarch64_sme_write_horvnx16sivnx16si */

    case 11:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13513; /* aarch64_sme_write_horvnx8divnx8di */

    case 12:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13515; /* aarch64_sme_write_horvnx32bfvnx32bf */

    case 13:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13517; /* aarch64_sme_write_horvnx32hfvnx32hf */

    case 14:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13519; /* aarch64_sme_write_horvnx16sfvnx16sf */

    case 15:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13521; /* aarch64_sme_write_horvnx8dfvnx8df */

    case 16:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13523; /* *aarch64_sme_write_horvnx32qivnx32qi_plus */

    case 17:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13525; /* *aarch64_sme_write_horvnx16hivnx16hi_plus */

    case 18:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13527; /* *aarch64_sme_write_horvnx8sivnx8si_plus */

    case 19:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13529; /* *aarch64_sme_write_horvnx4divnx4di_plus */

    case 20:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13531; /* *aarch64_sme_write_horvnx16bfvnx16bf_plus */

    case 21:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13533; /* *aarch64_sme_write_horvnx16hfvnx16hf_plus */

    case 22:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13535; /* *aarch64_sme_write_horvnx8sfvnx8sf_plus */

    case 23:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13537; /* *aarch64_sme_write_horvnx4dfvnx4df_plus */

    case 24:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13539; /* *aarch64_sme_write_horvnx64qivnx64qi_plus */

    case 25:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13541; /* *aarch64_sme_write_horvnx32hivnx32hi_plus */

    case 26:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13543; /* *aarch64_sme_write_horvnx16sivnx16si_plus */

    case 27:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13545; /* *aarch64_sme_write_horvnx8divnx8di_plus */

    case 28:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13547; /* *aarch64_sme_write_horvnx32bfvnx32bf_plus */

    case 29:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13549; /* *aarch64_sme_write_horvnx32hfvnx32hf_plus */

    case 30:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13551; /* *aarch64_sme_write_horvnx16sfvnx16sf_plus */

    case 31:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13553; /* *aarch64_sme_write_horvnx8dfvnx8df_plus */

    default:
      return -1;
    }
}

 int
recog_446 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 282:
      if (pattern204 (x1) != 0
          || !
#line 9276 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5253; /* aarch64_sm3tt1aqv4si */

    case 283:
      if (pattern204 (x1) != 0
          || !
#line 9276 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5254; /* aarch64_sm3tt1bqv4si */

    case 284:
      if (pattern204 (x1) != 0
          || !
#line 9276 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5255; /* aarch64_sm3tt2aqv4si */

    case 285:
      if (pattern204 (x1) != 0
          || !
#line 9276 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5256; /* aarch64_sm3tt2bqv4si */

    case 591:
      return recog_400 (x1, insn, pnum_clobbers);

    case 194:
      return recog_420 (x1, insn, pnum_clobbers);

    case 459:
      switch (pattern206 (x1))
        {
        case 0:
          if (!
#line 10251 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5392; /* aarch64_fmlalbv8hf */

        case 1:
          if (!
#line 2078 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12228; /* aarch64_sve_add_fmlalbvnx8hf */

        case 2:
          if (!
#line 10266 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5394; /* aarch64_fmlalb_lanev8hfv8qi */

        case 3:
          if (!
#line 10266 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5396; /* aarch64_fmlalb_lanev8hfv16qi */

        default:
          return -1;
        }

    case 465:
      switch (pattern206 (x1))
        {
        case 0:
          if (!
#line 10251 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5393; /* aarch64_fmlaltv8hf */

        case 1:
          if (!
#line 2078 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12229; /* aarch64_sve_add_fmlaltvnx8hf */

        case 2:
          if (!
#line 10266 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5395; /* aarch64_fmlalt_lanev8hfv8qi */

        case 3:
          if (!
#line 10266 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5397; /* aarch64_fmlalt_lanev8hfv16qi */

        default:
          return -1;
        }

    case 460:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 10282 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5398; /* aarch64_fmlallbbv4sf */

        case 1:
          if (!
#line 2093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12230; /* aarch64_sve_add_fmlallbbvnx4sf */

        case 2:
          if (!
#line 10297 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5402; /* aarch64_fmlallbb_lanev4sfv8qi */

        case 3:
          if (!
#line 10297 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5406; /* aarch64_fmlallbb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 461:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 10282 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5399; /* aarch64_fmlallbtv4sf */

        case 1:
          if (!
#line 2093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12231; /* aarch64_sve_add_fmlallbtvnx4sf */

        case 2:
          if (!
#line 10297 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5403; /* aarch64_fmlallbt_lanev4sfv8qi */

        case 3:
          if (!
#line 10297 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5407; /* aarch64_fmlallbt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 462:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 10282 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5400; /* aarch64_fmlalltbv4sf */

        case 1:
          if (!
#line 2093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12232; /* aarch64_sve_add_fmlalltbvnx4sf */

        case 2:
          if (!
#line 10297 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5404; /* aarch64_fmlalltb_lanev4sfv8qi */

        case 3:
          if (!
#line 10297 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5408; /* aarch64_fmlalltb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 463:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 10282 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5401; /* aarch64_fmlallttv4sf */

        case 1:
          if (!
#line 2093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12233; /* aarch64_sve_add_fmlallttvnx4sf */

        case 2:
          if (!
#line 10297 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5405; /* aarch64_fmlalltt_lanev4sfv8qi */

        case 3:
          if (!
#line 10297 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5409; /* aarch64_fmlalltt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 127:
      return recog_398 (x1, insn, pnum_clobbers);

    case 391:
      return recog_414 (x1, insn, pnum_clobbers);

    case 353:
      switch (pattern209 (x1))
        {
        case 0:
          if (!(
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3504 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8579; /* aarch64_pred_famaxvnx8hf */

        case 1:
          if (!(
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3504 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8583; /* aarch64_pred_famaxvnx4sf */

        case 2:
          if (!(
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3504 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8587; /* aarch64_pred_famaxvnx2df */

        default:
          return -1;
        }

    case 354:
      switch (pattern209 (x1))
        {
        case 0:
          if (!(
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3505 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8580; /* aarch64_pred_faminvnx8hf */

        case 1:
          if (!(
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3505 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8584; /* aarch64_pred_faminvnx4sf */

        case 2:
          if (!(
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3505 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8588; /* aarch64_pred_faminvnx2df */

        default:
          return -1;
        }

    case 371:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8581; /* aarch64_pred_divvnx8hf */

        case 1:
          if (!
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8585; /* aarch64_pred_divvnx4sf */

        case 2:
          if (!
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8589; /* aarch64_pred_divvnx2df */

        default:
          return -1;
        }

    case 379:
      return recog_424 (x1, insn, pnum_clobbers);

    case 352:
      return recog_422 (x1, insn, pnum_clobbers);

    case 355:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 6053 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9002; /* aarch64_pred_cadd90vnx8hf */

        case 1:
          if (!
#line 6053 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9004; /* aarch64_pred_cadd90vnx4sf */

        case 2:
          if (!
#line 6053 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9006; /* aarch64_pred_cadd90vnx2df */

        default:
          return -1;
        }

    case 356:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 6053 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9003; /* aarch64_pred_cadd270vnx8hf */

        case 1:
          if (!
#line 6053 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9005; /* aarch64_pred_cadd270vnx4sf */

        case 2:
          if (!
#line 6053 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9007; /* aarch64_pred_cadd270vnx2df */

        default:
          return -1;
        }

    case 393:
      return recog_423 (x1, insn, pnum_clobbers);

    case 378:
      return recog_421 (x1, insn, pnum_clobbers);

    case 372:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9105; /* aarch64_pred_fmax_nanvnx8hf */

        case 1:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9111; /* aarch64_pred_fmax_nanvnx4sf */

        case 2:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9117; /* aarch64_pred_fmax_nanvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 12004; /* aarch64_pred_fmax_nanvnx8bf */

        default:
          return -1;
        }

    case 373:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9106; /* aarch64_pred_fmaxvnx8hf */

        case 1:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9112; /* aarch64_pred_fmaxvnx4sf */

        case 2:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9118; /* aarch64_pred_fmaxvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 12005; /* aarch64_pred_fmaxvnx8bf */

        default:
          return -1;
        }

    case 374:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9107; /* aarch64_pred_fmin_nanvnx8hf */

        case 1:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9113; /* aarch64_pred_fmin_nanvnx4sf */

        case 2:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9119; /* aarch64_pred_fmin_nanvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 12006; /* aarch64_pred_fmin_nanvnx8bf */

        default:
          return -1;
        }

    case 375:
      return recog_413 (x1, insn, pnum_clobbers);

    case 395:
      switch (pattern216 (x1))
        {
        case 0:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9109; /* aarch64_pred_smaxvnx8hf */

        case 1:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9115; /* aarch64_pred_smaxvnx4sf */

        case 2:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9121; /* aarch64_pred_smaxvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 12011; /* aarch64_pred_smaxvnx8bf */

        case 4:
          if (!
#line 2937 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12697; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2937 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12699; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2937 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12701; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 396:
      switch (pattern216 (x1))
        {
        case 0:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9110; /* aarch64_pred_sminvnx8hf */

        case 1:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9116; /* aarch64_pred_sminvnx4sf */

        case 2:
          if (!
#line 6875 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9122; /* aarch64_pred_sminvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 12012; /* aarch64_pred_sminvnx8bf */

        case 4:
          if (!
#line 2937 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12698; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2937 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12700; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2937 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12702; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 579:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern234 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3397 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9498; /* aarch64_sve_bfdot_lanevnx4sf */

    case 580:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern234 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3398 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9499; /* aarch64_sve_bfmlalb_lanevnx4sf */

    case 581:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern234 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3399 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9500; /* aarch64_sve_bfmlalt_lanevnx4sf */

    case 582:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern234 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3400 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9501; /* aarch64_sve_bfmlslb_lanevnx4sf */

    case 583:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern234 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3401 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9502; /* aarch64_sve_bfmlslt_lanevnx4sf */

    case 357:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10273; /* aarch64_pred_fcmeqvnx8hf */

        case 1:
          if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10279; /* aarch64_pred_fcmeqvnx4sf */

        case 2:
          if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10285; /* aarch64_pred_fcmeqvnx2df */

        default:
          return -1;
        }

    case 358:
      return recog_419 (x1, insn, pnum_clobbers);

    case 359:
      return recog_418 (x1, insn, pnum_clobbers);

    case 364:
      return recog_417 (x1, insn, pnum_clobbers);

    case 365:
      return recog_416 (x1, insn, pnum_clobbers);

    case 366:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10278; /* aarch64_pred_fcmnevnx8hf */

        case 1:
          if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10284; /* aarch64_pred_fcmnevnx4sf */

        case 2:
          if (!
#line 8659 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10290; /* aarch64_pred_fcmnevnx2df */

        default:
          return -1;
        }

    case 367:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern950 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 8675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10291; /* aarch64_pred_fcmuovnx8hf */

        case E_VNx4BImode:
          if (pattern950 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 8675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10292; /* aarch64_pred_fcmuovnx4sf */

        case E_VNx2BImode:
          if (pattern950 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 8675 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10293; /* aarch64_pred_fcmuovnx2df */

        default:
          return -1;
        }

    case 439:
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern879 (x2, 
E_VNx4SFmode, 
E_VNx8BFmode, 
E_VNx4BImode) != 0
              || !
#line 10139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
            return -1;
          return 11117; /* aarch64_sve_cvtntvnx8bf */

        case E_VNx8HFmode:
          if (pattern879 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
              || !
#line 3217 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12797; /* aarch64_sve_cvtntvnx8hf */

        case E_VNx4SFmode:
          if (pattern879 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
              || !
#line 3217 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12798; /* aarch64_sve_cvtntvnx4sf */

        default:
          return -1;
        }

    case 120:
      if (GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 348 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11408; /* aarch64_gather_ld1q */

    case 122:
      return recog_415 (x1, insn, pnum_clobbers);

    case 541:
      return recog_412 (x1, insn, pnum_clobbers);

    case 542:
      return recog_411 (x1, insn, pnum_clobbers);

    case 622:
      if (pattern223 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!aarch64_reg_or_zero (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11561; /* aarch64_scatter_st1q */

    case 124:
      return recog_403 (x1, insn, pnum_clobbers);

    case 481:
      return recog_407 (x1, insn, pnum_clobbers);

    case 443:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 84
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_VNx16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx16QImode))
        return -1;
      switch (pattern1068 (x2))
        {
        case 0:
          if (!
#line 2149 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx8HFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12240; /* aarch64_sve_dotvnx8hf */

        case 1:
          if (!
#line 2149 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx4SFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12241; /* aarch64_sve_dotvnx4sf */

        default:
          return -1;
        }

    case 441:
      if (GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      if (!register_operand (operands[1], E_VNx4SFmode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DFmode)
          || !
#line 3307 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12802; /* aarch64_sve2_cvtxntvnx2df */

    case 136:
      switch (pattern224 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12861; /* aarch64_sve_whilege_b8_x2 */

        case 1:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12869; /* aarch64_sve_whilege_b16_x2 */

        case 2:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12877; /* aarch64_sve_whilege_b32_x2 */

        case 3:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12885; /* aarch64_sve_whilege_b64_x2 */

        default:
          return -1;
        }

    case 137:
      switch (pattern224 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12862; /* aarch64_sve_whilegt_b8_x2 */

        case 1:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12870; /* aarch64_sve_whilegt_b16_x2 */

        case 2:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12878; /* aarch64_sve_whilegt_b32_x2 */

        case 3:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12886; /* aarch64_sve_whilegt_b64_x2 */

        default:
          return -1;
        }

    case 138:
      switch (pattern224 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12863; /* aarch64_sve_whileugt_b8_x2 */

        case 1:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12871; /* aarch64_sve_whileugt_b16_x2 */

        case 2:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12879; /* aarch64_sve_whileugt_b32_x2 */

        case 3:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12887; /* aarch64_sve_whileugt_b64_x2 */

        default:
          return -1;
        }

    case 139:
      switch (pattern224 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12864; /* aarch64_sve_whileuge_b8_x2 */

        case 1:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12872; /* aarch64_sve_whileuge_b16_x2 */

        case 2:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12880; /* aarch64_sve_whileuge_b32_x2 */

        case 3:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12888; /* aarch64_sve_whileuge_b64_x2 */

        default:
          return -1;
        }

    case 140:
      switch (pattern224 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12865; /* aarch64_sve_whilele_b8_x2 */

        case 1:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12873; /* aarch64_sve_whilele_b16_x2 */

        case 2:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12881; /* aarch64_sve_whilele_b32_x2 */

        case 3:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12889; /* aarch64_sve_whilele_b64_x2 */

        default:
          return -1;
        }

    case 141:
      switch (pattern224 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12866; /* aarch64_sve_whileult_b8_x2 */

        case 1:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12874; /* aarch64_sve_whileult_b16_x2 */

        case 2:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12882; /* aarch64_sve_whileult_b32_x2 */

        case 3:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12890; /* aarch64_sve_whileult_b64_x2 */

        default:
          return -1;
        }

    case 142:
      switch (pattern224 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12867; /* aarch64_sve_whileule_b8_x2 */

        case 1:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12875; /* aarch64_sve_whileule_b16_x2 */

        case 2:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12883; /* aarch64_sve_whileule_b32_x2 */

        case 3:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12891; /* aarch64_sve_whileule_b64_x2 */

        default:
          return -1;
        }

    case 143:
      switch (pattern224 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12868; /* aarch64_sve_whilelt_b8_x2 */

        case 1:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12876; /* aarch64_sve_whilelt_b16_x2 */

        case 2:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12884; /* aarch64_sve_whilelt_b32_x2 */

        case 3:
          if (!
#line 3665 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12892; /* aarch64_sve_whilelt_b64_x2 */

        default:
          return -1;
        }

    case 632:
      return recog_406 (x1, insn, pnum_clobbers);

    case 699:
      return recog_405 (x1, insn, pnum_clobbers);

    case 701:
      return recog_404 (x1, insn, pnum_clobbers);

    case 650:
      return recog_402 (x1, insn, pnum_clobbers);

    case 651:
      return recog_401 (x1, insn, pnum_clobbers);

    case 679:
      return recog_408 (x1, insn, pnum_clobbers);

    case 703:
      return recog_399 (x1, insn, pnum_clobbers);

    case 633:
      return recog_426 (x1, insn, pnum_clobbers);

    case 663:
      return recog_425 (x1, insn, pnum_clobbers);

    case 639:
      return recog_410 (x1, insn, pnum_clobbers);

    case 646:
      return recog_409 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern610 (x2, 
E_SImode))
                {
                case 0:
                  return 256; /* *add_zero_extendqi_si */

                case 1:
                  return 260; /* *add_zero_extendhi_si */

                case 2:
                  return 264; /* *add_zero_extendsi_si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern610 (x2, 
E_DImode))
                {
                case 0:
                  return 258; /* *add_zero_extendqi_di */

                case 1:
                  return 262; /* *add_zero_extendhi_di */

                case 2:
                  return 266; /* *add_zero_extendsi_di */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern611 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4723 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3107; /* aarch64_uaddwv8qi */

            case E_V4SImode:
              if (pattern611 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4723 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3109; /* aarch64_uaddwv4hi */

            case E_V2DImode:
              if (pattern611 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4723 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3111; /* aarch64_uaddwv2si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern296 (x2))
            {
            case 0:
              if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3078; /* aarch64_uaddlv8qi */

            case 1:
              if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3082; /* aarch64_uaddlv4hi */

            case 2:
              if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3086; /* aarch64_uaddlv2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SMAX:
          switch (pattern617 (x2, 
SMIN))
            {
            case 0:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1731; /* aarch64_sabalv8qi */

            case 1:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1733; /* aarch64_sabalv4hi */

            case 2:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1735; /* aarch64_sabalv2si */

            case 3:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1737; /* aarch64_sabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1739; /* aarch64_sabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1741; /* aarch64_sabal2v4si_insn */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern617 (x2, 
UMIN))
            {
            case 0:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1732; /* aarch64_uabalv8qi */

            case 1:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1734; /* aarch64_uabalv4hi */

            case 2:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1736; /* aarch64_uabalv2si */

            case 3:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1738; /* aarch64_uabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1740; /* aarch64_uabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1742; /* aarch64_uabal2v4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          switch (pattern612 (x2))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3054; /* aarch64_uaddlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3066; /* aarch64_uaddlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3058; /* aarch64_uaddlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3070; /* aarch64_uaddlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3062; /* aarch64_uaddlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3074; /* aarch64_uaddlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern614 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4736 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3113; /* aarch64_uaddwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4749 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3119; /* aarch64_uaddw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4736 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3115; /* aarch64_uaddwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4749 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3121; /* aarch64_uaddw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4736 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3117; /* aarch64_uaddwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4749 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3123; /* aarch64_uaddw2v4si_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern390 (x2, 
E_DImode) != 0)
        return -1;
      switch (pattern330 (x2))
        {
        case 0:
          if (!
#line 10655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11184; /* aarch64_sve_incdi_pat */

        case 1:
          if (!
#line 10990 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11218; /* *aarch64_sve_incdivnx16bi_cntp */

        case 2:
          if (!
#line 10990 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11221; /* *aarch64_sve_incdivnx8bi_cntp */

        case 3:
          if (!
#line 10990 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11224; /* *aarch64_sve_incdivnx4bi_cntp */

        case 4:
          if (!
#line 10990 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11227; /* *aarch64_sve_incdivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_473 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (aarch64_logical_and_immediate (operands[2], E_SImode))
        return 544; /* *aarch64_andsi_imm2 */
      if (!aarch64_logical_operand (operands[2], E_SImode))
        return -1;
      return 546; /* andsi3 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if (aarch64_logical_and_immediate (operands[2], E_DImode))
        return 545; /* *aarch64_anddi_imm2 */
      if (!aarch64_logical_operand (operands[2], E_DImode))
        return -1;
      return 549; /* anddi3 */

    case E_V8QImode:
      if (pattern651 (x3, 
E_V8QImode) != 0
          || !
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1805; /* andv8qi3 */

    case E_V16QImode:
      if (pattern651 (x3, 
E_V16QImode) != 0
          || !
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1808; /* andv16qi3 */

    case E_V4HImode:
      if (pattern651 (x3, 
E_V4HImode) != 0
          || !
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1809; /* andv4hi3 */

    case E_V8HImode:
      if (pattern651 (x3, 
E_V8HImode) != 0
          || !
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1812; /* andv8hi3 */

    case E_V2SImode:
      if (pattern651 (x3, 
E_V2SImode) != 0
          || !
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1813; /* andv2si3 */

    case E_V4SImode:
      if (pattern651 (x3, 
E_V4SImode) != 0
          || !
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1816; /* andv4si3 */

    case E_V2DImode:
      if (pattern651 (x3, 
E_V2DImode) != 0
          || !
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1817; /* andv2di3 */

    case E_VNx16QImode:
      if (pattern593 (x3, 
E_VNx16QImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8232; /* andvnx16qi3 */

    case E_VNx8QImode:
      if (pattern593 (x3, 
E_VNx8QImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8235; /* andvnx8qi3 */

    case E_VNx4QImode:
      if (pattern593 (x3, 
E_VNx4QImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8238; /* andvnx4qi3 */

    case E_VNx2QImode:
      if (pattern593 (x3, 
E_VNx2QImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8241; /* andvnx2qi3 */

    case E_VNx8HImode:
      if (pattern593 (x3, 
E_VNx8HImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8244; /* andvnx8hi3 */

    case E_VNx4HImode:
      if (pattern593 (x3, 
E_VNx4HImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8247; /* andvnx4hi3 */

    case E_VNx2HImode:
      if (pattern593 (x3, 
E_VNx2HImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8250; /* andvnx2hi3 */

    case E_VNx4SImode:
      if (pattern593 (x3, 
E_VNx4SImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8253; /* andvnx4si3 */

    case E_VNx2SImode:
      if (pattern593 (x3, 
E_VNx2SImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8256; /* andvnx2si3 */

    case E_VNx2DImode:
      if (pattern593 (x3, 
E_VNx2DImode) != 0
          || !
#line 4838 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8259; /* andvnx2di3 */

    case E_VNx8BImode:
      if (pattern34 (x3, 
E_VNx8BImode) != 0
          || !
#line 6906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9124; /* andvnx8bi3 */

    case E_VNx4BImode:
      if (pattern34 (x3, 
E_VNx4BImode) != 0
          || !
#line 6906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9125; /* andvnx4bi3 */

    case E_VNx2BImode:
      if (pattern34 (x3, 
E_VNx2BImode) != 0
          || !
#line 6906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9126; /* andvnx2bi3 */

    default:
      return -1;
    }
}

 int
recog_477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 5; /* indirect_jump */

    case ZERO_EXTRACT:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 2);
      operands[1] = x6;
      if (const_int_operand (operands[1], E_VOIDmode))
        {
          x3 = XEXP (x1, 1);
          operands[2] = x3;
          switch (XWINT (x4, 0))
            {
            case 8L:
              switch (pattern1010 (x2))
                {
                case 0:
                  if (
#line 6561 "../../gcc/config/aarch64/aarch64.md"
(multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 32))
                    return 860; /* *insv_regsi_8 */
                  break;

                case 1:
                  if (
#line 6561 "../../gcc/config/aarch64/aarch64.md"
(multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
                    return 863; /* *insv_regdi_8 */
                  break;

                default:
                  break;
                }
              break;

            case 16L:
              switch (pattern1010 (x2))
                {
                case 0:
                  if (
#line 6561 "../../gcc/config/aarch64/aarch64.md"
(multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
                    return 861; /* *insv_regsi_16 */
                  break;

                case 1:
                  if (
#line 6561 "../../gcc/config/aarch64/aarch64.md"
(multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
                    return 864; /* *insv_regdi_16 */
                  break;

                default:
                  break;
                }
              break;

            case 32L:
              switch (pattern1010 (x2))
                {
                case 0:
                  if (
#line 6561 "../../gcc/config/aarch64/aarch64.md"
(multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 32))
                    return 862; /* *insv_regsi_32 */
                  break;

                case 1:
                  if (
#line 6561 "../../gcc/config/aarch64/aarch64.md"
(multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64))
                    return 865; /* *insv_regdi_32 */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x4;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[3] = x3;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[3], E_SImode)
              || !
#line 6581 "../../gcc/config/aarch64/aarch64.md"
(!(UINTVAL (operands[1]) == 0
     || (UINTVAL (operands[2]) + UINTVAL (operands[1])
	 > GET_MODE_BITSIZE (SImode)))))
            return -1;
          return 866; /* *insv_regsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[3], E_DImode)
              || !
#line 6581 "../../gcc/config/aarch64/aarch64.md"
(!(UINTVAL (operands[1]) == 0
     || (UINTVAL (operands[2]) + UINTVAL (operands[1])
	 > GET_MODE_BITSIZE (DImode)))))
            return -1;
          return 867; /* *insv_regdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16QImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx16QImode)
              || !
#line 694 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (VNx16QImode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((lra_in_progress || reload_completed)
       || (register_operand (operands[0], VNx16QImode)
	   && nonmemory_operand (operands[1], VNx16QImode)))))
            return -1;
          return 5579; /* *aarch64_sve_movvnx16qi_ldr_str */

        case E_VNx8HImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx8HImode)
              || !
#line 694 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (VNx8HImode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((lra_in_progress || reload_completed)
       || (register_operand (operands[0], VNx8HImode)
	   && nonmemory_operand (operands[1], VNx8HImode)))))
            return -1;
          return 5580; /* *aarch64_sve_movvnx8hi_ldr_str */

        case E_VNx4SImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx4SImode)
              || !
#line 694 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (VNx4SImode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((lra_in_progress || reload_completed)
       || (register_operand (operands[0], VNx4SImode)
	   && nonmemory_operand (operands[1], VNx4SImode)))))
            return -1;
          return 5581; /* *aarch64_sve_movvnx4si_ldr_str */

        case E_VNx2DImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx2DImode)
              || !
#line 694 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (VNx2DImode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((lra_in_progress || reload_completed)
       || (register_operand (operands[0], VNx2DImode)
	   && nonmemory_operand (operands[1], VNx2DImode)))))
            return -1;
          return 5582; /* *aarch64_sve_movvnx2di_ldr_str */

        case E_VNx8BFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8BFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx8BFmode)
              || !
#line 694 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (VNx8BFmode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((lra_in_progress || reload_completed)
       || (register_operand (operands[0], VNx8BFmode)
	   && nonmemory_operand (operands[1], VNx8BFmode)))))
            return -1;
          return 5583; /* *aarch64_sve_movvnx8bf_ldr_str */

        case E_VNx8HFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx8HFmode)
              || !
#line 694 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (VNx8HFmode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((lra_in_progress || reload_completed)
       || (register_operand (operands[0], VNx8HFmode)
	   && nonmemory_operand (operands[1], VNx8HFmode)))))
            return -1;
          return 5584; /* *aarch64_sve_movvnx8hf_ldr_str */

        case E_VNx4SFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx4SFmode)
              || !
#line 694 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (VNx4SFmode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((lra_in_progress || reload_completed)
       || (register_operand (operands[0], VNx4SFmode)
	   && nonmemory_operand (operands[1], VNx4SFmode)))))
            return -1;
          return 5585; /* *aarch64_sve_movvnx4sf_ldr_str */

        case E_VNx2DFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx2DFmode)
              || !
#line 694 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (VNx2DFmode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((lra_in_progress || reload_completed)
       || (register_operand (operands[0], VNx2DFmode)
	   && nonmemory_operand (operands[1], VNx2DFmode)))))
            return -1;
          return 5586; /* *aarch64_sve_movvnx2df_ldr_str */

        case E_VNx32QImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx32QImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx32QImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5695; /* *aarch64_sve_movvnx32qi_le */

        case E_VNx16HImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16HImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx16HImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5696; /* *aarch64_sve_movvnx16hi_le */

        case E_VNx8SImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8SImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx8SImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5697; /* *aarch64_sve_movvnx8si_le */

        case E_VNx4DImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4DImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx4DImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5698; /* *aarch64_sve_movvnx4di_le */

        case E_VNx16BFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16BFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx16BFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5699; /* *aarch64_sve_movvnx16bf_le */

        case E_VNx16HFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16HFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx16HFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5700; /* *aarch64_sve_movvnx16hf_le */

        case E_VNx8SFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8SFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx8SFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5701; /* *aarch64_sve_movvnx8sf_le */

        case E_VNx4DFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4DFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx4DFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5702; /* *aarch64_sve_movvnx4df_le */

        case E_VNx48QImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx48QImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx48QImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5703; /* *aarch64_sve_movvnx48qi_le */

        case E_VNx24HImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx24HImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx24HImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5704; /* *aarch64_sve_movvnx24hi_le */

        case E_VNx12SImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx12SImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx12SImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5705; /* *aarch64_sve_movvnx12si_le */

        case E_VNx6DImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx6DImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx6DImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5706; /* *aarch64_sve_movvnx6di_le */

        case E_VNx24BFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx24BFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx24BFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5707; /* *aarch64_sve_movvnx24bf_le */

        case E_VNx24HFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx24HFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx24HFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5708; /* *aarch64_sve_movvnx24hf_le */

        case E_VNx12SFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx12SFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx12SFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5709; /* *aarch64_sve_movvnx12sf_le */

        case E_VNx6DFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx6DFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx6DFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5710; /* *aarch64_sve_movvnx6df_le */

        case E_VNx64QImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx64QImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx64QImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5711; /* *aarch64_sve_movvnx64qi_le */

        case E_VNx32HImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx32HImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx32HImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5712; /* *aarch64_sve_movvnx32hi_le */

        case E_VNx16SImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16SImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx16SImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5713; /* *aarch64_sve_movvnx16si_le */

        case E_VNx8DImode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8DImode)
              || !aarch64_sve_general_operand (operands[1], E_VNx8DImode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5714; /* *aarch64_sve_movvnx8di_le */

        case E_VNx32BFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx32BFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx32BFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5715; /* *aarch64_sve_movvnx32bf_le */

        case E_VNx32HFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx32HFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx32HFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5716; /* *aarch64_sve_movvnx32hf_le */

        case E_VNx16SFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16SFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx16SFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5717; /* *aarch64_sve_movvnx16sf_le */

        case E_VNx8DFmode:
          if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8DFmode)
              || !aarch64_sve_general_operand (operands[1], E_VNx8DFmode)
              || !
#line 874 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          return 5718; /* *aarch64_sve_movvnx8df_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_485 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (GET_MODE (x2) == E_QImode)
        {
          if (memory_operand (operands[0], E_QImode)
              && const_int_operand (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0))
                    return 1339; /* aarch64_store_lane0v8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (16, INTVAL (operands[2])) == 0))
                    return 1340; /* aarch64_store_lane0v16qi */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_simd_nonimmediate_operand (operands[0], E_QImode)
              && immediate_operand (operands[2], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2976; /* aarch64_get_lanev8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2977; /* aarch64_get_lanev16qi */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case E_HImode:
      if (GET_MODE (x2) == E_HImode)
        {
          if (memory_operand (operands[0], E_HImode)
              && const_int_operand (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0))
                    return 1341; /* aarch64_store_lane0v4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0))
                    return 1342; /* aarch64_store_lane0v8hi */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_simd_nonimmediate_operand (operands[0], E_HImode)
              && immediate_operand (operands[2], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2978; /* aarch64_get_lanev4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2979; /* aarch64_get_lanev8hi */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case E_SImode:
      if (GET_MODE (x2) == E_SImode)
        {
          if (memory_operand (operands[0], E_SImode)
              && const_int_operand (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0))
                    return 1343; /* aarch64_store_lane0v2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0))
                    return 1344; /* aarch64_store_lane0v4si */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_simd_nonimmediate_operand (operands[0], E_SImode)
              && immediate_operand (operands[2], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2980; /* aarch64_get_lanev2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2981; /* aarch64_get_lanev4si */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case E_DImode:
      if (GET_MODE (x2) == E_DImode
          && register_operand (operands[1], E_V2DImode))
        {
          if (memory_operand (operands[0], E_DImode)
              && const_int_operand (operands[2], E_VOIDmode)
              && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0))
            return 1345; /* aarch64_store_lane0v2di */
          if (aarch64_simd_nonimmediate_operand (operands[0], E_DImode)
              && immediate_operand (operands[2], E_SImode))
            {
              if (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2982; /* aarch64_get_lanev2di */
              if (
#line 4312 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 1))
                return 2990; /* *aarch64_get_highv2di */
            }
        }
      break;

    case E_HFmode:
      if (GET_MODE (x2) == E_HFmode)
        {
          if (memory_operand (operands[0], E_HFmode)
              && const_int_operand (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0))
                    return 1346; /* aarch64_store_lane0v4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0))
                    return 1347; /* aarch64_store_lane0v8hf */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_simd_nonimmediate_operand (operands[0], E_HFmode)
              && immediate_operand (operands[2], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2983; /* aarch64_get_lanev4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2984; /* aarch64_get_lanev8hf */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case E_BFmode:
      if (GET_MODE (x2) == E_BFmode)
        {
          if (memory_operand (operands[0], E_BFmode)
              && const_int_operand (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4BFmode:
                  if (register_operand (operands[1], E_V4BFmode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0))
                    return 1348; /* aarch64_store_lane0v4bf */
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[1], E_V8BFmode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0))
                    return 1349; /* aarch64_store_lane0v8bf */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_simd_nonimmediate_operand (operands[0], E_BFmode)
              && immediate_operand (operands[2], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4BFmode:
                  if (register_operand (operands[1], E_V4BFmode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2985; /* aarch64_get_lanev4bf */
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[1], E_V8BFmode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2986; /* aarch64_get_lanev8bf */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case E_SFmode:
      if (GET_MODE (x2) == E_SFmode)
        {
          if (memory_operand (operands[0], E_SFmode)
              && const_int_operand (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0))
                    return 1350; /* aarch64_store_lane0v2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0))
                    return 1351; /* aarch64_store_lane0v4sf */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_simd_nonimmediate_operand (operands[0], E_SFmode)
              && immediate_operand (operands[2], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2987; /* aarch64_get_lanev2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2988; /* aarch64_get_lanev4sf */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case E_DFmode:
      if (GET_MODE (x2) == E_DFmode
          && register_operand (operands[1], E_V2DFmode))
        {
          if (memory_operand (operands[0], E_DFmode)
              && const_int_operand (operands[2], E_VOIDmode)
              && 
#line 228 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0))
            return 1352; /* aarch64_store_lane0v2df */
          if (aarch64_simd_nonimmediate_operand (operands[0], E_DFmode)
              && immediate_operand (operands[2], E_SImode))
            {
              if (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2989; /* aarch64_get_lanev2df */
              if (
#line 4312 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 1))
                return 2991; /* *aarch64_get_highv2df */
            }
        }
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  if (XWINT (x4, 0) == 0L)
    {
      switch (pattern697 (x2))
        {
        case 0:
          if (
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6552; /* *vec_extractvnx16qiqi_0 */
          break;

        case 1:
          if (
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6553; /* *vec_extractvnx8hihi_0 */
          break;

        case 2:
          if (
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6554; /* *vec_extractvnx4sisi_0 */
          break;

        case 3:
          if (
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6555; /* *vec_extractvnx2didi_0 */
          break;

        case 4:
          if (
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6556; /* *vec_extractvnx8bfbf_0 */
          break;

        case 5:
          if (
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6557; /* *vec_extractvnx8hfhf_0 */
          break;

        case 6:
          if (
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6558; /* *vec_extractvnx4sfsf_0 */
          break;

        case 7:
          if (
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6559; /* *vec_extractvnx2dfdf_0 */
          break;

        default:
          break;
        }
    }
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[1], E_VNx16QImode))
        return -1;
      if (aarch64_simd_nonimmediate_operand (operands[0], E_QImode)
          && 
#line 3098 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (QImode), 1, 15)))
        return 6560; /* *vec_extractvnx16qiqi_v128 */
      if (!register_operand (operands[0], E_QImode))
        return -1;
      if (
#line 3124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (QImode), 16, 63)))
        return 6568; /* *vec_extractvnx16qiqi_dup */
      if (!
#line 3139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && INTVAL (operands[2]) * GET_MODE_SIZE (QImode) >= 64))
        return -1;
      return 6576; /* *vec_extractvnx16qiqi_ext */

    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_VNx8HImode))
        return -1;
      if (aarch64_simd_nonimmediate_operand (operands[0], E_HImode)
          && 
#line 3098 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (HImode), 1, 15)))
        return 6561; /* *vec_extractvnx8hihi_v128 */
      if (!register_operand (operands[0], E_HImode))
        return -1;
      if (
#line 3124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (HImode), 16, 63)))
        return 6569; /* *vec_extractvnx8hihi_dup */
      if (!
#line 3139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && INTVAL (operands[2]) * GET_MODE_SIZE (HImode) >= 64))
        return -1;
      return 6577; /* *vec_extractvnx8hihi_ext */

    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_VNx4SImode))
        return -1;
      if (aarch64_simd_nonimmediate_operand (operands[0], E_SImode)
          && 
#line 3098 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (SImode), 1, 15)))
        return 6562; /* *vec_extractvnx4sisi_v128 */
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (
#line 3124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (SImode), 16, 63)))
        return 6570; /* *vec_extractvnx4sisi_dup */
      if (!
#line 3139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && INTVAL (operands[2]) * GET_MODE_SIZE (SImode) >= 64))
        return -1;
      return 6578; /* *vec_extractvnx4sisi_ext */

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      if (aarch64_simd_nonimmediate_operand (operands[0], E_DImode)
          && 
#line 3098 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (DImode), 1, 15)))
        return 6563; /* *vec_extractvnx2didi_v128 */
      if (!register_operand (operands[0], E_DImode))
        return -1;
      if (
#line 3124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (DImode), 16, 63)))
        return 6571; /* *vec_extractvnx2didi_dup */
      if (!
#line 3139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && INTVAL (operands[2]) * GET_MODE_SIZE (DImode) >= 64))
        return -1;
      return 6579; /* *vec_extractvnx2didi_ext */

    case E_BFmode:
      if (GET_MODE (x2) != E_BFmode
          || !register_operand (operands[1], E_VNx8BFmode))
        return -1;
      if (aarch64_simd_nonimmediate_operand (operands[0], E_BFmode)
          && 
#line 3098 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (BFmode), 1, 15)))
        return 6564; /* *vec_extractvnx8bfbf_v128 */
      if (!register_operand (operands[0], E_BFmode))
        return -1;
      if (
#line 3124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (BFmode), 16, 63)))
        return 6572; /* *vec_extractvnx8bfbf_dup */
      if (!
#line 3139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && INTVAL (operands[2]) * GET_MODE_SIZE (BFmode) >= 64))
        return -1;
      return 6580; /* *vec_extractvnx8bfbf_ext */

    case E_HFmode:
      if (GET_MODE (x2) != E_HFmode
          || !register_operand (operands[1], E_VNx8HFmode))
        return -1;
      if (aarch64_simd_nonimmediate_operand (operands[0], E_HFmode)
          && 
#line 3098 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (HFmode), 1, 15)))
        return 6565; /* *vec_extractvnx8hfhf_v128 */
      if (!register_operand (operands[0], E_HFmode))
        return -1;
      if (
#line 3124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (HFmode), 16, 63)))
        return 6573; /* *vec_extractvnx8hfhf_dup */
      if (!
#line 3139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && INTVAL (operands[2]) * GET_MODE_SIZE (HFmode) >= 64))
        return -1;
      return 6581; /* *vec_extractvnx8hfhf_ext */

    case E_SFmode:
      if (GET_MODE (x2) != E_SFmode
          || !register_operand (operands[1], E_VNx4SFmode))
        return -1;
      if (aarch64_simd_nonimmediate_operand (operands[0], E_SFmode)
          && 
#line 3098 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (SFmode), 1, 15)))
        return 6566; /* *vec_extractvnx4sfsf_v128 */
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      if (
#line 3124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (SFmode), 16, 63)))
        return 6574; /* *vec_extractvnx4sfsf_dup */
      if (!
#line 3139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && INTVAL (operands[2]) * GET_MODE_SIZE (SFmode) >= 64))
        return -1;
      return 6582; /* *vec_extractvnx4sfsf_ext */

    case E_DFmode:
      if (GET_MODE (x2) != E_DFmode
          || !register_operand (operands[1], E_VNx2DFmode))
        return -1;
      if (aarch64_simd_nonimmediate_operand (operands[0], E_DFmode)
          && 
#line 3098 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (DFmode), 1, 15)))
        return 6567; /* *vec_extractvnx2dfdf_v128 */
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      if (
#line 3124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * GET_MODE_SIZE (DFmode), 16, 63)))
        return 6575; /* *vec_extractvnx2dfdf_dup */
      if (!
#line 3139 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && INTVAL (operands[2]) * GET_MODE_SIZE (DFmode) >= 64))
        return -1;
      return 6583; /* *vec_extractvnx2dfdf_ext */

    default:
      return -1;
    }
}

 int
recog_497 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      switch (pattern418 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1371; /* iornv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1375; /* iornv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1379; /* iornv2si3_vec_concatz_be */

        case 3:
          if (pattern904 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1820; /* iorv8qi3_vec_concatz_be */

        case 4:
          if (pattern904 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1824; /* iorv4hi3_vec_concatz_be */

        case 5:
          if (pattern904 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1828; /* iorv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case AND:
      switch (pattern418 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1384; /* andnv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1388; /* andnv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1392; /* andnv2si3_vec_concatz_be */

        case 3:
          if (pattern905 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1807; /* andv8qi3_vec_concatz_be */

        case 4:
          if (pattern905 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1811; /* andv4hi3_vec_concatz_be */

        case 5:
          if (pattern905 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1815; /* andv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case PLUS:
      return recog_487 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_492 (x1, insn, pnum_clobbers);

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern424 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1423; /* mulv8qi3_vec_concatz_be */

        case E_V8HImode:
          if (pattern424 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1427; /* mulv4hi3_vec_concatz_be */

        case E_V4SImode:
          if (pattern424 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1431; /* mulv2si3_vec_concatz_be */

        case E_V8HFmode:
          if (pattern424 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2422; /* mulv4hf3_vec_concatz_be */

        case E_V4SFmode:
          if (pattern424 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2426; /* mulv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case BITREVERSE:
      if (pattern419 (x2) != 0
          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 380 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 1440; /* aarch64_rbitv8qi_vec_concatz_be */

    case UNSPEC:
      return recog_489 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_490 (x1, insn, pnum_clobbers);

    case ABS:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern533 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1656; /* absv8qi2_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1660; /* absv4hi2_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1664; /* absv2si2_vec_concatz_be */

            case 3:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2450; /* absv4hf2_vec_concatz_be */

            case 4:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2454; /* absv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case MINUS:
          x4 = XEXP (x2, 0);
          operands[3] = x4;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern537 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 1793; /* fabdv4hf3_vec_concatz_be */

            case E_V4SFmode:
              if (pattern537 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1797; /* fabdv2sf3_vec_concatz_be */

            case E_V2DFmode:
              if (pattern537 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1804; /* fabddf3_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_493 (x1, insn, pnum_clobbers);

    case NOT:
      switch (pattern421 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1846; /* one_cmplv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1850; /* one_cmplv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1854; /* one_cmplv2si2_vec_concatz_be */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1271 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1911; /* aarch64_simd_lshrv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1271 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1915; /* aarch64_simd_lshrv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1271 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1919; /* aarch64_simd_lshrv2si_vec_concatz_be */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1924; /* aarch64_simd_ashrv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1928; /* aarch64_simd_ashrv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1932; /* aarch64_simd_ashrv2si_vec_concatz_be */

        default:
          return -1;
        }

    case ASHIFT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case CONST_VECTOR:
        case CONST:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern908 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1395 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1974; /* aarch64_simd_imm_shlv8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern908 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1395 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1978; /* aarch64_simd_imm_shlv4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern908 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1395 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1982; /* aarch64_simd_imm_shlv2si_vec_concatz_be */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern424 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1406 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1987; /* aarch64_simd_reg_sshlv8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern424 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1406 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1991; /* aarch64_simd_reg_sshlv4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern424 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1406 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1995; /* aarch64_simd_reg_sshlv2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2116; /* smaxv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2132; /* smaxv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2148; /* smaxv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2119; /* sminv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2135; /* sminv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2151; /* sminv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2122; /* umaxv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2138; /* umaxv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2154; /* umaxv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2125; /* uminv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2141; /* uminv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2157; /* uminv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case DIV:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern424 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2694 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2431; /* *divv4hf3_vec_concatz_be */

        case E_V4SFmode:
          if (pattern424 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2694 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2435; /* *divv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case FMA:
      return recog_491 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern539 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3273 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2704; /* truncv2dfv2sf2_vec_concatz_be */

        case E_V8HFmode:
          if (pattern539 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3273 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2707; /* truncv4sfv4hf2_vec_concatz_be */

        default:
          return -1;
        }

    case CLRSB:
      switch (pattern421 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2862; /* clrsbv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2866; /* clrsbv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2870; /* clrsbv2si2_vec_concatz_be */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern421 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2874; /* clzv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2878; /* clzv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2882; /* clzv2si2_vec_concatz_be */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pattern419 (x2) != 0
          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3585 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 2886; /* popcountv8qi2_vec_concatz_be */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern772 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3042; /* *aarch64_combinez_bev8qi */

        case E_V8HImode:
          if (pattern772 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3043; /* *aarch64_combinez_bev4hi */

        case E_V8BFmode:
          if (pattern772 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3044; /* *aarch64_combinez_bev4bf */

        case E_V8HFmode:
          if (pattern772 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3045; /* *aarch64_combinez_bev4hf */

        case E_V4SImode:
          if (pattern772 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3046; /* *aarch64_combinez_bev2si */

        case E_V4SFmode:
          if (pattern772 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3047; /* *aarch64_combinez_bev2sf */

        case E_V2SImode:
          if (pattern772 (x2, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3048; /* *aarch64_combinez_besi */

        case E_V2SFmode:
          if (pattern772 (x2, 
E_SFmode, 
E_V2SFmode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3049; /* *aarch64_combinez_besf */

        case E_V2DImode:
          if (pattern772 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3050; /* *aarch64_combinez_bedi */

        case E_V2DFmode:
          if (pattern772 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4425 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && BYTES_BIG_ENDIAN))
            return -1;
          return 3051; /* *aarch64_combinez_bedf */

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_488 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3289; /* ssaddv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3305; /* ssaddv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3321; /* ssaddv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3292; /* usaddv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3308; /* usaddv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3324; /* usaddv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3295; /* sssubv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3311; /* sssubv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3327; /* sssubv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3298; /* ussubv8qi3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3314; /* ussubv4hi3_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3330; /* ussubv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern540 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3401; /* aarch64_sqmovnv8hi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3407; /* aarch64_sqmovnv4si_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3413; /* aarch64_sqmovnv2di_vec_concatz_be */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern549 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3946; /* *aarch64_sqsshrn_nv8hi_insn_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3964; /* *aarch64_sqsshrn_nv4si_insn_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3982; /* *aarch64_sqsshrn_nv2di_insn_vec_concatz_be */

            case 3:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 4000; /* *aarch64_sqrshrn_nv8hi_insn_vec_concatz_be */

            case 4:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 4009; /* *aarch64_sqrshrn_nv4si_insn_vec_concatz_be */

            case 5:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 4018; /* *aarch64_sqrshrn_nv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern550 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                return -1;
              return 3949; /* *aarch64_sqshrn_nv8hi_insn_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                return -1;
              return 3967; /* *aarch64_sqshrn_nv4si_insn_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                return -1;
              return 3985; /* *aarch64_sqshrn_nv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_TRUNCATE:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern540 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3404; /* aarch64_uqmovnv8hi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3410; /* aarch64_uqmovnv4si_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3416; /* aarch64_uqmovnv2di_vec_concatz_be */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern550 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3952; /* *aarch64_uqsshrn_nv8hi_insn_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3970; /* *aarch64_uqsshrn_nv4si_insn_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3988; /* *aarch64_uqsshrn_nv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern549 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT))))
                return -1;
              return 3955; /* *aarch64_uqshrn_nv8hi_insn_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT))))
                return -1;
              return 3973; /* *aarch64_uqshrn_nv4si_insn_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT))))
                return -1;
              return 3991; /* *aarch64_uqshrn_nv2di_insn_vec_concatz_be */

            case 3:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 4003; /* *aarch64_uqrshrn_nv8hi_insn_vec_concatz_be */

            case 4:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 4012; /* *aarch64_uqrshrn_nv4si_insn_vec_concatz_be */

            case 5:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 4021; /* *aarch64_uqrshrn_nv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_NEG:
      switch (pattern426 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3449; /* aarch64_sqnegv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3457; /* aarch64_sqnegv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3465; /* aarch64_sqnegv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3481; /* aarch64_sqnegdi_vec_concatz_be */

        default:
          return -1;
        }

    case SS_ABS:
      switch (pattern426 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3452; /* aarch64_sqabsv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3460; /* aarch64_sqabsv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3468; /* aarch64_sqabsv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3484; /* aarch64_sqabsdi_vec_concatz_be */

        default:
          return -1;
        }

    case SQRT:
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern420 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4431; /* *sqrtv4hf2_vec_concatz_be */

        case E_V4SFmode:
          if (pattern420 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4435; /* *sqrtv2sf2_vec_concatz_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 163:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!aarch64_sysreg_string (operands[1], E_VOIDmode))
            return -1;
          return 1; /* aarch64_read_sysregdi */

        case 164:
          if (GET_MODE (x2) != E_TImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_TImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!aarch64_sysreg_string (operands[1], E_VOIDmode)
              || !
#line 663 "../../gcc/config/aarch64/aarch64.md"
(TARGET_D128))
            return -1;
          return 2; /* aarch64_read_sysregti */

        case 3:
          switch (pattern45 (x1))
            {
            case 0:
              return 1221; /* aarch64_get_fpsrsi */

            case 1:
              return 1223; /* aarch64_get_fpsrdi */

            default:
              return -1;
            }

        case 1:
          switch (pattern45 (x1))
            {
            case 0:
              return 1222; /* aarch64_get_fpcrsi */

            case 1:
              return 1224; /* aarch64_get_fpcrdi */

            default:
              return -1;
            }

        case 63:
          if (GET_MODE (x2) != E_V8DImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_V8DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_V8DImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode)
              || !
#line 8634 "../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1274; /* ld64b */

        case 64:
          if (GET_MODE (x2) != E_V8DImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_V8DImode)
              || !
#line 8644 "../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1275; /* st64b */

        case 12:
          if (pattern46 (x1, 
16, 
E_DImode) != 0)
            return -1;
          return 1281; /* aarch64_chkfeat */

        case 13:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 1282; /* aarch64_load_gcspr */

        case 14:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 1283; /* aarch64_gcspopm */

        case 16:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 1286; /* aarch64_gcsss2 */

        case 684:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_TImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 0
              || GET_MODE (x3) != E_TImode)
            return -1;
          *pnum_clobbers = 5;
          return 13144; /* aarch64_get_sme_state */

        case 685:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 13145; /* aarch64_read_svcr */

        default:
          return -1;
        }

    case 2:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 6:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          return 1208; /* probe_stack_range */

        case 7:
          x7 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x7) != USE)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern787 (x2, 
E_QImode) != 0)
                return -1;
              return 1237; /* despeculate_simpleqi */

            case E_HImode:
              if (pattern787 (x2, 
E_HImode) != 0)
                return -1;
              return 1238; /* despeculate_simplehi */

            case E_SImode:
              if (pattern787 (x2, 
E_SImode) != 0)
                return -1;
              return 1239; /* despeculate_simplesi */

            case E_DImode:
              if (pattern788 (x2, 
E_DImode) != 0)
                return -1;
              return 1240; /* despeculate_simpledi */

            case E_TImode:
              if (pattern788 (x2, 
E_TImode) != 0)
                return -1;
              return 1241; /* despeculate_simpleti */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XVECEXP (x2, 0, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              switch (pattern790 (x2))
                {
                case 0:
                  *pnum_clobbers = 3;
                  return 5428; /* aarch64_atomic_addqi */

                case 1:
                  *pnum_clobbers = 3;
                  return 5433; /* aarch64_atomic_addhi */

                case 2:
                  *pnum_clobbers = 3;
                  return 5438; /* aarch64_atomic_addsi */

                case 3:
                  *pnum_clobbers = 3;
                  return 5443; /* aarch64_atomic_adddi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern790 (x2))
                {
                case 0:
                  *pnum_clobbers = 3;
                  return 5429; /* aarch64_atomic_subqi */

                case 1:
                  *pnum_clobbers = 3;
                  return 5434; /* aarch64_atomic_subhi */

                case 2:
                  *pnum_clobbers = 3;
                  return 5439; /* aarch64_atomic_subsi */

                case 3:
                  *pnum_clobbers = 3;
                  return 5444; /* aarch64_atomic_subdi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern792 (x2))
                {
                case 0:
                  *pnum_clobbers = 3;
                  return 5430; /* aarch64_atomic_orqi */

                case 1:
                  *pnum_clobbers = 3;
                  return 5435; /* aarch64_atomic_orhi */

                case 2:
                  *pnum_clobbers = 3;
                  return 5440; /* aarch64_atomic_orsi */

                case 3:
                  *pnum_clobbers = 3;
                  return 5445; /* aarch64_atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern792 (x2))
                {
                case 0:
                  *pnum_clobbers = 3;
                  return 5431; /* aarch64_atomic_xorqi */

                case 1:
                  *pnum_clobbers = 3;
                  return 5436; /* aarch64_atomic_xorhi */

                case 2:
                  *pnum_clobbers = 3;
                  return 5441; /* aarch64_atomic_xorsi */

                case 3:
                  *pnum_clobbers = 3;
                  return 5446; /* aarch64_atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern792 (x2))
                {
                case 0:
                  *pnum_clobbers = 3;
                  return 5432; /* aarch64_atomic_andqi */

                case 1:
                  *pnum_clobbers = 3;
                  return 5437; /* aarch64_atomic_andhi */

                case 2:
                  *pnum_clobbers = 3;
                  return 5442; /* aarch64_atomic_andsi */

                case 3:
                  *pnum_clobbers = 3;
                  return 5447; /* aarch64_atomic_anddi */

                default:
                  return -1;
                }

            case NOT:
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != AND)
                return -1;
              x9 = XEXP (x5, 1);
              operands[1] = x9;
              x10 = XEXP (x5, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1050 (x2, 
E_QImode) != 0)
                    return -1;
                  *pnum_clobbers = 3;
                  return 5464; /* atomic_nandqi */

                case E_HImode:
                  if (pattern1050 (x2, 
E_HImode) != 0)
                    return -1;
                  *pnum_clobbers = 3;
                  return 5465; /* atomic_nandhi */

                case E_SImode:
                  if (pattern1050 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 3;
                  return 5466; /* atomic_nandsi */

                case E_DImode:
                  if (pattern1050 (x2, 
E_DImode) != 0)
                    return -1;
                  *pnum_clobbers = 3;
                  return 5467; /* atomic_nanddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 25:
          switch (pattern374 (x2))
            {
            case 0:
              if (!
#line 687 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC))
                return -1;
              return 5541; /* aarch64_atomic_loadqi_rcpc */

            case 1:
              if (!
#line 687 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC))
                return -1;
              return 5542; /* aarch64_atomic_loadhi_rcpc */

            case 2:
              if (!
#line 687 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC))
                return -1;
              return 5543; /* aarch64_atomic_loadsi_rcpc */

            case 3:
              if (!
#line 687 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC))
                return -1;
              return 5544; /* aarch64_atomic_loaddi_rcpc */

            default:
              return -1;
            }

        case 24:
          switch (pattern374 (x2))
            {
            case 0:
              return 5545; /* aarch64_atomic_loadqi */

            case 1:
              return 5546; /* aarch64_atomic_loadhi */

            case 2:
              return 5547; /* aarch64_atomic_loadsi */

            case 3:
              return 5548; /* aarch64_atomic_loaddi */

            default:
              return -1;
            }

        case 26:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x7 = XVECEXP (x2, 0, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!aarch64_rcpc_memory_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !general_operand (operands[1], E_QImode))
                return -1;
              return 5564; /* atomic_storeqi */

            case E_HImode:
              if (!aarch64_rcpc_memory_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !general_operand (operands[1], E_HImode))
                return -1;
              return 5565; /* atomic_storehi */

            case E_SImode:
              if (!aarch64_rcpc_memory_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !general_operand (operands[1], E_SImode))
                return -1;
              return 5566; /* atomic_storesi */

            case E_DImode:
              if (!aarch64_rcpc_memory_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !general_operand (operands[1], E_DImode))
                return -1;
              return 5567; /* atomic_storedi */

            default:
              return -1;
            }

        case 22:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x7 = XVECEXP (x2, 0, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !aarch64_sync_memory_operand (operands[1], E_SImode))
                return -1;
              return 5570; /* aarch64_load_exclusivesi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !aarch64_sync_memory_operand (operands[1], E_DImode))
                return -1;
              return 5571; /* aarch64_load_exclusivedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x7 = XVECEXP (x2, 0, 1);
      operands[2] = x7;
      switch (XINT (x2, 1))
        {
        case 6:
          x11 = XVECEXP (x2, 0, 2);
          operands[3] = x11;
          x12 = XVECEXP (x2, 0, 3);
          operands[4] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern864 (x2, 
E_SImode) != 0
                  || !(
#line 8137 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE) && 
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
                return -1;
              return 1209; /* probe_sve_stack_clash_si */

            case E_DImode:
              if (pattern864 (x2, 
E_DImode) != 0
                  || !(
#line 8137 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE) && 
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
                return -1;
              return 1210; /* probe_sve_stack_clash_di */

            default:
              return -1;
            }

        case 7:
          x11 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x11) != USE)
            return -1;
          x13 = XEXP (x11, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 15
              || GET_MODE (x13) != E_DImode)
            return -1;
          x12 = XVECEXP (x2, 0, 3);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x14 = XEXP (x12, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 66
              || GET_MODE (x14) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1201 (x2, 
E_QImode) != 0)
                return -1;
              return 1232; /* *despeculate_copyqi_insn */

            case E_HImode:
              if (pattern1201 (x2, 
E_HImode) != 0)
                return -1;
              return 1233; /* *despeculate_copyhi_insn */

            case E_SImode:
              if (pattern1201 (x2, 
E_SImode) != 0)
                return -1;
              return 1234; /* *despeculate_copysi_insn */

            case E_DImode:
              if (pattern1201 (x2, 
E_DImode) != 0)
                return -1;
              return 1235; /* *despeculate_copydi_insn */

            case E_TImode:
              if (pattern1201 (x2, 
E_TImode) != 0)
                return -1;
              return 1236; /* *despeculate_copyti_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      switch (XINT (x2, 1))
        {
        case 32:
          switch (pattern47 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5448; /* aarch64_atomic_iorqi_lse */

            case 1:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5452; /* aarch64_atomic_iorhi_lse */

            case 2:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5456; /* aarch64_atomic_iorsi_lse */

            case 3:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5460; /* aarch64_atomic_iordi_lse */

            default:
              return -1;
            }

        case 33:
          switch (pattern47 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5449; /* aarch64_atomic_bicqi_lse */

            case 1:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5453; /* aarch64_atomic_bichi_lse */

            case 2:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5457; /* aarch64_atomic_bicsi_lse */

            case 3:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5461; /* aarch64_atomic_bicdi_lse */

            default:
              return -1;
            }

        case 34:
          switch (pattern47 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5450; /* aarch64_atomic_xorqi_lse */

            case 1:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5454; /* aarch64_atomic_xorhi_lse */

            case 2:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5458; /* aarch64_atomic_xorsi_lse */

            case 3:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5462; /* aarch64_atomic_xordi_lse */

            default:
              return -1;
            }

        case 35:
          switch (pattern47 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5451; /* aarch64_atomic_addqi_lse */

            case 1:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5455; /* aarch64_atomic_addhi_lse */

            case 2:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5459; /* aarch64_atomic_addsi_lse */

            case 3:
              if (!
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              *pnum_clobbers = 1;
              return 5463; /* aarch64_atomic_adddi_lse */

            default:
              return -1;
            }

        case 36:
          if (pattern48 (x1, 
E_VOIDmode, 
E_VNx16QImode, 
93) != 0)
            return -1;
          return 13158; /* aarch64_asm_update_za */

        case 37:
          if (pattern48 (x1, 
E_VOIDmode, 
E_V8DImode, 
94) != 0)
            return -1;
          return 13159; /* aarch64_asm_update_zt0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      return recog_469 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern814 (x3, 
E_SImode) != 0)
                return -1;
              return 371; /* *subsi3_carryin */

            case E_DImode:
              if (pattern814 (x3, 
E_DImode) != 0)
                return -1;
              return 372; /* *subdi3_carryin */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[3] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern815 (x3, 
E_SImode) != 0)
                return -1;
              return 374; /* *subsi3_carryin_alt */

            case E_DImode:
              if (pattern815 (x3, 
E_DImode) != 0)
                return -1;
              return 375; /* *subdi3_carryin_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern637 (x3, 
E_SImode) != 0)
            return -1;
          return 395; /* *ngcsi */

        case E_DImode:
          if (pattern637 (x3, 
E_DImode) != 0)
            return -1;
          return 396; /* *ngcdi */

        default:
          return -1;
        }

    case UMAX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case CONST_POLY_INT:
          x7 = XEXP (x3, 1);
          if (!rtx_equal_p (x7, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern816 (x3, 
E_SImode) != 0
                  || !
#line 5152 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE))
                return -1;
              return 534; /* aarch64_uqdecsi */

            case E_DImode:
              if (pattern816 (x3, 
E_DImode) != 0
                  || !
#line 5152 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE))
                return -1;
              return 535; /* aarch64_uqdecdi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != UMIN)
            return -1;
          switch (pattern639 (x3))
            {
            case 0:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1686; /* aarch64_uabdv8qi */

            case 1:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1690; /* aarch64_uabdv16qi */

            case 2:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1694; /* aarch64_uabdv4hi */

            case 3:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1698; /* aarch64_uabdv8hi */

            case 4:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1702; /* aarch64_uabdv2si */

            case 5:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1706; /* aarch64_uabdv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != 72057594037927935L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != AND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != CONST_INT
          || XWINT (x8, 0) != 72057594037927935L
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 8592 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
        return -1;
      return 1271; /* subp */

    case SMAX:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != SMIN)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern639 (x3))
        {
        case 0:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1683; /* aarch64_sabdv8qi */

        case 1:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1689; /* aarch64_sabdv16qi */

        case 2:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1691; /* aarch64_sabdv4hi */

        case 3:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1697; /* aarch64_sabdv8hi */

        case 4:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1699; /* aarch64_sabdv2si */

        case 5:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1705; /* aarch64_sabdv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern297 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
              && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3053; /* aarch64_ssublv16qi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
              || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3065; /* aarch64_ssublv16qi_lo_internal */

        case 1:
          if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
              && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3057; /* aarch64_ssublv8hi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
              || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3069; /* aarch64_ssublv8hi_lo_internal */

        case 2:
          if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
              && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3061; /* aarch64_ssublv4si_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
              || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3073; /* aarch64_ssublv4si_lo_internal */

        case 3:
          if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3077; /* aarch64_ssublv8qi */

        case 4:
          if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3081; /* aarch64_ssublv4hi */

        case 5:
          if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3085; /* aarch64_ssublv2si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern297 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
              && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3055; /* aarch64_usublv16qi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
              || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3067; /* aarch64_usublv16qi_lo_internal */

        case 1:
          if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
              && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3059; /* aarch64_usublv8hi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
              || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3071; /* aarch64_usublv8hi_lo_internal */

        case 2:
          if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
              && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3063; /* aarch64_usublv4si_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
              || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3075; /* aarch64_usublv4si_lo_internal */

        case 3:
          if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3079; /* aarch64_usublv8qi */

        case 4:
          if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3083; /* aarch64_usublv4hi */

        case 5:
          if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3087; /* aarch64_usublv2si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 125)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 2
          || XINT (x7, 1) != 125)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      operands[1] = x10;
      x11 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      switch (GET_CODE (x12))
        {
        case SMAX:
          switch (pattern1005 (x3, 
SMIN))
            {
            case 0:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8080; /* aarch64_pred_sabdvnx16qi */

            case 1:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8082; /* aarch64_pred_sabdvnx8qi */

            case 2:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8084; /* aarch64_pred_sabdvnx4qi */

            case 3:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8086; /* aarch64_pred_sabdvnx2qi */

            case 4:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8088; /* aarch64_pred_sabdvnx8hi */

            case 5:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8090; /* aarch64_pred_sabdvnx4hi */

            case 6:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8092; /* aarch64_pred_sabdvnx2hi */

            case 7:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8094; /* aarch64_pred_sabdvnx4si */

            case 8:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8096; /* aarch64_pred_sabdvnx2si */

            case 9:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8098; /* aarch64_pred_sabdvnx2di */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern1005 (x3, 
UMIN))
            {
            case 0:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8081; /* aarch64_pred_uabdvnx16qi */

            case 1:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8083; /* aarch64_pred_uabdvnx8qi */

            case 2:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8085; /* aarch64_pred_uabdvnx4qi */

            case 3:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8087; /* aarch64_pred_uabdvnx2qi */

            case 4:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8089; /* aarch64_pred_uabdvnx8hi */

            case 5:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8091; /* aarch64_pred_uabdvnx4hi */

            case 6:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8093; /* aarch64_pred_uabdvnx2hi */

            case 7:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8095; /* aarch64_pred_uabdvnx4si */

            case 8:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8097; /* aarch64_pred_uabdvnx2si */

            case 9:
              if (!
#line 4423 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8099; /* aarch64_pred_uabdvnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern395 (x3))
        {
        case 0:
          if (!
#line 4139 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 390; /* *aarch64_abssi2_cssc_insn */

        case 1:
          if (!
#line 4139 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 391; /* *aarch64_absdi2_cssc_insn */

        case 2:
          if (!(
#line 7520 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1121; /* abshf2 */

        case 3:
          if (!
#line 7520 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1122; /* abssf2 */

        case 4:
          if (!
#line 7520 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1123; /* absdf2 */

        case 5:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1654; /* absv8qi2 */

        case 6:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1657; /* absv16qi2 */

        case 7:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1658; /* absv4hi2 */

        case 8:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1661; /* absv8hi2 */

        case 9:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1662; /* absv2si2 */

        case 10:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1665; /* absv4si2 */

        case 11:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1666; /* absv2di2 */

        case 12:
          if (!(
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2448; /* absv4hf2 */

        case 13:
          if (!(
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2451; /* absv8hf2 */

        case 14:
          if (!
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2452; /* absv2sf2 */

        case 15:
          if (!
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2455; /* absv4sf2 */

        case 16:
          if (!
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2456; /* absv2df2 */

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern397 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1719; /* aarch64_sabdlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1725; /* aarch64_sabdlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1721; /* aarch64_sabdlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1727; /* aarch64_sabdlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1723; /* aarch64_sabdlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1729; /* aarch64_sabdlv4si_lo_internal */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern397 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1720; /* aarch64_uabdlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1726; /* aarch64_uabdlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1722; /* aarch64_uabdlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1728; /* aarch64_uabdlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1724; /* aarch64_uabdlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1730; /* aarch64_uabdlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HFmode:
              if (pattern369 (x3, 
E_V4HFmode) != 0
                  || !(
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1791; /* fabdv4hf3 */

            case E_V8HFmode:
              if (pattern369 (x3, 
E_V8HFmode) != 0
                  || !(
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1794; /* fabdv8hf3 */

            case E_V2SFmode:
              if (pattern369 (x3, 
E_V2SFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1795; /* fabdv2sf3 */

            case E_V4SFmode:
              if (pattern369 (x3, 
E_V4SFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1798; /* fabdv4sf3 */

            case E_V2DFmode:
              if (pattern369 (x3, 
E_V2DFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1799; /* fabdv2df3 */

            case E_HFmode:
              if (pattern369 (x3, 
E_HFmode) != 0
                  || !(
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1800; /* fabdhf3 */

            case E_SFmode:
              if (pattern369 (x3, 
E_SFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1801; /* fabdsf3 */

            case E_DFmode:
              if (pattern369 (x3, 
E_DFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1802; /* fabddf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 7512 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1118; /* *sqrthf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 7512 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1119; /* *sqrtsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 7512 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1120; /* *sqrtdf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 4429; /* *sqrtv4hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 4432; /* *sqrtv8hf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4433; /* *sqrtv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4436; /* *sqrtv4sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4437; /* *sqrtv2df2 */

    default:
      return -1;
    }
}

 int
recog_548 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10242; /* while_wrsivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10252; /* while_wrdivnx4bi_ptest */
}

 int
recog_552 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10162; /* *while_wrsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10172; /* *while_wrdivnx4bi_cc */
}

 int
recog_557 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10221; /* while_rwsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10231; /* while_rwdivnx8bi_ptest */
}

 int
recog_562 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10121; /* *while_rwsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10131; /* *while_rwdivnx16bi_cc */
}

 int
recog_570 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10120; /* *while_ugesivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10130; /* *while_ugedivnx16bi_cc */
}

 int
recog_579 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10258; /* while_gtsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10268; /* while_gtdivnx2bi_ptest */
}

 int
recog_589 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10217; /* while_gesivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10227; /* while_gedivnx8bi_ptest */
}

 int
recog_599 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  x7 = XVECEXP (x6, 0, 0);
  operands[6] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[7] = x8;
  if (!aarch64_sve_ptrue_flag (operands[7], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  switch (GET_CODE (x9))
    {
    case LT:
      switch (pattern1333 (x1, 
LT))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9643; /* *cmpltvnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9653; /* *cmpltvnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9683; /* *cmpltvnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9663; /* *cmpltvnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9693; /* *cmpltvnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9713; /* *cmpltvnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9673; /* *cmpltvnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9703; /* *cmpltvnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9723; /* *cmpltvnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9733; /* *cmpltvnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9743; /* *cmpltvnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9753; /* *cmpltvnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9783; /* *cmpltvnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9763; /* *cmpltvnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9793; /* *cmpltvnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9813; /* *cmpltvnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9773; /* *cmpltvnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9803; /* *cmpltvnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9823; /* *cmpltvnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9833; /* *cmpltvnx2di_ptest */

        default:
          return -1;
        }

    case LE:
      switch (pattern1333 (x1, 
LE))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9644; /* *cmplevnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9654; /* *cmplevnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9684; /* *cmplevnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9664; /* *cmplevnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9694; /* *cmplevnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9714; /* *cmplevnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9674; /* *cmplevnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9704; /* *cmplevnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9724; /* *cmplevnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9734; /* *cmplevnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9744; /* *cmplevnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9754; /* *cmplevnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9784; /* *cmplevnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9764; /* *cmplevnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9794; /* *cmplevnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9814; /* *cmplevnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9774; /* *cmplevnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9804; /* *cmplevnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9824; /* *cmplevnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9834; /* *cmplevnx2di_ptest */

        default:
          return -1;
        }

    case EQ:
      switch (pattern1333 (x1, 
EQ))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9645; /* *cmpeqvnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9655; /* *cmpeqvnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9685; /* *cmpeqvnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9665; /* *cmpeqvnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9695; /* *cmpeqvnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9715; /* *cmpeqvnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9675; /* *cmpeqvnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9705; /* *cmpeqvnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9725; /* *cmpeqvnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9735; /* *cmpeqvnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9745; /* *cmpeqvnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9755; /* *cmpeqvnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9785; /* *cmpeqvnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9765; /* *cmpeqvnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9795; /* *cmpeqvnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9815; /* *cmpeqvnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9775; /* *cmpeqvnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9805; /* *cmpeqvnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9825; /* *cmpeqvnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9835; /* *cmpeqvnx2di_ptest */

        default:
          return -1;
        }

    case NE:
      switch (pattern1333 (x1, 
NE))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9646; /* *cmpnevnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9656; /* *cmpnevnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9686; /* *cmpnevnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9666; /* *cmpnevnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9696; /* *cmpnevnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9716; /* *cmpnevnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9676; /* *cmpnevnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9706; /* *cmpnevnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9726; /* *cmpnevnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9736; /* *cmpnevnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9746; /* *cmpnevnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9756; /* *cmpnevnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9786; /* *cmpnevnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9766; /* *cmpnevnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9796; /* *cmpnevnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9816; /* *cmpnevnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9776; /* *cmpnevnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9806; /* *cmpnevnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9826; /* *cmpnevnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9836; /* *cmpnevnx2di_ptest */

        default:
          return -1;
        }

    case GE:
      switch (pattern1333 (x1, 
GE))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9647; /* *cmpgevnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9657; /* *cmpgevnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9687; /* *cmpgevnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9667; /* *cmpgevnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9697; /* *cmpgevnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9717; /* *cmpgevnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9677; /* *cmpgevnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9707; /* *cmpgevnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9727; /* *cmpgevnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9737; /* *cmpgevnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9747; /* *cmpgevnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9757; /* *cmpgevnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9787; /* *cmpgevnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9767; /* *cmpgevnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9797; /* *cmpgevnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9817; /* *cmpgevnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9777; /* *cmpgevnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9807; /* *cmpgevnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9827; /* *cmpgevnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9837; /* *cmpgevnx2di_ptest */

        default:
          return -1;
        }

    case GT:
      switch (pattern1333 (x1, 
GT))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9648; /* *cmpgtvnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9658; /* *cmpgtvnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9688; /* *cmpgtvnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9668; /* *cmpgtvnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9698; /* *cmpgtvnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9718; /* *cmpgtvnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9678; /* *cmpgtvnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9708; /* *cmpgtvnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9728; /* *cmpgtvnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9738; /* *cmpgtvnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9748; /* *cmpgtvnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9758; /* *cmpgtvnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9788; /* *cmpgtvnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9768; /* *cmpgtvnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9798; /* *cmpgtvnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9818; /* *cmpgtvnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9778; /* *cmpgtvnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9808; /* *cmpgtvnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9828; /* *cmpgtvnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9838; /* *cmpgtvnx2di_ptest */

        default:
          return -1;
        }

    case LTU:
      switch (pattern1337 (x1, 
LTU))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9649; /* *cmplovnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9659; /* *cmplovnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9689; /* *cmplovnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9669; /* *cmplovnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9699; /* *cmplovnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9719; /* *cmplovnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9679; /* *cmplovnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9709; /* *cmplovnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9729; /* *cmplovnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9739; /* *cmplovnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9749; /* *cmplovnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9759; /* *cmplovnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9789; /* *cmplovnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9769; /* *cmplovnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9799; /* *cmplovnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9819; /* *cmplovnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9779; /* *cmplovnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9809; /* *cmplovnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9829; /* *cmplovnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9839; /* *cmplovnx2di_ptest */

        default:
          return -1;
        }

    case LEU:
      switch (pattern1337 (x1, 
LEU))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9650; /* *cmplsvnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9660; /* *cmplsvnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9690; /* *cmplsvnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9670; /* *cmplsvnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9700; /* *cmplsvnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9720; /* *cmplsvnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9680; /* *cmplsvnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9710; /* *cmplsvnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9730; /* *cmplsvnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9740; /* *cmplsvnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9750; /* *cmplsvnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9760; /* *cmplsvnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9790; /* *cmplsvnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9770; /* *cmplsvnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9800; /* *cmplsvnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9820; /* *cmplsvnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9780; /* *cmplsvnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9810; /* *cmplsvnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9830; /* *cmplsvnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9840; /* *cmplsvnx2di_ptest */

        default:
          return -1;
        }

    case GEU:
      switch (pattern1337 (x1, 
GEU))
        {
        case 0:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9651; /* *cmphsvnx16qi_cc */

        case 1:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9661; /* *cmphsvnx8qi_cc */

        case 2:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9691; /* *cmphsvnx8hi_cc */

        case 3:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9671; /* *cmphsvnx4qi_cc */

        case 4:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9701; /* *cmphsvnx4hi_cc */

        case 5:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9721; /* *cmphsvnx4si_cc */

        case 6:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9681; /* *cmphsvnx2qi_cc */

        case 7:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9711; /* *cmphsvnx2hi_cc */

        case 8:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9731; /* *cmphsvnx2si_cc */

        case 9:
          if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9741; /* *cmphsvnx2di_cc */

        case 10:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9751; /* *cmphsvnx16qi_ptest */

        case 11:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9761; /* *cmphsvnx8qi_ptest */

        case 12:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9791; /* *cmphsvnx8hi_ptest */

        case 13:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9771; /* *cmphsvnx4qi_ptest */

        case 14:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9801; /* *cmphsvnx4hi_ptest */

        case 15:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9821; /* *cmphsvnx4si_ptest */

        case 16:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9781; /* *cmphsvnx2qi_ptest */

        case 17:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9811; /* *cmphsvnx2hi_ptest */

        case 18:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9831; /* *cmphsvnx2si_ptest */

        case 19:
          if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9841; /* *cmphsvnx2di_ptest */

        default:
          return -1;
        }

    case GTU:
      return recog_598 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_597 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern469 (x2))
    {
    case 0:
      if (!(
#line 715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed
   && (VNx16QImode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((REG_P (operands[0]) && MEM_P (operands[2]))
       || (REG_P (operands[2]) && MEM_P (operands[0])))) && 
#line 720 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_432 (insn, operands);

    case 1:
      if (!(
#line 715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed
   && (VNx8HImode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((REG_P (operands[0]) && MEM_P (operands[2]))
       || (REG_P (operands[2]) && MEM_P (operands[0])))) && 
#line 720 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_433 (insn, operands);

    case 2:
      if (!(
#line 715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed
   && (VNx4SImode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((REG_P (operands[0]) && MEM_P (operands[2]))
       || (REG_P (operands[2]) && MEM_P (operands[0])))) && 
#line 720 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_434 (insn, operands);

    case 3:
      if (!(
#line 715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed
   && (VNx2DImode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((REG_P (operands[0]) && MEM_P (operands[2]))
       || (REG_P (operands[2]) && MEM_P (operands[0])))) && 
#line 720 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_435 (insn, operands);

    case 4:
      if (!(
#line 715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed
   && (VNx8BFmode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((REG_P (operands[0]) && MEM_P (operands[2]))
       || (REG_P (operands[2]) && MEM_P (operands[0])))) && 
#line 720 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_436 (insn, operands);

    case 5:
      if (!(
#line 715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed
   && (VNx8HFmode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((REG_P (operands[0]) && MEM_P (operands[2]))
       || (REG_P (operands[2]) && MEM_P (operands[0])))) && 
#line 720 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_437 (insn, operands);

    case 6:
      if (!(
#line 715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed
   && (VNx4SFmode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((REG_P (operands[0]) && MEM_P (operands[2]))
       || (REG_P (operands[2]) && MEM_P (operands[0])))) && 
#line 720 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_438 (insn, operands);

    case 7:
      if (!(
#line 715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed
   && (VNx2DFmode == VNx16QImode || !BYTES_BIG_ENDIAN)
   && ((REG_P (operands[0]) && MEM_P (operands[2]))
       || (REG_P (operands[2]) && MEM_P (operands[0])))) && 
#line 720 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_439 (insn, operands);

    case 8:
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern714 (x2))
            {
            case 0:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16QImode)
       || register_operand (operands[2], VNx16QImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx16QImode)
   && register_operand (operands[2], VNx16QImode))))
                return NULL;
              return gen_split_440 (insn, operands);

            case 1:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8QImode)
       || register_operand (operands[2], VNx8QImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8QImode)
   && register_operand (operands[2], VNx8QImode))))
                return NULL;
              return gen_split_441 (insn, operands);

            case 2:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4QImode)
       || register_operand (operands[2], VNx4QImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4QImode)
   && register_operand (operands[2], VNx4QImode))))
                return NULL;
              return gen_split_442 (insn, operands);

            case 3:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2QImode)
       || register_operand (operands[2], VNx2QImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2QImode)
   && register_operand (operands[2], VNx2QImode))))
                return NULL;
              return gen_split_443 (insn, operands);

            case 4:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HImode)
       || register_operand (operands[2], VNx8HImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8HImode)
   && register_operand (operands[2], VNx8HImode))))
                return NULL;
              return gen_split_444 (insn, operands);

            case 5:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HImode)
       || register_operand (operands[2], VNx4HImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4HImode)
   && register_operand (operands[2], VNx4HImode))))
                return NULL;
              return gen_split_445 (insn, operands);

            case 6:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HImode)
       || register_operand (operands[2], VNx2HImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2HImode)
   && register_operand (operands[2], VNx2HImode))))
                return NULL;
              return gen_split_446 (insn, operands);

            case 7:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SImode)
       || register_operand (operands[2], VNx4SImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4SImode)
   && register_operand (operands[2], VNx4SImode))))
                return NULL;
              return gen_split_447 (insn, operands);

            case 8:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SImode)
       || register_operand (operands[2], VNx2SImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2SImode)
   && register_operand (operands[2], VNx2SImode))))
                return NULL;
              return gen_split_448 (insn, operands);

            case 9:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DImode)
       || register_operand (operands[2], VNx2DImode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2DImode)
   && register_operand (operands[2], VNx2DImode))))
                return NULL;
              return gen_split_449 (insn, operands);

            case 10:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HFmode)
       || register_operand (operands[2], VNx2HFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2HFmode)
   && register_operand (operands[2], VNx2HFmode))))
                return NULL;
              return gen_split_450 (insn, operands);

            case 11:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HFmode)
       || register_operand (operands[2], VNx4HFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4HFmode)
   && register_operand (operands[2], VNx4HFmode))))
                return NULL;
              return gen_split_451 (insn, operands);

            case 12:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SFmode)
       || register_operand (operands[2], VNx2SFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2SFmode)
   && register_operand (operands[2], VNx2SFmode))))
                return NULL;
              return gen_split_452 (insn, operands);

            case 13:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HFmode)
       || register_operand (operands[2], VNx8HFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8HFmode)
   && register_operand (operands[2], VNx8HFmode))))
                return NULL;
              return gen_split_453 (insn, operands);

            case 14:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SFmode)
       || register_operand (operands[2], VNx4SFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4SFmode)
   && register_operand (operands[2], VNx4SFmode))))
                return NULL;
              return gen_split_454 (insn, operands);

            case 15:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DFmode)
       || register_operand (operands[2], VNx2DFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2DFmode)
   && register_operand (operands[2], VNx2DFmode))))
                return NULL;
              return gen_split_455 (insn, operands);

            case 16:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BFmode)
       || register_operand (operands[2], VNx2BFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2BFmode)
   && register_operand (operands[2], VNx2BFmode))))
                return NULL;
              return gen_split_456 (insn, operands);

            case 17:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BFmode)
       || register_operand (operands[2], VNx4BFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4BFmode)
   && register_operand (operands[2], VNx4BFmode))))
                return NULL;
              return gen_split_457 (insn, operands);

            case 18:
              if (!(
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BFmode)
       || register_operand (operands[2], VNx8BFmode))) && 
#line 780 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8BFmode)
   && register_operand (operands[2], VNx8BFmode))))
                return NULL;
              return gen_split_458 (insn, operands);

            case 19:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32QImode)
       || register_operand (operands[2], VNx32QImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_545 (insn, operands);

            case 20:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HImode)
       || register_operand (operands[2], VNx16HImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_546 (insn, operands);

            case 21:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SImode)
       || register_operand (operands[2], VNx8SImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_547 (insn, operands);

            case 22:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DImode)
       || register_operand (operands[2], VNx4DImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_548 (insn, operands);

            case 23:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BFmode)
       || register_operand (operands[2], VNx16BFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_549 (insn, operands);

            case 24:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HFmode)
       || register_operand (operands[2], VNx16HFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_550 (insn, operands);

            case 25:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SFmode)
       || register_operand (operands[2], VNx8SFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_551 (insn, operands);

            case 26:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DFmode)
       || register_operand (operands[2], VNx4DFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_552 (insn, operands);

            case 27:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx48QImode)
       || register_operand (operands[2], VNx48QImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_553 (insn, operands);

            case 28:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HImode)
       || register_operand (operands[2], VNx24HImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_554 (insn, operands);

            case 29:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SImode)
       || register_operand (operands[2], VNx12SImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_555 (insn, operands);

            case 30:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DImode)
       || register_operand (operands[2], VNx6DImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_556 (insn, operands);

            case 31:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24BFmode)
       || register_operand (operands[2], VNx24BFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_557 (insn, operands);

            case 32:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HFmode)
       || register_operand (operands[2], VNx24HFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_558 (insn, operands);

            case 33:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SFmode)
       || register_operand (operands[2], VNx12SFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_559 (insn, operands);

            case 34:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DFmode)
       || register_operand (operands[2], VNx6DFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_560 (insn, operands);

            case 35:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx64QImode)
       || register_operand (operands[2], VNx64QImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_561 (insn, operands);

            case 36:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HImode)
       || register_operand (operands[2], VNx32HImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_562 (insn, operands);

            case 37:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SImode)
       || register_operand (operands[2], VNx16SImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_563 (insn, operands);

            case 38:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DImode)
       || register_operand (operands[2], VNx8DImode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_564 (insn, operands);

            case 39:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32BFmode)
       || register_operand (operands[2], VNx32BFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_565 (insn, operands);

            case 40:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HFmode)
       || register_operand (operands[2], VNx32HFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_566 (insn, operands);

            case 41:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SFmode)
       || register_operand (operands[2], VNx16SFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_567 (insn, operands);

            case 42:
              if (!(
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DFmode)
       || register_operand (operands[2], VNx8DFmode))) && 
#line 927 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_568 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          switch (pattern719 (x2))
            {
            case 0:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
                return NULL;
              return gen_split_1205 (insn, operands);

            case 1:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
                return NULL;
              return gen_split_1210 (insn, operands);

            case 2:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
                return NULL;
              return gen_split_1215 (insn, operands);

            case 3:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
                return NULL;
              return gen_split_1220 (insn, operands);

            case 4:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
                return NULL;
              return gen_split_1225 (insn, operands);

            case 5:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
                return NULL;
              return gen_split_1230 (insn, operands);

            case 6:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
                return NULL;
              return gen_split_1235 (insn, operands);

            case 7:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
                return NULL;
              return gen_split_1240 (insn, operands);

            case 8:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
                return NULL;
              return gen_split_1245 (insn, operands);

            case 9:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
                return NULL;
              return gen_split_1250 (insn, operands);

            case 10:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
                return NULL;
              return gen_split_1255 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          switch (pattern719 (x2))
            {
            case 0:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
                return NULL;
              return gen_split_1206 (insn, operands);

            case 1:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
                return NULL;
              return gen_split_1211 (insn, operands);

            case 2:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
                return NULL;
              return gen_split_1216 (insn, operands);

            case 3:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
                return NULL;
              return gen_split_1221 (insn, operands);

            case 4:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
                return NULL;
              return gen_split_1226 (insn, operands);

            case 5:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
                return NULL;
              return gen_split_1231 (insn, operands);

            case 6:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
                return NULL;
              return gen_split_1236 (insn, operands);

            case 7:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
                return NULL;
              return gen_split_1241 (insn, operands);

            case 8:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
                return NULL;
              return gen_split_1246 (insn, operands);

            case 9:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
                return NULL;
              return gen_split_1251 (insn, operands);

            case 10:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
                return NULL;
              return gen_split_1256 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern719 (x2))
            {
            case 0:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
                return NULL;
              return gen_split_1207 (insn, operands);

            case 1:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
                return NULL;
              return gen_split_1212 (insn, operands);

            case 2:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
                return NULL;
              return gen_split_1217 (insn, operands);

            case 3:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
                return NULL;
              return gen_split_1222 (insn, operands);

            case 4:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
                return NULL;
              return gen_split_1227 (insn, operands);

            case 5:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
                return NULL;
              return gen_split_1232 (insn, operands);

            case 6:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
                return NULL;
              return gen_split_1237 (insn, operands);

            case 7:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
                return NULL;
              return gen_split_1242 (insn, operands);

            case 8:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
                return NULL;
              return gen_split_1247 (insn, operands);

            case 9:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
                return NULL;
              return gen_split_1252 (insn, operands);

            case 10:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
                return NULL;
              return gen_split_1257 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern721 (x2))
            {
            case 0:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
                return NULL;
              return gen_split_1208 (insn, operands);

            case 1:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
                return NULL;
              return gen_split_1213 (insn, operands);

            case 2:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
                return NULL;
              return gen_split_1218 (insn, operands);

            case 3:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
                return NULL;
              return gen_split_1223 (insn, operands);

            case 4:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
                return NULL;
              return gen_split_1228 (insn, operands);

            case 5:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
                return NULL;
              return gen_split_1233 (insn, operands);

            case 6:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
                return NULL;
              return gen_split_1238 (insn, operands);

            case 7:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
                return NULL;
              return gen_split_1243 (insn, operands);

            case 8:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
                return NULL;
              return gen_split_1248 (insn, operands);

            case 9:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
                return NULL;
              return gen_split_1253 (insn, operands);

            case 10:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
                return NULL;
              return gen_split_1258 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern721 (x2))
            {
            case 0:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
                return NULL;
              return gen_split_1209 (insn, operands);

            case 1:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
                return NULL;
              return gen_split_1214 (insn, operands);

            case 2:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
                return NULL;
              return gen_split_1219 (insn, operands);

            case 3:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
                return NULL;
              return gen_split_1224 (insn, operands);

            case 4:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
                return NULL;
              return gen_split_1229 (insn, operands);

            case 5:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
                return NULL;
              return gen_split_1234 (insn, operands);

            case 6:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
                return NULL;
              return gen_split_1239 (insn, operands);

            case 7:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
                return NULL;
              return gen_split_1244 (insn, operands);

            case 8:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
                return NULL;
              return gen_split_1249 (insn, operands);

            case 9:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
                return NULL;
              return gen_split_1254 (insn, operands);

            case 10:
              if (!(
#line 4097 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4106 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
                return NULL;
              return gen_split_1259 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern724 (x2))
            {
            case 0:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx16QImode))))
                return NULL;
              return gen_split_1516 (insn, operands);

            case 1:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx8QImode))))
                return NULL;
              return gen_split_1519 (insn, operands);

            case 2:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4QImode))))
                return NULL;
              return gen_split_1522 (insn, operands);

            case 3:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2QImode))))
                return NULL;
              return gen_split_1525 (insn, operands);

            case 4:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx8HImode))))
                return NULL;
              return gen_split_1528 (insn, operands);

            case 5:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4HImode))))
                return NULL;
              return gen_split_1531 (insn, operands);

            case 6:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2HImode))))
                return NULL;
              return gen_split_1534 (insn, operands);

            case 7:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4SImode))))
                return NULL;
              return gen_split_1537 (insn, operands);

            case 8:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2SImode))))
                return NULL;
              return gen_split_1540 (insn, operands);

            case 9:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2DImode))))
                return NULL;
              return gen_split_1543 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern726 (x2))
            {
            case 0:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx16QImode))))
                return NULL;
              return gen_split_1517 (insn, operands);

            case 1:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx8QImode))))
                return NULL;
              return gen_split_1520 (insn, operands);

            case 2:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4QImode))))
                return NULL;
              return gen_split_1523 (insn, operands);

            case 3:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2QImode))))
                return NULL;
              return gen_split_1526 (insn, operands);

            case 4:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx8HImode))))
                return NULL;
              return gen_split_1529 (insn, operands);

            case 5:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4HImode))))
                return NULL;
              return gen_split_1532 (insn, operands);

            case 6:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2HImode))))
                return NULL;
              return gen_split_1535 (insn, operands);

            case 7:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4SImode))))
                return NULL;
              return gen_split_1538 (insn, operands);

            case 8:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2SImode))))
                return NULL;
              return gen_split_1541 (insn, operands);

            case 9:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2DImode))))
                return NULL;
              return gen_split_1544 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern726 (x2))
            {
            case 0:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx16QImode))))
                return NULL;
              return gen_split_1518 (insn, operands);

            case 1:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx8QImode))))
                return NULL;
              return gen_split_1521 (insn, operands);

            case 2:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4QImode))))
                return NULL;
              return gen_split_1524 (insn, operands);

            case 3:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2QImode))))
                return NULL;
              return gen_split_1527 (insn, operands);

            case 4:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx8HImode))))
                return NULL;
              return gen_split_1530 (insn, operands);

            case 5:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4HImode))))
                return NULL;
              return gen_split_1533 (insn, operands);

            case 6:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2HImode))))
                return NULL;
              return gen_split_1536 (insn, operands);

            case 7:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx4SImode))))
                return NULL;
              return gen_split_1539 (insn, operands);

            case 8:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2SImode))))
                return NULL;
              return gen_split_1542 (insn, operands);

            case 9:
              if (!(
#line 5038 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5045 "../../gcc/config/aarch64/aarch64-sve.md"
( !register_operand (operands[3], VNx2DImode))))
                return NULL;
              return gen_split_1545 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_73 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern702 (x2))
        {
        case 0:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1260 (insn, operands);

        case 1:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1277 (insn, operands);

        case 2:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1294 (insn, operands);

        case 3:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1311 (insn, operands);

        case 4:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1328 (insn, operands);

        case 5:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1345 (insn, operands);

        case 6:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1362 (insn, operands);

        case 7:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1379 (insn, operands);

        case 8:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1396 (insn, operands);

        case 9:
          if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1413 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x3, 1);
      operands[4] = x7;
      x8 = XVECEXP (x2, 0, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1114 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1999 (insn, operands);

        case E_VNx8QImode:
          if (pattern1114 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2000 (insn, operands);

        case E_VNx4QImode:
          if (pattern1114 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2001 (insn, operands);

        case E_VNx2QImode:
          if (pattern1114 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2002 (insn, operands);

        case E_VNx8HImode:
          if (pattern1114 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2003 (insn, operands);

        case E_VNx4HImode:
          if (pattern1114 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2004 (insn, operands);

        case E_VNx2HImode:
          if (pattern1114 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2005 (insn, operands);

        case E_VNx4SImode:
          if (pattern1114 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2006 (insn, operands);

        case E_VNx2SImode:
          if (pattern1114 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2007 (insn, operands);

        case E_VNx2DImode:
          if (pattern1114 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 7265 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7277 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2008 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_78 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return NULL;
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern696 (x2, 
E_V16QImode, 
E_V8QImode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V8QImode))))
        return gen_split_141 (insn, operands);
      break;

    case E_V4HImode:
      if (pattern696 (x2, 
E_V8HImode, 
E_V4HImode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V4HImode))))
        return gen_split_142 (insn, operands);
      break;

    case E_V2SImode:
      if (pattern696 (x2, 
E_V4SImode, 
E_V2SImode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V2SImode))))
        return gen_split_143 (insn, operands);
      break;

    case E_V4HFmode:
      if (pattern696 (x2, 
E_V8HFmode, 
E_V4HFmode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V4HFmode))))
        return gen_split_144 (insn, operands);
      break;

    case E_V4BFmode:
      if (pattern696 (x2, 
E_V8BFmode, 
E_V4BFmode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V4BFmode))))
        return gen_split_145 (insn, operands);
      break;

    case E_V2SFmode:
      if (pattern696 (x2, 
E_V4SFmode, 
E_V2SFmode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V2SFmode))))
        return gen_split_146 (insn, operands);
      break;

    case E_V16QImode:
      if (pattern656 (x2, 
E_VNx16QImode, 
E_V16QImode) == 0
          && (
#line 11426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)) && 
#line 11431 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2770 (insn, operands);
      break;

    case E_V8HImode:
      if (pattern656 (x2, 
E_VNx8HImode, 
E_V8HImode) == 0
          && (
#line 11426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)) && 
#line 11431 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2771 (insn, operands);
      break;

    case E_V4SImode:
      if (pattern656 (x2, 
E_VNx4SImode, 
E_V4SImode) == 0
          && (
#line 11426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)) && 
#line 11431 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2772 (insn, operands);
      break;

    case E_V2DImode:
      if (pattern656 (x2, 
E_VNx2DImode, 
E_V2DImode) == 0
          && (
#line 11426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)) && 
#line 11431 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2773 (insn, operands);
      break;

    case E_V8BFmode:
      if (pattern656 (x2, 
E_VNx8BFmode, 
E_V8BFmode) == 0
          && (
#line 11426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)) && 
#line 11431 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2774 (insn, operands);
      break;

    case E_V8HFmode:
      if (pattern656 (x2, 
E_VNx8HFmode, 
E_V8HFmode) == 0
          && (
#line 11426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)) && 
#line 11431 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2775 (insn, operands);
      break;

    case E_V4SFmode:
      if (pattern656 (x2, 
E_VNx4SFmode, 
E_V4SFmode) == 0
          && (
#line 11426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)) && 
#line 11431 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2776 (insn, operands);
      break;

    case E_V2DFmode:
      if (pattern656 (x2, 
E_VNx2DFmode, 
E_V2DFmode) == 0
          && (
#line 11426 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)) && 
#line 11431 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2777 (insn, operands);
      break;

    default:
      break;
    }
  if (XVECLEN (x3, 0) != 1)
    return NULL;
  operands[0] = x4;
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  if (immediate_operand (operands[2], E_SImode))
    {
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_QImode)
              && GET_MODE (x2) == E_QImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0)))
                    return gen_split_178 (insn, operands);
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (16, INTVAL (operands[2])) == 0)))
                    return gen_split_179 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_HImode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_HImode)
              && GET_MODE (x2) == E_HImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_180 (insn, operands);
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0)))
                    return gen_split_181 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_SImode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0)))
                    return gen_split_182 (insn, operands);
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_183 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_DImode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_V2DImode)
              && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0)))
            return gen_split_184 (insn, operands);
          break;

        case E_HFmode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_HFmode)
              && GET_MODE (x2) == E_HFmode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_185 (insn, operands);
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0)))
                    return gen_split_186 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_BFmode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_BFmode)
              && GET_MODE (x2) == E_BFmode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4BFmode:
                  if (register_operand (operands[1], E_V4BFmode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_187 (insn, operands);
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[1], E_V8BFmode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0)))
                    return gen_split_188 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_SFmode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_SFmode)
              && GET_MODE (x2) == E_SFmode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0)))
                    return gen_split_189 (insn, operands);
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_190 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_DFmode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && register_operand (operands[1], E_V2DFmode)
              && (
#line 4283 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4298 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0)))
            return gen_split_191 (insn, operands);
          break;

        default:
          break;
        }
    }
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  switch (pattern697 (x2))
    {
    case 0:
      if (!(
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3079 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1071 (insn, operands);

    case 1:
      if (!(
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3079 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1072 (insn, operands);

    case 2:
      if (!(
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3079 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1073 (insn, operands);

    case 3:
      if (!(
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3079 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1074 (insn, operands);

    case 4:
      if (!(
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3079 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1075 (insn, operands);

    case 5:
      if (!(
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3079 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1076 (insn, operands);

    case 6:
      if (!(
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3079 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1077 (insn, operands);

    case 7:
      if (!(
#line 3064 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3079 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1078 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_82 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NEG:
      switch (pattern50 (x3))
        {
        case 0:
          return gen_split_24 (insn, operands);

        case 1:
          return gen_split_25 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          switch (pattern456 (x3))
            {
            case 0:
              if (!
#line 5329 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_40 (insn, operands);

            case 1:
              if (!
#line 5329 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_44 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern457 (x3))
            {
            case 0:
              if (!
#line 5351 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (IOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_48 (insn, operands);

            case 1:
              if (!
#line 5351 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (IOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_52 (insn, operands);

            case 2:
              if (!
#line 5380 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (IOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_56 (insn, operands);

            case 3:
              if (!
#line 5380 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (IOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_60 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != UNSPEC
              || pattern590 (x6) != 0)
            return NULL;
          switch (pattern1038 (x3))
            {
            case 0:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx16QImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1851 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3002 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1851 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3003 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx16QImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3010 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3011 (insn, operands);

            case 1:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx8HImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1851 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3004 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1851 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3005 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx8HImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3012 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3013 (insn, operands);

            case 2:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx4SImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1851 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3006 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1851 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3007 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx4SImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3014 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3015 (insn, operands);

            case 3:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx2DImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1851 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3008 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1851 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3009 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx2DImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3016 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3017 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern368 (x3))
        {
        case 0:
          if (!
#line 5403 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_64 (insn, operands);

        case 1:
          if (!
#line 5403 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_67 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_107 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2422 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2432 (insn, operands);
}

 rtx_insn *
split_113 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2461 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2471 (insn, operands);
}

 rtx_insn *
split_120 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2480 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2490 (insn, operands);
}

 rtx_insn *
split_127 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2499 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2509 (insn, operands);
}

 rtx_insn *
split_134 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern1337 (x1, 
GEU))
    {
    case 0:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2123 (insn, operands);

    case 1:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2133 (insn, operands);

    case 2:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2163 (insn, operands);

    case 3:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2143 (insn, operands);

    case 4:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2173 (insn, operands);

    case 5:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2193 (insn, operands);

    case 6:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2153 (insn, operands);

    case 7:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2183 (insn, operands);

    case 8:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2203 (insn, operands);

    case 9:
      if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2213 (insn, operands);

    case 10:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2223 (insn, operands);

    case 11:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2233 (insn, operands);

    case 12:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2263 (insn, operands);

    case 13:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2243 (insn, operands);

    case 14:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2273 (insn, operands);

    case 15:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2293 (insn, operands);

    case 16:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2253 (insn, operands);

    case 17:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2283 (insn, operands);

    case 18:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2303 (insn, operands);

    case 19:
      if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2313 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2DImode))
    {
      switch (pattern935 (
E_V2DImode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_116 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_117 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_118 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_119 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_120 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_121 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_122 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_123 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2DImode))
    {
      if (register_operand (operands[1], E_V2DImode))
        {
          switch (pattern992 ())
            {
            case 0:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_180 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_181 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_182 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_183 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_184 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_185 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 6:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_186 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 7:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_187 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern991 (x2, 
E_V2DImode) == 0
              && 
#line 304 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2DImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_238 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern934 (x2, 
E_V2DImode) != 0
      || !
#line 325 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2DImode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_242 (insn, operands);
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V8HFmode))
    {
      switch (pattern935 (
E_V8HFmode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_124 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_125 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_126 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_127 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_128 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_129 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_130 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_131 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V8HFmode)
      || !register_operand (operands[1], E_V8HFmode))
    return NULL;
  switch (pattern992 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_188 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_189 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_190 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_191 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_192 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_193 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_194 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_195 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V16QImode))
    {
      switch (pattern935 (
E_V16QImode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_92 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_93 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_94 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_95 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_96 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_97 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_98 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_99 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode))
    return NULL;
  switch (pattern992 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_156 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_157 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_158 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_159 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_160 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_161 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_162 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_163 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return NULL;
          if (register_operand (operands[0], E_SImode)
              && aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              && 
#line 2678 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), SImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_1 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2)
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern863 (x6, 
E_SImode) != 0
              || !
#line 3781 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && INTVAL (operands[3]) == -INTVAL (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return NULL;
          if (register_operand (operands[0], E_DImode)
              && aarch64_pluslong_strict_immedate (operands[2], E_DImode)
              && 
#line 2678 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), DImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2)
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern863 (x6, 
E_DImode) != 0
              || !
#line 3781 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && INTVAL (operands[3]) == -INTVAL (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              || !
#line 2690 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_3 (insn, operands);

        case SUBREG:
        case MEM:
          if (peep2_current_count < 2
              || pattern584 (x4, 
ZERO_EXTEND) != 0)
            return NULL;
          if (
#line 139 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_221 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 3)
            return NULL;
          x9 = PATTERN (peep2_next_insn (2));
          if (pattern1228 (x9, 
ZERO_EXTEND) != 0
              || !
#line 244 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_231 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (peep2_current_count < 2)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != COMPARE
          || GET_MODE (x10) != E_CCmode)
        return NULL;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 66
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return NULL;
      x13 = XEXP (x10, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1200 (x2, 
E_SImode) != 0
              || !
#line 3743 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        case E_DImode:
          if (pattern1200 (x2, 
E_DImode) != 0
              || !
#line 3743 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || GET_MODE (x2) != E_CCmode)
        return NULL;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 66
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (aarch64_reg_or_zero (operands[2], E_SImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern930 (x6, 
E_SImode) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_6 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (aarch64_reg_or_zero (operands[2], E_DImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern930 (x6, 
E_DImode) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_7 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      operands[3] = x5;
      if (const_int_operand (operands[3], E_SImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern931 (x6, 
E_SImode) == 0
              && 
#line 3802 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[3]) == -INTVAL (operands[2])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!const_int_operand (operands[3], E_DImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern931 (x6, 
E_DImode) != 0
          || !
#line 3802 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[3]) == -INTVAL (operands[2])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      return peephole2_12 (x1, insn, pmatch_len_);

    case SIGN_EXTEND:
      if (peep2_current_count < 2
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      if (pattern584 (x4, 
SIGN_EXTEND) != 0)
        return NULL;
      if (
#line 127 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_220 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 3)
        return NULL;
      x9 = PATTERN (peep2_next_insn (2));
      if (pattern1228 (x9, 
SIGN_EXTEND) != 0
          || !
#line 224 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_230 (insn, operands);

    default:
      return NULL;
    }
}
