/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 6;

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 7;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 8;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 9;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[3] = x8;
  switch (XWINT (x5, 0))
    {
    case 8L:
      switch (GET_MODE (operands[3]))
        {
        case E_QImode:
          if (!register_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case 16L:
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case 32L:
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 4;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x3) != E_VNx8SFmode
          || !aligned_register_operand (operands[1], E_VNx8SFmode))
        return -1;
      return 8;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          return pattern79 (x3, 
E_HFmode); /* [-1, 0] */

        case E_SFmode:
          if (pattern79 (x3, 
E_SFmode) != 0)
            return -1;
          return 1;

        case E_DFmode:
          if (pattern79 (x3, 
E_DFmode) != 0)
            return -1;
          return 2;

        case E_V4HFmode:
          if (pattern79 (x3, 
E_V4HFmode) != 0)
            return -1;
          return 3;

        case E_V8HFmode:
          if (pattern79 (x3, 
E_V8HFmode) != 0)
            return -1;
          return 4;

        case E_V2SFmode:
          if (pattern79 (x3, 
E_V2SFmode) != 0)
            return -1;
          return 5;

        case E_V4SFmode:
          if (pattern79 (x3, 
E_V4SFmode) != 0)
            return -1;
          return 6;

        case E_V2DFmode:
          if (pattern79 (x3, 
E_V2DFmode) != 0)
            return -1;
          return 7;

        case E_VNx16BFmode:
          if (pattern80 (x3, 
E_VNx16BFmode) != 0)
            return -1;
          return 8;

        case E_VNx32BFmode:
          if (pattern80 (x3, 
E_VNx32BFmode) != 0)
            return -1;
          return 9;

        case E_VNx16HFmode:
          if (pattern80 (x3, 
E_VNx16HFmode) != 0)
            return -1;
          return 10;

        case E_VNx8SFmode:
          if (pattern80 (x3, 
E_VNx8SFmode) != 0)
            return -1;
          return 11;

        case E_VNx4DFmode:
          if (pattern80 (x3, 
E_VNx4DFmode) != 0)
            return -1;
          return 12;

        case E_VNx32HFmode:
          if (pattern80 (x3, 
E_VNx32HFmode) != 0)
            return -1;
          return 13;

        case E_VNx16SFmode:
          if (pattern80 (x3, 
E_VNx16SFmode) != 0)
            return -1;
          return 14;

        case E_VNx8DFmode:
          if (pattern80 (x3, 
E_VNx8DFmode) != 0)
            return -1;
          return 15;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern82 (x3);
      if (res >= 0)
        return res + 16; /* [16, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern79 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern79 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern79 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern79 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern79 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern79 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern79 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_V4HFmode:
      if (pattern79 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 7;

    case E_V8HFmode:
      if (pattern79 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 8;

    case E_V4BFmode:
      if (pattern79 (x3, 
E_V4BFmode) != 0)
        return -1;
      return 9;

    case E_V8BFmode:
      if (pattern79 (x3, 
E_V8BFmode) != 0)
        return -1;
      return 10;

    case E_V2SFmode:
      if (pattern79 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 11;

    case E_V4SFmode:
      if (pattern79 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 12;

    case E_V2DFmode:
      if (pattern79 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 13;

    case E_VNx16QImode:
      if (pattern79 (x3, 
E_VNx16QImode) != 0)
        return -1;
      return 14;

    case E_VNx8QImode:
      if (pattern79 (x3, 
E_VNx8QImode) != 0)
        return -1;
      return 15;

    case E_VNx4QImode:
      if (pattern79 (x3, 
E_VNx4QImode) != 0)
        return -1;
      return 16;

    case E_VNx2QImode:
      if (pattern79 (x3, 
E_VNx2QImode) != 0)
        return -1;
      return 17;

    case E_VNx8HImode:
      if (pattern79 (x3, 
E_VNx8HImode) != 0)
        return -1;
      return 18;

    case E_VNx4HImode:
      if (pattern79 (x3, 
E_VNx4HImode) != 0)
        return -1;
      return 19;

    case E_VNx2HImode:
      if (pattern79 (x3, 
E_VNx2HImode) != 0)
        return -1;
      return 20;

    case E_VNx4SImode:
      if (pattern79 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 21;

    case E_VNx2SImode:
      if (pattern79 (x3, 
E_VNx2SImode) != 0)
        return -1;
      return 22;

    case E_VNx2DImode:
      if (pattern79 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 23;

    case E_VNx2HFmode:
      if (pattern79 (x3, 
E_VNx2HFmode) != 0)
        return -1;
      return 24;

    case E_VNx4HFmode:
      if (pattern79 (x3, 
E_VNx4HFmode) != 0)
        return -1;
      return 25;

    case E_VNx2SFmode:
      if (pattern79 (x3, 
E_VNx2SFmode) != 0)
        return -1;
      return 26;

    case E_VNx8HFmode:
      if (pattern79 (x3, 
E_VNx8HFmode) != 0)
        return -1;
      return 27;

    case E_VNx4SFmode:
      if (pattern79 (x3, 
E_VNx4SFmode) != 0)
        return -1;
      return 28;

    case E_VNx2DFmode:
      if (pattern79 (x3, 
E_VNx2DFmode) != 0)
        return -1;
      return 29;

    case E_VNx2BFmode:
      if (pattern79 (x3, 
E_VNx2BFmode) != 0)
        return -1;
      return 30;

    case E_VNx4BFmode:
      if (pattern79 (x3, 
E_VNx4BFmode) != 0)
        return -1;
      return 31;

    case E_VNx8BFmode:
      if (pattern79 (x3, 
E_VNx8BFmode) != 0)
        return -1;
      return 32;

    case E_VNx16BImode:
      if (pattern79 (x3, 
E_VNx16BImode) != 0)
        return -1;
      return 33;

    case E_VNx8BImode:
      if (pattern79 (x3, 
E_VNx8BImode) != 0)
        return -1;
      return 34;

    case E_VNx4BImode:
      if (pattern79 (x3, 
E_VNx4BImode) != 0)
        return -1;
      return 35;

    case E_VNx2BImode:
      if (pattern79 (x3, 
E_VNx2BImode) != 0)
        return -1;
      return 36;

    default:
      return -1;
    }
}

int
pattern147 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_si (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern159 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern159 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern160 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern160 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern161 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern161 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern162 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern162 (x3, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_predicate_operand (operands[1], i1))
    return -1;
  return pattern178 (); /* [-1, 2] */
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (!memory_operand (operands[0], E_VNx32QImode)
          || GET_MODE (x3) != E_VNx32QImode
          || !aligned_register_operand (operands[1], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx16HImode:
      if (!memory_operand (operands[0], E_VNx16HImode)
          || GET_MODE (x3) != E_VNx16HImode
          || !aligned_register_operand (operands[1], E_VNx16HImode))
        return -1;
      return 1;

    case E_VNx8SImode:
      if (!memory_operand (operands[0], E_VNx8SImode)
          || GET_MODE (x3) != E_VNx8SImode
          || !aligned_register_operand (operands[1], E_VNx8SImode))
        return -1;
      return 2;

    case E_VNx4DImode:
      if (!memory_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x3) != E_VNx4DImode
          || !aligned_register_operand (operands[1], E_VNx4DImode))
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (!memory_operand (operands[0], E_VNx16BFmode)
          || GET_MODE (x3) != E_VNx16BFmode
          || !aligned_register_operand (operands[1], E_VNx16BFmode))
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (!memory_operand (operands[0], E_VNx16HFmode)
          || GET_MODE (x3) != E_VNx16HFmode
          || !aligned_register_operand (operands[1], E_VNx16HFmode))
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (!memory_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x3) != E_VNx8SFmode
          || !aligned_register_operand (operands[1], E_VNx8SFmode))
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (!memory_operand (operands[0], E_VNx4DFmode)
          || GET_MODE (x3) != E_VNx4DFmode
          || !aligned_register_operand (operands[1], E_VNx4DFmode))
        return -1;
      return 7;

    case E_VNx64QImode:
      if (!memory_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x3) != E_VNx64QImode
          || !aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      return 8;

    case E_VNx32HImode:
      if (!memory_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x3) != E_VNx32HImode
          || !aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      return 9;

    case E_VNx16SImode:
      if (!memory_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x3) != E_VNx16SImode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 10;

    case E_VNx8DImode:
      if (!memory_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x3) != E_VNx8DImode
          || !aligned_register_operand (operands[1], E_VNx8DImode))
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (!memory_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x3) != E_VNx32BFmode
          || !aligned_register_operand (operands[1], E_VNx32BFmode))
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (!memory_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x3) != E_VNx32HFmode
          || !aligned_register_operand (operands[1], E_VNx32HFmode))
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (!memory_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SFmode))
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (!memory_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x3) != E_VNx8DFmode
          || !aligned_register_operand (operands[1], E_VNx8DFmode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode
      || pattern234 (x1, 
i1, 
E_VNx16QImode) != 0)
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[2] = x8;
      switch (GET_MODE (x5))
        {
        case E_VNx32QImode:
          if (GET_MODE (x2) != E_VNx32QImode
              || GET_MODE (x3) != E_VNx32QImode
              || !aligned_register_operand (operands[2], E_VNx32QImode))
            return -1;
          return 0;

        case E_VNx16HImode:
          if (GET_MODE (x2) != E_VNx16HImode
              || GET_MODE (x3) != E_VNx16HImode
              || !aligned_register_operand (operands[2], E_VNx16HImode))
            return -1;
          return 1;

        case E_VNx8SImode:
          if (GET_MODE (x2) != E_VNx8SImode
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[2], E_VNx8SImode))
            return -1;
          return 2;

        case E_VNx4DImode:
          if (GET_MODE (x2) != E_VNx4DImode
              || GET_MODE (x3) != E_VNx4DImode
              || !aligned_register_operand (operands[2], E_VNx4DImode))
            return -1;
          return 3;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[2], E_VNx16BFmode))
            return -1;
          return 4;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[2], E_VNx16HFmode))
            return -1;
          return 5;

        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[2], E_VNx8SFmode))
            return -1;
          return 6;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[2], E_VNx4DFmode))
            return -1;
          return 7;

        case E_VNx64QImode:
          if (GET_MODE (x2) != E_VNx64QImode
              || GET_MODE (x3) != E_VNx64QImode
              || !aligned_register_operand (operands[2], E_VNx64QImode))
            return -1;
          return 8;

        case E_VNx32HImode:
          if (GET_MODE (x2) != E_VNx32HImode
              || GET_MODE (x3) != E_VNx32HImode
              || !aligned_register_operand (operands[2], E_VNx32HImode))
            return -1;
          return 9;

        case E_VNx16SImode:
          if (GET_MODE (x2) != E_VNx16SImode
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[2], E_VNx16SImode))
            return -1;
          return 10;

        case E_VNx8DImode:
          if (GET_MODE (x2) != E_VNx8DImode
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[2], E_VNx8DImode))
            return -1;
          return 11;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[2], E_VNx32BFmode))
            return -1;
          return 12;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[2], E_VNx32HFmode))
            return -1;
          return 13;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[2], E_VNx16SFmode))
            return -1;
          return 14;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[2], E_VNx8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[3] = x8;
      switch (GET_MODE (x5))
        {
        case E_VNx32QImode:
          if (GET_MODE (x2) != E_VNx32QImode
              || GET_MODE (x3) != E_VNx32QImode
              || !aligned_register_operand (operands[3], E_VNx32QImode))
            return -1;
          return 16;

        case E_VNx16HImode:
          if (GET_MODE (x2) != E_VNx16HImode
              || GET_MODE (x3) != E_VNx16HImode
              || !aligned_register_operand (operands[3], E_VNx16HImode))
            return -1;
          return 17;

        case E_VNx8SImode:
          if (GET_MODE (x2) != E_VNx8SImode
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[3], E_VNx8SImode))
            return -1;
          return 18;

        case E_VNx4DImode:
          if (GET_MODE (x2) != E_VNx4DImode
              || GET_MODE (x3) != E_VNx4DImode
              || !aligned_register_operand (operands[3], E_VNx4DImode))
            return -1;
          return 19;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[3], E_VNx16BFmode))
            return -1;
          return 20;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[3], E_VNx16HFmode))
            return -1;
          return 21;

        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[3], E_VNx8SFmode))
            return -1;
          return 22;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[3], E_VNx4DFmode))
            return -1;
          return 23;

        case E_VNx64QImode:
          if (GET_MODE (x2) != E_VNx64QImode
              || GET_MODE (x3) != E_VNx64QImode
              || !aligned_register_operand (operands[3], E_VNx64QImode))
            return -1;
          return 24;

        case E_VNx32HImode:
          if (GET_MODE (x2) != E_VNx32HImode
              || GET_MODE (x3) != E_VNx32HImode
              || !aligned_register_operand (operands[3], E_VNx32HImode))
            return -1;
          return 25;

        case E_VNx16SImode:
          if (GET_MODE (x2) != E_VNx16SImode
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[3], E_VNx16SImode))
            return -1;
          return 26;

        case E_VNx8DImode:
          if (GET_MODE (x2) != E_VNx8DImode
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[3], E_VNx8DImode))
            return -1;
          return 27;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[3], E_VNx32BFmode))
            return -1;
          return 28;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[3], E_VNx32HFmode))
            return -1;
          return 29;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[3], E_VNx16SFmode))
            return -1;
          return 30;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[3], E_VNx8DFmode))
            return -1;
          return 31;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern301 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_comparison_operator (operands[1], i1)
      || !general_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern303 (x1, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern303 (x1, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern303 (x1, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (pattern303 (x1, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_vsm_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern314 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern317 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern317 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern317 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern327 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern319 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern319 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern319 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern333 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx4SImode))
    return -1;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_si (operands[2], i1))
    return -1;
  return 0;
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case LT:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 0;

    case LE:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 1;

    case EQ:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 2;

    case GE:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 3;

    case GT:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 4;

    case LTU:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 5;

    case LEU:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 6;

    case GEU:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 7;

    case GTU:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!aarch64_simd_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 8;

    case NE:
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != AND
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x7, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x11 = XEXP (x8, 1);
      operands[2] = x11;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern383 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern388 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern392 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CC_SWPmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CC_SWPmode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  return pattern391 (x4); /* [-1, 1] */
}

int
pattern397 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern396 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern396 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern396 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern404 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern408 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern412 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_reg_or_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_reg_or_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[2] = x3;
  if (!aarch64_simd_or_scalar_imm_zero (operands[2], E_V8QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  return 0;
}

int
pattern426 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern420 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern420 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern420 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern420 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern434 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern433 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern433 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern433 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern440 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_int_rnd_operand (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[3], i1)
      || !register_operand (operands[1], E_V8QImode))
    return -1;
  return 0;
}

int
pattern445 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern447 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern34 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern34 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern34 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern34 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern34 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern34 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern34 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_HImode:
      if (pattern34 (x1, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_QImode:
      if (pattern34 (x1, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern445 (x1, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_DImode:
      if (pattern445 (x1, pnum_clobbers, 
E_DImode) != 0)
        return -1;
      return 10;

    case E_VNx16QImode:
      if (pattern446 (x1, 
E_VNx16QImode) != 0)
        return -1;
      return 11;

    case E_VNx8HImode:
      if (pattern446 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 12;

    case E_VNx4SImode:
      if (pattern446 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 13;

    case E_VNx2DImode:
      if (pattern446 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern464 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4DImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 4;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[6], E_VNx4BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[5], E_VNx4BImode)
      || !register_operand (operands[2], E_VNx4SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx4QImode:
      if (!aarch64_sve_gather_offset_b (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx4QImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!aarch64_sve_gather_offset_h (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx4HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern483 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  operands[4] = x5;
  x6 = XVECEXP (x3, 0, 0);
  operands[5] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern482 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern482 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern482 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern482 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern497 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern496 (x1, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern496 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern496 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern496 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern496 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern507 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          return pattern501 (x1, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx4SImode:
          if (pattern501 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx2DImode:
          if (pattern501 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 168)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern506 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
            return -1;
          return 3;

        case E_VNx2DImode:
          if (pattern506 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern523 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (!register_operand (operands[2], E_DImode))
                return -1;
              return 1;

            case E_SImode:
              if (!register_operand (operands[2], E_SImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      res = pattern16 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern538 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern537 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern537 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern537 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern546 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HImode)
      || GET_MODE (x1) != E_V8HImode
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern545 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern553 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern551 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern551 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern551 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern551 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      if (pattern551 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern551 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern564 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_VNx32BImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_NZCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_VNx32BImode))
    return -1;
  x9 = XVECEXP (x3, 0, 1);
  operands[1] = x9;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x10 = XVECEXP (x3, 0, 2);
  operands[2] = x10;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern580 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[3] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  return 0;
}

int
pattern585 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !aarch64_simd_shift_imm_qi (operands[1], E_VOIDmode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !aarch64_simd_shift_imm_hi (operands[1], E_VOIDmode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_simd_shift_imm_si (operands[1], E_VOIDmode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_simd_shift_imm_di (operands[1], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern593 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_logical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern609 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_1_to_3_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern617 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x4, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern615 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern615 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 1;

        case E_V2DImode:
          if (pattern615 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != VEC_SELECT)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != VEC_SELECT)
        return -1;
      x10 = XEXP (x6, 0);
      operands[2] = x10;
      x11 = XEXP (x6, 1);
      operands[4] = x11;
      x12 = XEXP (x7, 0);
      operands[3] = x12;
      x13 = XEXP (x7, 1);
      if (!rtx_equal_p (x13, operands[4]))
        return -1;
      x14 = XEXP (x8, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x8, 1);
      if (!rtx_equal_p (x15, operands[4]))
        return -1;
      x16 = XEXP (x9, 0);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern616 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V4SImode:
          if (pattern616 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern616 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern641 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern295 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern295 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern295 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern295 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern650 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern659 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern664 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern659 (x1, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern659 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern663 (x1, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern663 (x1, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x7 = XVECEXP (x6, 0, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x4 = XEXP (x1, 1);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x3) != E_HImode
              || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode))
                return -1;
              return 4;

            case E_V8HImode:
              if (!register_operand (operands[2], E_V8HImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x3) != E_SImode
              || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2SImode:
              if (!register_operand (operands[2], E_V2SImode))
                return -1;
              return 6;

            case E_V4SImode:
              if (!register_operand (operands[2], E_V4SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern694 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern700 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[3] = x4;
          operands[2] = x3;
          return 0;

        case MULT:
          operands[4] = x3;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 125)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 125)
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x7))
        {
        case SMAX:
          res = pattern699 (x1, 
SMIN);
          if (res >= 0)
            return res + 2; /* [2, 11] */
          return -1;

        case UMAX:
          res = pattern699 (x1, 
UMIN);
          if (res >= 0)
            return res + 12; /* [12, 21] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern710 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_lanes_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_stp_reg_operand (operands[1], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern714 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern712 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern712 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern712 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern712 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern712 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern712 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern712 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern712 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern712 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern712 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_VNx2HFmode:
      if (pattern712 (x1, 
E_VNx2HFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (pattern712 (x1, 
E_VNx4HFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 11;

    case E_VNx2SFmode:
      if (pattern712 (x1, 
E_VNx2SFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 12;

    case E_VNx8HFmode:
      if (pattern712 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 13;

    case E_VNx4SFmode:
      if (pattern712 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 14;

    case E_VNx2DFmode:
      if (pattern712 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 15;

    case E_VNx2BFmode:
      if (pattern712 (x1, 
E_VNx2BFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 16;

    case E_VNx4BFmode:
      if (pattern712 (x1, 
E_VNx4BFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 17;

    case E_VNx8BFmode:
      if (pattern712 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 18;

    case E_VNx32QImode:
      if (pattern713 (x1, 
E_VNx32QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 19;

    case E_VNx16HImode:
      if (pattern713 (x1, 
E_VNx16HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 20;

    case E_VNx8SImode:
      if (pattern713 (x1, 
E_VNx8SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 21;

    case E_VNx4DImode:
      if (pattern713 (x1, 
E_VNx4DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 22;

    case E_VNx16BFmode:
      if (pattern713 (x1, 
E_VNx16BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 23;

    case E_VNx16HFmode:
      if (pattern713 (x1, 
E_VNx16HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 24;

    case E_VNx8SFmode:
      if (pattern713 (x1, 
E_VNx8SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 25;

    case E_VNx4DFmode:
      if (pattern713 (x1, 
E_VNx4DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 26;

    case E_VNx48QImode:
      if (pattern713 (x1, 
E_VNx48QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 27;

    case E_VNx24HImode:
      if (pattern713 (x1, 
E_VNx24HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 28;

    case E_VNx12SImode:
      if (pattern713 (x1, 
E_VNx12SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 29;

    case E_VNx6DImode:
      if (pattern713 (x1, 
E_VNx6DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 30;

    case E_VNx24BFmode:
      if (pattern713 (x1, 
E_VNx24BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 31;

    case E_VNx24HFmode:
      if (pattern713 (x1, 
E_VNx24HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 32;

    case E_VNx12SFmode:
      if (pattern713 (x1, 
E_VNx12SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 33;

    case E_VNx6DFmode:
      if (pattern713 (x1, 
E_VNx6DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 34;

    case E_VNx64QImode:
      if (pattern713 (x1, 
E_VNx64QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 35;

    case E_VNx32HImode:
      if (pattern713 (x1, 
E_VNx32HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 36;

    case E_VNx16SImode:
      if (pattern713 (x1, 
E_VNx16SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 37;

    case E_VNx8DImode:
      if (pattern713 (x1, 
E_VNx8DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 38;

    case E_VNx32BFmode:
      if (pattern713 (x1, 
E_VNx32BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 39;

    case E_VNx32HFmode:
      if (pattern713 (x1, 
E_VNx32HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 40;

    case E_VNx16SFmode:
      if (pattern713 (x1, 
E_VNx16SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 41;

    case E_VNx8DFmode:
      if (pattern713 (x1, 
E_VNx8DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 42;

    default:
      return -1;
    }
}

int
pattern770 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern765 (x1, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern765 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern769 (x1, 
E_HImode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern769 (x1, 
E_SImode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      x4 = XEXP (x1, 0);
      operands[4] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x7 = XVECEXP (x6, 0, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode))
                return -1;
              return 4;

            case E_V8HImode:
              if (!register_operand (operands[2], E_V8HImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2SImode:
              if (!register_operand (operands[2], E_V2SImode))
                return -1;
              return 6;

            case E_V4SImode:
              if (!register_operand (operands[2], E_V4SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern821 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern828 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  return pattern827 (x2, 
i1); /* [-1, 0] */
}

int
pattern833 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern840 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !memory_operand (operands[1], i1)
      || !memory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern846 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[5] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern855 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          return pattern853 (x1, 
E_VNx16QImode, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SImode:
          if (pattern853 (x1, 
E_VNx8HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DImode:
          if (pattern853 (x1, 
E_VNx4SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 0);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern854 (x1, 
E_VNx8HImode, 
E_VNx16QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SImode:
          if (pattern854 (x1, 
E_VNx4SImode, 
E_VNx8HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DImode:
          if (pattern854 (x1, 
E_VNx2DImode, 
E_VNx4SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern875 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_VNx2DImode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern873 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern873 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern873 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern874 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern874 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SImode:
          if (pattern874 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern891 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_imm_zero (operands[2], i1)
      || !aarch64_simd_imm_minus_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern896 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  x6 = XEXP (x1, 1);
  operands[2] = x6;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || !aarch64_shift_imm_si (operands[1], E_QImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || !aarch64_shift_imm_di (operands[1], E_QImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern905 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_and_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern911 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x1, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern910 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern910 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern910 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern924 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern965 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern969 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_imm_zero (operands[2], i1)
      || !aarch64_simd_imm_minus_one (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern976 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 92
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 691
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 89
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 89
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern983 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[2] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  operands[5] = x11;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  switch (XINT (x6, 1))
    {
    case 357:
      return pattern980 (x3); /* [-1, 5] */

    case 358:
      res = pattern980 (x3);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    case 359:
      res = pattern980 (x3);
      if (res >= 0)
        return res + 12; /* [12, 17] */
      return -1;

    case 364:
      res = pattern980 (x3);
      if (res >= 0)
        return res + 18; /* [18, 23] */
      return -1;

    case 365:
      res = pattern980 (x3);
      if (res >= 0)
        return res + 24; /* [24, 29] */
      return -1;

    case 366:
      res = pattern980 (x3);
      if (res >= 0)
        return res + 30; /* [30, 35] */
      return -1;

    case 367:
      x13 = XEXP (x4, 1);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BImode:
              if (pattern981 (x3, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
                return -1;
              return 36;

            case E_VNx4BImode:
              if (pattern981 (x3, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
                return -1;
              return 37;

            case E_VNx2BImode:
              if (pattern981 (x3, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
                return -1;
              return 38;

            default:
              return -1;
            }

        case NOT:
          x14 = XEXP (x13, 0);
          operands[4] = x14;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BImode:
              if (pattern982 (x3, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
                return -1;
              return 39;

            case E_VNx4BImode:
              if (pattern982 (x3, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
                return -1;
              return 40;

            case E_VNx2BImode:
              if (pattern982 (x3, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
                return -1;
              return 41;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1010 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1016 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_imm_zero (operands[2], i1)
      || !aarch64_simd_imm_minus_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1025 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || GET_MODE (x2) != E_V2SImode
      || !register_operand (operands[2], E_V8QImode)
      || !immediate_operand (operands[4], E_SImode)
      || !register_operand (operands[1], E_V2SImode)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1032 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1041 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1039 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1039 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1039 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1039 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern1040 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HFmode:
          if (pattern1040 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SFmode:
          if (pattern1040 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DFmode:
          if (pattern1040 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1065 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4DImode:
      if (!aligned_register_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x1) != E_VNx4DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx4DImode)
        return -1;
      return 0;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x1) != E_VNx8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1075 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SFmode
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1085 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1092 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i2)
      || !aarch64_simd_umax_half_mode (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1102 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  switch (GET_CODE (x10))
    {
    case AND:
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != i1)
        return -1;
      return pattern920 (x1); /* [-1, 1] */

    case ZERO_EXTEND:
      if (GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != AND
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != i1
          || GET_MODE (x12) != E_SImode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x13 = XEXP (x12, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x11, 1);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1120 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern851 (x1, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern851 (x1, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      res = pattern851 (x1, 
E_VNx2DFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1137 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1146 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1163 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1173 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1178 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[2], E_SImode)
          || !aarch64_shift_imm_si (operands[3], E_QImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !aarch64_shift_imm_di (operands[3], E_QImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_simd_reg_or_zero (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx4BImode:
      return 0;

    case E_VNx2BImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1209 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || !aarch64_plus_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1216 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1221 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  return 0;
}

int
pattern1234 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1241 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_int_rnd_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1249 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[3] = x5;
  x6 = XVECEXP (x3, 0, 3);
  x7 = XVECEXP (x6, 0, 0);
  operands[4] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[5] = x8;
  if (!aarch64_sve_ptrue_flag (operands[5], E_SImode))
    return -1;
  return pattern1248 (x1, 
i1); /* [-1, 7] */
}

int
pattern1257 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_arith_with_sub_immediate (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1262 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  operands[5] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[6] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern461 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern461 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern461 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_plus_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_logical_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1284 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i2))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i2))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1297 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_hi_half (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1308 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1313 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_carry_operation (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !aarch64_carry_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1321 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1328 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[2], E_VNx16BFmode)
          || !aligned_register_operand (operands[3], E_VNx16BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[2], E_VNx32BFmode)
          || !aligned_register_operand (operands[3], E_VNx32BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[2], E_VNx16HFmode)
          || !aligned_register_operand (operands[3], E_VNx16HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[2], E_VNx32HFmode)
          || !aligned_register_operand (operands[3], E_VNx32HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1338 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1343 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || pattern1292 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1364 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1374 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  if (!cc_register (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case LABEL_REF:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      operands[0] = x3;
      operands[1] = x5;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      return 59; /* aarch64_bcond */

    case COMPARE:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 113)
        return -1;
      x8 = XEXP (x1, 0);
      operands[1] = x8;
      operands[4] = x3;
      operands[0] = x5;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      x11 = XVECEXP (x7, 0, 0);
      operands[5] = x11;
      if (!immediate_operand (operands[5], E_VOIDmode))
        return -1;
      if (cc_register (operands[1], E_CCmode)
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x6) == E_CCmode
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && aarch64_ccmp_operand (operands[3], E_SImode))
                return 84; /* ccmpccsi */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && aarch64_ccmp_operand (operands[3], E_DImode))
                return 85; /* ccmpccdi */
              break;

            default:
              break;
            }
        }
      if (cc_register (operands[1], E_CCFPmode))
        {
          switch (pattern1260 (x2, 
E_CCFPmode))
            {
            case 0:
              if (
#line 1104 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 86; /* ccmpccfpsf */
              break;

            case 1:
              if (
#line 1104 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 87; /* ccmpccfpdf */
              break;

            default:
              break;
            }
        }
      if (!cc_register (operands[1], E_CCFPEmode))
        return -1;
      switch (pattern1260 (x2, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 1104 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 88; /* ccmpccfpesf */

        case 1:
          if (!
#line 1104 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 89; /* ccmpccfpedf */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 113)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != COMPARE)
        return -1;
      x8 = XEXP (x1, 0);
      operands[1] = x8;
      operands[4] = x3;
      operands[0] = x5;
      x12 = XVECEXP (x6, 0, 0);
      operands[5] = x12;
      if (!immediate_operand (operands[5], E_VOIDmode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[2] = x13;
      x14 = XEXP (x7, 1);
      operands[3] = x14;
      if (cc_register (operands[1], E_CCmode)
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x6) == E_CCmode
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && aarch64_ccmp_operand (operands[3], E_SImode))
                return 90; /* ccmpccsi_rev */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && aarch64_ccmp_operand (operands[3], E_DImode))
                return 91; /* ccmpccdi_rev */
              break;

            default:
              break;
            }
        }
      if (cc_register (operands[1], E_CCFPmode))
        {
          switch (pattern1261 (x2, 
E_CCFPmode))
            {
            case 0:
              if (
#line 1141 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 92; /* ccmpccfpsf_rev */
              break;

            case 1:
              if (
#line 1141 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 93; /* ccmpccfpdf_rev */
              break;

            default:
              break;
            }
        }
      if (!cc_register (operands[1], E_CCFPEmode))
        return -1;
      switch (pattern1261 (x2, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 1141 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 94; /* ccmpccfpesf_rev */

        case 1:
          if (!
#line 1141 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 95; /* ccmpccfpedf_rev */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[3] = x6;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      operands[1] = x3;
      operands[2] = x5;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern1051 (x2, 
E_QImode) != 0
              || !
#line 4717 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 497; /* *cmovqi_insn */

        case E_HImode:
          if (pattern1051 (x2, 
E_HImode) != 0
              || !
#line 4717 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 498; /* *cmovhi_insn */

        case E_SImode:
          if (pattern1051 (x2, 
E_SImode) != 0
              || !
#line 4717 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 499; /* *cmovsi_insn */

        case E_DImode:
          if (pattern1051 (x2, 
E_DImode) != 0
              || !
#line 4717 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 500; /* *cmovdi_insn */

        case E_SFmode:
          if (pattern1052 (x2, 
E_SFmode) != 0
              || !
#line 4794 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 505; /* *cmovsf_insn */

        case E_DFmode:
          if (pattern1052 (x2, 
E_DFmode) != 0
              || !
#line 4794 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 506; /* *cmovdf_insn */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != ZERO_EXTEND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      operands[1] = x3;
      operands[2] = x5;
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 504; /* *cmovdi_insn_uxtw */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode)
          || GET_MODE (x3) != E_V4x8QImode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4574; /* aarch64_simd_ld4rv8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode)
          || GET_MODE (x3) != E_V4x4HImode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4575; /* aarch64_simd_ld4rv4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode)
          || GET_MODE (x3) != E_V4x2SImode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4576; /* aarch64_simd_ld4rv2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode)
          || GET_MODE (x3) != E_V4x1DImode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4577; /* aarch64_simd_ld4rdi */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode)
          || GET_MODE (x3) != E_V4x4HFmode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4578; /* aarch64_simd_ld4rv4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode)
          || GET_MODE (x3) != E_V4x2SFmode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4579; /* aarch64_simd_ld4rv2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode)
          || GET_MODE (x3) != E_V4x1DFmode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4580; /* aarch64_simd_ld4rdf */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode)
          || GET_MODE (x3) != E_V4x4BFmode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4581; /* aarch64_simd_ld4rv4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode)
          || GET_MODE (x3) != E_V4x16QImode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4582; /* aarch64_simd_ld4rv16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode)
          || GET_MODE (x3) != E_V4x8HImode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4583; /* aarch64_simd_ld4rv8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode)
          || GET_MODE (x3) != E_V4x4SImode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4584; /* aarch64_simd_ld4rv4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode)
          || GET_MODE (x3) != E_V4x2DImode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4585; /* aarch64_simd_ld4rv2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode)
          || GET_MODE (x3) != E_V4x8HFmode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4586; /* aarch64_simd_ld4rv8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode)
          || GET_MODE (x3) != E_V4x4SFmode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4587; /* aarch64_simd_ld4rv4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode)
          || GET_MODE (x3) != E_V4x2DFmode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4588; /* aarch64_simd_ld4rv2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode)
          || GET_MODE (x3) != E_V4x8BFmode
          || !
#line 7822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4589; /* aarch64_simd_ld4rv8bf */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode)
          || GET_MODE (x3) != E_V4x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8QImode)
          || !
#line 8473 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4864; /* aarch64_ld4v8qi_dreg */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode)
          || GET_MODE (x3) != E_V4x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HImode)
          || !
#line 8473 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4865; /* aarch64_ld4v4hi_dreg */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode)
          || GET_MODE (x3) != E_V4x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SImode)
          || !
#line 8473 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4866; /* aarch64_ld4v2si_dreg */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode)
          || GET_MODE (x3) != E_V4x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HFmode)
          || !
#line 8473 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4867; /* aarch64_ld4v4hf_dreg */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode)
          || GET_MODE (x3) != E_V4x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SFmode)
          || !
#line 8473 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4868; /* aarch64_ld4v2sf_dreg */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode)
          || GET_MODE (x3) != E_V4x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4BFmode)
          || !
#line 8473 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4869; /* aarch64_ld4v4bf_dreg */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode)
          || GET_MODE (x3) != E_V4x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DImode)
          || !
#line 8483 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4870; /* aarch64_ld4di_dreg */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode)
          || GET_MODE (x3) != E_V4x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DFmode)
          || !
#line 8483 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4871; /* aarch64_ld4df_dreg */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x16QImode)
          || !
#line 7712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4502; /* aarch64_simd_ld3v16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HImode)
          || !
#line 7712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4503; /* aarch64_simd_ld3v8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SImode)
          || !
#line 7712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4504; /* aarch64_simd_ld3v4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DImode)
          || !
#line 7712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4505; /* aarch64_simd_ld3v2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HFmode)
          || !
#line 7712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4506; /* aarch64_simd_ld3v8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SFmode)
          || !
#line 7712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4507; /* aarch64_simd_ld3v4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DFmode)
          || !
#line 7712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4508; /* aarch64_simd_ld3v2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8BFmode)
          || !
#line 7712 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4509; /* aarch64_simd_ld3v8bf */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5067; /* aarch64_rev64v8qi */

    case 1:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5076; /* aarch64_rev64v16qi */

    case 2:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5079; /* aarch64_rev64v4hi */

    case 3:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5088; /* aarch64_rev64v8hi */

    case 4:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5091; /* aarch64_rev64v2si */

    case 5:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5100; /* aarch64_rev64v4si */

    case 6:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5103; /* aarch64_rev64v2di */

    case 7:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5106; /* aarch64_rev64v4hf */

    case 8:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5115; /* aarch64_rev64v8hf */

    case 9:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5118; /* aarch64_rev64v4bf */

    case 10:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5127; /* aarch64_rev64v8bf */

    case 11:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5130; /* aarch64_rev64v2sf */

    case 12:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5139; /* aarch64_rev64v4sf */

    case 13:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5142; /* aarch64_rev64v2df */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern74 (x1))
    {
    case 0:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13061; /* aarch64_sve_uzpvnx64qi */

    case 1:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13063; /* aarch64_sve_uzpvnx32hi */

    case 2:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13065; /* aarch64_sve_uzpvnx16si */

    case 3:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13067; /* aarch64_sve_uzpvnx8di */

    case 4:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13069; /* aarch64_sve_uzpvnx32bf */

    case 5:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13071; /* aarch64_sve_uzpvnx32hf */

    case 6:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13073; /* aarch64_sve_uzpvnx16sf */

    case 7:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13075; /* aarch64_sve_uzpvnx8df */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern56 (x1))
    {
    case 0:
      if (!(
#line 7009 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 942; /* nearbyinthf2 */

    case 1:
      if (!
#line 7009 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 949; /* nearbyintsf2 */

    case 2:
      if (!
#line 7009 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 956; /* nearbyintdf2 */

    case 3:
      if (!(
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2541; /* nearbyintv4hf2 */

    case 4:
      if (!(
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2554; /* nearbyintv8hf2 */

    case 5:
      if (!
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2569; /* nearbyintv2sf2 */

    case 6:
      if (!
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2582; /* nearbyintv4sf2 */

    case 7:
      if (!
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2589; /* nearbyintv2df2 */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      switch (XINT (x3, 1))
        {
        case 316:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6965; /* aarch64_pred_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6968; /* aarch64_pred_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6971; /* aarch64_pred_revbvnx4si */

            case E_VNx2DImode:
              if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6974; /* aarch64_pred_revbvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6966; /* aarch64_pred_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6969; /* aarch64_pred_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6972; /* aarch64_pred_revhvnx4si */

            case E_VNx2DImode:
              if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6975; /* aarch64_pred_revhvnx2di */

            default:
              return -1;
            }

        case 319:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6967; /* aarch64_pred_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6970; /* aarch64_pred_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6973; /* aarch64_pred_revwvnx4si */

            case E_VNx2DImode:
              if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3386 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6976; /* aarch64_pred_revwvnx2di */

            default:
              return -1;
            }

        case 320:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              switch (pattern994 (x2, 
E_VNx16QImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 8))
                    return -1;
                  return 6977; /* aarch64_sve_revbhw_vnx16qivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 8))
                    return -1;
                  return 6996; /* aarch64_sve_revbhw_vnx16qivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 8))
                    return -1;
                  return 7015; /* aarch64_sve_revbhw_vnx16qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8QImode:
              switch (pattern994 (x2, 
E_VNx8QImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6978; /* aarch64_sve_revbhw_vnx8qivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6997; /* aarch64_sve_revbhw_vnx8qivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 7016; /* aarch64_sve_revbhw_vnx8qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4QImode:
              switch (pattern994 (x2, 
E_VNx4QImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6979; /* aarch64_sve_revbhw_vnx4qivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6998; /* aarch64_sve_revbhw_vnx4qivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 7017; /* aarch64_sve_revbhw_vnx4qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2QImode:
              switch (pattern994 (x2, 
E_VNx2QImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6980; /* aarch64_sve_revbhw_vnx2qivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6999; /* aarch64_sve_revbhw_vnx2qivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 7018; /* aarch64_sve_revbhw_vnx2qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HImode:
              switch (pattern994 (x2, 
E_VNx8HImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6981; /* aarch64_sve_revbhw_vnx8hivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 7000; /* aarch64_sve_revbhw_vnx8hivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 7019; /* aarch64_sve_revbhw_vnx8hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HImode:
              switch (pattern994 (x2, 
E_VNx4HImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6982; /* aarch64_sve_revbhw_vnx4hivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 7001; /* aarch64_sve_revbhw_vnx4hivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 7020; /* aarch64_sve_revbhw_vnx4hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HImode:
              switch (pattern994 (x2, 
E_VNx2HImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6983; /* aarch64_sve_revbhw_vnx2hivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 7002; /* aarch64_sve_revbhw_vnx2hivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 7021; /* aarch64_sve_revbhw_vnx2hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SImode:
              switch (pattern994 (x2, 
E_VNx4SImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6984; /* aarch64_sve_revbhw_vnx4sivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 7003; /* aarch64_sve_revbhw_vnx4sivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 7022; /* aarch64_sve_revbhw_vnx4sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SImode:
              switch (pattern994 (x2, 
E_VNx2SImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6985; /* aarch64_sve_revbhw_vnx2sivnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 7004; /* aarch64_sve_revbhw_vnx2sivnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 7023; /* aarch64_sve_revbhw_vnx2sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DImode:
              switch (pattern994 (x2, 
E_VNx2DImode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6986; /* aarch64_sve_revbhw_vnx2divnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 7005; /* aarch64_sve_revbhw_vnx2divnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 7024; /* aarch64_sve_revbhw_vnx2divnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HFmode:
              switch (pattern994 (x2, 
E_VNx2HFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6987; /* aarch64_sve_revbhw_vnx2hfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 7006; /* aarch64_sve_revbhw_vnx2hfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 7025; /* aarch64_sve_revbhw_vnx2hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HFmode:
              switch (pattern994 (x2, 
E_VNx4HFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6988; /* aarch64_sve_revbhw_vnx4hfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 7007; /* aarch64_sve_revbhw_vnx4hfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 7026; /* aarch64_sve_revbhw_vnx4hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SFmode:
              switch (pattern994 (x2, 
E_VNx2SFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6989; /* aarch64_sve_revbhw_vnx2sfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 7008; /* aarch64_sve_revbhw_vnx2sfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 7027; /* aarch64_sve_revbhw_vnx2sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HFmode:
              switch (pattern994 (x2, 
E_VNx8HFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6990; /* aarch64_sve_revbhw_vnx8hfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 7009; /* aarch64_sve_revbhw_vnx8hfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 7028; /* aarch64_sve_revbhw_vnx8hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SFmode:
              switch (pattern994 (x2, 
E_VNx4SFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6991; /* aarch64_sve_revbhw_vnx4sfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 7010; /* aarch64_sve_revbhw_vnx4sfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 7029; /* aarch64_sve_revbhw_vnx4sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DFmode:
              switch (pattern994 (x2, 
E_VNx2DFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6992; /* aarch64_sve_revbhw_vnx2dfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 7011; /* aarch64_sve_revbhw_vnx2dfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 7030; /* aarch64_sve_revbhw_vnx2dfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2BFmode:
              switch (pattern994 (x2, 
E_VNx2BFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6993; /* aarch64_sve_revbhw_vnx2bfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 7012; /* aarch64_sve_revbhw_vnx2bfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 7031; /* aarch64_sve_revbhw_vnx2bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4BFmode:
              switch (pattern994 (x2, 
E_VNx4BFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6994; /* aarch64_sve_revbhw_vnx4bfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 7013; /* aarch64_sve_revbhw_vnx4bfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 7032; /* aarch64_sve_revbhw_vnx4bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx8BFmode:
              switch (pattern994 (x2, 
E_VNx8BFmode))
                {
                case 0:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6995; /* aarch64_sve_revbhw_vnx8bfvnx8bi */

                case 1:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 7014; /* aarch64_sve_revbhw_vnx8bfvnx4bi */

                case 2:
                  if (!
#line 3405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 7033; /* aarch64_sve_revbhw_vnx8bfvnx2bi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 26:
          if (pattern940 (x2) != 0
              || !
#line 3449 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12821; /* aarch64_pred_urecpevnx4si */

        case 111:
          if (pattern940 (x2) != 0
              || !
#line 3449 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12822; /* aarch64_pred_ursqrtevnx4si */

        case 317:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1054 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3751 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12972; /* aarch64_pred_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern1054 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3751 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12973; /* aarch64_pred_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern1054 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3751 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12974; /* aarch64_pred_revdvnx4si */

            case E_VNx2DImode:
              if (pattern1054 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3751 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12975; /* aarch64_pred_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern1054 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3751 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12976; /* aarch64_pred_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern1054 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3751 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12977; /* aarch64_pred_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern1054 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3751 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12978; /* aarch64_pred_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern1054 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3751 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12979; /* aarch64_pred_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_59 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern108 (x1))
    {
    case 0:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4901; /* aarch64_uzp1v8qi */

    case 1:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4911; /* aarch64_uzp1v16qi */

    case 2:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4925; /* aarch64_uzp1v4hi */

    case 3:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4935; /* aarch64_uzp1v8hi */

    case 4:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4949; /* aarch64_uzp1v2si */

    case 5:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4959; /* aarch64_uzp1v4si */

    case 6:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4965; /* aarch64_uzp1v2di */

    case 7:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4979; /* aarch64_uzp1v4hf */

    case 8:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4989; /* aarch64_uzp1v8hf */

    case 9:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5003; /* aarch64_uzp1v4bf */

    case 10:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5013; /* aarch64_uzp1v8bf */

    case 11:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5027; /* aarch64_uzp1v2sf */

    case 12:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5037; /* aarch64_uzp1v4sf */

    case 13:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5043; /* aarch64_uzp1v2df */

    case 14:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10597; /* aarch64_sve_uzp1vnx16qi */

    case 15:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10607; /* aarch64_sve_uzp1vnx8qi */

    case 16:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10617; /* aarch64_sve_uzp1vnx4qi */

    case 17:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10627; /* aarch64_sve_uzp1vnx2qi */

    case 18:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10637; /* aarch64_sve_uzp1vnx8hi */

    case 19:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10647; /* aarch64_sve_uzp1vnx4hi */

    case 20:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10657; /* aarch64_sve_uzp1vnx2hi */

    case 21:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10667; /* aarch64_sve_uzp1vnx4si */

    case 22:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10677; /* aarch64_sve_uzp1vnx2si */

    case 23:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10687; /* aarch64_sve_uzp1vnx2di */

    case 24:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10697; /* aarch64_sve_uzp1vnx2hf */

    case 25:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10707; /* aarch64_sve_uzp1vnx4hf */

    case 26:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10717; /* aarch64_sve_uzp1vnx2sf */

    case 27:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10727; /* aarch64_sve_uzp1vnx8hf */

    case 28:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10737; /* aarch64_sve_uzp1vnx4sf */

    case 29:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10747; /* aarch64_sve_uzp1vnx2df */

    case 30:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10757; /* aarch64_sve_uzp1vnx2bf */

    case 31:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10767; /* aarch64_sve_uzp1vnx4bf */

    case 32:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10777; /* aarch64_sve_uzp1vnx8bf */

    case 33:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10858; /* aarch64_sve_uzp1vnx16bi */

    case 34:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10864; /* aarch64_sve_uzp1vnx8bi */

    case 35:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10870; /* aarch64_sve_uzp1vnx4bi */

    case 36:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10876; /* aarch64_sve_uzp1vnx2bi */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode)
          || !
#line 3788 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (8 / 8), 0, 15)))
        return -1;
      return 12988; /* aarch64_sve_dupqvnx16qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || !
#line 3788 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12989; /* aarch64_sve_dupqvnx8hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || !
#line 3788 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (32 / 8), 0, 15)))
        return -1;
      return 12990; /* aarch64_sve_dupqvnx4si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || !
#line 3788 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (64 / 8), 0, 15)))
        return -1;
      return 12991; /* aarch64_sve_dupqvnx2di */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x3) != E_VNx8BFmode
          || !register_operand (operands[1], E_VNx8BFmode)
          || !
#line 3788 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12992; /* aarch64_sve_dupqvnx8bf */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3788 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12993; /* aarch64_sve_dupqvnx8hf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode)
          || !
#line 3788 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (32 / 8), 0, 15)))
        return -1;
      return 12994; /* aarch64_sve_dupqvnx4sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DFmode)
          || !
#line 3788 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (64 / 8), 0, 15)))
        return -1;
      return 12995; /* aarch64_sve_dupqvnx2df */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern83 (x1))
    {
    case 0:
      if (!(
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1141; /* fmin_nanhf3 */

    case 1:
      if (!
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1145; /* fmin_nansf3 */

    case 2:
      if (!
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1149; /* fmin_nandf3 */

    case 3:
      if (!(
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2725; /* fmin_nanv4hf3 */

    case 4:
      if (!(
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2735; /* fmin_nanv8hf3 */

    case 5:
      if (!
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2741; /* fmin_nanv2sf3 */

    case 6:
      if (!
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2751; /* fmin_nanv4sf3 */

    case 7:
      if (!
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2755; /* fmin_nanv2df3 */

    case 8:
      if (!(
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12449; /* *aarch64_sve_fminvnx16bf */

    case 9:
      if (!(
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12453; /* *aarch64_sve_fminvnx32bf */

    case 10:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12457; /* *aarch64_sve_fminvnx16hf */

    case 11:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12461; /* *aarch64_sve_fminvnx8sf */

    case 12:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12465; /* *aarch64_sve_fminvnx4df */

    case 13:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12469; /* *aarch64_sve_fminvnx32hf */

    case 14:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12473; /* *aarch64_sve_fminvnx16sf */

    case 15:
      if (!
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12477; /* *aarch64_sve_fminvnx8df */

    case 16:
      if (!(
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12481; /* aarch64_sve_single_fminvnx16bf */

    case 17:
      if (!(
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12485; /* aarch64_sve_single_fminvnx32bf */

    case 18:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12489; /* aarch64_sve_single_fminvnx16hf */

    case 19:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12493; /* aarch64_sve_single_fminvnx8sf */

    case 20:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12497; /* aarch64_sve_single_fminvnx4df */

    case 21:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12501; /* aarch64_sve_single_fminvnx32hf */

    case 22:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12505; /* aarch64_sve_single_fminvnx16sf */

    case 23:
      if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12509; /* aarch64_sve_single_fminvnx8df */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern115 (x1))
    {
    case 0:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6584; /* extract_after_last_vnx16qi */

    case 1:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6586; /* extract_after_last_vnx8qi */

    case 2:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6588; /* extract_after_last_vnx4qi */

    case 3:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6590; /* extract_after_last_vnx2qi */

    case 4:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6592; /* extract_after_last_vnx8hi */

    case 5:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6594; /* extract_after_last_vnx4hi */

    case 6:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6596; /* extract_after_last_vnx2hi */

    case 7:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6598; /* extract_after_last_vnx4si */

    case 8:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6600; /* extract_after_last_vnx2si */

    case 9:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6602; /* extract_after_last_vnx2di */

    case 10:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6604; /* extract_after_last_vnx2hf */

    case 11:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6606; /* extract_after_last_vnx4hf */

    case 12:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6610; /* extract_after_last_vnx8hf */

    case 13:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6608; /* extract_after_last_vnx2sf */

    case 14:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6612; /* extract_after_last_vnx4sf */

    case 15:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6614; /* extract_after_last_vnx2df */

    case 16:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6616; /* extract_after_last_vnx2bf */

    case 17:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6618; /* extract_after_last_vnx4bf */

    case 18:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6620; /* extract_after_last_vnx8bf */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern727 (x3, 
E_V16QImode, 
E_VNx16BImode, 
E_VNx16QImode) != 0
          || !
#line 2857 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6508; /* aarch64_sve_ld1rqvnx16qi */

    case E_VNx8HImode:
      if (pattern727 (x3, 
E_V8HImode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 2857 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6509; /* aarch64_sve_ld1rqvnx8hi */

    case E_VNx4SImode:
      if (pattern727 (x3, 
E_V4SImode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 2857 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6510; /* aarch64_sve_ld1rqvnx4si */

    case E_VNx2DImode:
      if (pattern727 (x3, 
E_V2DImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 2857 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6511; /* aarch64_sve_ld1rqvnx2di */

    case E_VNx8BFmode:
      if (pattern727 (x3, 
E_V8BFmode, 
E_VNx8BImode, 
E_VNx8BFmode) != 0
          || !
#line 2857 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6512; /* aarch64_sve_ld1rqvnx8bf */

    case E_VNx8HFmode:
      if (pattern727 (x3, 
E_V8HFmode, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
          || !
#line 2857 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6513; /* aarch64_sve_ld1rqvnx8hf */

    case E_VNx4SFmode:
      if (pattern727 (x3, 
E_V4SFmode, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
          || !
#line 2857 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6514; /* aarch64_sve_ld1rqvnx4sf */

    case E_VNx2DFmode:
      if (pattern727 (x3, 
E_V2DFmode, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
          || !
#line 2857 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6515; /* aarch64_sve_ld1rqvnx2df */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern90 (x1))
    {
    case 0:
      if (!(
#line 742 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1630; /* aarch64_rsqrtsv4hf */

    case 1:
      if (!(
#line 742 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1631; /* aarch64_rsqrtsv8hf */

    case 2:
      if (!
#line 742 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1632; /* aarch64_rsqrtsv2sf */

    case 3:
      if (!
#line 742 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1633; /* aarch64_rsqrtsv4sf */

    case 4:
      if (!
#line 742 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1634; /* aarch64_rsqrtsv2df */

    case 5:
      if (!(
#line 742 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1635; /* aarch64_rsqrtshf */

    case 6:
      if (!
#line 742 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1636; /* aarch64_rsqrtssf */

    case 7:
      if (!
#line 742 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1637; /* aarch64_rsqrtsdf */

    case 8:
      if (!
#line 5555 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8574; /* aarch64_sve_frsqrtsvnx8hf */

    case 9:
      if (!
#line 5555 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8576; /* aarch64_sve_frsqrtsvnx4sf */

    case 10:
      if (!
#line 5555 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8578; /* aarch64_sve_frsqrtsvnx2df */

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_tls_ie_symref (operands[1], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode)
          || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
        return -1;
      return 1181; /* tlsie_tiny_si */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
        return -1;
      return 1182; /* tlsie_tiny_di */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern123 (x1))
    {
    case 0:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10787; /* aarch64_sve_uzp1qvnx16qi */

    case 1:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10793; /* aarch64_sve_uzp1qvnx8hi */

    case 2:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10799; /* aarch64_sve_uzp1qvnx4si */

    case 3:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10805; /* aarch64_sve_uzp1qvnx2di */

    case 4:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10811; /* aarch64_sve_uzp1qvnx8bf */

    case 5:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10817; /* aarch64_sve_uzp1qvnx8hf */

    case 6:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10823; /* aarch64_sve_uzp1qvnx4sf */

    case 7:
      if (!
#line 9374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10829; /* aarch64_sve_uzp1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern94 (x1))
    {
    case 0:
      if (!(
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2216; /* aarch64_smaxpv4hf */

    case 1:
      if (!(
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2224; /* aarch64_smaxpv8hf */

    case 2:
      if (!
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2232; /* aarch64_smaxpv2sf */

    case 3:
      if (!
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2240; /* aarch64_smaxpv4sf */

    case 4:
      if (!
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2244; /* aarch64_smaxpv2df */

    case 5:
      if (!
#line 9174 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10503; /* aarch64_pred_reduc_smax_vnx8hf */

    case 6:
      if (!
#line 9174 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10508; /* aarch64_pred_reduc_smax_vnx4sf */

    case 7:
      if (!
#line 9174 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10513; /* aarch64_pred_reduc_smax_vnx2df */

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern91 (x1))
    {
    case 0:
      if (!
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2011; /* aarch64_simd_reg_shlv8qi_signed */

    case 1:
      if (!
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2014; /* aarch64_simd_reg_shlv16qi_signed */

    case 2:
      if (!
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2015; /* aarch64_simd_reg_shlv4hi_signed */

    case 3:
      if (!
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2018; /* aarch64_simd_reg_shlv8hi_signed */

    case 4:
      if (!
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2019; /* aarch64_simd_reg_shlv2si_signed */

    case 5:
      if (!
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2022; /* aarch64_simd_reg_shlv4si_signed */

    case 6:
      if (!
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2023; /* aarch64_simd_reg_shlv2di_signed */

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern89 (x1))
    {
    case 0:
      if (!(
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5326; /* aarch64_famaxv4hf */

    case 1:
      if (!(
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5328; /* aarch64_famaxv8hf */

    case 2:
      if (!
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5330; /* aarch64_famaxv2sf */

    case 3:
      if (!
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5332; /* aarch64_famaxv4sf */

    case 4:
      if (!
#line 10104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5334; /* aarch64_famaxv2df */

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern141 (x1))
    {
    case 0:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12928; /* aarch64_pred_reduc_orqv_vnx16qi */

    case 1:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12936; /* aarch64_pred_reduc_orqv_vnx8hi */

    case 2:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12944; /* aarch64_pred_reduc_orqv_vnx4si */

    case 3:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12952; /* aarch64_pred_reduc_orqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern121 (x1))
    {
    case 0:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10473; /* aarch64_pred_reduc_and_vnx16qi */

    case 1:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10480; /* aarch64_pred_reduc_and_vnx8hi */

    case 2:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10487; /* aarch64_pred_reduc_and_vnx4si */

    case 3:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10494; /* aarch64_pred_reduc_and_vnx2di */

    default:
      return -1;
    }
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      switch (pattern1202 (x2, 
E_VNx8HFmode))
        {
        case 0:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SFmode)
              || !
#line 10061 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
            return -1;
          return 11111; /* *cond_fcvt_truncvnx4sfvnx8hf */

        case 1:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 10061 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 11112; /* *cond_fcvt_truncvnx2dfvnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      switch (pattern1202 (x2, 
E_VNx4SFmode))
        {
        case 0:
          if (!register_operand (operands[1], E_VNx4BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4SFmode:
              if (!register_operand (operands[2], E_VNx4SFmode)
                  || !
#line 10061 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                return -1;
              return 11113; /* *cond_fcvt_truncvnx4sfvnx4sf */

            case E_VNx8HFmode:
              if (!register_operand (operands[2], E_VNx8HFmode)
                  || !
#line 10254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                return -1;
              return 11131; /* *cond_fcvt_nontruncvnx8hfvnx4sf */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 10061 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 11114; /* *cond_fcvt_truncvnx2dfvnx4sf */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (pattern1162 (x2, 
E_VNx8BFmode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 10118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
        return -1;
      return 11116; /* *cond_fcvt_truncvnx4sfvnx8bf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x2) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8HFmode:
          if (!register_operand (operands[2], E_VNx8HFmode)
              || !
#line 10254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 11132; /* *cond_fcvt_nontruncvnx8hfvnx2df */

        case E_VNx4SFmode:
          if (!register_operand (operands[2], E_VNx4SFmode)
              || !
#line 10254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 11134; /* *cond_fcvt_nontruncvnx4sfvnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern869 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7289; /* *cond_ceilvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7355; /* *cond_ceilvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7300; /* *cond_ceilvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7366; /* *cond_ceilvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7311; /* *cond_ceilvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7377; /* *cond_ceilvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3841 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7322; /* *cond_ceilvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7388; /* *cond_ceilvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3841 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7333; /* *cond_ceilvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7399; /* *cond_ceilvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3841 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7344; /* *cond_ceilvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7410; /* *cond_ceilvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11852; /* *cond_uhsubvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11895; /* *cond_uhsubvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11935; /* *cond_uhsubvnx4si_any */
}

 int
recog_240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11825; /* *cond_srshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11873; /* *cond_srshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11913; /* *cond_srshlvnx16qi_any */
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11846; /* *cond_shsubvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11890; /* *cond_shsubvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11930; /* *cond_shsubvnx4si_any */
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1059 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8598; /* *cond_fminvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8744; /* *cond_fminvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8848; /* *cond_fminvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8611; /* *cond_fminvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8757; /* *cond_fminvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8861; /* *cond_fminvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8624; /* *cond_fminvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8770; /* *cond_fminvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8874; /* *cond_fminvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8637; /* *cond_fminvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8783; /* *cond_fminvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8887; /* *cond_fminvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8698; /* *cond_fminvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8948; /* *cond_fminvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8705; /* *cond_fminvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8955; /* *cond_fminvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8712; /* *cond_fminvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8962; /* *cond_fminvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8650; /* *cond_fminvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8796; /* *cond_fminvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8900; /* *cond_fminvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8663; /* *cond_fminvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8809; /* *cond_fminvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8913; /* *cond_fminvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8676; /* *cond_fminvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8822; /* *cond_fminvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8926; /* *cond_fminvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8689; /* *cond_fminvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8835; /* *cond_fminvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8939; /* *cond_fminvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5687 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8719; /* *cond_fminvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8969; /* *cond_fminvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5687 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8726; /* *cond_fminvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8976; /* *cond_fminvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5687 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8733; /* *cond_fminvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8983; /* *cond_fminvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1127 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9328; /* *cond_fmsvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9356; /* *cond_fmsvnx8hf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9388; /* *cond_fmsvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9332; /* *cond_fmsvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9360; /* *cond_fmsvnx4sf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9392; /* *cond_fmsvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9336; /* *cond_fmsvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9364; /* *cond_fmsvnx2df_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9396; /* *cond_fmsvnx2df_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9352; /* *cond_fmsvnx8bf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9384; /* *cond_fmsvnx8bf_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9340; /* *cond_fmsvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9372; /* *cond_fmsvnx8hf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9404; /* *cond_fmsvnx8hf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9344; /* *cond_fmsvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9376; /* *cond_fmsvnx4sf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9408; /* *cond_fmsvnx4sf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9348; /* *cond_fmsvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9380; /* *cond_fmsvnx2df_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9412; /* *cond_fmsvnx2df_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9368; /* *cond_fmsvnx8bf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9400; /* *cond_fmsvnx8bf_any_strict */

    default:
      return -1;
    }
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      switch (GET_CODE (operands[3]))
        {
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1061 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7154; /* *cond_uxtvnx16qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7164; /* *cond_uxtvnx16qi_any */

            case E_VNx8QImode:
              if (pattern1061 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7155; /* *cond_uxtvnx8qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7165; /* *cond_uxtvnx8qi_any */

            case E_VNx4QImode:
              if (pattern1061 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7156; /* *cond_uxtvnx4qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7166; /* *cond_uxtvnx4qi_any */

            case E_VNx2QImode:
              if (pattern1061 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7157; /* *cond_uxtvnx2qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7167; /* *cond_uxtvnx2qi_any */

            case E_VNx8HImode:
              if (pattern1061 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7158; /* *cond_uxtvnx8hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7168; /* *cond_uxtvnx8hi_any */

            case E_VNx4HImode:
              if (pattern1061 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7159; /* *cond_uxtvnx4hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7169; /* *cond_uxtvnx4hi_any */

            case E_VNx2HImode:
              if (pattern1061 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7160; /* *cond_uxtvnx2hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7170; /* *cond_uxtvnx2hi_any */

            case E_VNx4SImode:
              if (pattern1061 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7161; /* *cond_uxtvnx4si_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7171; /* *cond_uxtvnx4si_any */

            case E_VNx2SImode:
              if (pattern1061 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7162; /* *cond_uxtvnx2si_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7172; /* *cond_uxtvnx2si_any */

            case E_VNx2DImode:
              if (pattern1061 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3521 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7163; /* *cond_uxtvnx2di_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 3545 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7173; /* *cond_uxtvnx2di_any */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern599 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7546; /* *cond_andvnx16qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7716; /* *cond_andvnx16qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7886; /* *cond_andvnx16qi_any */

            case E_VNx8QImode:
              if (pattern599 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7563; /* *cond_andvnx8qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7733; /* *cond_andvnx8qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7903; /* *cond_andvnx8qi_any */

            case E_VNx4QImode:
              if (pattern599 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7580; /* *cond_andvnx4qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7750; /* *cond_andvnx4qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7920; /* *cond_andvnx4qi_any */

            case E_VNx2QImode:
              if (pattern599 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7597; /* *cond_andvnx2qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7767; /* *cond_andvnx2qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7937; /* *cond_andvnx2qi_any */

            case E_VNx8HImode:
              if (pattern599 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7614; /* *cond_andvnx8hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7784; /* *cond_andvnx8hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7954; /* *cond_andvnx8hi_any */

            case E_VNx4HImode:
              if (pattern599 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7631; /* *cond_andvnx4hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7801; /* *cond_andvnx4hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7971; /* *cond_andvnx4hi_any */

            case E_VNx2HImode:
              if (pattern599 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7648; /* *cond_andvnx2hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7818; /* *cond_andvnx2hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7988; /* *cond_andvnx2hi_any */

            case E_VNx4SImode:
              if (pattern599 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7665; /* *cond_andvnx4si_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7835; /* *cond_andvnx4si_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8005; /* *cond_andvnx4si_any */

            case E_VNx2SImode:
              if (pattern599 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7682; /* *cond_andvnx2si_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7852; /* *cond_andvnx2si_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8022; /* *cond_andvnx2si_any */

            case E_VNx2DImode:
              if (pattern599 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7699; /* *cond_andvnx2di_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7869; /* *cond_andvnx2di_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8039; /* *cond_andvnx2di_any */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern996 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8272; /* *cond_bicvnx16qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8282; /* *cond_bicvnx16qi_any */

        case E_VNx8QImode:
          if (pattern996 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8273; /* *cond_bicvnx8qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8283; /* *cond_bicvnx8qi_any */

        case E_VNx4QImode:
          if (pattern996 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8274; /* *cond_bicvnx4qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8284; /* *cond_bicvnx4qi_any */

        case E_VNx2QImode:
          if (pattern996 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8275; /* *cond_bicvnx2qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8285; /* *cond_bicvnx2qi_any */

        case E_VNx8HImode:
          if (pattern996 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8276; /* *cond_bicvnx8hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8286; /* *cond_bicvnx8hi_any */

        case E_VNx4HImode:
          if (pattern996 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8277; /* *cond_bicvnx4hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8287; /* *cond_bicvnx4hi_any */

        case E_VNx2HImode:
          if (pattern996 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8278; /* *cond_bicvnx2hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8288; /* *cond_bicvnx2hi_any */

        case E_VNx4SImode:
          if (pattern996 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8279; /* *cond_bicvnx4si_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8289; /* *cond_bicvnx4si_any */

        case E_VNx2SImode:
          if (pattern996 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8280; /* *cond_bicvnx2si_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8290; /* *cond_bicvnx2si_any */

        case E_VNx2DImode:
          if (pattern996 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4912 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8281; /* *cond_bicvnx2di_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4930 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8291; /* *cond_bicvnx2di_any */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern735 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7548; /* *cond_xorvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7718; /* *cond_xorvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7888; /* *cond_xorvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7565; /* *cond_xorvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7735; /* *cond_xorvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7905; /* *cond_xorvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7582; /* *cond_xorvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7752; /* *cond_xorvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7922; /* *cond_xorvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7599; /* *cond_xorvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7769; /* *cond_xorvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7939; /* *cond_xorvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7616; /* *cond_xorvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7786; /* *cond_xorvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7956; /* *cond_xorvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7633; /* *cond_xorvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7803; /* *cond_xorvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7973; /* *cond_xorvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7650; /* *cond_xorvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7820; /* *cond_xorvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7990; /* *cond_xorvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7667; /* *cond_xorvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7837; /* *cond_xorvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8007; /* *cond_xorvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7684; /* *cond_xorvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7854; /* *cond_xorvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8024; /* *cond_xorvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7701; /* *cond_xorvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7871; /* *cond_xorvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8041; /* *cond_xorvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern598 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6790; /* *cond_rbitvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6880; /* *cond_rbitvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6799; /* *cond_rbitvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6889; /* *cond_rbitvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6808; /* *cond_rbitvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6898; /* *cond_rbitvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6817; /* *cond_rbitvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6907; /* *cond_rbitvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6826; /* *cond_rbitvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6916; /* *cond_rbitvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6835; /* *cond_rbitvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6925; /* *cond_rbitvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6844; /* *cond_rbitvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6934; /* *cond_rbitvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6853; /* *cond_rbitvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6943; /* *cond_rbitvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6862; /* *cond_rbitvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6952; /* *cond_rbitvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6871; /* *cond_rbitvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6961; /* *cond_rbitvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern799 (x3, 
E_V8QImode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5053; /* aarch64_extv8qi */

    case E_V16QImode:
      if (pattern799 (x3, 
E_V16QImode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5054; /* aarch64_extv16qi */

    case E_V4HImode:
      if (pattern799 (x3, 
E_V4HImode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5055; /* aarch64_extv4hi */

    case E_V8HImode:
      if (pattern799 (x3, 
E_V8HImode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5056; /* aarch64_extv8hi */

    case E_V2SImode:
      if (pattern799 (x3, 
E_V2SImode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5057; /* aarch64_extv2si */

    case E_V4SImode:
      if (pattern799 (x3, 
E_V4SImode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5058; /* aarch64_extv4si */

    case E_V2DImode:
      if (pattern799 (x3, 
E_V2DImode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5059; /* aarch64_extv2di */

    case E_V4HFmode:
      if (pattern799 (x3, 
E_V4HFmode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5060; /* aarch64_extv4hf */

    case E_V8HFmode:
      if (pattern799 (x3, 
E_V8HFmode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5061; /* aarch64_extv8hf */

    case E_V4BFmode:
      if (pattern799 (x3, 
E_V4BFmode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5062; /* aarch64_extv4bf */

    case E_V8BFmode:
      if (pattern799 (x3, 
E_V8BFmode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5063; /* aarch64_extv8bf */

    case E_V2SFmode:
      if (pattern799 (x3, 
E_V2SFmode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5064; /* aarch64_extv2sf */

    case E_V4SFmode:
      if (pattern799 (x3, 
E_V4SFmode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5065; /* aarch64_extv4sf */

    case E_V2DFmode:
      if (pattern799 (x3, 
E_V2DFmode) != 0
          || !
#line 8711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5066; /* aarch64_extv2df */

    case E_VNx16QImode:
      if (pattern800 (x3, 
E_VNx16QImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 8 / 8, 0, 255)))
        return -1;
      return 10831; /* aarch64_sve_extvnx16qi */

    case E_VNx8QImode:
      if (pattern800 (x3, 
E_VNx8QImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10832; /* aarch64_sve_extvnx8qi */

    case E_VNx4QImode:
      if (pattern800 (x3, 
E_VNx4QImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10833; /* aarch64_sve_extvnx4qi */

    case E_VNx2QImode:
      if (pattern800 (x3, 
E_VNx2QImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10834; /* aarch64_sve_extvnx2qi */

    case E_VNx8HImode:
      if (pattern800 (x3, 
E_VNx8HImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10835; /* aarch64_sve_extvnx8hi */

    case E_VNx4HImode:
      if (pattern800 (x3, 
E_VNx4HImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10836; /* aarch64_sve_extvnx4hi */

    case E_VNx2HImode:
      if (pattern800 (x3, 
E_VNx2HImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10837; /* aarch64_sve_extvnx2hi */

    case E_VNx4SImode:
      if (pattern800 (x3, 
E_VNx4SImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10838; /* aarch64_sve_extvnx4si */

    case E_VNx2SImode:
      if (pattern800 (x3, 
E_VNx2SImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10839; /* aarch64_sve_extvnx2si */

    case E_VNx2DImode:
      if (pattern800 (x3, 
E_VNx2DImode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10840; /* aarch64_sve_extvnx2di */

    case E_VNx2HFmode:
      if (pattern800 (x3, 
E_VNx2HFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10841; /* aarch64_sve_extvnx2hf */

    case E_VNx4HFmode:
      if (pattern800 (x3, 
E_VNx4HFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10842; /* aarch64_sve_extvnx4hf */

    case E_VNx2SFmode:
      if (pattern800 (x3, 
E_VNx2SFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10843; /* aarch64_sve_extvnx2sf */

    case E_VNx8HFmode:
      if (pattern800 (x3, 
E_VNx8HFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10844; /* aarch64_sve_extvnx8hf */

    case E_VNx4SFmode:
      if (pattern800 (x3, 
E_VNx4SFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10845; /* aarch64_sve_extvnx4sf */

    case E_VNx2DFmode:
      if (pattern800 (x3, 
E_VNx2DFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10846; /* aarch64_sve_extvnx2df */

    case E_VNx2BFmode:
      if (pattern800 (x3, 
E_VNx2BFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10847; /* aarch64_sve_extvnx2bf */

    case E_VNx4BFmode:
      if (pattern800 (x3, 
E_VNx4BFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10848; /* aarch64_sve_extvnx4bf */

    case E_VNx8BFmode:
      if (pattern800 (x3, 
E_VNx8BFmode) != 0
          || !
#line 9387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10849; /* aarch64_sve_extvnx8bf */

    default:
      return -1;
    }
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (pattern802 (x3, 
E_VNx16QImode, 
E_VNx32QImode, 
E_VNx16BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5810; /* vec_mask_load_lanesvnx32qivnx16qi */

    case E_VNx16HImode:
      if (pattern802 (x3, 
E_VNx8HImode, 
E_VNx16HImode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5811; /* vec_mask_load_lanesvnx16hivnx8hi */

    case E_VNx8SImode:
      if (pattern802 (x3, 
E_VNx4SImode, 
E_VNx8SImode, 
E_VNx4BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5812; /* vec_mask_load_lanesvnx8sivnx4si */

    case E_VNx4DImode:
      if (pattern802 (x3, 
E_VNx2DImode, 
E_VNx4DImode, 
E_VNx2BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5813; /* vec_mask_load_lanesvnx4divnx2di */

    case E_VNx16BFmode:
      if (pattern802 (x3, 
E_VNx8BFmode, 
E_VNx16BFmode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5814; /* vec_mask_load_lanesvnx16bfvnx8bf */

    case E_VNx16HFmode:
      if (pattern802 (x3, 
E_VNx8HFmode, 
E_VNx16HFmode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5815; /* vec_mask_load_lanesvnx16hfvnx8hf */

    case E_VNx8SFmode:
      if (pattern802 (x3, 
E_VNx4SFmode, 
E_VNx8SFmode, 
E_VNx4BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5816; /* vec_mask_load_lanesvnx8sfvnx4sf */

    case E_VNx4DFmode:
      if (pattern802 (x3, 
E_VNx2DFmode, 
E_VNx4DFmode, 
E_VNx2BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5817; /* vec_mask_load_lanesvnx4dfvnx2df */

    case E_VNx48QImode:
      if (pattern802 (x3, 
E_VNx16QImode, 
E_VNx48QImode, 
E_VNx16BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5818; /* vec_mask_load_lanesvnx48qivnx16qi */

    case E_VNx24HImode:
      if (pattern802 (x3, 
E_VNx8HImode, 
E_VNx24HImode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5819; /* vec_mask_load_lanesvnx24hivnx8hi */

    case E_VNx12SImode:
      if (pattern802 (x3, 
E_VNx4SImode, 
E_VNx12SImode, 
E_VNx4BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5820; /* vec_mask_load_lanesvnx12sivnx4si */

    case E_VNx6DImode:
      if (pattern802 (x3, 
E_VNx2DImode, 
E_VNx6DImode, 
E_VNx2BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5821; /* vec_mask_load_lanesvnx6divnx2di */

    case E_VNx24BFmode:
      if (pattern802 (x3, 
E_VNx8BFmode, 
E_VNx24BFmode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5822; /* vec_mask_load_lanesvnx24bfvnx8bf */

    case E_VNx24HFmode:
      if (pattern802 (x3, 
E_VNx8HFmode, 
E_VNx24HFmode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5823; /* vec_mask_load_lanesvnx24hfvnx8hf */

    case E_VNx12SFmode:
      if (pattern802 (x3, 
E_VNx4SFmode, 
E_VNx12SFmode, 
E_VNx4BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5824; /* vec_mask_load_lanesvnx12sfvnx4sf */

    case E_VNx6DFmode:
      if (pattern802 (x3, 
E_VNx2DFmode, 
E_VNx6DFmode, 
E_VNx2BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5825; /* vec_mask_load_lanesvnx6dfvnx2df */

    case E_VNx64QImode:
      if (pattern802 (x3, 
E_VNx16QImode, 
E_VNx64QImode, 
E_VNx16BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5826; /* vec_mask_load_lanesvnx64qivnx16qi */

    case E_VNx32HImode:
      if (pattern802 (x3, 
E_VNx8HImode, 
E_VNx32HImode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5827; /* vec_mask_load_lanesvnx32hivnx8hi */

    case E_VNx16SImode:
      if (pattern802 (x3, 
E_VNx4SImode, 
E_VNx16SImode, 
E_VNx4BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5828; /* vec_mask_load_lanesvnx16sivnx4si */

    case E_VNx8DImode:
      if (pattern802 (x3, 
E_VNx2DImode, 
E_VNx8DImode, 
E_VNx2BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5829; /* vec_mask_load_lanesvnx8divnx2di */

    case E_VNx32BFmode:
      if (pattern802 (x3, 
E_VNx8BFmode, 
E_VNx32BFmode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5830; /* vec_mask_load_lanesvnx32bfvnx8bf */

    case E_VNx32HFmode:
      if (pattern802 (x3, 
E_VNx8HFmode, 
E_VNx32HFmode, 
E_VNx8BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5831; /* vec_mask_load_lanesvnx32hfvnx8hf */

    case E_VNx16SFmode:
      if (pattern802 (x3, 
E_VNx4SFmode, 
E_VNx16SFmode, 
E_VNx4BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5832; /* vec_mask_load_lanesvnx16sfvnx4sf */

    case E_VNx8DFmode:
      if (pattern802 (x3, 
E_VNx2DFmode, 
E_VNx8DFmode, 
E_VNx2BImode) != 0
          || !
#line 1359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5833; /* vec_mask_load_lanesvnx8dfvnx2df */

    default:
      return -1;
    }
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern152 (x1))
    {
    case 0:
      if (!
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3561; /* aarch64_sqrdmlahv4hi */

    case 1:
      if (!
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3567; /* aarch64_sqrdmlahv8hi */

    case 2:
      if (!
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3569; /* aarch64_sqrdmlahv2si */

    case 3:
      if (!
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3575; /* aarch64_sqrdmlahv4si */

    case 4:
      if (!
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3577; /* aarch64_sqrdmlahhi */

    case 5:
      if (!
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3579; /* aarch64_sqrdmlahsi */

    case 6:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12035; /* aarch64_sve_sqrdmlahvnx16qi */

    case 7:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12043; /* aarch64_sve_sqrdmlahvnx8hi */

    case 8:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12051; /* aarch64_sve_sqrdmlahvnx4si */

    case 9:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12059; /* aarch64_sve_sqrdmlahvnx2di */

    case 10:
      if (!
#line 5709 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3581; /* aarch64_sqrdmlah_lanev4hi */

    case 11:
      if (!
#line 5747 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3601; /* aarch64_sqrdmlah_laneqv4hi */

    case 12:
      if (!
#line 5709 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3587; /* aarch64_sqrdmlah_lanev8hi */

    case 13:
      if (!
#line 5747 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3607; /* aarch64_sqrdmlah_laneqv8hi */

    case 14:
      if (!
#line 5709 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3589; /* aarch64_sqrdmlah_lanev2si */

    case 15:
      if (!
#line 5747 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3609; /* aarch64_sqrdmlah_laneqv2si */

    case 16:
      if (!
#line 5709 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3595; /* aarch64_sqrdmlah_lanev4si */

    case 17:
      if (!
#line 5747 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3615; /* aarch64_sqrdmlah_laneqv4si */

    case 18:
      if (!
#line 5727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3597; /* aarch64_sqrdmlah_lanehi */

    case 19:
      if (!
#line 5765 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3617; /* aarch64_sqrdmlah_laneqhi */

    case 20:
      if (!
#line 5727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3599; /* aarch64_sqrdmlah_lanesi */

    case 21:
      if (!
#line 5765 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3619; /* aarch64_sqrdmlah_laneqsi */

    case 22:
      if (!
#line 1468 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12061; /* aarch64_sve_sqrdmlah_lane_vnx8hi */

    case 23:
      if (!
#line 1468 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12063; /* aarch64_sve_sqrdmlah_lane_vnx4si */

    case 24:
      if (!
#line 1468 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12065; /* aarch64_sve_sqrdmlah_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_328 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern173 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10034; /* while_ultsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10044; /* while_ultdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10054; /* while_ultsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10064; /* while_ultdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10074; /* while_ultsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10084; /* while_ultdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10094; /* while_ultsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10104; /* while_ultdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern187 (x1))
    {
    case 0:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11345; /* aarch64_ldnt1vnx32qi */

    case 1:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11347; /* aarch64_ldnt1vnx16hi */

    case 2:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11349; /* aarch64_ldnt1vnx8si */

    case 3:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11351; /* aarch64_ldnt1vnx4di */

    case 4:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11353; /* aarch64_ldnt1vnx16bf */

    case 5:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11355; /* aarch64_ldnt1vnx16hf */

    case 6:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11357; /* aarch64_ldnt1vnx8sf */

    case 7:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11359; /* aarch64_ldnt1vnx4df */

    case 8:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11361; /* aarch64_ldnt1vnx64qi */

    case 9:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11363; /* aarch64_ldnt1vnx32hi */

    case 10:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11365; /* aarch64_ldnt1vnx16si */

    case 11:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11367; /* aarch64_ldnt1vnx8di */

    case 12:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11369; /* aarch64_ldnt1vnx32bf */

    case 13:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11371; /* aarch64_ldnt1vnx32hf */

    case 14:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11373; /* aarch64_ldnt1vnx16sf */

    case 15:
      if (!
#line 275 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11375; /* aarch64_ldnt1vnx8df */

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_VNx16BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx16BImode)
          || !
#line 9445 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10878; /* aarch64_sve_trn1_convvnx16bi */

    case E_VNx8BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx8BImode)
          || !
#line 9445 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10879; /* aarch64_sve_trn1_convvnx8bi */

    case E_VNx4BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx4BImode)
          || !
#line 9445 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10880; /* aarch64_sve_trn1_convvnx4bi */

    case E_VNx2BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx2BImode)
          || !
#line 9445 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10881; /* aarch64_sve_trn1_convvnx2bi */

    default:
      return -1;
    }
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern158 (x1))
    {
    case 0:
      if (!
#line 6705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3873; /* aarch64_ssli_nv8qi */

    case 1:
      if (!
#line 6705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3877; /* aarch64_ssli_nv16qi */

    case 2:
      if (!
#line 6705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3881; /* aarch64_ssli_nv4hi */

    case 3:
      if (!
#line 6705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3885; /* aarch64_ssli_nv8hi */

    case 4:
      if (!
#line 6705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3889; /* aarch64_ssli_nv2si */

    case 5:
      if (!
#line 6705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3893; /* aarch64_ssli_nv4si */

    case 6:
      if (!
#line 6705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3897; /* aarch64_ssli_nv2di */

    case 7:
      if (!
#line 6705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3901; /* aarch64_ssli_ndi */

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12721; /* aarch64_sve_cmla180vnx16qi */

    case 1:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12729; /* aarch64_sve_cmla180vnx8hi */

    case 2:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12737; /* aarch64_sve_cmla180vnx4si */

    case 3:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12745; /* aarch64_sve_cmla180vnx2di */

    case 4:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12753; /* aarch64_cmla180_lane_vnx8hi */

    case 5:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12761; /* aarch64_cmla180_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3080 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12770; /* aarch64_sve_cdot270vnx4si */

    case 1:
      if (!
#line 3080 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12774; /* aarch64_sve_cdot270vnx2di */

    case 2:
      if (!
#line 3097 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12778; /* aarch64_cdot270_lane_vnx4si */

    case 3:
      if (!
#line 3097 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12782; /* aarch64_cdot270_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 2805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12652; /* aarch64_pred_sminpvnx16qi */

    case 1:
      if (!
#line 2805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12657; /* aarch64_pred_sminpvnx8hi */

    case 2:
      if (!
#line 2805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12662; /* aarch64_pred_sminpvnx4si */

    case 3:
      if (!
#line 2805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12667; /* aarch64_pred_sminpvnx2di */

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern189 (x1, 
E_VNx32BImode))
    {
    case 0:
      if (!
#line 625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11586; /* aarch64_sve_pext8x2 */

    case 1:
      if (!
#line 625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11587; /* aarch64_sve_pext16x2 */

    case 2:
      if (!
#line 625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11588; /* aarch64_sve_pext32x2 */

    case 3:
      if (!
#line 625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11589; /* aarch64_sve_pext64x2 */

    default:
      return -1;
    }
}

 int
recog_396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (XWINT (x3, 0) != 1L)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CC_NZCmode)
    return -1;
  x5 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x5))
    {
    case CONST:
      operands[1] = x5;
      if (!aarch64_sve_ptrue_svpattern_immediate (operands[1], E_VNx16BImode))
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 128
          || GET_MODE (x6) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 1);
      operands[3] = x8;
      x9 = XVECEXP (x6, 0, 0);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x10 = XVECEXP (x6, 0, 1);
      operands[5] = x10;
      if (!aarch64_simd_imm_zero (operands[5], E_VNx16BImode)
          || !
#line 1054 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 5775; /* *aarch64_sve_ptruevnx16bi_ptest */

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x5), 0))
        return -1;
      x6 = XEXP (x5, 0);
      if (!aarch64_sve_ptrue_svpattern_immediate (x6, E_VNx16BImode))
        return -1;
      operands[1] = x6;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 2
          || XINT (x11, 1) != 128
          || GET_MODE (x11) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 1);
      operands[3] = x8;
      x12 = XVECEXP (x11, 0, 0);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x13 = XVECEXP (x11, 0, 1);
      operands[5] = x13;
      switch (GET_MODE (x5))
        {
        case E_VNx8BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx8BImode)
              || !
#line 1080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5776; /* *aarch64_sve_ptruevnx8bi_ptest */

        case E_VNx4BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx4BImode)
              || !
#line 1080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5777; /* *aarch64_sve_ptruevnx4bi_ptest */

        case E_VNx2BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx2BImode)
              || !
#line 1080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5778; /* *aarch64_sve_ptruevnx2bi_ptest */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x5) != 86
          || GET_MODE (x5) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      if (!rtx_equal_p (x8, operands[1])
          || !
#line 1219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      *pnum_clobbers = 1;
      return 5787; /* *aarch64_rdffr_ptest */

    case UNSPEC:
      return recog_395 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16QImode
      || pattern262 (x2, 
89, 
E_VNx16QImode, 
93) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_VNx16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 93
      || GET_MODE (x4) != E_VNx16QImode)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!pmode_register_operand (operands[1], E_VOIDmode)
          || !
#line 514 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME))
        return -1;
      return 13182; /* aarch64_sme_ldr0 */

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !aarch64_mov_operand (operands[3], E_SImode)
              || !(
#line 529 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME
   && aarch64_sme_ldr_vnum_offset_p (operands[1], operands[3])) && 
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
            return -1;
          return 13183; /* aarch64_sme_ldrnsi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !aarch64_mov_operand (operands[3], E_DImode)
              || !(
#line 529 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME
   && aarch64_sme_ldr_vnum_offset_p (operands[1], operands[3])) && 
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
            return -1;
          return 13184; /* aarch64_sme_ldrndi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_406 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 2L:
      switch (pattern998 (x2))
        {
        case 0:
          if (!
#line 4093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13119; /* aarch64_sve_luti2vnx16qi */

        case 1:
          if (!
#line 4093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13121; /* aarch64_sve_luti2vnx8hi */

        case 2:
          if (!
#line 4105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13127; /* aarch64_sve_luti2vnx16hi */

        case 3:
          if (!
#line 4093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13123; /* aarch64_sve_luti2vnx8hf */

        case 4:
          if (!
#line 4105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13129; /* aarch64_sve_luti2vnx16hf */

        case 5:
          if (!
#line 4093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13125; /* aarch64_sve_luti2vnx8bf */

        case 6:
          if (!
#line 4105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13131; /* aarch64_sve_luti2vnx16bf */

        default:
          return -1;
        }

    case 4L:
      switch (pattern998 (x2))
        {
        case 0:
          if (!
#line 4093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13120; /* aarch64_sve_luti4vnx16qi */

        case 1:
          if (!
#line 4093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13122; /* aarch64_sve_luti4vnx8hi */

        case 2:
          if (!
#line 4105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13128; /* aarch64_sve_luti4vnx16hi */

        case 3:
          if (!
#line 4093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13124; /* aarch64_sve_luti4vnx8hf */

        case 4:
          if (!
#line 4105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13130; /* aarch64_sve_luti4vnx16hf */

        case 5:
          if (!
#line 4093 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13126; /* aarch64_sve_luti4vnx8bf */

        case 6:
          if (!
#line 4105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 13132; /* aarch64_sve_luti4vnx16bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern946 (x3, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 5345 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8543; /* aarch64_pred_fscalevnx8hf */

    case E_VNx4SFmode:
      if (pattern946 (x3, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 5345 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8544; /* aarch64_pred_fscalevnx4sf */

    case E_VNx2DFmode:
      if (pattern946 (x3, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 5345 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8545; /* aarch64_pred_fscalevnx2df */

    case E_HFmode:
      if (pattern946 (x3, 
E_HImode, 
E_HFmode, 
E_VNx8BImode) != 0
          || !
#line 5345 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8546; /* aarch64_pred_fscalehf */

    case E_SFmode:
      if (pattern946 (x3, 
E_SImode, 
E_SFmode, 
E_VNx4BImode) != 0
          || !
#line 5345 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8547; /* aarch64_pred_fscalesf */

    case E_DFmode:
      if (pattern946 (x3, 
E_DImode, 
E_DFmode, 
E_VNx2BImode) != 0
          || !
#line 5345 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8548; /* aarch64_pred_fscaledf */

    default:
      return -1;
    }
}

 int
recog_420 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern193 (x2, 
E_V8QImode, 
E_V4HFmode) != 0
          || !
#line 203 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5380; /* aarch64_fdotv4hf */

    case E_V8HFmode:
      if (pattern193 (x2, 
E_V16QImode, 
E_V8HFmode) != 0
          || !
#line 204 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5381; /* aarch64_fdotv8hf */

    case E_V2SFmode:
      if (pattern193 (x2, 
E_V8QImode, 
E_V2SFmode) != 0
          || !
#line 205 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5382; /* aarch64_fdotv2sf */

    case E_V4SFmode:
      if (pattern193 (x2, 
E_V16QImode, 
E_V4SFmode) != 0
          || !
#line 206 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5383; /* aarch64_fdotv4sf */

    default:
      return -1;
    }
}

 int
recog_425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern229 (x1))
    {
    case 0:
      if (!
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13586; /* aarch64_sme_subvnx8si */

    case 1:
      if (!(
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13588; /* aarch64_sme_subvnx4di */

    case 2:
      if (!
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13590; /* aarch64_sme_subvnx16si */

    case 3:
      if (!(
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 748 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13592; /* aarch64_sme_subvnx8di */

    case 4:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13594; /* *aarch64_sme_subvnx8si_plus */

    case 5:
      if (!(
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13596; /* *aarch64_sme_subvnx4di_plus */

    case 6:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13598; /* *aarch64_sme_subvnx16si_plus */

    case 7:
      if (!(
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 748 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13600; /* *aarch64_sme_subvnx8di_plus */

    default:
      return -1;
    }
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern228 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 3);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern246 (x1))
            {
            case 0:
              if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13667; /* aarch64_sme_usdotvnx4sivnx32qi */

            case 1:
              if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13670; /* aarch64_sme_usdotvnx4sivnx64qi */

            case 2:
              if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13673; /* aarch64_sme_usdotvnx4sivnx16hi */

            case 3:
              if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13676; /* aarch64_sme_usdotvnx4sivnx32hi */

            case 4:
              if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13679; /* aarch64_sme_usdotvnx2divnx32qi */

            case 5:
              if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13682; /* aarch64_sme_usdotvnx2divnx64qi */

            case 6:
              if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13685; /* aarch64_sme_usdotvnx2divnx16hi */

            case 7:
              if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13688; /* aarch64_sme_usdotvnx2divnx32hi */

            case 8:
              if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13715; /* aarch64_sme_single_usdotvnx4sivnx32qi */

            case 9:
              if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13718; /* aarch64_sme_single_usdotvnx4sivnx64qi */

            case 10:
              if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13721; /* aarch64_sme_single_usdotvnx4sivnx16hi */

            case 11:
              if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13724; /* aarch64_sme_single_usdotvnx4sivnx32hi */

            case 12:
              if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13727; /* aarch64_sme_single_usdotvnx2divnx32qi */

            case 13:
              if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13730; /* aarch64_sme_single_usdotvnx2divnx64qi */

            case 14:
              if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13733; /* aarch64_sme_single_usdotvnx2divnx16hi */

            case 15:
              if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13736; /* aarch64_sme_single_usdotvnx2divnx32hi */

            case 16:
              if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13771; /* aarch64_sme_lane_usdotvnx4sivnx32qi */

            case 17:
              if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13779; /* aarch64_sme_lane_usdotvnx4sivnx64qi */

            case 18:
              if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13787; /* aarch64_sme_lane_usdotvnx4sivnx16hi */

            case 19:
              if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13795; /* aarch64_sme_lane_usdotvnx4sivnx32hi */

            case 20:
              if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13803; /* aarch64_sme_lane_usdotvnx2divnx32qi */

            case 21:
              if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13811; /* aarch64_sme_lane_usdotvnx2divnx64qi */

            case 22:
              if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13819; /* aarch64_sme_lane_usdotvnx2divnx16hi */

            case 23:
              if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13827; /* aarch64_sme_lane_usdotvnx2divnx32hi */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x4 = XEXP (x1, 0);
          if (GET_MODE (x4) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (GET_MODE (x5) != E_VNx4SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_VNx16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 4);
          operands[1] = x7;
          switch (GET_MODE (x3))
            {
            case E_VNx32QImode:
              if (!register_operand (operands[1], E_VNx32QImode)
                  || !
#line 1356 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13761; /* aarch64_sme_single_sudotvnx4sivnx32qi */

            case E_VNx64QImode:
              if (!register_operand (operands[1], E_VNx64QImode)
                  || !
#line 1356 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13762; /* aarch64_sme_single_sudotvnx4sivnx64qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 3);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern250 (x1))
            {
            case 0:
              if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13691; /* *aarch64_sme_usdotvnx4sivnx32qi_plus */

            case 1:
              if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13694; /* *aarch64_sme_usdotvnx4sivnx64qi_plus */

            case 2:
              if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13697; /* *aarch64_sme_usdotvnx4sivnx16hi_plus */

            case 3:
              if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13700; /* *aarch64_sme_usdotvnx4sivnx32hi_plus */

            case 4:
              if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13703; /* *aarch64_sme_usdotvnx2divnx32qi_plus */

            case 5:
              if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13706; /* *aarch64_sme_usdotvnx2divnx64qi_plus */

            case 6:
              if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13709; /* *aarch64_sme_usdotvnx2divnx16hi_plus */

            case 7:
              if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13712; /* *aarch64_sme_usdotvnx2divnx32hi_plus */

            case 8:
              if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13739; /* *aarch64_sme_single_usdotvnx4sivnx32qi_plus */

            case 9:
              if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13742; /* *aarch64_sme_single_usdotvnx4sivnx64qi_plus */

            case 10:
              if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13745; /* *aarch64_sme_single_usdotvnx4sivnx16hi_plus */

            case 11:
              if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13748; /* *aarch64_sme_single_usdotvnx4sivnx32hi_plus */

            case 12:
              if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13751; /* *aarch64_sme_single_usdotvnx2divnx32qi_plus */

            case 13:
              if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13754; /* *aarch64_sme_single_usdotvnx2divnx64qi_plus */

            case 14:
              if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13757; /* *aarch64_sme_single_usdotvnx2divnx16hi_plus */

            case 15:
              if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13760; /* *aarch64_sme_single_usdotvnx2divnx32hi_plus */

            case 16:
              if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13835; /* *aarch64_sme_lane_usdotvnx4sivnx32qi_plus */

            case 17:
              if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13843; /* *aarch64_sme_lane_usdotvnx4sivnx64qi_plus */

            case 18:
              if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13851; /* *aarch64_sme_lane_usdotvnx4sivnx16hi_plus */

            case 19:
              if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13859; /* *aarch64_sme_lane_usdotvnx4sivnx32hi_plus */

            case 20:
              if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13867; /* *aarch64_sme_lane_usdotvnx2divnx32qi_plus */

            case 21:
              if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13875; /* *aarch64_sme_lane_usdotvnx2divnx64qi_plus */

            case 22:
              if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13883; /* *aarch64_sme_lane_usdotvnx2divnx16hi_plus */

            case 23:
              if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13891; /* *aarch64_sme_lane_usdotvnx2divnx32hi_plus */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x4 = XEXP (x1, 0);
          if (GET_MODE (x4) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (GET_MODE (x5) != E_VNx4SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[3] = x6;
          if (!register_operand (operands[3], E_VNx16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 4);
          operands[2] = x7;
          switch (GET_MODE (x3))
            {
            case E_VNx32QImode:
              if (!register_operand (operands[2], E_VNx32QImode)
                  || !
#line 1371 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13763; /* *aarch64_sme_single_sudotvnx4sivnx32qi_plus */

            case E_VNx64QImode:
              if (!register_operand (operands[2], E_VNx64QImode)
                  || !
#line 1371 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13764; /* *aarch64_sme_single_sudotvnx4sivnx64qi_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_444 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 43:
      return recog_158 (x1, insn, pnum_clobbers);

    case 9:
      if (pattern75 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 4881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 507; /* aarch64_crc32b */

    case 14:
      if (pattern75 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 4881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 508; /* aarch64_crc32h */

    case 15:
      if (pattern76 (x1, 
E_SImode) != 0
          || !
#line 4881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 509; /* aarch64_crc32w */

    case 16:
      if (pattern75 (x1, 
E_DImode, 
E_SImode) != 0
          || !
#line 4881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 510; /* aarch64_crc32x */

    case 10:
      if (pattern75 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 4881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 511; /* aarch64_crc32cb */

    case 11:
      if (pattern75 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 4881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 512; /* aarch64_crc32ch */

    case 12:
      if (pattern76 (x1, 
E_SImode) != 0
          || !
#line 4881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 513; /* aarch64_crc32cw */

    case 13:
      if (pattern75 (x1, 
E_DImode, 
E_SImode) != 0
          || !
#line 4881 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 514; /* aarch64_crc32cx */

    case 84:
      if (pattern75 (x1, 
E_QImode, 
E_DImode) != 0
          || !
#line 6241 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 799; /* *aarch64_sisd_ushl */

    case 105:
      if (pattern75 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 6251 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 800; /* *aarch64_ushl_2s */

    case 83:
      if (pattern75 (x1, 
E_QImode, 
E_DImode) != 0
          || !
#line 6261 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 801; /* *aarch64_sisd_sshl */

    case 85:
      if (pattern75 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 6271 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 802; /* *aarch64_sshl_2s */

    case 19:
      return recog_152 (x1, insn, pnum_clobbers);

    case 20:
      return recog_151 (x1, insn, pnum_clobbers);

    case 79:
      return recog_150 (x1, insn, pnum_clobbers);

    case 104:
      return recog_149 (x1, insn, pnum_clobbers);

    case 196:
      return recog_95 (x1, insn, pnum_clobbers);

    case 199:
      return recog_94 (x1, insn, pnum_clobbers);

    case 277:
      return recog_93 (x1, insn, pnum_clobbers);

    case 278:
      return recog_74 (x1, insn, pnum_clobbers);

    case 42:
      return recog_128 (x1, insn, pnum_clobbers);

    case 99:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1184; /* tlsle12_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1185; /* tlsle12_di */

        default:
          return -1;
        }

    case 100:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1186; /* tlsle24_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1187; /* tlsle24_di */

        default:
          return -1;
        }

    case 74:
      if (pattern86 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1198; /* paciasp */

    case 2:
      if (pattern86 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1199; /* autiasp */

    case 75:
      if (pattern86 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1200; /* pacibsp */

    case 3:
      if (pattern86 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1201; /* autibsp */

    case 72:
      if (pattern86 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1202; /* pacia1716 */

    case 0:
      if (pattern86 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1203; /* autia1716 */

    case 73:
      if (pattern86 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1204; /* pacib1716 */

    case 1:
      if (pattern86 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1205; /* autib1716 */

    case 109:
      return recog_148 (x1, insn, pnum_clobbers);

    case 154:
      if (pattern88 (x1) != 0)
        return -1;
      return 1225; /* speculation_tracker */

    case 155:
      if (pattern88 (x1) != 0)
        return -1;
      return 1226; /* speculation_tracker_rev */

    case 405:
      return recog_171 (x1, insn, pnum_clobbers);

    case 406:
      return recog_170 (x1, insn, pnum_clobbers);

    case 112:
      return recog_119 (x1, insn, pnum_clobbers);

    case 186:
      return recog_157 (x1, insn, pnum_clobbers);

    case 185:
      return recog_156 (x1, insn, pnum_clobbers);

    case 274:
      return recog_90 (x1, insn, pnum_clobbers);

    case 208:
      return recog_124 (x1, insn, pnum_clobbers);

    case 209:
      return recog_122 (x1, insn, pnum_clobbers);

    case 206:
      return recog_123 (x1, insn, pnum_clobbers);

    case 207:
      return recog_121 (x1, insn, pnum_clobbers);

    case 198:
      return recog_147 (x1, insn, pnum_clobbers);

    case 201:
      return recog_146 (x1, insn, pnum_clobbers);

    case 197:
      return recog_145 (x1, insn, pnum_clobbers);

    case 200:
      return recog_144 (x1, insn, pnum_clobbers);

    case 202:
      return recog_143 (x1, insn, pnum_clobbers);

    case 218:
      return recog_160 (x1, insn, pnum_clobbers);

    case 271:
      return recog_112 (x1, insn, pnum_clobbers);

    case 219:
      return recog_75 (x1, insn, pnum_clobbers);

    case 221:
      return recog_88 (x1, insn, pnum_clobbers);

    case 220:
      return recog_118 (x1, insn, pnum_clobbers);

    case 216:
      return recog_73 (x1, insn, pnum_clobbers);

    case 217:
      return recog_78 (x1, insn, pnum_clobbers);

    case 229:
      return recog_142 (x1, insn, pnum_clobbers);

    case 230:
      return recog_141 (x1, insn, pnum_clobbers);

    case 231:
      return recog_92 (x1, insn, pnum_clobbers);

    case 232:
      return recog_91 (x1, insn, pnum_clobbers);

    case 227:
      return recog_98 (x1, insn, pnum_clobbers);

    case 228:
      return recog_97 (x1, insn, pnum_clobbers);

    case 233:
      return recog_117 (x1, insn, pnum_clobbers);

    case 234:
      return recog_116 (x1, insn, pnum_clobbers);

    case 226:
      return recog_96 (x1, insn, pnum_clobbers);

    case 94:
      return recog_86 (x1, insn, pnum_clobbers);

    case 95:
      return recog_85 (x1, insn, pnum_clobbers);

    case 96:
      return recog_84 (x1, insn, pnum_clobbers);

    case 183:
      return recog_115 (x1, insn, pnum_clobbers);

    case 273:
      return recog_77 (x1, insn, pnum_clobbers);

    case 242:
      return recog_89 (x1, insn, pnum_clobbers);

    case 246:
      if (pattern107 (x1, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 8665 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4888; /* aarch64_combinev16qi */

    case 247:
      return recog_71 (x1, insn, pnum_clobbers);

    case 248:
      return recog_83 (x1, insn, pnum_clobbers);

    case 251:
      return recog_82 (x1, insn, pnum_clobbers);

    case 252:
      return recog_81 (x1, insn, pnum_clobbers);

    case 249:
      return recog_80 (x1, insn, pnum_clobbers);

    case 250:
      return recog_79 (x1, insn, pnum_clobbers);

    case 28:
      return recog_114 (x1, insn, pnum_clobbers);

    case 266:
      if (pattern76 (x1, 
E_V4SImode) != 0
          || !
#line 9085 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5229; /* aarch64_crypto_sha1su1v4si */

    case 269:
      if (pattern76 (x1, 
E_V4SImode) != 0
          || !
#line 9130 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5236; /* aarch64_crypto_sha256su0v4si */

    case 292:
      if (pattern76 (x1, 
E_V2DImode) != 0
          || !
#line 9164 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
        return -1;
      return 5240; /* aarch64_crypto_sha512su0qv2di */

    case 288:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 9299 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
            return -1;
          return 5259; /* aarch64_sm4eqv4si */

        case 1:
          if (!
#line 4216 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_SM4))
            return -1;
          return 13140; /* aarch64_sve2_sm4e */

        default:
          return -1;
        }

    case 289:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 9309 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
            return -1;
          return 5260; /* aarch64_sm4ekeyqv4si */

        case 1:
          if (!
#line 4227 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_SM4))
            return -1;
          return 13141; /* aarch64_sve2_sm4ekey */

        default:
          return -1;
        }

    case 272:
      if (pattern107 (x1, 
E_V2DImode, 
E_TImode) != 0
          || !
#line 9905 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
        return -1;
      return 5286; /* aarch64_crypto_pmullv2di */

    case 586:
      if (pattern75 (x1, 
E_V4SFmode, 
E_V8BFmode) != 0
          || !
#line 10056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
        return -1;
      return 5320; /* aarch64_bfcvtn2v8bf */

    case 589:
      return recog_169 (x1, insn, pnum_clobbers);

    case 590:
      return recog_168 (x1, insn, pnum_clobbers);

    case 190:
      return recog_193 (x1, insn, pnum_clobbers);

    case 192:
      return recog_192 (x1, insn, pnum_clobbers);

    case 204:
      return recog_120 (x1, insn, pnum_clobbers);

    case 69:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[1] = x4;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      return 5578; /* *dmb */

    case 125:
      return recog_72 (x1, insn, pnum_clobbers);

    case 152:
      return recog_106 (x1, insn, pnum_clobbers);

    case 158:
      return recog_155 (x1, insn, pnum_clobbers);

    case 119:
      return recog_111 (x1, insn, pnum_clobbers);

    case 177:
      return recog_105 (x1, insn, pnum_clobbers);

    case 148:
      return recog_110 (x1, insn, pnum_clobbers);

    case 398:
      return recog_104 (x1, insn, pnum_clobbers);

    case 399:
      return recog_103 (x1, insn, pnum_clobbers);

    case 298:
      return recog_107 (x1, insn, pnum_clobbers);

    case 400:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8412; /* aarch64_sve_lslvnx16qi */

        case 1:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8415; /* aarch64_sve_lslvnx8hi */

        case 2:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8418; /* aarch64_sve_lslvnx4si */

        default:
          return -1;
        }

    case 401:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8413; /* aarch64_sve_asrvnx16qi */

        case 1:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8416; /* aarch64_sve_asrvnx8hi */

        case 2:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8419; /* aarch64_sve_asrvnx4si */

        default:
          return -1;
        }

    case 402:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8414; /* aarch64_sve_lsrvnx16qi */

        case 1:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8417; /* aarch64_sve_lsrvnx8hi */

        case 2:
          if (!
#line 5125 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8420; /* aarch64_sve_lsrvnx4si */

        default:
          return -1;
        }

    case 328:
      switch (pattern118 (x1))
        {
        case 0:
          if (!
#line 5331 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8537; /* aarch64_sve_ftsmulvnx8hf */

        case 1:
          if (!
#line 5331 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8539; /* aarch64_sve_ftsmulvnx4sf */

        case 2:
          if (!
#line 5331 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8541; /* aarch64_sve_ftsmulvnx2df */

        default:
          return -1;
        }

    case 329:
      switch (pattern118 (x1))
        {
        case 0:
          if (!
#line 5331 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8538; /* aarch64_sve_ftsselvnx8hf */

        case 1:
          if (!
#line 5331 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8540; /* aarch64_sve_ftsselvnx4sf */

        case 2:
          if (!
#line 5331 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8542; /* aarch64_sve_ftsselvnx2df */

        default:
          return -1;
        }

    case 313:
      return recog_127 (x1, insn, pnum_clobbers);

    case 314:
      return recog_125 (x1, insn, pnum_clobbers);

    case 315:
      return recog_126 (x1, insn, pnum_clobbers);

    case 308:
      return recog_191 (x1, insn, pnum_clobbers);

    case 309:
      return recog_190 (x1, insn, pnum_clobbers);

    case 310:
      return recog_189 (x1, insn, pnum_clobbers);

    case 311:
      return recog_188 (x1, insn, pnum_clobbers);

    case 312:
      return recog_187 (x1, insn, pnum_clobbers);

    case 243:
      return recog_109 (x1, insn, pnum_clobbers);

    case 172:
      return recog_140 (x1, insn, pnum_clobbers);

    case 628:
      return recog_102 (x1, insn, pnum_clobbers);

    case 629:
      return recog_100 (x1, insn, pnum_clobbers);

    case 630:
      return recog_101 (x1, insn, pnum_clobbers);

    case 631:
      return recog_99 (x1, insn, pnum_clobbers);

    case 338:
      return recog_139 (x1, insn, pnum_clobbers);

    case 339:
      return recog_138 (x1, insn, pnum_clobbers);

    case 334:
      return recog_137 (x1, insn, pnum_clobbers);

    case 335:
      return recog_136 (x1, insn, pnum_clobbers);

    case 336:
      return recog_135 (x1, insn, pnum_clobbers);

    case 337:
      return recog_133 (x1, insn, pnum_clobbers);

    case 133:
      return recog_113 (x1, insn, pnum_clobbers);

    case 612:
      return recog_154 (x1, insn, pnum_clobbers);

    case 607:
      return recog_134 (x1, insn, pnum_clobbers);

    case 609:
      return recog_76 (x1, insn, pnum_clobbers);

    case 494:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12256; /* aarch64_sve_saddwbvnx8hi */

        case 1:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12264; /* aarch64_sve_saddwbvnx4si */

        case 2:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12272; /* aarch64_sve_saddwbvnx2di */

        default:
          return -1;
        }

    case 495:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12257; /* aarch64_sve_saddwtvnx8hi */

        case 1:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12265; /* aarch64_sve_saddwtvnx4si */

        case 2:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12273; /* aarch64_sve_saddwtvnx2di */

        default:
          return -1;
        }

    case 539:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12258; /* aarch64_sve_ssubwbvnx8hi */

        case 1:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12266; /* aarch64_sve_ssubwbvnx4si */

        case 2:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12274; /* aarch64_sve_ssubwbvnx2di */

        default:
          return -1;
        }

    case 540:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12259; /* aarch64_sve_ssubwtvnx8hi */

        case 1:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12267; /* aarch64_sve_ssubwtvnx4si */

        case 2:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12275; /* aarch64_sve_ssubwtvnx2di */

        default:
          return -1;
        }

    case 551:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12260; /* aarch64_sve_uaddwbvnx8hi */

        case 1:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12268; /* aarch64_sve_uaddwbvnx4si */

        case 2:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12276; /* aarch64_sve_uaddwbvnx2di */

        default:
          return -1;
        }

    case 552:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12261; /* aarch64_sve_uaddwtvnx8hi */

        case 1:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12269; /* aarch64_sve_uaddwtvnx4si */

        case 2:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12277; /* aarch64_sve_uaddwtvnx2di */

        default:
          return -1;
        }

    case 571:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12262; /* aarch64_sve_usubwbvnx8hi */

        case 1:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12270; /* aarch64_sve_usubwbvnx4si */

        case 2:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12278; /* aarch64_sve_usubwbvnx2di */

        default:
          return -1;
        }

    case 572:
      switch (pattern124 (x1))
        {
        case 0:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12263; /* aarch64_sve_usubwtvnx8hi */

        case 1:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12271; /* aarch64_sve_usubwtvnx4si */

        case 2:
          if (!
#line 2220 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12279; /* aarch64_sve_usubwtvnx2di */

        default:
          return -1;
        }

    case 489:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12280; /* aarch64_sve_sabdlbvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12301; /* aarch64_sve_sabdlbvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12322; /* aarch64_sve_sabdlbvnx2di */

        default:
          return -1;
        }

    case 490:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12281; /* aarch64_sve_sabdltvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12302; /* aarch64_sve_sabdltvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12323; /* aarch64_sve_sabdltvnx2di */

        default:
          return -1;
        }

    case 491:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12282; /* aarch64_sve_saddlbvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12303; /* aarch64_sve_saddlbvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12324; /* aarch64_sve_saddlbvnx2di */

        default:
          return -1;
        }

    case 492:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12283; /* aarch64_sve_saddlbtvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12304; /* aarch64_sve_saddlbtvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12325; /* aarch64_sve_saddlbtvnx2di */

        default:
          return -1;
        }

    case 493:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12284; /* aarch64_sve_saddltvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12305; /* aarch64_sve_saddltvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12326; /* aarch64_sve_saddltvnx2di */

        default:
          return -1;
        }

    case 505:
      return recog_167 (x1, insn, pnum_clobbers);

    case 506:
      return recog_166 (x1, insn, pnum_clobbers);

    case 509:
      return recog_165 (x1, insn, pnum_clobbers);

    case 511:
      return recog_164 (x1, insn, pnum_clobbers);

    case 535:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12289; /* aarch64_sve_ssublbvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12310; /* aarch64_sve_ssublbvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12331; /* aarch64_sve_ssublbvnx2di */

        default:
          return -1;
        }

    case 536:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12290; /* aarch64_sve_ssublbtvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12311; /* aarch64_sve_ssublbtvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12332; /* aarch64_sve_ssublbtvnx2di */

        default:
          return -1;
        }

    case 537:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12291; /* aarch64_sve_ssubltvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12312; /* aarch64_sve_ssubltvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12333; /* aarch64_sve_ssubltvnx2di */

        default:
          return -1;
        }

    case 538:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12292; /* aarch64_sve_ssubltbvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12313; /* aarch64_sve_ssubltbvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12334; /* aarch64_sve_ssubltbvnx2di */

        default:
          return -1;
        }

    case 547:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12293; /* aarch64_sve_uabdlbvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12314; /* aarch64_sve_uabdlbvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12335; /* aarch64_sve_uabdlbvnx2di */

        default:
          return -1;
        }

    case 548:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12294; /* aarch64_sve_uabdltvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12315; /* aarch64_sve_uabdltvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12336; /* aarch64_sve_uabdltvnx2di */

        default:
          return -1;
        }

    case 549:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12295; /* aarch64_sve_uaddlbvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12316; /* aarch64_sve_uaddlbvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12337; /* aarch64_sve_uaddlbvnx2di */

        default:
          return -1;
        }

    case 550:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12296; /* aarch64_sve_uaddltvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12317; /* aarch64_sve_uaddltvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12338; /* aarch64_sve_uaddltvnx2di */

        default:
          return -1;
        }

    case 557:
      return recog_163 (x1, insn, pnum_clobbers);

    case 558:
      return recog_162 (x1, insn, pnum_clobbers);

    case 569:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12299; /* aarch64_sve_usublbvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12320; /* aarch64_sve_usublbvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12341; /* aarch64_sve_usublbvnx2di */

        default:
          return -1;
        }

    case 570:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12300; /* aarch64_sve_usubltvnx8hi */

        case 1:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12321; /* aarch64_sve_usubltvnx4si */

        case 2:
          if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12342; /* aarch64_sve_usubltvnx2di */

        default:
          return -1;
        }

    case 533:
      switch (pattern130 (x1))
        {
        case 0:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12355; /* aarch64_sve_sshllbvnx8hi */

        case 1:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12359; /* aarch64_sve_sshllbvnx4si */

        case 2:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12363; /* aarch64_sve_sshllbvnx2di */

        default:
          return -1;
        }

    case 534:
      switch (pattern130 (x1))
        {
        case 0:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12356; /* aarch64_sve_sshlltvnx8hi */

        case 1:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12360; /* aarch64_sve_sshlltvnx4si */

        case 2:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12364; /* aarch64_sve_sshlltvnx2di */

        default:
          return -1;
        }

    case 567:
      switch (pattern130 (x1))
        {
        case 0:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12357; /* aarch64_sve_ushllbvnx8hi */

        case 1:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12361; /* aarch64_sve_ushllbvnx4si */

        case 2:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12365; /* aarch64_sve_ushllbvnx2di */

        default:
          return -1;
        }

    case 568:
      switch (pattern130 (x1))
        {
        case 0:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12358; /* aarch64_sve_ushlltvnx8hi */

        case 1:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12362; /* aarch64_sve_ushlltvnx4si */

        case 2:
          if (!
#line 2291 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12366; /* aarch64_sve_ushlltvnx2di */

        default:
          return -1;
        }

    case 529:
      switch (pattern131 (x1))
        {
        case 0:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12530; /* aarch64_sve_sqxtntvnx8hi */

        case 1:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12533; /* aarch64_sve_sqxtntvnx4si */

        case 2:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12536; /* aarch64_sve_sqxtntvnx2di */

        default:
          return -1;
        }

    case 531:
      switch (pattern131 (x1))
        {
        case 0:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12531; /* aarch64_sve_sqxtuntvnx8hi */

        case 1:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12534; /* aarch64_sve_sqxtuntvnx4si */

        case 2:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12537; /* aarch64_sve_sqxtuntvnx2di */

        default:
          return -1;
        }

    case 566:
      switch (pattern131 (x1))
        {
        case 0:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12532; /* aarch64_sve_uqxtntvnx8hi */

        case 1:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12535; /* aarch64_sve_uqxtntvnx4si */

        case 2:
          if (!
#line 2625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12538; /* aarch64_sve_uqxtntvnx2di */

        default:
          return -1;
        }

    case 418:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12557; /* aarch64_sve_addhnbvnx8hi */

        case 1:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12561; /* aarch64_sve_addhnbvnx4si */

        case 2:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12565; /* aarch64_sve_addhnbvnx2di */

        default:
          return -1;
        }

    case 483:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12558; /* aarch64_sve_raddhnbvnx8hi */

        case 1:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12562; /* aarch64_sve_raddhnbvnx4si */

        case 2:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12566; /* aarch64_sve_raddhnbvnx2di */

        default:
          return -1;
        }

    case 487:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12559; /* aarch64_sve_rsubhnbvnx8hi */

        case 1:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12563; /* aarch64_sve_rsubhnbvnx4si */

        case 2:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12567; /* aarch64_sve_rsubhnbvnx2di */

        default:
          return -1;
        }

    case 543:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12560; /* aarch64_sve_subhnbvnx8hi */

        case 1:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12564; /* aarch64_sve_subhnbvnx4si */

        case 2:
          if (!
#line 2686 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12568; /* aarch64_sve_subhnbvnx2di */

        default:
          return -1;
        }

    case 485:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12584; /* aarch64_sve_rshrnbvnx8hi */

        case 1:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12592; /* aarch64_sve_rshrnbvnx4si */

        case 2:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12600; /* aarch64_sve_rshrnbvnx2di */

        default:
          return -1;
        }

    case 498:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12585; /* aarch64_sve_shrnbvnx8hi */

        case 1:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12593; /* aarch64_sve_shrnbvnx4si */

        case 2:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12601; /* aarch64_sve_shrnbvnx2di */

        default:
          return -1;
        }

    case 518:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12586; /* aarch64_sve_sqrshrnbvnx8hi */

        case 1:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12594; /* aarch64_sve_sqrshrnbvnx4si */

        case 2:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12602; /* aarch64_sve_sqrshrnbvnx2di */

        default:
          return -1;
        }

    case 522:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12587; /* aarch64_sve_sqrshrunbvnx8hi */

        case 1:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12595; /* aarch64_sve_sqrshrunbvnx4si */

        case 2:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12603; /* aarch64_sve_sqrshrunbvnx2di */

        default:
          return -1;
        }

    case 524:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12588; /* aarch64_sve_sqshrnbvnx8hi */

        case 1:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12596; /* aarch64_sve_sqshrnbvnx4si */

        case 2:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12604; /* aarch64_sve_sqshrnbvnx2di */

        default:
          return -1;
        }

    case 526:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12589; /* aarch64_sve_sqshrunbvnx8hi */

        case 1:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12597; /* aarch64_sve_sqshrunbvnx4si */

        case 2:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12605; /* aarch64_sve_sqshrunbvnx2di */

        default:
          return -1;
        }

    case 561:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12590; /* aarch64_sve_uqrshrnbvnx8hi */

        case 1:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12598; /* aarch64_sve_uqrshrnbvnx4si */

        case 2:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12606; /* aarch64_sve_uqrshrnbvnx2di */

        default:
          return -1;
        }

    case 563:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12591; /* aarch64_sve_uqshrnbvnx8hi */

        case 1:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12599; /* aarch64_sve_uqshrnbvnx4si */

        case 2:
          if (!
#line 2744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12607; /* aarch64_sve_uqshrnbvnx2di */

        default:
          return -1;
        }

    case 516:
      switch (pattern134 (x1))
        {
        case 0:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3689 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12632; /* aarch64_sve_sqrshrvnx8si */

        case 1:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3689 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12644; /* aarch64_sve_sqrshrvnx8di */

        case 2:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3689 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12638; /* aarch64_sve_sqrshrvnx16si */

        default:
          return -1;
        }

    case 517:
      switch (pattern134 (x1))
        {
        case 0:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3690 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12633; /* aarch64_sve_sqrshrnvnx8si */

        case 1:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3690 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12645; /* aarch64_sve_sqrshrnvnx8di */

        case 2:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3690 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12639; /* aarch64_sve_sqrshrnvnx16si */

        default:
          return -1;
        }

    case 520:
      switch (pattern134 (x1))
        {
        case 0:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3691 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12634; /* aarch64_sve_sqrshruvnx8si */

        case 1:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3691 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12646; /* aarch64_sve_sqrshruvnx8di */

        case 2:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3691 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12640; /* aarch64_sve_sqrshruvnx16si */

        default:
          return -1;
        }

    case 521:
      switch (pattern134 (x1))
        {
        case 0:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12635; /* aarch64_sve_sqrshrunvnx8si */

        case 1:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12647; /* aarch64_sve_sqrshrunvnx8di */

        case 2:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3692 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12641; /* aarch64_sve_sqrshrunvnx16si */

        default:
          return -1;
        }

    case 559:
      switch (pattern134 (x1))
        {
        case 0:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3693 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12636; /* aarch64_sve_uqrshrvnx8si */

        case 1:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3693 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12648; /* aarch64_sve_uqrshrvnx8di */

        case 2:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3693 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12642; /* aarch64_sve_uqrshrvnx16si */

        default:
          return -1;
        }

    case 560:
      switch (pattern134 (x1))
        {
        case 0:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12637; /* aarch64_sve_uqrshrnvnx8si */

        case 1:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12649; /* aarch64_sve_uqrshrnvnx8di */

        case 2:
          if (!(
#line 2779 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12643; /* aarch64_sve_uqrshrnvnx16si */

        default:
          return -1;
        }

    case 424:
      return recog_186 (x1, insn, pnum_clobbers);

    case 423:
      return recog_185 (x1, insn, pnum_clobbers);

    case 508:
      return recog_184 (x1, insn, pnum_clobbers);

    case 507:
      return recog_183 (x1, insn, pnum_clobbers);

    case 447:
      switch (pattern137 (x1))
        {
        case 0:
          if (!
#line 3191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12789; /* aarch64_sve2_fp8_cvt_f1cvtvnx8bf */

        case 1:
          if (!
#line 3191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12793; /* aarch64_sve2_fp8_cvt_f1cvtvnx8hf */

        default:
          return -1;
        }

    case 449:
      switch (pattern137 (x1))
        {
        case 0:
          if (!
#line 3191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12790; /* aarch64_sve2_fp8_cvt_f2cvtvnx8bf */

        case 1:
          if (!
#line 3191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12794; /* aarch64_sve2_fp8_cvt_f2cvtvnx8hf */

        default:
          return -1;
        }

    case 448:
      switch (pattern137 (x1))
        {
        case 0:
          if (!
#line 3191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12791; /* aarch64_sve2_fp8_cvt_f1cvtltvnx8bf */

        case 1:
          if (!
#line 3191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12795; /* aarch64_sve2_fp8_cvt_f1cvtltvnx8hf */

        default:
          return -1;
        }

    case 450:
      switch (pattern137 (x1))
        {
        case 0:
          if (!
#line 3191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12792; /* aarch64_sve2_fp8_cvt_f2cvtltvnx8bf */

        case 1:
          if (!
#line 3191 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12796; /* aarch64_sve2_fp8_cvt_f2cvtltvnx8hf */

        default:
          return -1;
        }

    case 468:
      return recog_159 (x1, insn, pnum_clobbers);

    case 452:
      if (pattern138 (x2) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!aligned_register_operand (operands[1], E_VNx8SFmode)
          || !
#line 3381 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
        return -1;
      return 12811; /* aarch64_sve2_fp8_cvtnbvnx16qi */

    case 477:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 3606 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12835; /* aarch64_sve_pmullbvnx8hi */

        case 1:
          if (!
#line 3606 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12837; /* aarch64_sve_pmullbvnx2di */

        default:
          return -1;
        }

    case 479:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 3606 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12836; /* aarch64_sve_pmulltvnx8hi */

        case 1:
          if (!
#line 3606 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12838; /* aarch64_sve_pmulltvnx2di */

        default:
          return -1;
        }

    case 478:
      switch (pattern140 (x1))
        {
        case 0:
          if (!
#line 3619 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12839; /* aarch64_sve_pmullb_pairvnx16qi */

        case 1:
          if (!
#line 3619 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12841; /* aarch64_sve_pmullb_pairvnx4si */

        case 2:
          if (!(
#line 3619 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 685 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2_AES)))
            return -1;
          return 12843; /* aarch64_sve_pmullb_pairvnx2di */

        default:
          return -1;
        }

    case 480:
      switch (pattern140 (x1))
        {
        case 0:
          if (!
#line 3619 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12840; /* aarch64_sve_pmullt_pairvnx16qi */

        case 1:
          if (!
#line 3619 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12842; /* aarch64_sve_pmullt_pairvnx4si */

        case 2:
          if (!(
#line 3619 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 685 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2_AES)))
            return -1;
          return 12844; /* aarch64_sve_pmullt_pairvnx2di */

        default:
          return -1;
        }

    case 594:
      return recog_182 (x1, insn, pnum_clobbers);

    case 595:
      return recog_180 (x1, insn, pnum_clobbers);

    case 597:
      return recog_181 (x1, insn, pnum_clobbers);

    case 610:
      return recog_179 (x1, insn, pnum_clobbers);

    case 615:
      return recog_178 (x1, insn, pnum_clobbers);

    case 616:
      return recog_177 (x1, insn, pnum_clobbers);

    case 624:
      return recog_176 (x1, insn, pnum_clobbers);

    case 625:
      return recog_175 (x1, insn, pnum_clobbers);

    case 599:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12957; /* aarch64_pred_reduc_faddqv_vnx8hf */

        case 1:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12962; /* aarch64_pred_reduc_faddqv_vnx4sf */

        case 2:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12967; /* aarch64_pred_reduc_faddqv_vnx2df */

        default:
          return -1;
        }

    case 600:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12958; /* aarch64_pred_reduc_fmaxqv_vnx8hf */

        case 1:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12963; /* aarch64_pred_reduc_fmaxqv_vnx4sf */

        case 2:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12968; /* aarch64_pred_reduc_fmaxqv_vnx2df */

        default:
          return -1;
        }

    case 601:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12959; /* aarch64_pred_reduc_fmaxnmqv_vnx8hf */

        case 1:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12964; /* aarch64_pred_reduc_fmaxnmqv_vnx4sf */

        case 2:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12969; /* aarch64_pred_reduc_fmaxnmqv_vnx2df */

        default:
          return -1;
        }

    case 602:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12960; /* aarch64_pred_reduc_fminqv_vnx8hf */

        case 1:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12965; /* aarch64_pred_reduc_fminqv_vnx4sf */

        case 2:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12970; /* aarch64_pred_reduc_fminqv_vnx2df */

        default:
          return -1;
        }

    case 603:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12961; /* aarch64_pred_reduc_fminnmqv_vnx8hf */

        case 1:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12966; /* aarch64_pred_reduc_fminnmqv_vnx4sf */

        case 2:
          if (!
#line 3728 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12971; /* aarch64_pred_reduc_fminnmqv_vnx2df */

        default:
          return -1;
        }

    case 596:
      return recog_87 (x1, insn, pnum_clobbers);

    case 545:
      return recog_108 (x1, insn, pnum_clobbers);

    case 576:
      return recog_132 (x1, insn, pnum_clobbers);

    case 574:
      return recog_130 (x1, insn, pnum_clobbers);

    case 577:
      return recog_131 (x1, insn, pnum_clobbers);

    case 575:
      return recog_129 (x1, insn, pnum_clobbers);

    case 420:
      return recog_174 (x1, insn, pnum_clobbers);

    case 421:
      return recog_173 (x1, insn, pnum_clobbers);

    case 422:
      return recog_172 (x1, insn, pnum_clobbers);

    case 470:
      if (pattern76 (x1, 
E_VNx16QImode) != 0
          || !
#line 3980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 13106; /* aarch64_sve2_histsegvnx16qi */

    case 682:
      if (pattern145 (x1, 
E_DImode, 
67) != 0)
        return -1;
      return 13142; /* aarch64_old_vg_saved */

    case 690:
      if (pnum_clobbers == NULL
          || pattern146 (x1, 
91, 
90) != 0)
        return -1;
      *pnum_clobbers = 7;
      return 13148; /* aarch64_tpidr2_save */

    case 689:
      if (pattern146 (x1, 
93, 
91) != 0)
        return -1;
      return 13151; /* aarch64_initial_zero_za */

    case 693:
      return recog_153 (x1, insn, pnum_clobbers);

    case 692:
      if (GET_MODE (x2) != E_DImode
          || pattern262 (x2, 
92, 
E_DImode, 
90) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 13155; /* aarch64_read_tpidr2 */

    case 700:
      return recog_161 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_483 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!aarch64_sve_dup_operand (operands[1], E_QImode)
              || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6454; /* *vec_duplicatevnx16qi_reg */

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !
#line 2785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6473; /* aarch64_vec_duplicate_vqvnx16qi_le */

        default:
          return -1;
        }

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6455; /* *vec_duplicatevnx8qi_reg */

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6456; /* *vec_duplicatevnx4qi_reg */

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6457; /* *vec_duplicatevnx2qi_reg */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!aarch64_sve_dup_operand (operands[1], E_HImode)
              || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6458; /* *vec_duplicatevnx8hi_reg */

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !
#line 2785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6474; /* aarch64_vec_duplicate_vqvnx8hi_le */

        default:
          return -1;
        }

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6459; /* *vec_duplicatevnx4hi_reg */

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6460; /* *vec_duplicatevnx2hi_reg */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!aarch64_sve_dup_operand (operands[1], E_SImode)
              || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6461; /* *vec_duplicatevnx4si_reg */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !
#line 2785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6475; /* aarch64_vec_duplicate_vqvnx4si_le */

        default:
          return -1;
        }

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2SImode
          || !aarch64_sve_dup_operand (operands[1], E_SImode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6462; /* *vec_duplicatevnx2si_reg */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!aarch64_sve_dup_operand (operands[1], E_DImode)
              || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6463; /* *vec_duplicatevnx2di_reg */

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !
#line 2785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6476; /* aarch64_vec_duplicate_vqvnx2di_le */

        default:
          return -1;
        }

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6464; /* *vec_duplicatevnx2hf_reg */

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6465; /* *vec_duplicatevnx4hf_reg */

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2SFmode
          || !aarch64_sve_dup_operand (operands[1], E_SFmode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6466; /* *vec_duplicatevnx2sf_reg */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_HFmode)
              || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6467; /* *vec_duplicatevnx8hf_reg */

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !
#line 2785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6478; /* aarch64_vec_duplicate_vqvnx8hf_le */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_SFmode)
              || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6468; /* *vec_duplicatevnx4sf_reg */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 2785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6479; /* aarch64_vec_duplicate_vqvnx4sf_le */

        default:
          return -1;
        }

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_DFmode)
              || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6469; /* *vec_duplicatevnx2df_reg */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !
#line 2785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6480; /* aarch64_vec_duplicate_vqvnx2df_le */

        default:
          return -1;
        }

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6470; /* *vec_duplicatevnx2bf_reg */

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode)
          || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6471; /* *vec_duplicatevnx4bf_reg */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_BFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_BFmode)
              || !
#line 2752 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6472; /* *vec_duplicatevnx8bf_reg */

        case E_V8BFmode:
          if (!nonimmediate_operand (operands[1], E_V8BFmode)
              || !
#line 2785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6477; /* aarch64_vec_duplicate_vqvnx8bf_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              x7 = XEXP (x2, 0);
              operands[4] = x7;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x5, 1);
              switch (GET_CODE (x9))
                {
                case SIGN_EXTEND:
                  switch (pattern967 (x2))
                    {
                    case 0:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3126; /* *aarch64_shaddv8qi_vec_concatz_be_insn */

                    case 1:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3142; /* *aarch64_shaddv4hi_vec_concatz_be_insn */

                    case 2:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3158; /* *aarch64_shaddv2si_vec_concatz_be_insn */

                    default:
                      return -1;
                    }

                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_VECTOR:
                  operands[3] = x9;
                  x10 = XEXP (x4, 1);
                  operands[2] = x10;
                  switch (pattern1023 (x2))
                    {
                    case 0:
                      if (pattern544 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3841; /* aarch64_srshr_nv8qi_vec_concatz_be_insn */

                    case 1:
                      if (pattern546 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3849; /* aarch64_srshr_nv4hi_vec_concatz_be_insn */

                    case 2:
                      if (pattern548 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3857; /* aarch64_srshr_nv2si_vec_concatz_be_insn */

                    case 3:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3867; /* aarch64_srshr_ndi_vec_concatz_be_insn */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x9 = XEXP (x5, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x7 = XEXP (x2, 0);
              operands[4] = x7;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              switch (pattern967 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3132; /* *aarch64_uhaddv8qi_vec_concatz_be_insn */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3148; /* *aarch64_uhaddv4hi_vec_concatz_be_insn */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3164; /* *aarch64_uhaddv2si_vec_concatz_be_insn */

                default:
                  return -1;
                }

            case PLUS:
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              x8 = XEXP (x6, 0);
              switch (GET_CODE (x8))
                {
                case SIGN_EXTEND:
                  switch (pattern911 (x2, 
SIGN_EXTEND))
                    {
                    case 0:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3174; /* *aarch64_srhaddv8qi_vec_concatz_be_insn */

                    case 1:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3182; /* *aarch64_srhaddv4hi_vec_concatz_be_insn */

                    case 2:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3190; /* *aarch64_srhaddv2si_vec_concatz_be_insn */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern911 (x2, 
ZERO_EXTEND))
                    {
                    case 0:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3177; /* *aarch64_urhaddv8qi_vec_concatz_be_insn */

                    case 1:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3185; /* *aarch64_urhaddv4hi_vec_concatz_be_insn */

                    case 2:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3193; /* *aarch64_urhaddv2si_vec_concatz_be_insn */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[1] = x8;
                  x7 = XEXP (x2, 0);
                  operands[5] = x7;
                  x11 = XEXP (x6, 1);
                  operands[2] = x11;
                  switch (pattern1022 (x2))
                    {
                    case 0:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3216; /* aarch64_raddhnv8hi_insn_vec_concatz_be */

                    case 1:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3222; /* aarch64_raddhnv4si_insn_vec_concatz_be */

                    case 2:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3228; /* aarch64_raddhnv2di_insn_vec_concatz_be */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x6;
              x7 = XEXP (x2, 0);
              operands[4] = x7;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              x10 = XEXP (x4, 1);
              operands[3] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1088 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3198; /* aarch64_addhnv8hi_insn_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1088 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3204; /* aarch64_addhnv4si_insn_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1088 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3210; /* aarch64_addhnv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case MINUS:
              x7 = XEXP (x2, 0);
              operands[5] = x7;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x11 = XEXP (x6, 1);
              operands[2] = x11;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              switch (pattern1022 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3219; /* aarch64_rsubhnv8hi_insn_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3225; /* aarch64_rsubhnv4si_insn_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3231; /* aarch64_rsubhnv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern913 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3129; /* *aarch64_shsubv8qi_vec_concatz_be_insn */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3145; /* *aarch64_shsubv4hi_vec_concatz_be_insn */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3161; /* *aarch64_shsubv2si_vec_concatz_be_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern913 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3135; /* *aarch64_uhsubv8qi_vec_concatz_be_insn */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3151; /* *aarch64_uhsubv4hi_vec_concatz_be_insn */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3167; /* *aarch64_uhsubv2si_vec_concatz_be_insn */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x6;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1088 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3201; /* aarch64_subhnv8hi_insn_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1088 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3207; /* aarch64_subhnv4si_insn_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1088 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3213; /* aarch64_subhnv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (pattern541 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3958; /* *aarch64_sshrn_nv8hi_insn_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3976; /* *aarch64_sshrn_nv4si_insn_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3994; /* *aarch64_sshrn_nv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMIN:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SMAX)
        return -1;
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1089 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5516 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3434; /* *aarch64_sqmovunv8hi_insn_vec_concatz_be */

            case E_V8HImode:
              if (pattern1089 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5516 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3437; /* *aarch64_sqmovunv4si_insn_vec_concatz_be */

            case E_V4SImode:
              if (pattern1089 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5516 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3440; /* *aarch64_sqmovunv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        case ASHIFTRT:
          x11 = XEXP (x6, 1);
          operands[2] = x11;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[1] = x8;
              x7 = XEXP (x2, 0);
              operands[5] = x7;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              x10 = XEXP (x4, 1);
              operands[4] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1178 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V8HImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V8HImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 4033; /* *aarch64_sqshrun_nv8hi_insn_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1178 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V4SImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V4SImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 4036; /* *aarch64_sqshrun_nv4si_insn_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1178 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V2DImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V2DImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 4039; /* *aarch64_sqshrun_nv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case PLUS:
              x12 = XEXP (x8, 0);
              if (GET_CODE (x12) != SIGN_EXTEND)
                return -1;
              x7 = XEXP (x2, 0);
              operands[6] = x7;
              x13 = XEXP (x12, 0);
              operands[1] = x13;
              x14 = XEXP (x8, 1);
              operands[3] = x14;
              x9 = XEXP (x5, 1);
              operands[4] = x9;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1239 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V8SImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V8SImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6917 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4045; /* *aarch64_sqrshrun_nv8hi_insn_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1239 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V4DImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V4DImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6917 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4048; /* *aarch64_sqrshrun_nv4si_insn_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1239 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V2TImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V2TImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6917 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4051; /* *aarch64_sqrshrun_nv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != ZERO_EXTEND)
            return -1;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          switch (pattern1023 (x2))
            {
            case 0:
              if (pattern1147 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V8HImode:
                  if (pattern543 (x5, 
E_V8QImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3844; /* aarch64_urshr_nv8qi_vec_concatz_be_insn */

                case E_V8SImode:
                  if (pattern543 (x5, 
E_V8HImode, 
E_V8SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4006; /* *aarch64_rshrn_nv8hi_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case 1:
              if (pattern1147 (x2, 
E_V4HImode, 
E_V8HImode) != 0)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V4SImode:
                  if (pattern545 (x5, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3852; /* aarch64_urshr_nv4hi_vec_concatz_be_insn */

                case E_V4DImode:
                  if (pattern545 (x5, 
E_V4SImode, 
E_V4DImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4015; /* *aarch64_rshrn_nv4si_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case 2:
              if (pattern1147 (x2, 
E_V2SImode, 
E_V4SImode) != 0)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V2DImode:
                  if (pattern547 (x5, 
E_V2SImode, 
E_V2DImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3860; /* aarch64_urshr_nv2si_vec_concatz_be_insn */

                case E_V2TImode:
                  if (pattern547 (x5, 
E_V2DImode, 
E_V2TImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4024; /* *aarch64_rshrn_nv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case 3:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 3870; /* aarch64_urshr_ndi_vec_concatz_be_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern542 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3961; /* *aarch64_shrn_nv8hi_insn_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3979; /* *aarch64_shrn_nv4si_insn_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3997; /* *aarch64_shrn_nv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern540 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 9944 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5295; /* truncv8hiv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 9944 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5298; /* truncv4siv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 9944 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5301; /* truncv2div2si2_vec_concatz_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_494 (x1, insn, pnum_clobbers);

    case 1:
      switch (XINT (x3, 1))
        {
        case 187:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern551 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1668; /* aarch64_absv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern551 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1672; /* aarch64_absv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern551 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1676; /* aarch64_absv2si_vec_concatz_le */

            case E_V2DImode:
              if (pattern551 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1681; /* aarch64_absdi_vec_concatz_le */

            default:
              return -1;
            }

        case 36:
          switch (pattern552 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2530; /* btruncv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2558; /* btruncv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 34:
          switch (pattern552 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2533; /* ceilv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2561; /* ceilv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 32:
          switch (pattern552 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2536; /* floorv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2564; /* floorv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 33:
          switch (pattern552 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2539; /* roundevenv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2567; /* roundevenv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 31:
          switch (pattern552 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2542; /* nearbyintv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2570; /* nearbyintv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 35:
          switch (pattern552 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2545; /* rintv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2573; /* rintv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 30:
          switch (pattern552 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2548; /* roundv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2576; /* roundv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 588:
          if (GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2SFmode)
              || !
#line 3250 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
            return -1;
          return 2701; /* aarch64_float_trunc_rodd_hi_v4sf_be */

        case 254:
          switch (pattern553 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5068; /* aarch64_rev64v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5080; /* aarch64_rev64v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5092; /* aarch64_rev64v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5107; /* aarch64_rev64v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5119; /* aarch64_rev64v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5131; /* aarch64_rev64v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case 255:
          switch (pattern553 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5071; /* aarch64_rev32v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5083; /* aarch64_rev32v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5095; /* aarch64_rev32v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5110; /* aarch64_rev32v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5122; /* aarch64_rev32v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5134; /* aarch64_rev32v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case 256:
          switch (pattern553 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5074; /* aarch64_rev16v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5086; /* aarch64_rev16v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5098; /* aarch64_rev16v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5113; /* aarch64_rev16v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5125; /* aarch64_rev16v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5137; /* aarch64_rev16v2sf_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      switch (XINT (x3, 1))
        {
        case 275:
          switch (pattern555 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3562; /* aarch64_sqrdmlahv4hi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3570; /* aarch64_sqrdmlahv2si_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5709 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3582; /* aarch64_sqrdmlah_lanev4hi_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5747 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3602; /* aarch64_sqrdmlah_laneqv4hi_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5709 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3590; /* aarch64_sqrdmlah_lanev2si_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5747 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3610; /* aarch64_sqrdmlah_laneqv2si_vec_concatz_le */

            default:
              return -1;
            }

        case 276:
          switch (pattern555 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3565; /* aarch64_sqrdmlshv4hi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3573; /* aarch64_sqrdmlshv2si_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5709 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3585; /* aarch64_sqrdmlsh_lanev4hi_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5747 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3605; /* aarch64_sqrdmlsh_laneqv4hi_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5709 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3593; /* aarch64_sqrdmlsh_lanev2si_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5747 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3613; /* aarch64_sqrdmlsh_laneqv2si_vec_concatz_le */

            default:
              return -1;
            }

        case 188:
          if (GET_MODE (x3) != E_V8QImode)
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 84
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V8QImode)
              || !
#line 10201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8 && BYTES_BIG_ENDIAN))
            return -1;
          return 5374; /* aarch64_fcvtnv4sf_high_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_509 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_473 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (!register_operand (x5, E_VNx16BImode))
        return -1;
      operands[1] = x5;
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 86
          && GET_MODE (x3) == E_VNx16BImode
          && 
#line 1181 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return 5785; /* aarch64_rdffr_z */
      operands[2] = x5;
      operands[1] = x3;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !
#line 6906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9123; /* andvnx16bi3 */

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_CODE (operands[3]))
        {
        case REG:
        case SUBREG:
          switch (pattern51 (x2))
            {
            case 0:
              return 573; /* and_ashlsi3 */

            case 1:
              return 588; /* and_ashldi3 */

            default:
              return -1;
            }

        case CONST_INT:
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern939 (x2, 
E_SImode) != 0
                  || !
#line 6812 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (SImode, operands[3], operands[2])))
                return -1;
              return 921; /* *andim_ashiftsi_bfiz */

            case E_DImode:
              if (pattern939 (x2, 
E_DImode) != 0
                  || !
#line 6812 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (DImode, operands[3], operands[2])))
                return -1;
              return 922; /* *andim_ashiftdi_bfiz */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern52 (x2))
        {
        case 0:
          return 576; /* and_ashrsi3 */

        case 1:
          return 591; /* and_ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      operands[2] = x7;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern495 (x2))
        {
        case 0:
          return 579; /* and_lshrsi3 */

        case 1:
          return 594; /* and_lshrdi3 */

        default:
          break;
        }
      if (XWINT (x7, 0) != 56L)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 176
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[2] = x11;
      if (!aarch64_granule16_simm9 (operands[2], E_DImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode)
          || !
#line 8622 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
        return -1;
      return 1273; /* stg */

    case ROTATERT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern52 (x2))
        {
        case 0:
          return 582; /* and_rotrsi3 */

        case 1:
          return 597; /* and_rotrdi3 */

        default:
          return -1;
        }

    case ROTATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern52 (x2))
        {
        case 0:
          return 585; /* and_rotlsi3 */

        case 1:
          return 600; /* and_rotldi3 */

        default:
          return -1;
        }

    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern708 (x2, 
E_SImode) != 0)
                return -1;
              return 631; /* andnsi3 */

            case E_DImode:
              if (pattern708 (x2, 
E_DImode) != 0)
                return -1;
              return 633; /* andndi3 */

            case E_V8QImode:
              if (pattern708 (x2, 
E_V8QImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1382; /* andnv8qi3 */

            case E_V16QImode:
              if (pattern708 (x2, 
E_V16QImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1385; /* andnv16qi3 */

            case E_V4HImode:
              if (pattern708 (x2, 
E_V4HImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1386; /* andnv4hi3 */

            case E_V8HImode:
              if (pattern708 (x2, 
E_V8HImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1389; /* andnv8hi3 */

            case E_V2SImode:
              if (pattern708 (x2, 
E_V2SImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1390; /* andnv2si3 */

            case E_V4SImode:
              if (pattern708 (x2, 
E_V4SImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1393; /* andnv4si3 */

            case E_V2DImode:
              if (pattern708 (x2, 
E_V2DImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1394; /* andnv2di3 */

            case E_VNx16BImode:
              if (pattern708 (x2, 
E_VNx16BImode) != 0
                  || !
#line 3974 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7414; /* *one_cmplvnx16bi3 */

            case E_VNx8BImode:
              if (pattern708 (x2, 
E_VNx8BImode) != 0
                  || !
#line 3974 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7415; /* *one_cmplvnx8bi3 */

            case E_VNx4BImode:
              if (pattern708 (x2, 
E_VNx4BImode) != 0
                  || !
#line 3974 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7416; /* *one_cmplvnx4bi3 */

            case E_VNx2BImode:
              if (pattern708 (x2, 
E_VNx2BImode) != 0
                  || !
#line 3974 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7417; /* *one_cmplvnx2bi3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern376 (x2))
            {
            case 0:
              return 645; /* and_one_cmpl_ashlsi3 */

            case 1:
              return 660; /* and_one_cmpl_ashldi3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern376 (x2))
            {
            case 0:
              return 648; /* and_one_cmpl_ashrsi3 */

            case 1:
              return 663; /* and_one_cmpl_ashrdi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern376 (x2))
            {
            case 0:
              return 651; /* and_one_cmpl_lshrsi3 */

            case 1:
              return 666; /* and_one_cmpl_lshrdi3 */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern376 (x2))
            {
            case 0:
              return 654; /* and_one_cmpl_rotrsi3 */

            case 1:
              return 669; /* and_one_cmpl_rotrdi3 */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern376 (x2))
            {
            case 0:
              return 657; /* and_one_cmpl_rotlsi3 */

            case 1:
              return 672; /* and_one_cmpl_rotldi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_474 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern304 (x2))
            {
            case 0:
              if (!
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9127; /* aarch64_pred_andvnx16bi_z */

            case 1:
              if (!
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9130; /* aarch64_pred_andvnx8bi_z */

            case 2:
              if (!
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9133; /* aarch64_pred_andvnx4bi_z */

            case 3:
              if (!
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9136; /* aarch64_pred_andvnx2bi_z */

            default:
              return -1;
            }

        case NOT:
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              switch (pattern522 (x2))
                {
                case 0:
                  if (!
#line 7008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9163; /* aarch64_pred_bicvnx16bi_z */

                case 1:
                  if (!
#line 7008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9165; /* aarch64_pred_bicvnx8bi_z */

                case 2:
                  if (!
#line 7008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9167; /* aarch64_pred_bicvnx4bi_z */

                case 3:
                  if (!
#line 7008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9169; /* aarch64_pred_bicvnx2bi_z */

                case 4:
                  if (!
#line 7082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9187; /* aarch64_pred_norvnx16bi_z */

                case 5:
                  if (!
#line 7082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9189; /* aarch64_pred_norvnx8bi_z */

                case 6:
                  if (!
#line 7082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9191; /* aarch64_pred_norvnx4bi_z */

                case 7:
                  if (!
#line 7082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9193; /* aarch64_pred_norvnx2bi_z */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pnum_clobbers == NULL
                  || XVECLEN (x12, 0) != 4)
                return -1;
              x13 = XVECEXP (x12, 0, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x14 = XVECEXP (x12, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x12, 0, 2);
              operands[2] = x15;
              x16 = XVECEXP (x12, 0, 3);
              operands[3] = x16;
              x5 = XEXP (x2, 1);
              if (!rtx_equal_p (x5, operands[1]))
                return -1;
              switch (XINT (x12, 1))
                {
                case 357:
                  switch (pattern1143 (x2))
                    {
                    case 0:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10315; /* *fcmeqvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10321; /* *fcmeqvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10327; /* *fcmeqvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10333; /* *fcmeqvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10339; /* *fcmeqvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10345; /* *fcmeqvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 358:
                  switch (pattern1143 (x2))
                    {
                    case 0:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10316; /* *fcmgevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10322; /* *fcmgevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10328; /* *fcmgevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10334; /* *fcmgevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10340; /* *fcmgevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10346; /* *fcmgevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 359:
                  switch (pattern1143 (x2))
                    {
                    case 0:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10317; /* *fcmgtvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10323; /* *fcmgtvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10329; /* *fcmgtvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10335; /* *fcmgtvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10341; /* *fcmgtvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10347; /* *fcmgtvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 364:
                  switch (pattern1143 (x2))
                    {
                    case 0:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10318; /* *fcmlevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10324; /* *fcmlevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10330; /* *fcmlevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10336; /* *fcmlevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10342; /* *fcmlevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10348; /* *fcmlevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 365:
                  switch (pattern1143 (x2))
                    {
                    case 0:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10319; /* *fcmltvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10325; /* *fcmltvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10331; /* *fcmltvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10337; /* *fcmltvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10343; /* *fcmltvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10349; /* *fcmltvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 366:
                  switch (pattern1143 (x2))
                    {
                    case 0:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10320; /* *fcmnevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10326; /* *fcmnevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10332; /* *fcmnevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10338; /* *fcmnevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10344; /* *fcmnevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10350; /* *fcmnevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 367:
                  x7 = XEXP (x3, 1);
                  switch (GET_CODE (x7))
                    {
                    case REG:
                    case SUBREG:
                      operands[4] = x7;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx8BImode:
                          if (pattern1234 (x2, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
                              || !
#line 8825 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10351; /* *fcmuovnx8hf_bic_combine */

                        case E_VNx4BImode:
                          if (pattern1234 (x2, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
                              || !
#line 8825 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10352; /* *fcmuovnx4sf_bic_combine */

                        case E_VNx2BImode:
                          if (pattern1234 (x2, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
                              || !
#line 8825 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10353; /* *fcmuovnx2df_bic_combine */

                        default:
                          return -1;
                        }

                    case NOT:
                      x17 = XEXP (x7, 0);
                      operands[4] = x17;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx8BImode:
                          if (pattern1235 (x2, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
                              || !
#line 8862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10354; /* *fcmuovnx8hf_nor_combine */

                        case E_VNx4BImode:
                          if (pattern1235 (x2, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
                              || !
#line 8862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10355; /* *fcmuovnx4sf_nor_combine */

                        case E_VNx2BImode:
                          if (pattern1235 (x2, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
                              || !
#line 8862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10356; /* *fcmuovnx2df_nor_combine */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern303 (x2, 
E_VNx16BImode) != 0
                  || !
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9128; /* aarch64_pred_iorvnx16bi_z */

            case E_VNx8BImode:
              if (pattern303 (x2, 
E_VNx8BImode) != 0
                  || !
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9131; /* aarch64_pred_iorvnx8bi_z */

            case E_VNx4BImode:
              if (pattern303 (x2, 
E_VNx4BImode) != 0
                  || !
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9134; /* aarch64_pred_iorvnx4bi_z */

            case E_VNx2BImode:
              if (pattern303 (x2, 
E_VNx2BImode) != 0
                  || !
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9137; /* aarch64_pred_iorvnx2bi_z */

            default:
              return -1;
            }

        case NOT:
          switch (pattern522 (x2))
            {
            case 0:
              if (!
#line 7008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9164; /* aarch64_pred_ornvnx16bi_z */

            case 1:
              if (!
#line 7008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9166; /* aarch64_pred_ornvnx8bi_z */

            case 2:
              if (!
#line 7008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9168; /* aarch64_pred_ornvnx4bi_z */

            case 3:
              if (!
#line 7008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9170; /* aarch64_pred_ornvnx2bi_z */

            case 4:
              if (!
#line 7082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9188; /* aarch64_pred_nandvnx16bi_z */

            case 5:
              if (!
#line 7082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9190; /* aarch64_pred_nandvnx8bi_z */

            case 6:
              if (!
#line 7082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9192; /* aarch64_pred_nandvnx4bi_z */

            case 7:
              if (!
#line 7082 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9194; /* aarch64_pred_nandvnx2bi_z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern304 (x2))
        {
        case 0:
          if (!
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9129; /* aarch64_pred_xorvnx16bi_z */

        case 1:
          if (!
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9132; /* aarch64_pred_xorvnx8bi_z */

        case 2:
          if (!
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9135; /* aarch64_pred_xorvnx4bi_z */

        case 3:
          if (!
#line 6936 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9138; /* aarch64_pred_xorvnx2bi_z */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern311 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern762 (x3, 
E_SImode) == 0
                  && 
#line 7550 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1125; /* *aarch64_sminsi3_cssc */
              break;

            case E_DImode:
              if (pattern762 (x3, 
E_DImode) == 0
                  && 
#line 7550 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1129; /* *aarch64_smindi3_cssc */
              break;

            case E_SFmode:
              if (pattern34 (x3, 
E_SFmode) == 0
                  && 
#line 7584 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1138; /* sminsf3 */
              break;

            case E_DFmode:
              if (pattern34 (x3, 
E_DFmode) == 0
                  && 
#line 7584 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1139; /* smindf3 */
              break;

            case E_V8QImode:
              if (pattern34 (x3, 
E_V8QImode) == 0
                  && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2117; /* sminv8qi3 */
              break;

            case E_V16QImode:
              if (pattern34 (x3, 
E_V16QImode) == 0
                  && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2127; /* sminv16qi3 */
              break;

            case E_V4HImode:
              if (pattern34 (x3, 
E_V4HImode) == 0
                  && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2133; /* sminv4hi3 */
              break;

            case E_V8HImode:
              if (pattern34 (x3, 
E_V8HImode) == 0
                  && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2143; /* sminv8hi3 */
              break;

            case E_V2SImode:
              if (pattern34 (x3, 
E_V2SImode) == 0
                  && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2149; /* sminv2si3 */
              break;

            case E_V4SImode:
              if (pattern34 (x3, 
E_V4SImode) == 0
                  && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2159; /* sminv4si3 */
              break;

            case E_V4HFmode:
              if (pattern34 (x3, 
E_V4HFmode) == 0
                  && (
#line 3368 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2713; /* sminv4hf3 */
              break;

            case E_V8HFmode:
              if (pattern34 (x3, 
E_V8HFmode) == 0
                  && (
#line 3368 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2715; /* sminv8hf3 */
              break;

            case E_V2SFmode:
              if (pattern34 (x3, 
E_V2SFmode) == 0
                  && 
#line 3368 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2717; /* sminv2sf3 */
              break;

            case E_V4SFmode:
              if (pattern34 (x3, 
E_V4SFmode) == 0
                  && 
#line 3368 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2719; /* sminv4sf3 */
              break;

            case E_V2DFmode:
              if (pattern34 (x3, 
E_V2DFmode) == 0
                  && 
#line 3368 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2721; /* sminv2df3 */
              break;

            case E_VNx32QImode:
              if (pattern35 (x3, 
E_VNx32QImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11611; /* *sminvnx32qi3 */
              break;

            case E_VNx16HImode:
              if (pattern35 (x3, 
E_VNx16HImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11615; /* *sminvnx16hi3 */
              break;

            case E_VNx8SImode:
              if (pattern35 (x3, 
E_VNx8SImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11619; /* *sminvnx8si3 */
              break;

            case E_VNx4DImode:
              if (pattern35 (x3, 
E_VNx4DImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11623; /* *sminvnx4di3 */
              break;

            case E_VNx64QImode:
              if (pattern35 (x3, 
E_VNx64QImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11627; /* *sminvnx64qi3 */
              break;

            case E_VNx32HImode:
              if (pattern35 (x3, 
E_VNx32HImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11631; /* *sminvnx32hi3 */
              break;

            case E_VNx16SImode:
              if (pattern35 (x3, 
E_VNx16SImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11635; /* *sminvnx16si3 */
              break;

            case E_VNx8DImode:
              if (pattern35 (x3, 
E_VNx8DImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11639; /* *sminvnx8di3 */
              break;

            default:
              break;
            }
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              return 1133; /* *aarch64_sminsi3_zero */

            case 1:
              return 1135; /* *aarch64_smindi3_zero */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7483; /* *post_ra_sminvnx16qi3 */

        case 2:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7488; /* *post_ra_sminvnx8qi3 */

        case 3:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7493; /* *post_ra_sminvnx4qi3 */

        case 4:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7498; /* *post_ra_sminvnx2qi3 */

        case 5:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7503; /* *post_ra_sminvnx8hi3 */

        case 6:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7508; /* *post_ra_sminvnx4hi3 */

        case 7:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7513; /* *post_ra_sminvnx2hi3 */

        case 8:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7518; /* *post_ra_sminvnx4si3 */

        case 9:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7523; /* *post_ra_sminvnx2si3 */

        case 10:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7528; /* *post_ra_sminvnx2di3 */

        case 11:
          if (!
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7533; /* *post_ra_sminv2di3 */

        case 12:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11644; /* aarch64_sve_single_sminvnx32qi */

        case 13:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11649; /* aarch64_sve_single_sminvnx16hi */

        case 14:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11654; /* aarch64_sve_single_sminvnx8si */

        case 15:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11659; /* aarch64_sve_single_sminvnx4di */

        case 16:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11664; /* aarch64_sve_single_sminvnx64qi */

        case 17:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11669; /* aarch64_sve_single_sminvnx32hi */

        case 18:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11674; /* aarch64_sve_single_sminvnx16si */

        case 19:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11679; /* aarch64_sve_single_sminvnx8di */

        default:
          return -1;
        }

    case SMAX:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          x9 = XEXP (x6, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[1] = x9;
              switch (XWINT (x5, 0))
                {
                case 255L:
                  if (pattern965 (x3, 
E_HImode) != 0
                      || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode)
                      || !
#line 6864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 4040; /* aarch64_sqshrun_nhi_insn */

                case 65535L:
                  if (pattern965 (x3, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode)
                      || !
#line 6864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 4041; /* aarch64_sqshrun_nsi_insn */

                case 4294967295L:
                  if (pattern965 (x3, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode)
                      || !
#line 6864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 4042; /* aarch64_sqshrun_ndi_insn */

                default:
                  return -1;
                }

            case PLUS:
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != SIGN_EXTEND)
                return -1;
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x9, 1);
              operands[3] = x12;
              switch (XWINT (x5, 0))
                {
                case 255L:
                  if (pattern1079 (x3, 
E_SImode, 
E_HImode) != 0
                      || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode)
                      || !
#line 6935 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4052; /* aarch64_sqrshrun_nhi_insn */

                case 65535L:
                  if (pattern1079 (x3, 
E_DImode, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode)
                      || !
#line 6935 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4053; /* aarch64_sqrshrun_nsi_insn */

                case 4294967295L:
                  if (!register_operand (operands[0], E_TImode)
                      || GET_MODE (x3) != E_TImode
                      || GET_MODE (x4) != E_TImode
                      || pattern1078 (x6, 
E_TImode, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode)
                      || !
#line 6935 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4054; /* aarch64_sqrshrun_ndi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern316 (x3))
            {
            case 0:
              if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11730; /* aarch64_sve_sclampvnx16qi */

            case 1:
              if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11732; /* aarch64_sve_sclampvnx8hi */

            case 2:
              if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11734; /* aarch64_sve_sclampvnx4si */

            case 3:
              if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11736; /* aarch64_sve_sclampvnx2di */

            case 4:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11746; /* aarch64_sve_sclamp_singlevnx32qi */

            case 5:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11748; /* aarch64_sve_sclamp_singlevnx16hi */

            case 6:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11750; /* aarch64_sve_sclamp_singlevnx8si */

            case 7:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11752; /* aarch64_sve_sclamp_singlevnx4di */

            case 8:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11754; /* aarch64_sve_sclamp_singlevnx64qi */

            case 9:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11756; /* aarch64_sve_sclamp_singlevnx32hi */

            case 10:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11758; /* aarch64_sve_sclamp_singlevnx16si */

            case 11:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11760; /* aarch64_sve_sclamp_singlevnx8di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern313 (x3))
        {
        case 0:
          if (!(
#line 10113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5337; /* *aarch64_faminmax_fused */

        case 1:
          if (!(
#line 10113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5339; /* *aarch64_faminmax_fused */

        case 2:
          if (!
#line 10113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5341; /* *aarch64_faminmax_fused */

        case 3:
          if (!
#line 10113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5343; /* *aarch64_faminmax_fused */

        case 4:
          if (!
#line 10113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5345; /* *aarch64_faminmax_fused */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_534 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case TRUNCATE:
      operands[1] = x4;
      res = recog_475 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (!subreg_lowpart_operator (x4, E_SImode))
        return -1;
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTRACT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!aarch64_simd_shift_imm_offset_si (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!aarch64_simd_shift_imm_si (operands[3], E_VOIDmode)
          || !
#line 6840 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
        return -1;
      return 925; /* *ashiftsi_extvdi_bfiz */

    case SIGN_EXTEND:
      switch (pattern309 (x3))
        {
        case 0:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 909; /* *extendqi_shft_si */

        case 1:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 913; /* *extendhi_shft_si */

        case 2:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 917; /* *extendsi_shft_si */

        case 3:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 911; /* *extendqi_shft_di */

        case 4:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 915; /* *extendhi_shft_di */

        case 5:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 919; /* *extendsi_shft_di */

        case 6:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3827; /* aarch64_sshllv8qi */

        case 7:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3829; /* aarch64_sshllv4hi */

        case 8:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3831; /* aarch64_sshllv2si */

        case 9:
          if (!
#line 6616 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3833; /* aarch64_sshll2v16qi */

        case 10:
          if (!
#line 6616 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3835; /* aarch64_sshll2v8hi */

        case 11:
          if (!
#line 6616 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3837; /* aarch64_sshll2v4si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern309 (x3))
        {
        case 0:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 910; /* *zero_extendqi_shft_si */

        case 1:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 914; /* *zero_extendhi_shft_si */

        case 2:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 918; /* *zero_extendsi_shft_si */

        case 3:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 912; /* *zero_extendqi_shft_di */

        case 4:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 916; /* *zero_extendhi_shft_di */

        case 5:
          if (!
#line 6795 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 920; /* *zero_extendsi_shft_di */

        case 6:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3828; /* aarch64_ushllv8qi */

        case 7:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3830; /* aarch64_ushllv4hi */

        case 8:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3832; /* aarch64_ushllv2si */

        case 9:
          if (!
#line 6616 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3834; /* aarch64_ushll2v16qi */

        case 10:
          if (!
#line 6616 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3836; /* aarch64_ushll2v8hi */

        case 11:
          if (!
#line 6616 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3838; /* aarch64_ushll2v4si */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x10 = XEXP (x4, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern337 (x3, 
E_VOIDmode, 
E_SImode) != 0
              || !aarch64_simd_shift_imm_si (operands[3], E_VOIDmode)
              || !
#line 6825 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
            return -1;
          return 923; /* *ashiftsi_extv_bfiz */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_simd_shift_imm_offset_di (operands[2], E_VOIDmode)
              || !aarch64_simd_shift_imm_di (operands[3], E_VOIDmode)
              || !
#line 6825 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (DImode) - 1)))
            return -1;
          return 924; /* *ashiftdi_extv_bfiz */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_538 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 7143 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 1039; /* extendsfdf2 */

            case E_HFmode:
              if (!register_operand (operands[1], E_HFmode)
                  || !
#line 7159 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 1041; /* extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 7151 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1040; /* extendhfsf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !
#line 3208 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2696; /* extendv2sfv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4HFmode)
              || !
#line 3208 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2697; /* extendv4hfv4sf2 */

        case E_VNx8SFmode:
          if (!aligned_register_operand (operands[0], E_VNx8SFmode)
              || GET_MODE (x3) != E_VNx8SFmode
              || !register_operand (operands[1], E_VNx8HFmode)
              || !
#line 3323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME_F16F16))
            return -1;
          return 12803; /* extendvnx8hfvnx8sf2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern655 (x3, 
E_V8HFmode, 
E_V4HFmode, 
E_V4SFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[2], E_V8HFmode)
              && 
#line 3132 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2672; /* aarch64_simd_vec_unpacks_lo_v8hf */
          if (!vect_par_cnst_hi_half (operands[2], E_V8HFmode)
              || !
#line 3188 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2694; /* aarch64_simd_vec_unpacks_hi_v8hf */

        case E_V2DFmode:
          if (pattern655 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[2], E_V4SFmode)
              && 
#line 3132 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2673; /* aarch64_simd_vec_unpacks_lo_v4sf */
          if (!vect_par_cnst_hi_half (operands[2], E_V4SFmode)
              || !
#line 3188 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2695; /* aarch64_simd_vec_unpacks_hi_v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_549 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10222; /* while_wrsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10232; /* while_wrdivnx8bi_ptest */
}

 int
recog_554 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10122; /* *while_wrsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10132; /* *while_wrdivnx16bi_cc */
}

 int
recog_559 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10181; /* *while_rwsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10191; /* *while_rwdivnx2bi_cc */
}

 int
recog_564 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10240; /* while_ugesivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10250; /* while_ugedivnx4bi_ptest */
}

 int
recog_573 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10219; /* while_ugtsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10229; /* while_ugtdivnx8bi_ptest */
}

 int
recog_583 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10178; /* *while_gtsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10188; /* *while_gtdivnx2bi_cc */
}

 int
recog_593 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10137; /* *while_gesivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10147; /* *while_gedivnx8bi_cc */
}

 int
recog_603 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern679 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10041; /* while_rwsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10051; /* while_rwdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10061; /* while_rwsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10071; /* while_rwdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10081; /* while_rwsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10091; /* while_rwdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10101; /* while_rwsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10111; /* while_rwdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_607 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XINT (x4, 1))
    {
    case 136:
      switch (pattern684 (x1))
        {
        case 0:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12893; /* aarch64_sve_whilege_c8 */

        case 1:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12901; /* aarch64_sve_whilege_c16 */

        case 2:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12909; /* aarch64_sve_whilege_c32 */

        case 3:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12917; /* aarch64_sve_whilege_c64 */

        default:
          return -1;
        }

    case 137:
      switch (pattern684 (x1))
        {
        case 0:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12894; /* aarch64_sve_whilegt_c8 */

        case 1:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12902; /* aarch64_sve_whilegt_c16 */

        case 2:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12910; /* aarch64_sve_whilegt_c32 */

        case 3:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12918; /* aarch64_sve_whilegt_c64 */

        default:
          return -1;
        }

    case 138:
      switch (pattern684 (x1))
        {
        case 0:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12895; /* aarch64_sve_whileugt_c8 */

        case 1:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12903; /* aarch64_sve_whileugt_c16 */

        case 2:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12911; /* aarch64_sve_whileugt_c32 */

        case 3:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12919; /* aarch64_sve_whileugt_c64 */

        default:
          return -1;
        }

    case 139:
      switch (pattern684 (x1))
        {
        case 0:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12896; /* aarch64_sve_whileuge_c8 */

        case 1:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12904; /* aarch64_sve_whileuge_c16 */

        case 2:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12912; /* aarch64_sve_whileuge_c32 */

        case 3:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12920; /* aarch64_sve_whileuge_c64 */

        default:
          return -1;
        }

    case 140:
      switch (pattern684 (x1))
        {
        case 0:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12897; /* aarch64_sve_whilele_c8 */

        case 1:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12905; /* aarch64_sve_whilele_c16 */

        case 2:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12913; /* aarch64_sve_whilele_c32 */

        case 3:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12921; /* aarch64_sve_whilele_c64 */

        default:
          return -1;
        }

    case 141:
      switch (pattern684 (x1))
        {
        case 0:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12898; /* aarch64_sve_whileult_c8 */

        case 1:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12906; /* aarch64_sve_whileult_c16 */

        case 2:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12914; /* aarch64_sve_whileult_c32 */

        case 3:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12922; /* aarch64_sve_whileult_c64 */

        default:
          return -1;
        }

    case 142:
      switch (pattern684 (x1))
        {
        case 0:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12899; /* aarch64_sve_whileule_c8 */

        case 1:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12907; /* aarch64_sve_whileule_c16 */

        case 2:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12915; /* aarch64_sve_whileule_c32 */

        case 3:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12923; /* aarch64_sve_whileule_c64 */

        default:
          return -1;
        }

    case 143:
      switch (pattern684 (x1))
        {
        case 0:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12900; /* aarch64_sve_whilelt_c8 */

        case 1:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12908; /* aarch64_sve_whilelt_c16 */

        case 2:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12916; /* aarch64_sve_whilelt_c32 */

        case 3:
          if (!
#line 3679 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12924; /* aarch64_sve_whilelt_c64 */

        default:
          return -1;
        }

    case 653:
      switch (pattern689 (x1, 
653))
        {
        case 0:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13259; /* aarch64_sme_readz_horvnx16qivnx16qi */

        case 1:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13261; /* aarch64_sme_readz_horvnx8hivnx8hi */

        case 2:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13263; /* aarch64_sme_readz_horvnx4sivnx4si */

        case 3:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13265; /* aarch64_sme_readz_horvnx2divnx2di */

        case 4:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13267; /* aarch64_sme_readz_horvnx8hivnx8bf */

        case 5:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13269; /* aarch64_sme_readz_horvnx8hivnx8hf */

        case 6:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13271; /* aarch64_sme_readz_horvnx4sivnx4sf */

        case 7:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13273; /* aarch64_sme_readz_horvnx2divnx2df */

        case 8:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13419; /* aarch64_sme_readz_horvnx32qivnx32qi */

        case 9:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13421; /* aarch64_sme_readz_horvnx16hivnx16hi */

        case 10:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13423; /* aarch64_sme_readz_horvnx8sivnx8si */

        case 11:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13425; /* aarch64_sme_readz_horvnx4divnx4di */

        case 12:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13427; /* aarch64_sme_readz_horvnx16bfvnx16bf */

        case 13:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13429; /* aarch64_sme_readz_horvnx16hfvnx16hf */

        case 14:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13431; /* aarch64_sme_readz_horvnx8sfvnx8sf */

        case 15:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13433; /* aarch64_sme_readz_horvnx4dfvnx4df */

        case 16:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13435; /* aarch64_sme_readz_horvnx64qivnx64qi */

        case 17:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13437; /* aarch64_sme_readz_horvnx32hivnx32hi */

        case 18:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13439; /* aarch64_sme_readz_horvnx16sivnx16si */

        case 19:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13441; /* aarch64_sme_readz_horvnx8divnx8di */

        case 20:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13443; /* aarch64_sme_readz_horvnx32bfvnx32bf */

        case 21:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13445; /* aarch64_sme_readz_horvnx32hfvnx32hf */

        case 22:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13447; /* aarch64_sme_readz_horvnx16sfvnx16sf */

        case 23:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13449; /* aarch64_sme_readz_horvnx8dfvnx8df */

        case 24:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13291; /* aarch64_sme_readz_horvnx1tivnx16qi */

        case 25:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13293; /* aarch64_sme_readz_horvnx1tivnx8hi */

        case 26:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13295; /* aarch64_sme_readz_horvnx1tivnx4si */

        case 27:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13297; /* aarch64_sme_readz_horvnx1tivnx2di */

        case 28:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13299; /* aarch64_sme_readz_horvnx1tivnx8bf */

        case 29:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13301; /* aarch64_sme_readz_horvnx1tivnx8hf */

        case 30:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13303; /* aarch64_sme_readz_horvnx1tivnx4sf */

        case 31:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13305; /* aarch64_sme_readz_horvnx1tivnx2df */

        case 32:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 13275; /* *aarch64_sme_readz_horvnx16qivnx16qi_plus */

        case 33:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13277; /* *aarch64_sme_readz_horvnx8hivnx8hi_plus */

        case 34:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13279; /* *aarch64_sme_readz_horvnx4sivnx4si_plus */

        case 35:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13281; /* *aarch64_sme_readz_horvnx2divnx2di_plus */

        case 36:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13283; /* *aarch64_sme_readz_horvnx8hivnx8bf_plus */

        case 37:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13285; /* *aarch64_sme_readz_horvnx8hivnx8hf_plus */

        case 38:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13287; /* *aarch64_sme_readz_horvnx4sivnx4sf_plus */

        case 39:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13289; /* *aarch64_sme_readz_horvnx2divnx2df_plus */

        case 40:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 13451; /* *aarch64_sme_readz_horvnx32qivnx32qi_plus */

        case 41:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13453; /* *aarch64_sme_readz_horvnx16hivnx16hi_plus */

        case 42:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13455; /* *aarch64_sme_readz_horvnx8sivnx8si_plus */

        case 43:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13457; /* *aarch64_sme_readz_horvnx4divnx4di_plus */

        case 44:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13459; /* *aarch64_sme_readz_horvnx16bfvnx16bf_plus */

        case 45:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13461; /* *aarch64_sme_readz_horvnx16hfvnx16hf_plus */

        case 46:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13463; /* *aarch64_sme_readz_horvnx8sfvnx8sf_plus */

        case 47:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13465; /* *aarch64_sme_readz_horvnx4dfvnx4df_plus */

        case 48:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 13467; /* *aarch64_sme_readz_horvnx64qivnx64qi_plus */

        case 49:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13469; /* *aarch64_sme_readz_horvnx32hivnx32hi_plus */

        case 50:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13471; /* *aarch64_sme_readz_horvnx16sivnx16si_plus */

        case 51:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13473; /* *aarch64_sme_readz_horvnx8divnx8di_plus */

        case 52:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13475; /* *aarch64_sme_readz_horvnx32bfvnx32bf_plus */

        case 53:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13477; /* *aarch64_sme_readz_horvnx32hfvnx32hf_plus */

        case 54:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13479; /* *aarch64_sme_readz_horvnx16sfvnx16sf_plus */

        case 55:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13481; /* *aarch64_sme_readz_horvnx8dfvnx8df_plus */

        default:
          return -1;
        }

    case 654:
      switch (pattern689 (x1, 
654))
        {
        case 0:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13260; /* aarch64_sme_readz_vervnx16qivnx16qi */

        case 1:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13262; /* aarch64_sme_readz_vervnx8hivnx8hi */

        case 2:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13264; /* aarch64_sme_readz_vervnx4sivnx4si */

        case 3:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13266; /* aarch64_sme_readz_vervnx2divnx2di */

        case 4:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13268; /* aarch64_sme_readz_vervnx8hivnx8bf */

        case 5:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13270; /* aarch64_sme_readz_vervnx8hivnx8hf */

        case 6:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13272; /* aarch64_sme_readz_vervnx4sivnx4sf */

        case 7:
          if (!
#line 720 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13274; /* aarch64_sme_readz_vervnx2divnx2df */

        case 8:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13420; /* aarch64_sme_readz_vervnx32qivnx32qi */

        case 9:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13422; /* aarch64_sme_readz_vervnx16hivnx16hi */

        case 10:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13424; /* aarch64_sme_readz_vervnx8sivnx8si */

        case 11:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13426; /* aarch64_sme_readz_vervnx4divnx4di */

        case 12:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13428; /* aarch64_sme_readz_vervnx16bfvnx16bf */

        case 13:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13430; /* aarch64_sme_readz_vervnx16hfvnx16hf */

        case 14:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13432; /* aarch64_sme_readz_vervnx8sfvnx8sf */

        case 15:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13434; /* aarch64_sme_readz_vervnx4dfvnx4df */

        case 16:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13436; /* aarch64_sme_readz_vervnx64qivnx64qi */

        case 17:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13438; /* aarch64_sme_readz_vervnx32hivnx32hi */

        case 18:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13440; /* aarch64_sme_readz_vervnx16sivnx16si */

        case 19:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13442; /* aarch64_sme_readz_vervnx8divnx8di */

        case 20:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13444; /* aarch64_sme_readz_vervnx32bfvnx32bf */

        case 21:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13446; /* aarch64_sme_readz_vervnx32hfvnx32hf */

        case 22:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13448; /* aarch64_sme_readz_vervnx16sfvnx16sf */

        case 23:
          if (!
#line 872 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13450; /* aarch64_sme_readz_vervnx8dfvnx8df */

        case 24:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13292; /* aarch64_sme_readz_vervnx1tivnx16qi */

        case 25:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13294; /* aarch64_sme_readz_vervnx1tivnx8hi */

        case 26:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13296; /* aarch64_sme_readz_vervnx1tivnx4si */

        case 27:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13298; /* aarch64_sme_readz_vervnx1tivnx2di */

        case 28:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13300; /* aarch64_sme_readz_vervnx1tivnx8bf */

        case 29:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13302; /* aarch64_sme_readz_vervnx1tivnx8hf */

        case 30:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13304; /* aarch64_sme_readz_vervnx1tivnx4sf */

        case 31:
          if (!
#line 765 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
            return -1;
          return 13306; /* aarch64_sme_readz_vervnx1tivnx2df */

        case 32:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 13276; /* *aarch64_sme_readz_vervnx16qivnx16qi_plus */

        case 33:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13278; /* *aarch64_sme_readz_vervnx8hivnx8hi_plus */

        case 34:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13280; /* *aarch64_sme_readz_vervnx4sivnx4si_plus */

        case 35:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13282; /* *aarch64_sme_readz_vervnx2divnx2di_plus */

        case 36:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13284; /* *aarch64_sme_readz_vervnx8hivnx8bf_plus */

        case 37:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13286; /* *aarch64_sme_readz_vervnx8hivnx8hf_plus */

        case 38:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13288; /* *aarch64_sme_readz_vervnx4sivnx4sf_plus */

        case 39:
          if (!
#line 743 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13290; /* *aarch64_sme_readz_vervnx2divnx2df_plus */

        case 40:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 13452; /* *aarch64_sme_readz_vervnx32qivnx32qi_plus */

        case 41:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13454; /* *aarch64_sme_readz_vervnx16hivnx16hi_plus */

        case 42:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13456; /* *aarch64_sme_readz_vervnx8sivnx8si_plus */

        case 43:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13458; /* *aarch64_sme_readz_vervnx4divnx4di_plus */

        case 44:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13460; /* *aarch64_sme_readz_vervnx16bfvnx16bf_plus */

        case 45:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13462; /* *aarch64_sme_readz_vervnx16hfvnx16hf_plus */

        case 46:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13464; /* *aarch64_sme_readz_vervnx8sfvnx8sf_plus */

        case 47:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13466; /* *aarch64_sme_readz_vervnx4dfvnx4df_plus */

        case 48:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 13468; /* *aarch64_sme_readz_vervnx64qivnx64qi_plus */

        case 49:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13470; /* *aarch64_sme_readz_vervnx32hivnx32hi_plus */

        case 50:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13472; /* *aarch64_sme_readz_vervnx16sivnx16si_plus */

        case 51:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13474; /* *aarch64_sme_readz_vervnx8divnx8di_plus */

        case 52:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13476; /* *aarch64_sme_readz_vervnx32bfvnx32bf_plus */

        case 53:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 13478; /* *aarch64_sme_readz_vervnx32hfvnx32hf_plus */

        case 54:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 13480; /* *aarch64_sme_readz_vervnx16sfvnx16sf_plus */

        case 55:
          if (!
#line 900 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 13482; /* *aarch64_sme_readz_vervnx8dfvnx8df_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_625 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          switch (XINT (x1, 1))
            {
            case 165:
              if (GET_MODE (x1) != E_DImode
                  || !aarch64_sysreg_string (operands[0], E_VOIDmode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              return 3; /* aarch64_write_sysregdi */

            case 166:
              if (GET_MODE (x1) != E_TImode
                  || !aarch64_sysreg_string (operands[0], E_VOIDmode)
                  || !register_operand (operands[1], E_TImode)
                  || !
#line 679 "../../gcc/config/aarch64/aarch64.md"
(TARGET_D128))
                return -1;
              return 4; /* aarch64_write_sysregti */

            case 181:
              if (!const_int_operand (operands[0], E_VOIDmode)
                  || !const_int_operand (operands[1], E_VOIDmode))
                return -1;
              return 1278; /* patchable_area */

            default:
              return -1;
            }

        case 1:
          switch (XINT (x1, 1))
            {
            case 5:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1207; /* blockage */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 1217; /* aarch64_set_fpsrsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 1219; /* aarch64_set_fpsrdi */

                default:
                  return -1;
                }

            case 2:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 1218; /* aarch64_set_fpcrsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 1220; /* aarch64_set_fpcrdi */

                default:
                  return -1;
                }

            case 8:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1227; /* bti_noarg */

            case 9:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1228; /* bti_c */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1229; /* bti_j */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1230; /* bti_jc */

            case 7:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1231; /* speculation_barrier */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1284; /* aarch64_gcspopm_xzr */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              return 1285; /* aarch64_gcsss1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      return recog_626 (x1, insn, pnum_clobbers);

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          if (XINT (x1, 1) != 71)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 97; /* nop */

        case 2:
          if (XINT (x1, 1) != 167)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!aarch64_prefetch_operand (operands[1], E_DImode))
            return -1;
          return 99; /* aarch64_pldx */

        default:
          return -1;
        }

    case PREFETCH:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (aarch64_prefetch_operand (operands[0], E_DImode))
        {
          x5 = XEXP (x1, 1);
          operands[1] = x5;
          if (const_int_operand (operands[1], E_QImode))
            {
              x6 = XEXP (x1, 2);
              operands[2] = x6;
              if (const_int_operand (operands[2], E_QImode))
                return 98; /* prefetch */
            }
        }
      if (GET_CODE (x4) != UNSPEC
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x1, 1);
      if (!const_int_operand (x5, E_DImode))
        return -1;
      x6 = XEXP (x1, 2);
      if (!const_int_operand (x6, E_DImode))
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          if (XINT (x4, 1) != 170)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[0] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[1] = x8;
          x9 = XVECEXP (x4, 0, 2);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          operands[3] = x5;
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (!register_operand (operands[0], E_VNx16BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx16QImode)
                  || !
#line 2158 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6320; /* aarch64_sve_prefetchvnx16qi */

            case E_VNx8BImode:
              if (!register_operand (operands[0], E_VNx8BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx8HImode)
                  || !
#line 2158 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6321; /* aarch64_sve_prefetchvnx8hi */

            case E_VNx4BImode:
              if (!register_operand (operands[0], E_VNx4BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx4SImode)
                  || !
#line 2158 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6322; /* aarch64_sve_prefetchvnx4si */

            case E_VNx2BImode:
              if (!register_operand (operands[0], E_VNx2BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx2DImode)
                  || !
#line 2158 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6323; /* aarch64_sve_prefetchvnx2di */

            default:
              return -1;
            }

        case 7:
          if (XINT (x4, 1) != 171)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[0] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[1] = x8;
          x10 = XVECEXP (x4, 0, 3);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x11 = XVECEXP (x4, 0, 4);
          operands[4] = x11;
          x12 = XVECEXP (x4, 0, 5);
          operands[5] = x12;
          x13 = XVECEXP (x4, 0, 6);
          operands[6] = x13;
          if (!const_int_operand (operands[6], E_DImode))
            return -1;
          operands[7] = x5;
          operands[8] = x6;
          x9 = XVECEXP (x4, 0, 2);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4BImode:
                  if (!register_operand (operands[0], E_VNx4BImode)
                      || !register_operand (operands[2], E_VNx4SImode))
                    return -1;
                  if (aarch64_sve_gather_offset_b (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_b (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                      && 
#line 2198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6324; /* aarch64_sve_gather_prefetchvnx16qivnx4si */
                  if (aarch64_sve_gather_offset_h (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_h (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                      && 
#line 2198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6325; /* aarch64_sve_gather_prefetchvnx8hivnx4si */
                  if (aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                      && 
#line 2198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6326; /* aarch64_sve_gather_prefetchvnx4sivnx4si */
                  if (!aarch64_sve_gather_offset_d (operands[1], E_DImode)
                      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                      || !
#line 2198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6327; /* aarch64_sve_gather_prefetchvnx2divnx4si */

                case E_VNx2BImode:
                  if (!register_operand (operands[0], E_VNx2BImode)
                      || !register_operand (operands[2], E_VNx2DImode))
                    return -1;
                  if (aarch64_sve_gather_offset_b (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_b (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                      && 
#line 2227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6328; /* aarch64_sve_gather_prefetchvnx16qivnx2di */
                  if (aarch64_sve_gather_offset_h (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_h (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                      && 
#line 2227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6329; /* aarch64_sve_gather_prefetchvnx8hivnx2di */
                  if (aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                      && 
#line 2227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6330; /* aarch64_sve_gather_prefetchvnx4sivnx2di */
                  if (!aarch64_sve_gather_offset_d (operands[1], E_DImode)
                      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                      || !
#line 2227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6331; /* aarch64_sve_gather_prefetchvnx2divnx2di */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pattern583 (x9) != 0
                  || !register_operand (operands[0], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x14 = XVECEXP (x9, 0, 0);
              operands[9] = x14;
              x15 = XVECEXP (x9, 0, 1);
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              if (aarch64_gather_scale_operand_b (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                  && 
#line 2258 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6332; /* *aarch64_sve_gather_prefetchvnx16qivnx2di_sxtw */
              if (aarch64_gather_scale_operand_h (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                  && 
#line 2258 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6333; /* *aarch64_sve_gather_prefetchvnx8hivnx2di_sxtw */
              if (aarch64_gather_scale_operand_w (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                  && 
#line 2258 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6334; /* *aarch64_sve_gather_prefetchvnx4sivnx2di_sxtw */
              if (!aarch64_gather_scale_operand_d (operands[4], E_DImode)
                  || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                  || !
#line 2258 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6335; /* *aarch64_sve_gather_prefetchvnx2divnx2di_sxtw */

            case AND:
              if (GET_MODE (x9) != E_VNx2DImode
                  || !register_operand (operands[0], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x18 = XEXP (x9, 0);
              operands[2] = x18;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x19 = XEXP (x9, 1);
              operands[9] = x19;
              if (!aarch64_sve_uxtw_immediate (operands[9], E_VNx2DImode))
                return -1;
              if (aarch64_gather_scale_operand_b (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                  && 
#line 2288 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6336; /* *aarch64_sve_gather_prefetchvnx16qivnx2di_uxtw */
              if (aarch64_gather_scale_operand_h (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                  && 
#line 2288 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6337; /* *aarch64_sve_gather_prefetchvnx8hivnx2di_uxtw */
              if (aarch64_gather_scale_operand_w (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                  && 
#line 2288 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6338; /* *aarch64_sve_gather_prefetchvnx4sivnx2di_uxtw */
              if (!aarch64_gather_scale_operand_d (operands[4], E_DImode)
                  || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                  || !
#line 2288 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6339; /* *aarch64_sve_gather_prefetchvnx2divnx2di_uxtw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x4 = XEXP (x1, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return 100; /* trap */

    case RETURN:
      return 101; /* *do_return */

    case SIMPLE_RETURN:
      return 102; /* simple_return */

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern867 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3824 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1146 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3873 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1179 (insn, operands);

    case E_VNx4SFmode:
      if (pattern867 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3824 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1157 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3873 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1190 (insn, operands);

    case E_VNx2DFmode:
      if (pattern867 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3824 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1168 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3873 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1201 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2947 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2955 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2963 (insn, operands);
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2856 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2897 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2937 (insn, operands);
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2855 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2896 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2936 (insn, operands);
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2842 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2885 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2925 (insn, operands);
}

 rtx_insn *
split_34 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2829 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2874 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2914 (insn, operands);
}

 rtx_insn *
split_39 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2816 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2863 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2903 (insn, operands);
}

 rtx_insn *
split_44 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2849 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2891 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2931 (insn, operands);
}

 rtx_insn *
split_50 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2824 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2870 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2910 (insn, operands);
}

 rtx_insn *
split_56 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2846 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2888 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2928 (insn, operands);
}

 rtx_insn *
split_62 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1045 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1684 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1757 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1809 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1697 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1770 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1822 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1710 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1783 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1835 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1723 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1796 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1848 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1732 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1909 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1739 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1916 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1746 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1923 (insn, operands);

    case 7:
      if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1861 (insn, operands);

    case 8:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1874 (insn, operands);

    case 9:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1887 (insn, operands);

    case 10:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1900 (insn, operands);

    case 11:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1930 (insn, operands);

    case 12:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1937 (insn, operands);

    case 13:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1944 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_68 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[3] = x6;
  switch (XINT (x3, 1))
    {
    case 391:
      switch (XWINT (x4, 0))
        {
        case 0L:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1163 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5388 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1656 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
                  || !(
#line 5428 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1659 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1163 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5388 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1657 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
                  || !(
#line 5428 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1660 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1163 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5388 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1658 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
                  || !(
#line 5428 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1661 (insn, operands);

            default:
              return NULL;
            }

        case 1L:
          x8 = XVECEXP (x2, 0, 2);
          operands[4] = x8;
          x7 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1226 (x2, 
E_VNx8HFmode, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !(
#line 5465 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5472 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1662 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1226 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !(
#line 5465 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5472 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1663 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1226 (x2, 
E_VNx2DFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !(
#line 5465 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5472 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1664 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 352:
      return split_59 (x1, insn);

    case 353:
      switch (pattern1041 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1678 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1751 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1803 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1691 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1764 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1816 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1704 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1777 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1829 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1717 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1790 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1842 (insn, operands);

        case 4:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1855 (insn, operands);

        case 5:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1868 (insn, operands);

        case 6:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1881 (insn, operands);

        case 7:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3463 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1894 (insn, operands);

        default:
          return NULL;
        }

    case 354:
      switch (pattern1041 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1679 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1752 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1804 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1692 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1765 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1817 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1705 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1778 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1718 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1791 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1843 (insn, operands);

        case 4:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 5:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 6:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1882 (insn, operands);

        case 7:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3464 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1895 (insn, operands);

        default:
          return NULL;
        }

    case 371:
      switch (pattern1041 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1680 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1753 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1805 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1693 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1766 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1818 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1706 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1779 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1719 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1792 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1844 (insn, operands);

        case 4:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1857 (insn, operands);

        case 5:
          if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1870 (insn, operands);

        case 6:
          if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1883 (insn, operands);

        case 7:
          if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1896 (insn, operands);

        default:
          return NULL;
        }

    case 372:
      return split_65 (x1, insn);

    case 373:
      return split_64 (x1, insn);

    case 374:
      return split_63 (x1, insn);

    case 375:
      return split_62 (x1, insn);

    case 378:
      return split_58 (x1, insn);

    case 379:
      switch (pattern1041 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1686 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1759 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1811 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1699 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1772 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1824 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1712 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1785 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1837 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1725 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1798 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1850 (insn, operands);

        case 4:
          if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1863 (insn, operands);

        case 5:
          if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1876 (insn, operands);

        case 6:
          if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1889 (insn, operands);

        case 7:
          if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1902 (insn, operands);

        default:
          return NULL;
        }

    case 393:
      return split_57 (x1, insn);

    case 395:
      return split_61 (x1, insn);

    case 396:
      return split_60 (x1, insn);

    case 355:
      switch (pattern1046 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6103 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6108 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1957 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6153 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1963 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6103 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6108 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1959 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6153 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1965 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6103 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6108 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1961 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6153 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1967 (insn, operands);

        case 3:
          if (!(
#line 6183 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6190 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1969 (insn, operands);

        case 4:
          if (!(
#line 6183 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6190 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1971 (insn, operands);

        case 5:
          if (!(
#line 6183 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6190 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1973 (insn, operands);

        default:
          return NULL;
        }

    case 356:
      switch (pattern1046 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6103 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6108 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1958 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6153 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1964 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6103 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6108 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1960 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6153 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1966 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 6103 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6108 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1962 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6153 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1968 (insn, operands);

        case 3:
          if (!(
#line 6183 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6190 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1970 (insn, operands);

        case 4:
          if (!(
#line 6183 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6190 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1972 (insn, operands);

        case 5:
          if (!(
#line 6183 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6190 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1974 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_83 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NEG:
      switch (pattern302 (x3))
        {
        case 0:
          return gen_split_26 (insn, operands);

        case 1:
          return gen_split_27 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          switch (pattern456 (x3))
            {
            case 0:
              if (!
#line 5329 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 1:
              if (!
#line 5329 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_45 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern457 (x3))
            {
            case 0:
              if (!
#line 5351 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (XOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 1:
              if (!
#line 5351 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (XOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 2:
              if (!
#line 5380 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (XOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 3:
              if (!
#line 5380 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (XOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return NULL;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DImode))
            return NULL;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return NULL;
          x9 = XEXP (x3, 1);
          if (rtx_equal_p (x9, operands[3])
              && (
#line 3804 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 3811 "../../gcc/config/aarch64/aarch64-simd.md"
( REG_P (operands[0]) && GP_REGNUM_P (REGNO (operands[0])))))
            return gen_split_176 (insn, operands);
          if (!rtx_equal_p (x9, operands[2])
              || !(
#line 3845 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 3852 "../../gcc/config/aarch64/aarch64-simd.md"
( REG_P (operands[0]) && GP_REGNUM_P (REGNO (operands[0])))))
            return NULL;
          return gen_split_177 (insn, operands);

        case UNSPEC:
          switch (pattern407 (x3))
            {
            case 0:
              if (!(
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1594 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2974 (insn, operands);

            case 1:
              if (!(
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1594 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2975 (insn, operands);

            case 2:
              if (!(
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1594 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2976 (insn, operands);

            case 3:
              if (!(
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1594 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2977 (insn, operands);

            case 4:
              x9 = XEXP (x3, 1);
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2994 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2995 (insn, operands);

            case 5:
              x9 = XEXP (x3, 1);
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2996 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2997 (insn, operands);

            case 6:
              x9 = XEXP (x3, 1);
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2998 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2999 (insn, operands);

            case 7:
              x9 = XEXP (x3, 1);
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3000 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1792 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3001 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern368 (x3))
        {
        case 0:
          if (!
#line 5403 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_65 (insn, operands);

        case 1:
          if (!
#line 5403 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_68 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_115 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2421 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2431 (insn, operands);
}

 rtx_insn *
split_122 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2440 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2450 (insn, operands);
}

 rtx_insn *
split_129 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2459 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2469 (insn, operands);
}

 rtx_insn *
split_136 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case UNSPEC:
      if (XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 126)
        return NULL;
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern925 (x1))
        {
        case 0:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2315 (insn, operands);

        case 1:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2325 (insn, operands);

        case 2:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2355 (insn, operands);

        case 3:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2335 (insn, operands);

        case 4:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2365 (insn, operands);

        case 5:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2385 (insn, operands);

        case 6:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2345 (insn, operands);

        case 7:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2375 (insn, operands);

        case 8:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2395 (insn, operands);

        case 9:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2405 (insn, operands);

        case 10:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2316 (insn, operands);

        case 11:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2326 (insn, operands);

        case 12:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2356 (insn, operands);

        case 13:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2336 (insn, operands);

        case 14:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2366 (insn, operands);

        case 15:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2386 (insn, operands);

        case 16:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2346 (insn, operands);

        case 17:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2376 (insn, operands);

        case 18:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2396 (insn, operands);

        case 19:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2406 (insn, operands);

        case 20:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2317 (insn, operands);

        case 21:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2327 (insn, operands);

        case 22:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2357 (insn, operands);

        case 23:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2337 (insn, operands);

        case 24:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2367 (insn, operands);

        case 25:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2387 (insn, operands);

        case 26:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2347 (insn, operands);

        case 27:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2377 (insn, operands);

        case 28:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2397 (insn, operands);

        case 29:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2407 (insn, operands);

        case 30:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2318 (insn, operands);

        case 31:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2328 (insn, operands);

        case 32:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2358 (insn, operands);

        case 33:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2338 (insn, operands);

        case 34:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2368 (insn, operands);

        case 35:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2388 (insn, operands);

        case 36:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2348 (insn, operands);

        case 37:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2378 (insn, operands);

        case 38:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2398 (insn, operands);

        case 39:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2408 (insn, operands);

        case 40:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2319 (insn, operands);

        case 41:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2329 (insn, operands);

        case 42:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2359 (insn, operands);

        case 43:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2339 (insn, operands);

        case 44:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2369 (insn, operands);

        case 45:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2389 (insn, operands);

        case 46:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2349 (insn, operands);

        case 47:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2379 (insn, operands);

        case 48:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2399 (insn, operands);

        case 49:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2409 (insn, operands);

        case 50:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2320 (insn, operands);

        case 51:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2330 (insn, operands);

        case 52:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2360 (insn, operands);

        case 53:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2340 (insn, operands);

        case 54:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2370 (insn, operands);

        case 55:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2390 (insn, operands);

        case 56:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2350 (insn, operands);

        case 57:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2380 (insn, operands);

        case 58:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2400 (insn, operands);

        case 59:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2410 (insn, operands);

        case 60:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2321 (insn, operands);

        case 61:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2331 (insn, operands);

        case 62:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2361 (insn, operands);

        case 63:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2341 (insn, operands);

        case 64:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2371 (insn, operands);

        case 65:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2391 (insn, operands);

        case 66:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2351 (insn, operands);

        case 67:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2381 (insn, operands);

        case 68:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2401 (insn, operands);

        case 69:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2411 (insn, operands);

        case 70:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2322 (insn, operands);

        case 71:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2332 (insn, operands);

        case 72:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2362 (insn, operands);

        case 73:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2342 (insn, operands);

        case 74:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2372 (insn, operands);

        case 75:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2392 (insn, operands);

        case 76:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2352 (insn, operands);

        case 77:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2382 (insn, operands);

        case 78:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2402 (insn, operands);

        case 79:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2412 (insn, operands);

        case 80:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2323 (insn, operands);

        case 81:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2333 (insn, operands);

        case 82:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2363 (insn, operands);

        case 83:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2343 (insn, operands);

        case 84:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2373 (insn, operands);

        case 85:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2393 (insn, operands);

        case 86:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2353 (insn, operands);

        case 87:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2383 (insn, operands);

        case 88:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2403 (insn, operands);

        case 89:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2413 (insn, operands);

        case 90:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2324 (insn, operands);

        case 91:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2334 (insn, operands);

        case 92:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2364 (insn, operands);

        case 93:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2344 (insn, operands);

        case 94:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2374 (insn, operands);

        case 95:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2394 (insn, operands);

        case 96:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2354 (insn, operands);

        case 97:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2384 (insn, operands);

        case 98:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2404 (insn, operands);

        case 99:
          if (!(
#line 8433 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8435 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2414 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x8 = XEXP (x6, 0);
      if (pattern568 (x8) != 0)
        return NULL;
      switch (pattern983 (x1))
        {
        case 0:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2596 (insn, operands);

        case 1:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2602 (insn, operands);

        case 2:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2608 (insn, operands);

        case 3:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2614 (insn, operands);

        case 4:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2620 (insn, operands);

        case 5:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2626 (insn, operands);

        case 6:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2597 (insn, operands);

        case 7:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2603 (insn, operands);

        case 8:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2609 (insn, operands);

        case 9:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2615 (insn, operands);

        case 10:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2621 (insn, operands);

        case 11:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2627 (insn, operands);

        case 12:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2598 (insn, operands);

        case 13:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2604 (insn, operands);

        case 14:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2610 (insn, operands);

        case 15:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2616 (insn, operands);

        case 16:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2622 (insn, operands);

        case 17:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2628 (insn, operands);

        case 18:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2599 (insn, operands);

        case 19:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2605 (insn, operands);

        case 20:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2611 (insn, operands);

        case 21:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2617 (insn, operands);

        case 22:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2623 (insn, operands);

        case 23:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2629 (insn, operands);

        case 24:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2600 (insn, operands);

        case 25:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2606 (insn, operands);

        case 26:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2612 (insn, operands);

        case 27:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2618 (insn, operands);

        case 28:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2624 (insn, operands);

        case 29:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2630 (insn, operands);

        case 30:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2601 (insn, operands);

        case 31:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2607 (insn, operands);

        case 32:
          if (!(
#line 8749 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8751 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2613 (insn, operands);

        case 33:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2619 (insn, operands);

        case 34:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2625 (insn, operands);

        case 35:
          if (!(
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8789 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2631 (insn, operands);

        case 36:
          if (!(
#line 8825 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8827 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2632 (insn, operands);

        case 37:
          if (!(
#line 8825 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8827 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2633 (insn, operands);

        case 38:
          if (!(
#line 8825 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8827 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2634 (insn, operands);

        case 39:
          if (!(
#line 8862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8864 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2635 (insn, operands);

        case 40:
          if (!(
#line 8862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8864 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2636 (insn, operands);

        case 41:
          if (!(
#line 8862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8864 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_2637 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
