/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_fp_vec_pow2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return -1;
  return pattern15 (x1); /* [-1, 1] */
}

int
pattern20 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 307
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode))
    return -1;
  return pattern23 (x3); /* [-1, 3] */
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_uminmax_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      return pattern37 (x1, 
E_VNx16QImode, 
E_VNx32QImode); /* [-1, 0] */

    case E_VNx16HImode:
      if (pattern37 (x1, 
E_VNx8HImode, 
E_VNx16HImode) != 0)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (pattern37 (x1, 
E_VNx4SImode, 
E_VNx8SImode) != 0)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (pattern37 (x1, 
E_VNx2DImode, 
E_VNx4DImode) != 0)
        return -1;
      return 3;

    case E_VNx64QImode:
      if (pattern37 (x1, 
E_VNx16QImode, 
E_VNx64QImode) != 0)
        return -1;
      return 4;

    case E_VNx32HImode:
      if (pattern37 (x1, 
E_VNx8HImode, 
E_VNx32HImode) != 0)
        return -1;
      return 5;

    case E_VNx16SImode:
      if (pattern37 (x1, 
E_VNx4SImode, 
E_VNx16SImode) != 0)
        return -1;
      return 6;

    case E_VNx8DImode:
      if (pattern37 (x1, 
E_VNx2DImode, 
E_VNx8DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_tls_le_symref (operands[1], E_VOIDmode))
    return -1;
  return pattern44 (x3); /* [-1, 1] */
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x3) != E_VNx64QImode
          || !aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x3) != E_VNx32HImode
          || !aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      return 1;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x3) != E_VNx16SImode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 2;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x3) != E_VNx8DImode
          || !aligned_register_operand (operands[1], E_VNx8DImode))
        return -1;
      return 3;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x3) != E_VNx32BFmode
          || !aligned_register_operand (operands[1], E_VNx32BFmode))
        return -1;
      return 4;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x3) != E_VNx32HFmode
          || !aligned_register_operand (operands[1], E_VNx32HFmode))
        return -1;
      return 5;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SFmode))
        return -1;
      return 6;

    case E_VNx8DFmode:
      if (!aligned_register_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x3) != E_VNx8DFmode
          || !aligned_register_operand (operands[1], E_VNx8DFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      return 0;

    case VEC_DUPLICATE:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      return 1;

    case VEC_SELECT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x8 = XVECEXP (x7, 0, 0);
      operands[3] = x8;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          res = pattern96 (x3, 
E_V4HImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_V8HImode:
          res = pattern96 (x3, 
E_V8HImode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_V2SImode:
          res = pattern97 (x3, 
E_V2SImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case E_V4SImode:
          res = pattern97 (x3, 
E_V4SImode);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case E_HImode:
          res = pattern96 (x3, 
E_HImode);
          if (res >= 0)
            return res + 10; /* [10, 11] */
          return -1;

        case E_SImode:
          res = pattern97 (x3, 
E_SImode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 168)
        return -1;
      x9 = XVECEXP (x5, 0, 0);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern98 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 14;

        case E_VNx4SImode:
          if (pattern98 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 15;

        case E_VNx2DImode:
          if (pattern98 (x3, 
E_VNx2DImode) != 0)
            return -1;
          return 16;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern126 (x3); /* [-1, 2] */
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  return pattern68 (x3); /* [-1, 2] */
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern79 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern79 (x3, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern79 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern79 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XVECEXP (x3, 0, 2);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              return pattern147 (x3, 
E_V4HImode); /* [-1, 0] */

            case E_V8HImode:
              if (pattern147 (x3, 
E_V8HImode) != 0)
                return -1;
              return 1;

            case E_V2SImode:
              if (pattern147 (x3, 
E_V2SImode) != 0)
                return -1;
              return 2;

            case E_V4SImode:
              if (pattern147 (x3, 
E_V4SImode) != 0)
                return -1;
              return 3;

            case E_HImode:
              if (pattern147 (x3, 
E_HImode) != 0)
                return -1;
              return 4;

            case E_SImode:
              if (pattern147 (x3, 
E_SImode) != 0)
                return -1;
              return 5;

            case E_VNx16QImode:
              if (pattern148 (x3, 
E_VNx16QImode) != 0)
                return -1;
              return 6;

            case E_VNx8HImode:
              if (pattern148 (x3, 
E_VNx8HImode) != 0)
                return -1;
              return 7;

            case E_VNx4SImode:
              if (pattern148 (x3, 
E_VNx4SImode) != 0)
                return -1;
              return 8;

            case E_VNx2DImode:
              if (pattern148 (x3, 
E_VNx2DImode) != 0)
                return -1;
              return 9;

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          operands[2] = x4;
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          x9 = XVECEXP (x6, 0, 0);
          operands[4] = x9;
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              res = pattern149 (x3, 
E_V4HImode);
              if (res >= 0)
                return res + 10; /* [10, 11] */
              return -1;

            case E_V8HImode:
              res = pattern149 (x3, 
E_V8HImode);
              if (res >= 0)
                return res + 12; /* [12, 13] */
              return -1;

            case E_V2SImode:
              res = pattern150 (x3, 
E_V2SImode);
              if (res >= 0)
                return res + 14; /* [14, 15] */
              return -1;

            case E_V4SImode:
              res = pattern150 (x3, 
E_V4SImode);
              if (res >= 0)
                return res + 16; /* [16, 17] */
              return -1;

            case E_HImode:
              res = pattern149 (x3, 
E_HImode);
              if (res >= 0)
                return res + 18; /* [18, 19] */
              return -1;

            case E_SImode:
              res = pattern150 (x3, 
E_SImode);
              if (res >= 0)
                return res + 20; /* [20, 21] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 168)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[2] = x7;
      x10 = XVECEXP (x4, 0, 0);
      operands[3] = x10;
      x11 = XVECEXP (x4, 0, 1);
      operands[4] = x11;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 2);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern151 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 22;

        case E_VNx4SImode:
          if (pattern151 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 23;

        case E_VNx2DImode:
          if (pattern151 (x3, 
E_VNx2DImode) != 0)
            return -1;
          return 24;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_maxmin_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  return pattern211 (x3); /* [-1, 3] */
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern217 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern217 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern217 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return pattern226 (x2); /* [-1, 15] */

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      res = pattern226 (x2);
      if (res >= 0)
        return res + 16; /* [16, 31] */
      return -1;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x4 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[2], E_VNx32QImode)
          || !aligned_register_operand (operands[3], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[2], E_VNx64QImode)
          || !aligned_register_operand (operands[3], E_VNx64QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || !aligned_register_operand (operands[3], E_VNx16HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || !aligned_register_operand (operands[3], E_VNx32HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 4);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          return pattern247 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern247 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          res = pattern248 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern248 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 168)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[3] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[4] = x8;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          res = pattern249 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        case E_VNx2DImode:
          res = pattern249 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 20; /* [20, 23] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern262 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      return pattern265 (x2, 
E_VNx16QImode, 
E_VNx4BImode, 
E_VNx4SImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern265 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern276 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_ldff1_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 0;

    case E_VNx1TImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !aarch64_plus_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern294 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern298 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern306 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern305 (); /* [-1, 2] */
}

int
pattern308 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[1], i2)
      || !vect_par_cnst_hi_half (operands[2], i2)
      || !aarch64_simd_shll_imm_vec (operands[3], i1))
    return -1;
  return 0;
}

int
pattern315 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern319 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8QImode
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!aarch64_simd_or_scalar_imm_zero (operands[2], E_V8QImode))
    return -1;
  return 0;
}

int
pattern326 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern325 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern325 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern325 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx2DImode))
    return -1;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern340 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern346 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern346 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern357 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern362 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  x12 = XVECEXP (x3, 0, 2);
  operands[3] = x12;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern350 (x1); /* [-1, 3] */
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!aarch64_any_register_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode)
        return -1;
      return 0;

    case E_VNx8QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x1) != E_VNx8QImode)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x1) != E_VNx4QImode)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x1) != E_VNx4HImode)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x1) != E_VNx2HImode)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x1) != E_VNx2SImode)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode)
        return -1;
      return 9;

    case E_VNx2HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x1) != E_VNx2HFmode)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x1) != E_VNx4HFmode)
        return -1;
      return 11;

    case E_VNx2SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x1) != E_VNx2SFmode)
        return -1;
      return 12;

    case E_VNx8HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      return 13;

    case E_VNx4SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode)
        return -1;
      return 14;

    case E_VNx2DFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x1) != E_VNx2DFmode)
        return -1;
      return 15;

    case E_VNx2BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x1) != E_VNx2BFmode)
        return -1;
      return 16;

    case E_VNx4BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x1) != E_VNx4BFmode)
        return -1;
      return 17;

    case E_VNx8BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern406 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (XINT (x2, 1))
    {
    case 357:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          return pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode); /* [-1, 0] */

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 358:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 3;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 4;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 359:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 6;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 7;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case 364:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 9;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 10;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case 365:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 12;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 13;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 14;

        default:
          return -1;
        }

    case 366:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 15;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 16;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case 367:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern413 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 18;

        case E_VNx4BImode:
          if (pattern413 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 19;

        case E_VNx2BImode:
          if (pattern413 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 20;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern446 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_sqadd_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern450 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern23 (x1);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern460 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[4] = x3;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 3);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern208 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern208 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern208 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern208 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_imm_one (operands[1], i2)
      || !aarch64_sve_nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern472 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !memory_operand (operands[1], E_VNx8QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !memory_operand (operands[1], E_VNx4QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !memory_operand (operands[1], E_VNx4HImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2HImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2SImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern481 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC)
    return -1;
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      switch (XINT (x3, 1))
        {
        case 115:
          x7 = XVECEXP (x3, 0, 2);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              return pattern472 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 5] */

            case E_VNx4HImode:
              res = pattern472 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 6; /* [6, 11] */
              return -1;

            case E_VNx2HImode:
              res = pattern472 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 12; /* [12, 17] */
              return -1;

            case E_VNx4SImode:
              res = pattern472 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 18; /* [18, 23] */
              return -1;

            case E_VNx2SImode:
              res = pattern472 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 24; /* [24, 29] */
              return -1;

            case E_VNx2DImode:
              res = pattern472 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 30; /* [30, 35] */
              return -1;

            default:
              return -1;
            }

        case 403:
          x7 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 86
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              res = pattern473 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
              if (res >= 0)
                return res + 36; /* [36, 41] */
              return -1;

            case E_VNx4HImode:
              res = pattern473 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 42; /* [42, 47] */
              return -1;

            case E_VNx2HImode:
              res = pattern473 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 48; /* [48, 53] */
              return -1;

            case E_VNx4SImode:
              res = pattern473 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 54; /* [54, 59] */
              return -1;

            case E_VNx2SImode:
              res = pattern473 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 60; /* [60, 65] */
              return -1;

            case E_VNx2DImode:
              res = pattern473 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 66; /* [66, 71] */
              return -1;

            default:
              return -1;
            }

        case 404:
          x7 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 86
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              res = pattern474 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
              if (res >= 0)
                return res + 72; /* [72, 77] */
              return -1;

            case E_VNx4HImode:
              res = pattern474 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 78; /* [78, 83] */
              return -1;

            case E_VNx2HImode:
              res = pattern474 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 84; /* [84, 89] */
              return -1;

            case E_VNx4SImode:
              res = pattern474 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 90; /* [90, 95] */
              return -1;

            case E_VNx2SImode:
              res = pattern474 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 96; /* [96, 101] */
              return -1;

            case E_VNx2DImode:
              res = pattern474 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 102; /* [102, 107] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x3, 1) != 125)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          res = pattern475 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
          if (res >= 0)
            return res + 108; /* [108, 113] */
          return -1;

        case E_VNx4HImode:
          res = pattern475 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
          if (res >= 0)
            return res + 114; /* [114, 119] */
          return -1;

        case E_VNx2HImode:
          res = pattern475 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 120; /* [120, 125] */
          return -1;

        case E_VNx4SImode:
          res = pattern475 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
          if (res >= 0)
            return res + 126; /* [126, 131] */
          return -1;

        case E_VNx2SImode:
          res = pattern475 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 132; /* [132, 137] */
          return -1;

        case E_VNx2DImode:
          res = pattern475 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 138; /* [138, 143] */
          return -1;

        default:
          return -1;
        }

    case 7:
      x5 = XVECEXP (x3, 0, 0);
      operands[5] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      x8 = XVECEXP (x3, 0, 3);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      operands[4] = x9;
      switch (XINT (x3, 1))
        {
        case 120:
          x10 = XVECEXP (x3, 0, 6);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SCRATCH)
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              x12 = XVECEXP (x3, 0, 5);
              operands[7] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4HImode:
                  res = pattern476 (x1, 
E_VNx4HImode);
                  if (res >= 0)
                    return res + 144; /* [144, 145] */
                  return -1;

                case E_VNx4SImode:
                  res = pattern476 (x1, 
E_VNx4SImode);
                  if (res >= 0)
                    return res + 146; /* [146, 147] */
                  return -1;

                case E_VNx2HImode:
                  res = pattern477 (x1, 
E_VNx2HImode);
                  if (res >= 0)
                    return res + 148; /* [148, 150] */
                  return -1;

                case E_VNx2SImode:
                  res = pattern477 (x1, 
E_VNx2SImode);
                  if (res >= 0)
                    return res + 151; /* [151, 153] */
                  return -1;

                case E_VNx2DImode:
                  res = pattern477 (x1, 
E_VNx2DImode);
                  if (res >= 0)
                    return res + 154; /* [154, 156] */
                  return -1;

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 125
                  || GET_MODE (x7) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              if (!register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x13 = XVECEXP (x7, 0, 0);
              operands[7] = x13;
              x14 = XVECEXP (x7, 0, 1);
              if (GET_MODE (x14) != E_VNx2DImode)
                return -1;
              x12 = XVECEXP (x3, 0, 5);
              operands[8] = x12;
              switch (GET_CODE (x14))
                {
                case SIGN_EXTEND:
                  x15 = XEXP (x14, 0);
                  switch (GET_CODE (x15))
                    {
                    case REG:
                    case SUBREG:
                      res = pattern479 (x1);
                      if (res >= 0)
                        return res + 157; /* [157, 165] */
                      return -1;

                    case TRUNCATE:
                      if (GET_MODE (x15) != E_VNx2SImode)
                        return -1;
                      x16 = XEXP (x15, 0);
                      operands[2] = x16;
                      if (!register_operand (operands[2], E_VNx2DImode))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx2HImode:
                          res = pattern478 (x1, 
E_VNx2HImode);
                          if (res >= 0)
                            return res + 166; /* [166, 168] */
                          return -1;

                        case E_VNx2SImode:
                          res = pattern478 (x1, 
E_VNx2SImode);
                          if (res >= 0)
                            return res + 169; /* [169, 171] */
                          return -1;

                        case E_VNx2DImode:
                          res = pattern478 (x1, 
E_VNx2DImode);
                          if (res >= 0)
                            return res + 172; /* [172, 174] */
                          return -1;

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  res = pattern479 (x1);
                  if (res >= 0)
                    return res + 175; /* [175, 183] */
                  return -1;

                default:
                  return -1;
                }

            case AND:
              if (GET_MODE (x7) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[7] = x4;
              if (!register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x17 = XEXP (x7, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x18 = XEXP (x7, 1);
              operands[6] = x18;
              if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
                return -1;
              x12 = XVECEXP (x3, 0, 5);
              operands[8] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx2HImode:
                  res = pattern478 (x1, 
E_VNx2HImode);
                  if (res >= 0)
                    return res + 184; /* [184, 186] */
                  return -1;

                case E_VNx2SImode:
                  res = pattern478 (x1, 
E_VNx2SImode);
                  if (res >= 0)
                    return res + 187; /* [187, 189] */
                  return -1;

                case E_VNx2DImode:
                  res = pattern478 (x1, 
E_VNx2DImode);
                  if (res >= 0)
                    return res + 190; /* [190, 192] */
                  return -1;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 121:
          x12 = XVECEXP (x3, 0, 5);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x19 = XEXP (x12, 0);
          if (GET_CODE (x19) != SCRATCH)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 86
              || GET_MODE (x10) != E_VNx16BImode
              || !register_operand (operands[0], E_VNx2DImode)
              || GET_MODE (x1) != E_VNx2DImode
              || GET_MODE (x2) != E_VNx2DImode
              || !register_operand (operands[5], E_VNx2BImode)
              || !aarch64_reg_or_zero (operands[1], E_DImode))
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          if (GET_MODE (x7) != E_VNx2DImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case UNSPEC:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 125)
                return -1;
              x14 = XVECEXP (x7, 0, 1);
              if (GET_CODE (x14) != SIGN_EXTEND
                  || GET_MODE (x14) != E_VNx2DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != TRUNCATE
                  || GET_MODE (x15) != E_VNx2SImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              x13 = XVECEXP (x7, 0, 0);
              operands[7] = x13;
              x16 = XEXP (x15, 0);
              operands[2] = x16;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              res = pattern480 (x3);
              if (res >= 0)
                return res + 193; /* [193, 195] */
              return -1;

            case AND:
              x4 = XVECEXP (x1, 0, 0);
              operands[7] = x4;
              x17 = XEXP (x7, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x18 = XEXP (x7, 1);
              operands[6] = x18;
              if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
                return -1;
              res = pattern480 (x3);
              if (res >= 0)
                return res + 196; /* [196, 198] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern646 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_xor_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern651 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_and_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern655 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern661 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern659 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern659 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern659 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern668 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[2], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[2], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[2], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern684 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_VNx16BImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_NZCmode
      || !register_operand (operands[0], E_VNx16BImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[1] = x8;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[2] = x9;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  x10 = XVECEXP (x3, 0, 4);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern696 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_lo_half (operands[2], i1))
    return -1;
  return 0;
}

int
pattern702 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern701 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern701 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern701 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern701 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern701 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern701 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern701 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern701 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern701 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern701 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern713 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_struct_nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_sve_struct_nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern719 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern718 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern718 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern718 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern718 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern718 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern718 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern718 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern718 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern718 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern718 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern718 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern727 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ld1rq_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern731 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern737 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      operands[1] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      operands[2] = x3;
      x5 = XEXP (x2, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern752 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern757 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern763 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern772 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern777 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x4, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern776 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern776 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern776 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern788 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern794 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 56]
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern801 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !memory_operand (operands[1], i1)
      || !aarch64_maskload_else_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern809 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern819 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern818 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern818 (x1, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern818 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern818 (x1, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern818 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern818 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern838 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_raddsubhn_imm_vec (operands[4], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[5], i1))
    return -1;
  return 0;
}

int
pattern852 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern851 (x1, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern851 (x1, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      res = pattern851 (x1, 
E_VNx2DFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern862 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC)
    return -1;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 415:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              return pattern856 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

            case E_VNx8QImode:
              if (pattern856 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 1;

            case E_VNx4QImode:
              if (pattern856 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 2;

            case E_VNx2QImode:
              if (pattern856 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 3;

            case E_VNx8HImode:
              if (pattern856 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 4;

            case E_VNx4HImode:
              if (pattern856 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 5;

            case E_VNx2HImode:
              if (pattern856 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 6;

            case E_VNx4SImode:
              if (pattern856 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 7;

            case E_VNx2SImode:
              if (pattern856 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 8;

            case E_VNx2DImode:
              if (pattern856 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 9;

            default:
              return -1;
            }

        case 226:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern857 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 10;

            case E_VNx8QImode:
              if (pattern857 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 11;

            case E_VNx4QImode:
              if (pattern857 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 12;

            case E_VNx2QImode:
              if (pattern857 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 13;

            case E_VNx8HImode:
              if (pattern857 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 14;

            case E_VNx4HImode:
              if (pattern857 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 15;

            case E_VNx2HImode:
              if (pattern857 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 16;

            case E_VNx4SImode:
              if (pattern857 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 17;

            case E_VNx2SImode:
              if (pattern857 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 18;

            case E_VNx2DImode:
              if (pattern857 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 19;

            default:
              return -1;
            }

        case 224:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern856 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 20;

            case E_VNx8QImode:
              if (pattern856 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 21;

            case E_VNx4QImode:
              if (pattern856 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 22;

            case E_VNx2QImode:
              if (pattern856 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 23;

            case E_VNx8HImode:
              if (pattern856 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 24;

            case E_VNx4HImode:
              if (pattern856 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 25;

            case E_VNx2HImode:
              if (pattern856 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 26;

            case E_VNx4SImode:
              if (pattern856 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 27;

            case E_VNx2SImode:
              if (pattern856 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 28;

            case E_VNx2DImode:
              if (pattern856 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 29;

            default:
              return -1;
            }

        case 225:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern856 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 30;

            case E_VNx8QImode:
              if (pattern856 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 31;

            case E_VNx4QImode:
              if (pattern856 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 32;

            case E_VNx2QImode:
              if (pattern856 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 33;

            case E_VNx8HImode:
              if (pattern856 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 34;

            case E_VNx4HImode:
              if (pattern856 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 35;

            case E_VNx2HImode:
              if (pattern856 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 36;

            case E_VNx4SImode:
              if (pattern856 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 37;

            case E_VNx2SImode:
              if (pattern856 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 38;

            case E_VNx2DImode:
              if (pattern856 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 39;

            default:
              return -1;
            }

        case 210:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 40;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 41;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 42;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 43;

            default:
              return -1;
            }

        case 214:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 44;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 45;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 46;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 47;

            default:
              return -1;
            }

        case 233:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 48;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 49;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 50;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 51;

            default:
              return -1;
            }

        case 212:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 52;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 53;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 54;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 55;

            default:
              return -1;
            }

        case 231:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 56;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 57;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 58;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 59;

            default:
              return -1;
            }

        case 221:
          res = pattern860 (x1);
          if (res >= 0)
            return res + 60; /* [60, 67] */
          return -1;

        case 211:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 68;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 69;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 70;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 71;

            default:
              return -1;
            }

        case 215:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 72;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 73;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 74;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 75;

            default:
              return -1;
            }

        case 234:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 76;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 77;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 78;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 79;

            default:
              return -1;
            }

        case 213:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 80;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 81;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 82;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 83;

            default:
              return -1;
            }

        case 232:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 84;

            case E_VNx8HImode:
              if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 85;

            case E_VNx4SImode:
              if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 86;

            case E_VNx2DImode:
              if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 87;

            default:
              return -1;
            }

        case 220:
          res = pattern860 (x1);
          if (res >= 0)
            return res + 88; /* [88, 95] */
          return -1;

        case 227:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern861 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 96;

            case E_VNx8HImode:
              if (pattern861 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 97;

            case E_VNx4SImode:
              if (pattern861 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 98;

            case E_VNx2DImode:
              if (pattern861 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 99;

            default:
              return -1;
            }

        case 228:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern861 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 100;

            case E_VNx8HImode:
              if (pattern861 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 101;

            case E_VNx4SImode:
              if (pattern861 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 102;

            case E_VNx2DImode:
              if (pattern861 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 103;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      operands[4] = x6;
      if (GET_MODE (x3) != E_VNx4SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx4SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 26:
          return 104;

        case 111:
          return 105;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1051 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_reg_zero_or_m1_or_1 (operands[3], i1)
      || !aarch64_reg_zero_or_m1_or_1 (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1055 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1061 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_uxt_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1068 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode))
        return -1;
      return 0;

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1077 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern1076 (x4, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1089 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1)
      || !aarch64_simd_umax_half_mode (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1098 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[4] = x7;
  x8 = XVECEXP (x4, 0, 1);
  operands[1] = x8;
  x9 = XVECEXP (x4, 0, 2);
  operands[2] = x9;
  x10 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x10))
    {
    case SET:
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 3
          || XINT (x11, 1) != i1)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x10, 0);
      operands[0] = x13;
      x14 = XVECEXP (x11, 0, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      x15 = XVECEXP (x11, 0, 2);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x11) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (!register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x11) != E_VNx8BImode)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (!register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x11) != E_VNx4BImode)
            return -1;
          return 2;

        case E_VNx2BImode:
          if (!register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x11) != E_VNx2BImode)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x13 = XEXP (x10, 0);
      operands[0] = x13;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 4;

        case E_VNx8BImode:
          if (!scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 5;

        case E_VNx4BImode:
          if (!scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 6;

        case E_VNx2BImode:
          if (!scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern849 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern849 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern849 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16BImode)
      || !register_operand (operands[4], E_VNx2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern1130 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern1130 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern1130 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1151 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1161 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1170 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1179 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1188 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  x10 = XEXP (x8, 1);
  operands[3] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  return pattern1187 (x1); /* [-1, 1] */
}

int
pattern1193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1198 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !aarch64_sync_memory_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1207 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i1)
      || !const_scalar_int_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !aarch64_plus_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1212 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_hi_half (operands[4], i2))
    return -1;
  x6 = XEXP (x3, 1);
  return pattern1182 (x6, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1226 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i2)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], E_VNx2BImode)
      || !aarch64_sve_gather_offset_d (operands[1], E_DImode)
      || !register_operand (operands[2], E_VNx2DImode)
      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1239 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4
      || !aarch64_simd_or_scalar_imm_zero (operands[6], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_int_rnd_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1247 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (GET_MODE (x4) != E_VNx16BImode)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  return pattern1245 (x1, 
i1); /* [-1, 1] */
}

int
pattern1256 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i1)
    return -1;
  return 0;
}

int
pattern1264 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i3))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1271 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_borrow_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1277 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1277 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1277 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1277 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1289 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1298 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_hi_half (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode
          || !aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (pattern1306 (x1, 
E_VNx2HImode) != 0)
        return -1;
      return 1;

    case E_VNx2HFmode:
      if (pattern1306 (x1, 
E_VNx2HFmode) != 0)
        return -1;
      return 2;

    case E_VNx2BFmode:
      if (pattern1306 (x1, 
E_VNx2BFmode) != 0)
        return -1;
      return 3;

    case E_VNx2SImode:
      if (pattern1307 (x1, 
E_VNx2SImode) != 0)
        return -1;
      return 4;

    case E_VNx2SFmode:
      if (pattern1307 (x1, 
E_VNx2SFmode) != 0)
        return -1;
      return 5;

    case E_VNx2DImode:
      if (pattern1308 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern1308 (x1, 
E_VNx2DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern1324 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_borrow_operation (operands[3], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !aarch64_borrow_operation (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1334 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8HImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1339 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || pattern1338 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1344 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[1], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[1], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[1], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[1], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1356 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_operator (operands[7], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[10] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !aarch64_stp_reg_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[4]))
    return -1;
  return 0;
}

int
pattern1366 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !aarch64_carry_operation (operands[3], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x8 = XEXP (x3, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1
      || !aarch64_carry_operation (operands[4], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  x9 = XEXP (x6, 2);
  operands[5] = x9;
  switch (pattern938 (x2))
    {
    case 0:
      if (!aarch64_simd_shift_imm_si (operands[5], E_SImode)
          || !
#line 6752 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_M1U << INTVAL (operands[4])
   && INTVAL (operands[4])
   && (UINTVAL (operands[4]) + UINTVAL (operands[5])
       <= GET_MODE_BITSIZE (SImode))))
        return -1;
      return 904; /* *aarch64_bfxilsi_extr */

    case 1:
      if (!aarch64_simd_shift_imm_di (operands[5], E_DImode)
          || !
#line 6752 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_M1U << INTVAL (operands[4])
   && INTVAL (operands[4])
   && (UINTVAL (operands[4]) + UINTVAL (operands[5])
       <= GET_MODE_BITSIZE (DImode))))
        return -1;
      return 905; /* *aarch64_bfxildi_extr */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10566; /* aarch64_sve_revvnx16qi */

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x3) != E_VNx8QImode
          || !register_operand (operands[1], E_VNx8QImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10567; /* aarch64_sve_revvnx8qi */

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x3) != E_VNx4QImode
          || !register_operand (operands[1], E_VNx4QImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10568; /* aarch64_sve_revvnx4qi */

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x3) != E_VNx2QImode
          || !register_operand (operands[1], E_VNx2QImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10569; /* aarch64_sve_revvnx2qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10570; /* aarch64_sve_revvnx8hi */

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x3) != E_VNx4HImode
          || !register_operand (operands[1], E_VNx4HImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10571; /* aarch64_sve_revvnx4hi */

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x3) != E_VNx2HImode
          || !register_operand (operands[1], E_VNx2HImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10572; /* aarch64_sve_revvnx2hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10573; /* aarch64_sve_revvnx4si */

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x3) != E_VNx2SImode
          || !register_operand (operands[1], E_VNx2SImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10574; /* aarch64_sve_revvnx2si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10575; /* aarch64_sve_revvnx2di */

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x3) != E_VNx2HFmode
          || !register_operand (operands[1], E_VNx2HFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10576; /* aarch64_sve_revvnx2hf */

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x3) != E_VNx4HFmode
          || !register_operand (operands[1], E_VNx4HFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10577; /* aarch64_sve_revvnx4hf */

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x3) != E_VNx2SFmode
          || !register_operand (operands[1], E_VNx2SFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10578; /* aarch64_sve_revvnx2sf */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10579; /* aarch64_sve_revvnx8hf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10580; /* aarch64_sve_revvnx4sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10581; /* aarch64_sve_revvnx2df */

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x3) != E_VNx2BFmode
          || !register_operand (operands[1], E_VNx2BFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10582; /* aarch64_sve_revvnx2bf */

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x3) != E_VNx4BFmode
          || !register_operand (operands[1], E_VNx4BFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10583; /* aarch64_sve_revvnx4bf */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x3) != E_VNx8BFmode
          || !register_operand (operands[1], E_VNx8BFmode)
          || !
#line 9318 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10584; /* aarch64_sve_revvnx8bf */

    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[1], E_VNx16BImode)
          || !
#line 9409 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10850; /* aarch64_sve_revvnx16bi */

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode)
          || !
#line 9409 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10851; /* aarch64_sve_revvnx8bi */

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !
#line 9409 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10852; /* aarch64_sve_revvnx4bi */

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode)
          || !
#line 9409 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10853; /* aarch64_sve_revvnx2bi */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 8888 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5199; /* aarch64_frecpev4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 8888 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5200; /* aarch64_frecpev8hf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 8888 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5201; /* aarch64_frecpev2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 8888 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5202; /* aarch64_frecpev4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 8888 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5203; /* aarch64_frecpev2df */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 8888 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5204; /* aarch64_frecpehf */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 8888 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5205; /* aarch64_frecpesf */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 8888 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5206; /* aarch64_frecpedf */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3759 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7243; /* aarch64_sve_frecpevnx8hf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode)
          || !
#line 3759 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7245; /* aarch64_sve_frecpevnx4sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DFmode)
          || !
#line 3759 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 7247; /* aarch64_sve_frecpevnx2df */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8QImode)
          || !
#line 8433 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4848; /* aarch64_ld2v8qi_dreg */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HImode)
          || !
#line 8433 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4849; /* aarch64_ld2v4hi_dreg */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SImode)
          || !
#line 8433 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4850; /* aarch64_ld2v2si_dreg */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HFmode)
          || !
#line 8433 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4851; /* aarch64_ld2v4hf_dreg */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SFmode)
          || !
#line 8433 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4852; /* aarch64_ld2v2sf_dreg */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4BFmode)
          || !
#line 8433 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4853; /* aarch64_ld2v4bf_dreg */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DImode)
          || !
#line 8443 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4854; /* aarch64_ld2di_dreg */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DFmode)
          || !
#line 8443 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4855; /* aarch64_ld2df_dreg */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11300; /* aarch64_pmov_to_vnx16qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11301; /* aarch64_pmov_to_vnx8hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11302; /* aarch64_pmov_to_vnx4si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11303; /* aarch64_pmov_to_vnx2di */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5070; /* aarch64_rev32v8qi */

    case 1:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5077; /* aarch64_rev32v16qi */

    case 2:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5082; /* aarch64_rev32v4hi */

    case 3:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5089; /* aarch64_rev32v8hi */

    case 4:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5094; /* aarch64_rev32v2si */

    case 5:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5101; /* aarch64_rev32v4si */

    case 6:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5104; /* aarch64_rev32v2di */

    case 7:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5109; /* aarch64_rev32v4hf */

    case 8:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5116; /* aarch64_rev32v8hf */

    case 9:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5121; /* aarch64_rev32v4bf */

    case 10:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5128; /* aarch64_rev32v8bf */

    case 11:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5133; /* aarch64_rev32v2sf */

    case 12:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5140; /* aarch64_rev32v4sf */

    case 13:
      if (!
#line 8727 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5143; /* aarch64_rev32v2df */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern74 (x1))
    {
    case 0:
      if (!
#line 3887 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13077; /* aarch64_sve_uzpqvnx64qi */

    case 1:
      if (!
#line 3887 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13079; /* aarch64_sve_uzpqvnx32hi */

    case 2:
      if (!
#line 3887 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13081; /* aarch64_sve_uzpqvnx16si */

    case 3:
      if (!
#line 3887 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13083; /* aarch64_sve_uzpqvnx8di */

    case 4:
      if (!
#line 3887 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13085; /* aarch64_sve_uzpqvnx32bf */

    case 5:
      if (!
#line 3887 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13087; /* aarch64_sve_uzpqvnx32hf */

    case 6:
      if (!
#line 3887 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13089; /* aarch64_sve_uzpqvnx16sf */

    case 7:
      if (!
#line 3887 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13091; /* aarch64_sve_uzpqvnx8df */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 8917 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5218; /* aarch64_urecpev2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 8917 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5219; /* aarch64_urecpev4si */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (pattern709 ())
    {
    case 0:
      if (!
#line 181 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11308; /* aarch64_pmov_from_vnx16qi */

    case 1:
      if (!
#line 181 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11309; /* aarch64_pmov_from_vnx8hi */

    case 2:
      if (!
#line 181 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11310; /* aarch64_pmov_from_vnx4si */

    case 3:
      if (!
#line 181 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11311; /* aarch64_pmov_from_vnx2di */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern714 (x2))
    {
    case 0:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16QImode)
       || register_operand (operands[2], VNx16QImode))))
        return -1;
      return 5614; /* aarch64_pred_movvnx16qi */

    case 1:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8QImode)
       || register_operand (operands[2], VNx8QImode))))
        return -1;
      return 5615; /* aarch64_pred_movvnx8qi */

    case 2:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4QImode)
       || register_operand (operands[2], VNx4QImode))))
        return -1;
      return 5616; /* aarch64_pred_movvnx4qi */

    case 3:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2QImode)
       || register_operand (operands[2], VNx2QImode))))
        return -1;
      return 5617; /* aarch64_pred_movvnx2qi */

    case 4:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HImode)
       || register_operand (operands[2], VNx8HImode))))
        return -1;
      return 5618; /* aarch64_pred_movvnx8hi */

    case 5:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HImode)
       || register_operand (operands[2], VNx4HImode))))
        return -1;
      return 5619; /* aarch64_pred_movvnx4hi */

    case 6:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HImode)
       || register_operand (operands[2], VNx2HImode))))
        return -1;
      return 5620; /* aarch64_pred_movvnx2hi */

    case 7:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SImode)
       || register_operand (operands[2], VNx4SImode))))
        return -1;
      return 5621; /* aarch64_pred_movvnx4si */

    case 8:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SImode)
       || register_operand (operands[2], VNx2SImode))))
        return -1;
      return 5622; /* aarch64_pred_movvnx2si */

    case 9:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DImode)
       || register_operand (operands[2], VNx2DImode))))
        return -1;
      return 5623; /* aarch64_pred_movvnx2di */

    case 10:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HFmode)
       || register_operand (operands[2], VNx2HFmode))))
        return -1;
      return 5624; /* aarch64_pred_movvnx2hf */

    case 11:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HFmode)
       || register_operand (operands[2], VNx4HFmode))))
        return -1;
      return 5625; /* aarch64_pred_movvnx4hf */

    case 12:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SFmode)
       || register_operand (operands[2], VNx2SFmode))))
        return -1;
      return 5626; /* aarch64_pred_movvnx2sf */

    case 13:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HFmode)
       || register_operand (operands[2], VNx8HFmode))))
        return -1;
      return 5627; /* aarch64_pred_movvnx8hf */

    case 14:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SFmode)
       || register_operand (operands[2], VNx4SFmode))))
        return -1;
      return 5628; /* aarch64_pred_movvnx4sf */

    case 15:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DFmode)
       || register_operand (operands[2], VNx2DFmode))))
        return -1;
      return 5629; /* aarch64_pred_movvnx2df */

    case 16:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BFmode)
       || register_operand (operands[2], VNx2BFmode))))
        return -1;
      return 5630; /* aarch64_pred_movvnx2bf */

    case 17:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BFmode)
       || register_operand (operands[2], VNx4BFmode))))
        return -1;
      return 5631; /* aarch64_pred_movvnx4bf */

    case 18:
      if (!
#line 772 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BFmode)
       || register_operand (operands[2], VNx8BFmode))))
        return -1;
      return 5632; /* aarch64_pred_movvnx8bf */

    case 19:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32QImode)
       || register_operand (operands[2], VNx32QImode))))
        return -1;
      return 5743; /* aarch64_pred_movvnx32qi */

    case 20:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HImode)
       || register_operand (operands[2], VNx16HImode))))
        return -1;
      return 5744; /* aarch64_pred_movvnx16hi */

    case 21:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SImode)
       || register_operand (operands[2], VNx8SImode))))
        return -1;
      return 5745; /* aarch64_pred_movvnx8si */

    case 22:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DImode)
       || register_operand (operands[2], VNx4DImode))))
        return -1;
      return 5746; /* aarch64_pred_movvnx4di */

    case 23:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BFmode)
       || register_operand (operands[2], VNx16BFmode))))
        return -1;
      return 5747; /* aarch64_pred_movvnx16bf */

    case 24:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HFmode)
       || register_operand (operands[2], VNx16HFmode))))
        return -1;
      return 5748; /* aarch64_pred_movvnx16hf */

    case 25:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SFmode)
       || register_operand (operands[2], VNx8SFmode))))
        return -1;
      return 5749; /* aarch64_pred_movvnx8sf */

    case 26:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DFmode)
       || register_operand (operands[2], VNx4DFmode))))
        return -1;
      return 5750; /* aarch64_pred_movvnx4df */

    case 27:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx48QImode)
       || register_operand (operands[2], VNx48QImode))))
        return -1;
      return 5751; /* aarch64_pred_movvnx48qi */

    case 28:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HImode)
       || register_operand (operands[2], VNx24HImode))))
        return -1;
      return 5752; /* aarch64_pred_movvnx24hi */

    case 29:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SImode)
       || register_operand (operands[2], VNx12SImode))))
        return -1;
      return 5753; /* aarch64_pred_movvnx12si */

    case 30:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DImode)
       || register_operand (operands[2], VNx6DImode))))
        return -1;
      return 5754; /* aarch64_pred_movvnx6di */

    case 31:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24BFmode)
       || register_operand (operands[2], VNx24BFmode))))
        return -1;
      return 5755; /* aarch64_pred_movvnx24bf */

    case 32:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HFmode)
       || register_operand (operands[2], VNx24HFmode))))
        return -1;
      return 5756; /* aarch64_pred_movvnx24hf */

    case 33:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SFmode)
       || register_operand (operands[2], VNx12SFmode))))
        return -1;
      return 5757; /* aarch64_pred_movvnx12sf */

    case 34:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DFmode)
       || register_operand (operands[2], VNx6DFmode))))
        return -1;
      return 5758; /* aarch64_pred_movvnx6df */

    case 35:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx64QImode)
       || register_operand (operands[2], VNx64QImode))))
        return -1;
      return 5759; /* aarch64_pred_movvnx64qi */

    case 36:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HImode)
       || register_operand (operands[2], VNx32HImode))))
        return -1;
      return 5760; /* aarch64_pred_movvnx32hi */

    case 37:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SImode)
       || register_operand (operands[2], VNx16SImode))))
        return -1;
      return 5761; /* aarch64_pred_movvnx16si */

    case 38:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DImode)
       || register_operand (operands[2], VNx8DImode))))
        return -1;
      return 5762; /* aarch64_pred_movvnx8di */

    case 39:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32BFmode)
       || register_operand (operands[2], VNx32BFmode))))
        return -1;
      return 5763; /* aarch64_pred_movvnx32bf */

    case 40:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HFmode)
       || register_operand (operands[2], VNx32HFmode))))
        return -1;
      return 5764; /* aarch64_pred_movvnx32hf */

    case 41:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SFmode)
       || register_operand (operands[2], VNx16SFmode))))
        return -1;
      return 5765; /* aarch64_pred_movvnx16sf */

    case 42:
      if (!
#line 923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DFmode)
       || register_operand (operands[2], VNx8DFmode))))
        return -1;
      return 5766; /* aarch64_pred_movvnx8df */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern79 (x3, 
E_HFmode) != 0
                  || !(
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
                return -1;
              return 1143; /* fminhf3 */

            case E_SFmode:
              if (pattern79 (x3, 
E_SFmode) != 0
                  || !
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 1147; /* fminsf3 */

            case E_DFmode:
              if (pattern79 (x3, 
E_DFmode) != 0
                  || !
#line 7597 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 1151; /* fmindf3 */

            case E_V4HFmode:
              if (pattern79 (x3, 
E_V4HFmode) != 0
                  || !(
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2731; /* fminv4hf3 */

            case E_V8HFmode:
              if (pattern125 (x3, 
E_V8HFmode, 
E_V8HFmode) != 0
                  || !(
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2737; /* fminv8hf3 */

            case E_V2SFmode:
              if (pattern79 (x3, 
E_V2SFmode) != 0
                  || !
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2747; /* fminv2sf3 */

            case E_V4SFmode:
              if (pattern79 (x3, 
E_V4SFmode) != 0
                  || !
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2753; /* fminv4sf3 */

            case E_V2DFmode:
              if (pattern79 (x3, 
E_V2DFmode) != 0
                  || !
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2757; /* fminv2df3 */

            case E_VNx16BFmode:
              if (pattern80 (x3, 
E_VNx16BFmode) != 0
                  || !(
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12450; /* *aarch64_sve_fminnmvnx16bf */

            case E_VNx32BFmode:
              if (pattern80 (x3, 
E_VNx32BFmode) != 0
                  || !(
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12454; /* *aarch64_sve_fminnmvnx32bf */

            case E_VNx16HFmode:
              if (pattern80 (x3, 
E_VNx16HFmode) != 0
                  || !
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12458; /* *aarch64_sve_fminnmvnx16hf */

            case E_VNx8SFmode:
              if (pattern80 (x3, 
E_VNx8SFmode) != 0
                  || !
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12462; /* *aarch64_sve_fminnmvnx8sf */

            case E_VNx4DFmode:
              if (pattern80 (x3, 
E_VNx4DFmode) != 0
                  || !
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12466; /* *aarch64_sve_fminnmvnx4df */

            case E_VNx32HFmode:
              if (pattern80 (x3, 
E_VNx32HFmode) != 0
                  || !
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12470; /* *aarch64_sve_fminnmvnx32hf */

            case E_VNx16SFmode:
              if (pattern80 (x3, 
E_VNx16SFmode) != 0
                  || !
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12474; /* *aarch64_sve_fminnmvnx16sf */

            case E_VNx8DFmode:
              if (pattern80 (x3, 
E_VNx8DFmode) != 0
                  || !
#line 2502 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12478; /* *aarch64_sve_fminnmvnx8df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern82 (x3))
            {
            case 0:
              if (!(
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12482; /* aarch64_sve_single_fminnmvnx16bf */

            case 1:
              if (!(
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12486; /* aarch64_sve_single_fminnmvnx32bf */

            case 2:
              if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12490; /* aarch64_sve_single_fminnmvnx16hf */

            case 3:
              if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12494; /* aarch64_sve_single_fminnmvnx8sf */

            case 4:
              if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12498; /* aarch64_sve_single_fminnmvnx4df */

            case 5:
              if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12502; /* aarch64_sve_single_fminnmvnx32hf */

            case 6:
              if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12506; /* aarch64_sve_single_fminnmvnx16sf */

            case 7:
              if (!
#line 2513 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12510; /* aarch64_sve_single_fminnmvnx8df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 277)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          x5 = XVECEXP (x3, 0, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1053 (x3, 
E_VNx8BFmode) != 0
                  || !
#line 503 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))
                return -1;
              return 12013; /* aarch64_sve_fclampvnx8bf */

            case E_VNx8HFmode:
              if (pattern1053 (x3, 
E_VNx8HFmode) != 0
                  || !
#line 504 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 12014; /* aarch64_sve_fclampvnx8hf */

            case E_VNx4SFmode:
              if (pattern1053 (x3, 
E_VNx4SFmode) != 0
                  || !
#line 505 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 12015; /* aarch64_sve_fclampvnx4sf */

            case E_VNx2DFmode:
              if (pattern1053 (x3, 
E_VNx2DFmode) != 0
                  || !
#line 506 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 12016; /* aarch64_sve_fclampvnx2df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != VEC_DUPLICATE)
            return -1;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BFmode:
              if (pattern1119 (x3, 
E_VNx8BFmode, 
E_VNx16BFmode) != 0
                  || !(
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12021; /* aarch64_sve_fclamp_singlevnx16bf */

            case E_VNx32BFmode:
              if (pattern1119 (x3, 
E_VNx8BFmode, 
E_VNx32BFmode) != 0
                  || !(
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12022; /* aarch64_sve_fclamp_singlevnx32bf */

            case E_VNx16HFmode:
              if (pattern1119 (x3, 
E_VNx8HFmode, 
E_VNx16HFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12023; /* aarch64_sve_fclamp_singlevnx16hf */

            case E_VNx8SFmode:
              if (pattern1119 (x3, 
E_VNx4SFmode, 
E_VNx8SFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12024; /* aarch64_sve_fclamp_singlevnx8sf */

            case E_VNx4DFmode:
              if (pattern1119 (x3, 
E_VNx2DFmode, 
E_VNx4DFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12025; /* aarch64_sve_fclamp_singlevnx4df */

            case E_VNx32HFmode:
              if (pattern1119 (x3, 
E_VNx8HFmode, 
E_VNx32HFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12026; /* aarch64_sve_fclamp_singlevnx32hf */

            case E_VNx16SFmode:
              if (pattern1119 (x3, 
E_VNx4SFmode, 
E_VNx16SFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12027; /* aarch64_sve_fclamp_singlevnx16sf */

            case E_VNx8DFmode:
              if (pattern1119 (x3, 
E_VNx2DFmode, 
E_VNx8DFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12028; /* aarch64_sve_fclamp_singlevnx8df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern108 (x1))
    {
    case 0:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4898; /* aarch64_trn2v8qi */

    case 1:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4910; /* aarch64_trn2v16qi */

    case 2:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4922; /* aarch64_trn2v4hi */

    case 3:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4934; /* aarch64_trn2v8hi */

    case 4:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4946; /* aarch64_trn2v2si */

    case 5:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4958; /* aarch64_trn2v4si */

    case 6:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4964; /* aarch64_trn2v2di */

    case 7:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4976; /* aarch64_trn2v4hf */

    case 8:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4988; /* aarch64_trn2v8hf */

    case 9:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5000; /* aarch64_trn2v4bf */

    case 10:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5012; /* aarch64_trn2v8bf */

    case 11:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5024; /* aarch64_trn2v2sf */

    case 12:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5036; /* aarch64_trn2v4sf */

    case 13:
      if (!
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5042; /* aarch64_trn2v2df */

    case 14:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10596; /* aarch64_sve_trn2vnx16qi */

    case 15:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10606; /* aarch64_sve_trn2vnx8qi */

    case 16:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10616; /* aarch64_sve_trn2vnx4qi */

    case 17:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10626; /* aarch64_sve_trn2vnx2qi */

    case 18:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10636; /* aarch64_sve_trn2vnx8hi */

    case 19:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10646; /* aarch64_sve_trn2vnx4hi */

    case 20:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10656; /* aarch64_sve_trn2vnx2hi */

    case 21:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10666; /* aarch64_sve_trn2vnx4si */

    case 22:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10676; /* aarch64_sve_trn2vnx2si */

    case 23:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10686; /* aarch64_sve_trn2vnx2di */

    case 24:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10696; /* aarch64_sve_trn2vnx2hf */

    case 25:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10706; /* aarch64_sve_trn2vnx4hf */

    case 26:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10716; /* aarch64_sve_trn2vnx2sf */

    case 27:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10726; /* aarch64_sve_trn2vnx8hf */

    case 28:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10736; /* aarch64_sve_trn2vnx4sf */

    case 29:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10746; /* aarch64_sve_trn2vnx2df */

    case 30:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10756; /* aarch64_sve_trn2vnx2bf */

    case 31:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10766; /* aarch64_sve_trn2vnx4bf */

    case 32:
      if (!
#line 9362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10776; /* aarch64_sve_trn2vnx8bf */

    case 33:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10857; /* aarch64_sve_trn2vnx16bi */

    case 34:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10863; /* aarch64_sve_trn2vnx8bi */

    case 35:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10869; /* aarch64_sve_trn2vnx4bi */

    case 36:
      if (!
#line 9431 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10875; /* aarch64_sve_trn2vnx2bi */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern79 (x3, 
E_V8QImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3355; /* aarch64_suqaddv8qi */

        case E_V16QImode:
          if (pattern79 (x3, 
E_V16QImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3361; /* aarch64_suqaddv16qi */

        case E_V4HImode:
          if (pattern79 (x3, 
E_V4HImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3363; /* aarch64_suqaddv4hi */

        case E_V8HImode:
          if (pattern79 (x3, 
E_V8HImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3369; /* aarch64_suqaddv8hi */

        case E_V2SImode:
          if (pattern79 (x3, 
E_V2SImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3371; /* aarch64_suqaddv2si */

        case E_V4SImode:
          if (pattern79 (x3, 
E_V4SImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3377; /* aarch64_suqaddv4si */

        case E_V2DImode:
          if (pattern79 (x3, 
E_V2DImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3379; /* aarch64_suqaddv2di */

        case E_QImode:
          if (pattern79 (x3, 
E_QImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3381; /* aarch64_suqaddqi */

        case E_HImode:
          if (pattern79 (x3, 
E_HImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3383; /* aarch64_suqaddhi */

        case E_SImode:
          if (pattern79 (x3, 
E_SImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3385; /* aarch64_suqaddsi */

        case E_DImode:
          if (pattern79 (x3, 
E_DImode) != 0
              || !
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3387; /* aarch64_suqadddi */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern795 (x3, 
E_VNx16QImode) != 0
              || !
#line 980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11777; /* aarch64_sve_suqaddvnx16qi_const */

        case E_VNx8HImode:
          if (pattern795 (x3, 
E_VNx8HImode) != 0
              || !
#line 980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11778; /* aarch64_sve_suqaddvnx8hi_const */

        case E_VNx4SImode:
          if (pattern795 (x3, 
E_VNx4SImode) != 0
              || !
#line 980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11779; /* aarch64_sve_suqaddvnx4si_const */

        case E_VNx2DImode:
          if (pattern795 (x3, 
E_VNx2DImode) != 0
              || !
#line 980 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11780; /* aarch64_sve_suqaddvnx2di_const */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern106 (x1))
    {
    case 0:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3754; /* aarch64_uqshlv8qi */

    case 1:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3764; /* aarch64_uqshlv16qi */

    case 2:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3770; /* aarch64_uqshlv4hi */

    case 3:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3780; /* aarch64_uqshlv8hi */

    case 4:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3786; /* aarch64_uqshlv2si */

    case 5:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3796; /* aarch64_uqshlv4si */

    case 6:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3800; /* aarch64_uqshlv2di */

    case 7:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3804; /* aarch64_uqshlqi */

    case 8:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3808; /* aarch64_uqshlhi */

    case 9:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3812; /* aarch64_uqshlsi */

    case 10:
      if (!
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3818; /* aarch64_uqshldi */

    case 11:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3907; /* aarch64_uqshl_nv8qi */

    case 12:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3910; /* aarch64_uqshl_nv16qi */

    case 13:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3913; /* aarch64_uqshl_nv4hi */

    case 14:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3916; /* aarch64_uqshl_nv8hi */

    case 15:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3919; /* aarch64_uqshl_nv2si */

    case 16:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3922; /* aarch64_uqshl_nv4si */

    case 17:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3925; /* aarch64_uqshl_nv2di */

    case 18:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3928; /* aarch64_uqshl_nqi */

    case 19:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3931; /* aarch64_uqshl_nhi */

    case 20:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3934; /* aarch64_uqshl_nsi */

    case 21:
      if (!
#line 6718 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3937; /* aarch64_uqshl_ndi */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern115 (x1))
    {
    case 0:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6585; /* extract_last_vnx16qi */

    case 1:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6587; /* extract_last_vnx8qi */

    case 2:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6589; /* extract_last_vnx4qi */

    case 3:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6591; /* extract_last_vnx2qi */

    case 4:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6593; /* extract_last_vnx8hi */

    case 5:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6595; /* extract_last_vnx4hi */

    case 6:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6597; /* extract_last_vnx2hi */

    case 7:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6599; /* extract_last_vnx4si */

    case 8:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6601; /* extract_last_vnx2si */

    case 9:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6603; /* extract_last_vnx2di */

    case 10:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6605; /* extract_last_vnx2hf */

    case 11:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6607; /* extract_last_vnx4hf */

    case 12:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6611; /* extract_last_vnx8hf */

    case 13:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6609; /* extract_last_vnx2sf */

    case 14:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6613; /* extract_last_vnx4sf */

    case 15:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6615; /* extract_last_vnx2df */

    case 16:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6617; /* extract_last_vnx2bf */

    case 17:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6619; /* extract_last_vnx4bf */

    case 18:
      if (!
#line 3166 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6621; /* extract_last_vnx8bf */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern79 (x3, 
E_VNx4SImode) != 0
              || !
#line 4278 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 8066; /* aarch64_adrvnx4si */

        case E_VNx2DImode:
          if (pattern79 (x3, 
E_VNx2DImode) != 0
              || !
#line 4278 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 8067; /* aarch64_adrvnx2di */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern596 (x5) != 0
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x5, 0, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_VNx2DImode)
          || !
#line 4294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 8068; /* *aarch64_adr_sxtw */

    case AND:
      if (GET_MODE (x5) != E_VNx2DImode
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      x10 = XEXP (x5, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[3] = x11;
      if (!aarch64_sve_uxtw_immediate (operands[3], E_VNx2DImode)
          || !
#line 4311 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 8069; /* *aarch64_adr_uxtw_unspec */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1DImode:
      if (!register_operand (operands[1], E_V1DImode)
          || !
#line 7914 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4630; /* aarch64_vec_stl1_lanesv1di_lanesi */

    case E_V1DFmode:
      if (!register_operand (operands[1], E_V1DFmode)
          || !
#line 7914 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4631; /* aarch64_vec_stl1_lanesv1df_lanedf */

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 7914 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4632; /* aarch64_vec_stl1_lanesv2di_lanedi */

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 7914 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4633; /* aarch64_vec_stl1_lanesv2df_lanedf */

    default:
      return -1;
    }
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2165; /* aarch64_uminpv8qi */

    case 1:
      if (!
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2175; /* aarch64_uminpv16qi */

    case 2:
      if (!
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2181; /* aarch64_uminpv4hi */

    case 3:
      if (!
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2191; /* aarch64_uminpv8hi */

    case 4:
      if (!
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2197; /* aarch64_uminpv2si */

    case 5:
      if (!
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2207; /* aarch64_uminpv4si */

    case 6:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10478; /* aarch64_pred_reduc_umin_vnx16qi */

    case 7:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10485; /* aarch64_pred_reduc_umin_vnx8hi */

    case 8:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10492; /* aarch64_pred_reduc_umin_vnx4si */

    case 9:
      if (!
#line 9130 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10499; /* aarch64_pred_reduc_umin_vnx2di */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 3859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13029; /* aarch64_sve_uzpvnx32qi */

    case 1:
      if (!
#line 3859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13031; /* aarch64_sve_uzpvnx16hi */

    case 2:
      if (!
#line 3859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13033; /* aarch64_sve_uzpvnx8si */

    case 3:
      if (!
#line 3859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13035; /* aarch64_sve_uzpvnx4di */

    case 4:
      if (!
#line 3859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13037; /* aarch64_sve_uzpvnx16bf */

    case 5:
      if (!
#line 3859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13039; /* aarch64_sve_uzpvnx16hf */

    case 6:
      if (!
#line 3859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13041; /* aarch64_sve_uzpvnx8sf */

    case 7:
      if (!
#line 3859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13043; /* aarch64_sve_uzpvnx4df */

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern732 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 9260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10535; /* aarch64_sve_compactvnx4si */

    case E_VNx2DImode:
      if (pattern732 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 9260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10536; /* aarch64_sve_compactvnx2di */

    case E_VNx4SFmode:
      if (pattern732 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 9260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10537; /* aarch64_sve_compactvnx4sf */

    case E_VNx2DFmode:
      if (pattern732 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 9260 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10538; /* aarch64_sve_compactvnx2df */

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern78 (x1))
    {
    case 0:
      return 1083; /* scvtfsi3 */

    case 1:
      return 1085; /* scvtfdi3 */

    case 2:
      if (!
#line 7392 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1091; /* scvtfsihf3 */

    case 3:
      if (!
#line 7392 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1093; /* scvtfdihf3 */

    case 4:
      if (!
#line 7412 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1097; /* scvtfhi3 */

    case 5:
      if (!(
#line 3156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 291 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2684; /* scvtfv4hi3 */

    case 6:
      if (!(
#line 3156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 292 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2686; /* scvtfv8hi3 */

    case 7:
      if (!
#line 3156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2688; /* scvtfv2si3 */

    case 8:
      if (!
#line 3156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2690; /* scvtfv4si3 */

    case 9:
      if (!
#line 3156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2692; /* scvtfv2di3 */

    default:
      return -1;
    }
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern129 (x1))
    {
    case 0:
      if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12298; /* aarch64_sve_umulltvnx8hi */

    case 1:
      if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12319; /* aarch64_sve_umulltvnx4si */

    case 2:
      if (!
#line 2257 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12340; /* aarch64_sve_umulltvnx2di */

    case 3:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12348; /* aarch64_sve_umullt_lane_vnx4si */

    case 4:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12354; /* aarch64_sve_umullt_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern135 (x1))
    {
    case 0:
      if (!
#line 3906 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 13094; /* aarch64_sve_bgrpvnx16qi */

    case 1:
      if (!
#line 3906 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 13097; /* aarch64_sve_bgrpvnx8hi */

    case 2:
      if (!
#line 3906 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 13100; /* aarch64_sve_bgrpvnx4si */

    case 3:
      if (!
#line 3906 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 13103; /* aarch64_sve_bgrpvnx2di */

    default:
      return -1;
    }
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern141 (x1))
    {
    case 0:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12927; /* aarch64_pred_reduc_eorqv_vnx16qi */

    case 1:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12935; /* aarch64_pred_reduc_eorqv_vnx8hi */

    case 2:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12943; /* aarch64_pred_reduc_eorqv_vnx4si */

    case 3:
      if (!
#line 3707 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12951; /* aarch64_pred_reduc_eorqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern120 (x1))
    {
    case 0:
      if (!
#line 9108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 8))
        return -1;
      return 10465; /* aarch64_pred_reduc_sadd_vnx16qi */

    case 1:
      if (!
#line 9108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 10467; /* aarch64_pred_reduc_sadd_vnx8hi */

    case 2:
      if (!
#line 9108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 10469; /* aarch64_pred_reduc_sadd_vnx4si */

    case 3:
      if (!
#line 9108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 10471; /* aarch64_pred_reduc_sadd_vnx2di */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1122 (x2))
        {
        case 0:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10966; /* *cond_fix_trunc_nontruncvnx8hfvnx8hi_relaxed */
          break;

        case 1:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10968; /* *cond_fix_trunc_nontruncvnx4sfvnx8hi_relaxed */
          break;

        case 2:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10970; /* *cond_fix_trunc_nontruncvnx2dfvnx8hi_relaxed */
          break;

        case 3:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10972; /* *cond_fix_trunc_nontruncvnx8hfvnx4si_relaxed */
          break;

        case 4:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10974; /* *cond_fix_trunc_nontruncvnx4sfvnx4si_relaxed */
          break;

        case 5:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10976; /* *cond_fix_trunc_nontruncvnx2dfvnx4si_relaxed */
          break;

        case 6:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10978; /* *cond_fix_trunc_nontruncvnx8hfvnx2di_relaxed */
          break;

        case 7:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10980; /* *cond_fix_trunc_nontruncvnx4sfvnx2di_relaxed */
          break;

        case 8:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10982; /* *cond_fix_trunc_nontruncvnx2dfvnx2di_relaxed */
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (pattern1123 (x2))
        {
        case 0:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10984; /* *cond_fix_trunc_nontruncvnx8hfvnx8hi_strict */
          break;

        case 1:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10986; /* *cond_fix_trunc_nontruncvnx4sfvnx8hi_strict */
          break;

        case 2:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10988; /* *cond_fix_trunc_nontruncvnx2dfvnx8hi_strict */
          break;

        case 3:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10990; /* *cond_fix_trunc_nontruncvnx8hfvnx4si_strict */
          break;

        case 4:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10992; /* *cond_fix_trunc_nontruncvnx4sfvnx4si_strict */
          break;

        case 5:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10994; /* *cond_fix_trunc_nontruncvnx2dfvnx4si_strict */
          break;

        case 6:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10996; /* *cond_fix_trunc_nontruncvnx8hfvnx2di_strict */
          break;

        case 7:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10998; /* *cond_fix_trunc_nontruncvnx4sfvnx2di_strict */
          break;

        case 8:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 11000; /* *cond_fix_trunc_nontruncvnx2dfvnx2di_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
      || pattern1124 (x2, 
E_VNx2DFmode, 
E_VNx4SImode) != 0
      || !
#line 9701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 11002; /* *cond_fix_trunc_truncvnx2dfvnx4si */
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11980; /* *cond_uqshlvnx16qi_2 */
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11988; /* *cond_uqshlvnx16qi_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11996; /* *cond_uqshlvnx16qi_any */
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11831; /* *cond_urshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11878; /* *cond_urshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11918; /* *cond_urshlvnx16qi_any */
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11853; /* *cond_uqrshlvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11896; /* *cond_uqrshlvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11936; /* *cond_uqrshlvnx4si_any */
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11839; /* *cond_uhaddvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11884; /* *cond_uhaddvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11924; /* *cond_uhaddvnx8hi_any */
}

 int
recog_245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11859; /* *cond_sqrshlvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11901; /* *cond_sqrshlvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11941; /* *cond_sqrshlvnx2di_any */
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1109 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8601; /* *cond_subvnx8bf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8747; /* *cond_subvnx8bf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8851; /* *cond_subvnx8bf_any_relaxed */

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8614; /* *cond_subvnx8hf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8760; /* *cond_subvnx8hf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8864; /* *cond_subvnx8hf_any_relaxed */

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8627; /* *cond_subvnx4sf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8773; /* *cond_subvnx4sf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8877; /* *cond_subvnx4sf_any_relaxed */

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8640; /* *cond_subvnx2df_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8786; /* *cond_subvnx2df_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8890; /* *cond_subvnx2df_any_relaxed */

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6243 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9035; /* *cond_subvnx8hf_3_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 6287 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9041; /* *cond_subvnx8hf_const_relaxed */

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6243 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9036; /* *cond_subvnx4sf_3_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 6287 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9042; /* *cond_subvnx4sf_const_relaxed */

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6243 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9037; /* *cond_subvnx2df_3_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 6287 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9043; /* *cond_subvnx2df_const_relaxed */

        default:
          return -1;
        }

    case 1L:
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern1109 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8653; /* *cond_subvnx8bf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8799; /* *cond_subvnx8bf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8903; /* *cond_subvnx8bf_any_strict */

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8666; /* *cond_subvnx8hf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8812; /* *cond_subvnx8hf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8916; /* *cond_subvnx8hf_any_strict */

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8679; /* *cond_subvnx4sf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8825; /* *cond_subvnx4sf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8929; /* *cond_subvnx4sf_any_strict */

        case 3:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8692; /* *cond_subvnx2df_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8838; /* *cond_subvnx2df_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8942; /* *cond_subvnx2df_any_strict */

        case 4:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6266 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9038; /* *cond_subvnx8hf_3_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 6323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9044; /* *cond_subvnx8hf_const_strict */

        case 5:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6266 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9039; /* *cond_subvnx4sf_3_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 6323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9045; /* *cond_subvnx4sf_const_strict */

        case 6:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6266 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9040; /* *cond_subvnx2df_3_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 6323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9046; /* *cond_subvnx2df_const_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[4] = x7;
  switch (XINT (x3, 1))
    {
    case 376:
      switch (pattern1127 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9325; /* *cond_fmavnx8hf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9353; /* *cond_fmavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9385; /* *cond_fmavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9329; /* *cond_fmavnx4sf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9357; /* *cond_fmavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9389; /* *cond_fmavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9333; /* *cond_fmavnx2df_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9361; /* *cond_fmavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9393; /* *cond_fmavnx2df_any_relaxed */

        case 3:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9349; /* *cond_fmavnx8bf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9381; /* *cond_fmavnx8bf_any_relaxed */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9337; /* *cond_fmavnx8hf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9369; /* *cond_fmavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9401; /* *cond_fmavnx8hf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9341; /* *cond_fmavnx4sf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9373; /* *cond_fmavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9405; /* *cond_fmavnx4sf_any_strict */

        case 6:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9345; /* *cond_fmavnx2df_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9377; /* *cond_fmavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9409; /* *cond_fmavnx2df_any_strict */

        case 7:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9365; /* *cond_fmavnx8bf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9397; /* *cond_fmavnx8bf_any_strict */

        default:
          return -1;
        }

    case 377:
      switch (pattern1127 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9326; /* *cond_fnmavnx8hf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9354; /* *cond_fnmavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9386; /* *cond_fnmavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9330; /* *cond_fnmavnx4sf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9358; /* *cond_fnmavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9390; /* *cond_fnmavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9334; /* *cond_fnmavnx2df_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9362; /* *cond_fnmavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9394; /* *cond_fnmavnx2df_any_relaxed */

        case 3:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9350; /* *cond_fnmavnx8bf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9382; /* *cond_fnmavnx8bf_any_relaxed */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9338; /* *cond_fnmavnx8hf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9370; /* *cond_fnmavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9402; /* *cond_fnmavnx8hf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9342; /* *cond_fnmavnx4sf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9374; /* *cond_fnmavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9406; /* *cond_fnmavnx4sf_any_strict */

        case 6:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9346; /* *cond_fnmavnx2df_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9378; /* *cond_fnmavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9410; /* *cond_fnmavnx2df_any_strict */

        case 7:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9366; /* *cond_fnmavnx8bf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9398; /* *cond_fnmavnx8bf_any_strict */

        default:
          return -1;
        }

    case 381:
      return recog_267 (x1, insn, pnum_clobbers);

    case 382:
      return recog_266 (x1, insn, pnum_clobbers);

    case 360:
      switch (pattern1128 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9433; /* *cond_fcmlavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9457; /* *cond_fcmlavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9437; /* *cond_fcmlavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9461; /* *cond_fcmlavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9441; /* *cond_fcmlavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9465; /* *cond_fcmlavnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9445; /* *cond_fcmlavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9469; /* *cond_fcmlavnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9449; /* *cond_fcmlavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9473; /* *cond_fcmlavnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9453; /* *cond_fcmlavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9477; /* *cond_fcmlavnx2df_any_strict */

        default:
          return -1;
        }

    case 361:
      switch (pattern1128 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9434; /* *cond_fcmla90vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9458; /* *cond_fcmla90vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9438; /* *cond_fcmla90vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9462; /* *cond_fcmla90vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9442; /* *cond_fcmla90vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9466; /* *cond_fcmla90vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9446; /* *cond_fcmla90vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9470; /* *cond_fcmla90vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9450; /* *cond_fcmla90vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9474; /* *cond_fcmla90vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9454; /* *cond_fcmla90vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9478; /* *cond_fcmla90vnx2df_any_strict */

        default:
          return -1;
        }

    case 362:
      switch (pattern1128 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9435; /* *cond_fcmla180vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9459; /* *cond_fcmla180vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9439; /* *cond_fcmla180vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9463; /* *cond_fcmla180vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9443; /* *cond_fcmla180vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9467; /* *cond_fcmla180vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9447; /* *cond_fcmla180vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9471; /* *cond_fcmla180vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9451; /* *cond_fcmla180vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9475; /* *cond_fcmla180vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9455; /* *cond_fcmla180vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9479; /* *cond_fcmla180vnx2df_any_strict */

        default:
          return -1;
        }

    case 363:
      switch (pattern1128 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9436; /* *cond_fcmla270vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9460; /* *cond_fcmla270vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9440; /* *cond_fcmla270vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9464; /* *cond_fcmla270vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9444; /* *cond_fcmla270vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9468; /* *cond_fcmla270vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9448; /* *cond_fcmla270vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9472; /* *cond_fcmla270vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9452; /* *cond_fcmla270vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9476; /* *cond_fcmla270vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9456; /* *cond_fcmla270vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9480; /* *cond_fcmla270vnx2df_any_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern735 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7547; /* *cond_iorvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7717; /* *cond_iorvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7887; /* *cond_iorvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7564; /* *cond_iorvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7734; /* *cond_iorvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7904; /* *cond_iorvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7581; /* *cond_iorvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7751; /* *cond_iorvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7921; /* *cond_iorvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7598; /* *cond_iorvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7768; /* *cond_iorvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7938; /* *cond_iorvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7615; /* *cond_iorvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7785; /* *cond_iorvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7955; /* *cond_iorvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7632; /* *cond_iorvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7802; /* *cond_iorvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7972; /* *cond_iorvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7649; /* *cond_iorvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7819; /* *cond_iorvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7989; /* *cond_iorvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7666; /* *cond_iorvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7836; /* *cond_iorvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8006; /* *cond_iorvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7683; /* *cond_iorvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7853; /* *cond_iorvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8023; /* *cond_iorvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7700; /* *cond_iorvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7870; /* *cond_iorvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8040; /* *cond_iorvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern598 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6789; /* *cond_popcountvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6879; /* *cond_popcountvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6798; /* *cond_popcountvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6888; /* *cond_popcountvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6807; /* *cond_popcountvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6897; /* *cond_popcountvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6816; /* *cond_popcountvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6906; /* *cond_popcountvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6825; /* *cond_popcountvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6915; /* *cond_popcountvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6834; /* *cond_popcountvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6924; /* *cond_popcountvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6843; /* *cond_popcountvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6933; /* *cond_popcountvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6852; /* *cond_popcountvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6942; /* *cond_popcountvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6861; /* *cond_popcountvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6951; /* *cond_popcountvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6870; /* *cond_popcountvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6960; /* *cond_popcountvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode)
          || GET_MODE (x3) != E_V4x8QImode
          || !register_operand (operands[2], E_V4x8QImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4590; /* aarch64_vec_load_lanesv4x8qi_lanev8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode)
          || GET_MODE (x3) != E_V4x4HImode
          || !register_operand (operands[2], E_V4x4HImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4591; /* aarch64_vec_load_lanesv4x4hi_lanev4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode)
          || GET_MODE (x3) != E_V4x2SImode
          || !register_operand (operands[2], E_V4x2SImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4592; /* aarch64_vec_load_lanesv4x2si_lanev2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode)
          || GET_MODE (x3) != E_V4x1DImode
          || !register_operand (operands[2], E_V4x1DImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4593; /* aarch64_vec_load_lanesv4x1di_lanedi */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode)
          || GET_MODE (x3) != E_V4x4HFmode
          || !register_operand (operands[2], E_V4x4HFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4594; /* aarch64_vec_load_lanesv4x4hf_lanev4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode)
          || GET_MODE (x3) != E_V4x2SFmode
          || !register_operand (operands[2], E_V4x2SFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4595; /* aarch64_vec_load_lanesv4x2sf_lanev2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode)
          || GET_MODE (x3) != E_V4x1DFmode
          || !register_operand (operands[2], E_V4x1DFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4596; /* aarch64_vec_load_lanesv4x1df_lanedf */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode)
          || GET_MODE (x3) != E_V4x4BFmode
          || !register_operand (operands[2], E_V4x4BFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4597; /* aarch64_vec_load_lanesv4x4bf_lanev4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode)
          || GET_MODE (x3) != E_V4x16QImode
          || !register_operand (operands[2], E_V4x16QImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4598; /* aarch64_vec_load_lanesv4x16qi_lanev16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode)
          || GET_MODE (x3) != E_V4x8HImode
          || !register_operand (operands[2], E_V4x8HImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4599; /* aarch64_vec_load_lanesv4x8hi_lanev8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode)
          || GET_MODE (x3) != E_V4x4SImode
          || !register_operand (operands[2], E_V4x4SImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4600; /* aarch64_vec_load_lanesv4x4si_lanev4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode)
          || GET_MODE (x3) != E_V4x2DImode
          || !register_operand (operands[2], E_V4x2DImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4601; /* aarch64_vec_load_lanesv4x2di_lanev2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode)
          || GET_MODE (x3) != E_V4x8HFmode
          || !register_operand (operands[2], E_V4x8HFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4602; /* aarch64_vec_load_lanesv4x8hf_lanev8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode)
          || GET_MODE (x3) != E_V4x4SFmode
          || !register_operand (operands[2], E_V4x4SFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4603; /* aarch64_vec_load_lanesv4x4sf_lanev4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode)
          || GET_MODE (x3) != E_V4x2DFmode
          || !register_operand (operands[2], E_V4x2DFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4604; /* aarch64_vec_load_lanesv4x2df_lanev2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode)
          || GET_MODE (x3) != E_V4x8BFmode
          || !register_operand (operands[2], E_V4x8BFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4605; /* aarch64_vec_load_lanesv4x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern182 (x1))
    {
    case 0:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
        return -1;
      return 11004; /* aarch64_sve_float_nonextendvnx8hivnx8hf */

    case 1:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 11010; /* aarch64_sve_float_nonextendvnx4sivnx8hf */

    case 2:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      return 11016; /* aarch64_sve_float_nonextendvnx2divnx8hf */

    case 3:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
        return -1;
      return 11006; /* aarch64_sve_float_nonextendvnx8hivnx4sf */

    case 4:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 11012; /* aarch64_sve_float_nonextendvnx4sivnx4sf */

    case 5:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      return 11018; /* aarch64_sve_float_nonextendvnx2divnx4sf */

    case 6:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
        return -1;
      return 11008; /* aarch64_sve_float_nonextendvnx8hivnx2df */

    case 7:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 11014; /* aarch64_sve_float_nonextendvnx4sivnx2df */

    case 8:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      return 11020; /* aarch64_sve_float_nonextendvnx2divnx2df */

    case 9:
      if (!
#line 9809 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 11058; /* aarch64_sve_float_extendvnx4sivnx2df */

    case 10:
      if (aarch64_predicate_operand (operands[1], E_VNx8BImode)
          && register_operand (operands[2], E_VNx8HImode)
          && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x82 | 0x81) & 0x22) == 0))
        return 11022; /* *aarch64_sve_float_nonextendvnx8hivnx2hf */
      if (aarch64_predicate_operand (operands[1], E_VNx4BImode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4HImode:
              if (register_operand (operands[2], E_VNx4HImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x42 | 0x41) & 0x22) == 0))
                return 11028; /* *aarch64_sve_float_nonextendvnx4hivnx2hf */
              break;

            case E_VNx4SImode:
              if (register_operand (operands[2], E_VNx4SImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x44 | 0x43) & 0x22) == 0))
                return 11040; /* *aarch64_sve_float_nonextendvnx4sivnx2hf */
              break;

            default:
              break;
            }
        }
      if (!aarch64_predicate_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (pattern1064 ())
        {
        case 0:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x22 | 0x21) & 0x22) == 0))
            return -1;
          return 11034; /* *aarch64_sve_float_nonextendvnx2hivnx2hf */

        case 1:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x24 | 0x23) & 0x22) == 0))
            return -1;
          return 11046; /* *aarch64_sve_float_nonextendvnx2sivnx2hf */

        case 2:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x28 | 0x27) & 0x22) == 0))
            return -1;
          return 11052; /* *aarch64_sve_float_nonextendvnx2divnx2hf */

        default:
          return -1;
        }

    case 11:
      if (aarch64_predicate_operand (operands[1], E_VNx8BImode)
          && register_operand (operands[2], E_VNx8HImode)
          && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x82 | 0x81) & 0x42) == 0))
        return 11024; /* *aarch64_sve_float_nonextendvnx8hivnx4hf */
      if (aarch64_predicate_operand (operands[1], E_VNx4BImode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4HImode:
              if (register_operand (operands[2], E_VNx4HImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x42 | 0x41) & 0x42) == 0))
                return 11030; /* *aarch64_sve_float_nonextendvnx4hivnx4hf */
              break;

            case E_VNx4SImode:
              if (register_operand (operands[2], E_VNx4SImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x44 | 0x43) & 0x42) == 0))
                return 11042; /* *aarch64_sve_float_nonextendvnx4sivnx4hf */
              break;

            default:
              break;
            }
        }
      if (!aarch64_predicate_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (pattern1064 ())
        {
        case 0:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x22 | 0x21) & 0x42) == 0))
            return -1;
          return 11036; /* *aarch64_sve_float_nonextendvnx2hivnx4hf */

        case 1:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x24 | 0x23) & 0x42) == 0))
            return -1;
          return 11048; /* *aarch64_sve_float_nonextendvnx2sivnx4hf */

        case 2:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x28 | 0x27) & 0x42) == 0))
            return -1;
          return 11054; /* *aarch64_sve_float_nonextendvnx2divnx4hf */

        default:
          return -1;
        }

    case 12:
      if (aarch64_predicate_operand (operands[1], E_VNx8BImode)
          && register_operand (operands[2], E_VNx8HImode)
          && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x82 | 0x81) & 0x24) == 0))
        return 11026; /* *aarch64_sve_float_nonextendvnx8hivnx2sf */
      if (aarch64_predicate_operand (operands[1], E_VNx4BImode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4HImode:
              if (register_operand (operands[2], E_VNx4HImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x42 | 0x41) & 0x24) == 0))
                return 11032; /* *aarch64_sve_float_nonextendvnx4hivnx2sf */
              break;

            case E_VNx4SImode:
              if (register_operand (operands[2], E_VNx4SImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x44 | 0x43) & 0x24) == 0))
                return 11044; /* *aarch64_sve_float_nonextendvnx4sivnx2sf */
              break;

            default:
              break;
            }
        }
      if (!aarch64_predicate_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (pattern1064 ())
        {
        case 0:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x22 | 0x21) & 0x24) == 0))
            return -1;
          return 11038; /* *aarch64_sve_float_nonextendvnx2hivnx2sf */

        case 1:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x24 | 0x23) & 0x24) == 0))
            return -1;
          return 11050; /* *aarch64_sve_float_nonextendvnx2sivnx2sf */

        case 2:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x28 | 0x27) & 0x24) == 0))
            return -1;
          return 11056; /* *aarch64_sve_float_nonextendvnx2divnx2sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      switch (pattern798 (x3, 
E_V8QImode))
        {
        case 0:
          if (!
#line 8586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4874; /* aarch64_qtbx1v8qi */

        case 1:
          if (!
#line 8609 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4878; /* aarch64_qtbx2v8qi */

        case 2:
          if (!
#line 8632 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4882; /* aarch64_qtbx3v8qi */

        case 3:
          if (!
#line 8655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4886; /* aarch64_qtbx4v8qi */

        default:
          return -1;
        }

    case E_V16QImode:
      switch (pattern798 (x3, 
E_V16QImode))
        {
        case 0:
          if (!
#line 8586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4875; /* aarch64_qtbx1v16qi */

        case 1:
          if (!
#line 8609 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4879; /* aarch64_qtbx2v16qi */

        case 2:
          if (!
#line 8632 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4883; /* aarch64_qtbx3v16qi */

        case 3:
          if (!
#line 8655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4887; /* aarch64_qtbx4v16qi */

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (pattern199 (x3, 
E_VNx16QImode) != 0
          || !
#line 3841 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13012; /* aarch64_sve_tbxvnx16qi */

    case E_VNx8HImode:
      if (pattern199 (x3, 
E_VNx8HImode) != 0
          || !
#line 3841 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13014; /* aarch64_sve_tbxvnx8hi */

    case E_VNx4SImode:
      if (pattern199 (x3, 
E_VNx4SImode) != 0
          || !
#line 3841 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13016; /* aarch64_sve_tbxvnx4si */

    case E_VNx2DImode:
      if (pattern199 (x3, 
E_VNx2DImode) != 0
          || !
#line 3841 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13018; /* aarch64_sve_tbxvnx2di */

    case E_VNx8BFmode:
      if (pattern797 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !
#line 3841 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13020; /* aarch64_sve_tbxvnx8bf */

    case E_VNx8HFmode:
      if (pattern797 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !
#line 3841 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13022; /* aarch64_sve_tbxvnx8hf */

    case E_VNx4SFmode:
      if (pattern797 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !
#line 3841 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13024; /* aarch64_sve_tbxvnx4sf */

    case E_VNx2DFmode:
      if (pattern797 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !
#line 3841 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13026; /* aarch64_sve_tbxvnx2df */

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern173 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10037; /* while_gesivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10047; /* while_gedivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10057; /* while_gesivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10067; /* while_gedivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10077; /* while_gesivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10087; /* while_gedivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10097; /* while_gesivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10107; /* while_gedivnx2bi */

    default:
      return -1;
    }
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern803 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6389; /* aarch64_stnt1vnx16qi */

    case E_VNx8HImode:
      if (pattern803 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6390; /* aarch64_stnt1vnx8hi */

    case E_VNx4SImode:
      if (pattern803 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6391; /* aarch64_stnt1vnx4si */

    case E_VNx2DImode:
      if (pattern803 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6392; /* aarch64_stnt1vnx2di */

    case E_VNx8BFmode:
      if (pattern803 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6393; /* aarch64_stnt1vnx8bf */

    case E_VNx8HFmode:
      if (pattern803 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6394; /* aarch64_stnt1vnx8hf */

    case E_VNx4SFmode:
      if (pattern803 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6395; /* aarch64_stnt1vnx4sf */

    case E_VNx2DFmode:
      if (pattern803 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6396; /* aarch64_stnt1vnx2df */

    default:
      return -1;
    }
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern801 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6138; /* aarch64_ldnt1vnx16qi */

    case E_VNx8HImode:
      if (pattern801 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6139; /* aarch64_ldnt1vnx8hi */

    case E_VNx4SImode:
      if (pattern801 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6140; /* aarch64_ldnt1vnx4si */

    case E_VNx2DImode:
      if (pattern801 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6141; /* aarch64_ldnt1vnx2di */

    case E_VNx8BFmode:
      if (pattern801 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6142; /* aarch64_ldnt1vnx8bf */

    case E_VNx8HFmode:
      if (pattern801 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6143; /* aarch64_ldnt1vnx8hf */

    case E_VNx4SFmode:
      if (pattern801 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6144; /* aarch64_ldnt1vnx4sf */

    case E_VNx2DFmode:
      if (pattern801 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6145; /* aarch64_ldnt1vnx2df */

    default:
      return -1;
    }
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern806 (x3, 
E_VNx16QImode) != 0
          || !
#line 1990 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12212; /* aarch64_sve_slivnx16qi */

    case E_VNx8HImode:
      if (pattern806 (x3, 
E_VNx8HImode) != 0
          || !
#line 1990 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12214; /* aarch64_sve_slivnx8hi */

    case E_VNx4SImode:
      if (pattern806 (x3, 
E_VNx4SImode) != 0
          || !
#line 1990 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12216; /* aarch64_sve_slivnx4si */

    case E_VNx2DImode:
      if (pattern806 (x3, 
E_VNx2DImode) != 0
          || !
#line 1990 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12218; /* aarch64_sve_slivnx2di */

    default:
      return -1;
    }
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12726; /* aarch64_sve_sqrdcmlah270vnx16qi */

    case 1:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12734; /* aarch64_sve_sqrdcmlah270vnx8hi */

    case 2:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12742; /* aarch64_sve_sqrdcmlah270vnx4si */

    case 3:
      if (!
#line 3000 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12750; /* aarch64_sve_sqrdcmlah270vnx2di */

    case 4:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12758; /* aarch64_sqrdcmlah270_lane_vnx8hi */

    case 5:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12766; /* aarch64_sqrdcmlah270_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[3] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (pattern804 (x3, 
E_VNx8HFmode, 
E_HFmode, 
E_VNx8BImode) != 0
          || !
#line 9205 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10516; /* mask_fold_left_plus_vnx8hf */

    case E_SFmode:
      if (pattern804 (x3, 
E_VNx4SFmode, 
E_SFmode, 
E_VNx4BImode) != 0
          || !
#line 9205 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10517; /* mask_fold_left_plus_vnx4sf */

    case E_DFmode:
      if (pattern804 (x3, 
E_VNx2DFmode, 
E_DFmode, 
E_VNx2BImode) != 0
          || !
#line 9205 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10518; /* mask_fold_left_plus_vnx2df */

    default:
      return -1;
    }
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3080 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12767; /* aarch64_sve_cdotvnx4si */

    case 1:
      if (!
#line 3080 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12771; /* aarch64_sve_cdotvnx2di */

    case 2:
      if (!
#line 3097 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12775; /* aarch64_cdot_lane_vnx4si */

    case 3:
      if (!
#line 3097 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12779; /* aarch64_cdot_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12030; /* aarch64_sve_adcltvnx16qi */

    case 1:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12038; /* aarch64_sve_adcltvnx8hi */

    case 2:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12046; /* aarch64_sve_adcltvnx4si */

    case 3:
      if (!
#line 1451 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12054; /* aarch64_sve_adcltvnx2di */

    default:
      return -1;
    }
}

 int
recog_393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (x3))
    {
    case E_VNx16BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10201; /* while_rwsivnx16bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10211; /* while_rwdivnx16bi_ptest */

    case E_VNx8BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10221; /* while_rwsivnx8bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10231; /* while_rwdivnx8bi_ptest */

    case E_VNx4BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10241; /* while_rwsivnx4bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10251; /* while_rwdivnx4bi_ptest */

    case E_VNx2BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10261; /* while_rwsivnx2bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10271; /* while_rwdivnx2bi_ptest */

    default:
      return -1;
    }
}

 int
recog_403 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern223 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[1] = x4;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[0], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode)
                  || !
#line 557 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11562; /* aarch64_scatter_stntvnx4si */

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode)
                  || !
#line 557 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11564; /* aarch64_scatter_stntvnx4sf */

            default:
              return -1;
            }

        case E_VNx2BImode:
          if (!register_operand (operands[0], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode)
                  || !
#line 557 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11563; /* aarch64_scatter_stntvnx2di */

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode)
                  || !
#line 557 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11565; /* aarch64_scatter_stntvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          switch (pattern1175 (x6, 
E_VNx4SImode, 
E_VNx4BImode))
            {
            case 0:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
                return -1;
              return 11566; /* aarch64_scatter_stnt_vnx4sivnx8qi */

            case 1:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
                return -1;
              return 11567; /* aarch64_scatter_stnt_vnx4sivnx4qi */

            case 2:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
                return -1;
              return 11568; /* aarch64_scatter_stnt_vnx4sivnx2qi */

            case 3:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
                return -1;
              return 11569; /* aarch64_scatter_stnt_vnx4sivnx4hi */

            case 4:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
                return -1;
              return 11570; /* aarch64_scatter_stnt_vnx4sivnx2hi */

            case 5:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
                return -1;
              return 11571; /* aarch64_scatter_stnt_vnx4sivnx2si */

            default:
              return -1;
            }

        case E_VNx2BImode:
          switch (pattern1175 (x6, 
E_VNx2DImode, 
E_VNx2BImode))
            {
            case 0:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
                return -1;
              return 11572; /* aarch64_scatter_stnt_vnx2divnx8qi */

            case 1:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
                return -1;
              return 11573; /* aarch64_scatter_stnt_vnx2divnx4qi */

            case 2:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
                return -1;
              return 11574; /* aarch64_scatter_stnt_vnx2divnx2qi */

            case 3:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
                return -1;
              return 11575; /* aarch64_scatter_stnt_vnx2divnx4hi */

            case 4:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
                return -1;
              return 11576; /* aarch64_scatter_stnt_vnx2divnx2hi */

            case 5:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
                return -1;
              return 11577; /* aarch64_scatter_stnt_vnx2divnx2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_412 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern222 (x1))
    {
    case 0:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11497; /* aarch64_st1vnx32qi_strided2 */

    case 1:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11499; /* aarch64_st1vnx16hi_strided2 */

    case 2:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11501; /* aarch64_st1vnx8si_strided2 */

    case 3:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11503; /* aarch64_st1vnx4di_strided2 */

    case 4:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11505; /* aarch64_st1vnx16bf_strided2 */

    case 5:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11507; /* aarch64_st1vnx16hf_strided2 */

    case 6:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11509; /* aarch64_st1vnx8sf_strided2 */

    case 7:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11511; /* aarch64_st1vnx4df_strided2 */

    case 8:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11513; /* aarch64_st1vnx64qi_strided2 */

    case 9:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11515; /* aarch64_st1vnx32hi_strided2 */

    case 10:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11517; /* aarch64_st1vnx16si_strided2 */

    case 11:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11519; /* aarch64_st1vnx8di_strided2 */

    case 12:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11521; /* aarch64_st1vnx32bf_strided2 */

    case 13:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11523; /* aarch64_st1vnx32hf_strided2 */

    case 14:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11525; /* aarch64_st1vnx16sf_strided2 */

    case 15:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11527; /* aarch64_st1vnx8df_strided2 */

    default:
      return -1;
    }
}

 int
recog_424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern208 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8582; /* aarch64_pred_mulxvnx8hf */

    case E_VNx4SFmode:
      if (pattern208 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8586; /* aarch64_pred_mulxvnx4sf */

    case E_VNx2DFmode:
      if (pattern208 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 5584 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8590; /* aarch64_pred_mulxvnx2df */

    case E_VNx8BFmode:
      if (pattern208 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && false))
        return -1;
      return 12009; /* aarch64_pred_mulxvnx8bf */

    default:
      return -1;
    }
}

 int
recog_432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern254 (x1))
    {
    case 0:
      if (!
#line 1431 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13893; /* aarch64_sme_smlavnx4sivnx16qi */

    case 1:
      if (!
#line 1431 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13897; /* aarch64_sme_smlavnx4sivnx8hi */

    case 2:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13909; /* aarch64_sme_smlavnx4sivnx32qi */

    case 3:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13913; /* aarch64_sme_smlavnx4sivnx64qi */

    case 4:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13917; /* aarch64_sme_smlavnx4sivnx16hi */

    case 5:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13921; /* aarch64_sme_smlavnx4sivnx32hi */

    case 6:
      if (!
#line 1559 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14021; /* aarch64_sme_smlavnx2divnx8hi */

    case 7:
      if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14029; /* aarch64_sme_smlavnx2divnx16hi */

    case 8:
      if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14033; /* aarch64_sme_smlavnx2divnx32hi */

    case 9:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13941; /* aarch64_sme_single_smlavnx4sivnx32qi */

    case 10:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13945; /* aarch64_sme_single_smlavnx4sivnx64qi */

    case 11:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13949; /* aarch64_sme_single_smlavnx4sivnx16hi */

    case 12:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13953; /* aarch64_sme_single_smlavnx4sivnx32hi */

    case 13:
      if (!
#line 1620 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14045; /* aarch64_sme_single_smlavnx2divnx16hi */

    case 14:
      if (!
#line 1620 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14049; /* aarch64_sme_single_smlavnx2divnx32hi */

    case 15:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13973; /* aarch64_sme_lane_smlavnx4sivnx16qi */

    case 16:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13977; /* aarch64_sme_lane_smlavnx4sivnx32qi */

    case 17:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13981; /* aarch64_sme_lane_smlavnx4sivnx64qi */

    case 18:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13985; /* aarch64_sme_lane_smlavnx4sivnx8hi */

    case 19:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13989; /* aarch64_sme_lane_smlavnx4sivnx16hi */

    case 20:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13993; /* aarch64_sme_lane_smlavnx4sivnx32hi */

    case 21:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14061; /* aarch64_sme_lane_smlavnx2divnx8hi */

    case 22:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14065; /* aarch64_sme_lane_smlavnx2divnx16hi */

    case 23:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14069; /* aarch64_sme_lane_smlavnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1445 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13901; /* *aarch64_sme_smlavnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1445 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13905; /* *aarch64_sme_smlavnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1325 ())
            {
            case 0:
              if (
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13925; /* *aarch64_sme_smlavnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13929; /* *aarch64_sme_smlavnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13933; /* *aarch64_sme_smlavnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13937; /* *aarch64_sme_smlavnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1573 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 14025; /* *aarch64_sme_smlavnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1603 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 14037; /* *aarch64_sme_smlavnx2divnx16hi_plus */

        case 1:
          if (!
#line 1603 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 14041; /* *aarch64_sme_smlavnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1327 (x3))
            {
            case 0:
              if (
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13957; /* *aarch64_sme_single_smlavnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13961; /* *aarch64_sme_single_smlavnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13965; /* *aarch64_sme_single_smlavnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13969; /* *aarch64_sme_single_smlavnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1635 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14053; /* *aarch64_sme_single_smlavnx2divnx16hi_plus */

    case 28:
      if (!
#line 1635 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 14057; /* *aarch64_sme_single_smlavnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13997; /* *aarch64_sme_lane_smlavnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1368 (x3))
                {
                case 0:
                  if (
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 14001; /* *aarch64_sme_lane_smlavnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 14005; /* *aarch64_sme_lane_smlavnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 14009; /* *aarch64_sme_lane_smlavnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1369 (x3))
        {
        case 0:
          if (!
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14013; /* *aarch64_sme_lane_smlavnx4sivnx16hi */

        case 1:
          if (!
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14017; /* *aarch64_sme_lane_smlavnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 14073; /* *aarch64_sme_lane_smlavnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1369 (x3))
        {
        case 0:
          if (!
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 14077; /* *aarch64_sme_lane_smlavnx2divnx16hi */

        case 1:
          if (!
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 14081; /* *aarch64_sme_lane_smlavnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_440 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern112 (x2, 
E_VNx4SImode, 
93) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != 168)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93
      || GET_MODE (x5) != E_VNx4SImode)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (!const_int_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 3);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 0);
      operands[2] = x9;
      operands[3] = x6;
      switch (pattern1344 (x4))
        {
        case 0:
          if (!
#line 1829 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14124; /* aarch64_sme_lane_fvdotvnx4sivnx16bf */

        case 1:
          if (!
#line 1829 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14126; /* aarch64_sme_lane_fvdotvnx4sivnx32bf */

        case 2:
          if (!
#line 1829 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14128; /* aarch64_sme_lane_fvdotvnx4sivnx16hf */

        case 3:
          if (!
#line 1829 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14130; /* aarch64_sme_lane_fvdotvnx4sivnx32hf */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x7, 1);
      operands[1] = x11;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 3);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 0);
      operands[3] = x9;
      operands[4] = x6;
      switch (pattern1357 (x4))
        {
        case 0:
          if (!
#line 1846 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14132; /* *aarch64_sme_lane_fvdotvnx4sivnx16bf_plus */

        case 1:
          if (!
#line 1846 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14134; /* *aarch64_sme_lane_fvdotvnx4sivnx32bf_plus */

        case 2:
          if (!
#line 1846 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14136; /* *aarch64_sme_lane_fvdotvnx4sivnx16hf_plus */

        case 3:
          if (!
#line 1846 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14138; /* *aarch64_sme_lane_fvdotvnx4sivnx32hf_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_441 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern252 (x1))
    {
    case 0:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13772; /* aarch64_sme_lane_usvdotvnx4sivnx32qi */

    case 1:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13780; /* aarch64_sme_lane_usvdotvnx4sivnx64qi */

    case 2:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13788; /* aarch64_sme_lane_usvdotvnx4sivnx16hi */

    case 3:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13796; /* aarch64_sme_lane_usvdotvnx4sivnx32hi */

    case 4:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13804; /* aarch64_sme_lane_usvdotvnx2divnx32qi */

    case 5:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13812; /* aarch64_sme_lane_usvdotvnx2divnx64qi */

    case 6:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13820; /* aarch64_sme_lane_usvdotvnx2divnx16hi */

    case 7:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13828; /* aarch64_sme_lane_usvdotvnx2divnx32hi */

    case 8:
      if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13836; /* *aarch64_sme_lane_usvdotvnx4sivnx32qi_plus */

    case 9:
      if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13844; /* *aarch64_sme_lane_usvdotvnx4sivnx64qi_plus */

    case 10:
      if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13852; /* *aarch64_sme_lane_usvdotvnx4sivnx16hi_plus */

    case 11:
      if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13860; /* *aarch64_sme_lane_usvdotvnx4sivnx32hi_plus */

    case 12:
      if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13868; /* *aarch64_sme_lane_usvdotvnx2divnx32qi_plus */

    case 13:
      if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13876; /* *aarch64_sme_lane_usvdotvnx2divnx64qi_plus */

    case 14:
      if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13884; /* *aarch64_sme_lane_usvdotvnx2divnx16hi_plus */

    case 15:
      if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13892; /* *aarch64_sme_lane_usvdotvnx2divnx32hi_plus */

    default:
      return -1;
    }
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 162:
      if (pattern55 (x1, 
84) != 0
          || !aarch64_reg_or_zero (operands[0], E_DImode)
          || !
#line 2073 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP8))
        return -1;
      return 124; /* aarch64_write_fpmr */

    case 82:
      if (GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 6280 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 803; /* *aarch64_sisd_neg_qi */

    case 36:
      return recog_53 (x1, insn, pnum_clobbers);

    case 34:
      return recog_41 (x1, insn, pnum_clobbers);

    case 32:
      return recog_40 (x1, insn, pnum_clobbers);

    case 33:
      return recog_39 (x1, insn, pnum_clobbers);

    case 31:
      return recog_52 (x1, insn, pnum_clobbers);

    case 35:
      return recog_51 (x1, insn, pnum_clobbers);

    case 30:
      return recog_38 (x1, insn, pnum_clobbers);

    case 39:
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LO_SUM)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern865 (x2, 
E_SImode) != 0
              || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
            return -1;
          return 1169; /* ldr_got_small_28k_si */

        case E_DImode:
          if (pattern865 (x2, 
E_DImode) != 0
              || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
            return -1;
          return 1170; /* ldr_got_small_28k_di */

        default:
          return -1;
        }

    case 41:
      return recog_50 (x1, insn, pnum_clobbers);

    case 97:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1175; /* aarch64_load_tp_hard */

    case 40:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!aarch64_tls_ie_symref (operands[1], E_VOIDmode))
        return -1;
      switch (pattern44 (x2))
        {
        case 0:
          if (!
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
            return -1;
          return 1178; /* tlsie_small_si */

        case 1:
          if (!
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
            return -1;
          return 1179; /* tlsie_small_di */

        default:
          return -1;
        }

    case 101:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1188; /* tlsle32_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1189; /* tlsle32_di */

        default:
          return -1;
        }

    case 102:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1190; /* tlsle48_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1191; /* tlsle48_di */

        default:
          return -1;
        }

    case 21:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 8055 "../../gcc/config/aarch64/aarch64.md"
(TARGET_JSCVT))
        return -1;
      *pnum_clobbers = 1;
      return 1197; /* aarch64_fjcvtzs */

    case 114:
      if (pattern46 (x1, 
30, 
E_DImode) != 0)
        return -1;
      return 1206; /* xpaclri */

    case 107:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      switch (pattern44 (x2))
        {
        case 0:
          if (!(
#line 8187 "../../gcc/config/aarch64/aarch64.md"
(aarch64_stack_protector_guard != SSP_GLOBAL) && 
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
            return -1;
          return 1211; /* reg_stack_protect_address_si */

        case 1:
          if (!(
#line 8187 "../../gcc/config/aarch64/aarch64.md"
(aarch64_stack_protector_guard != SSP_GLOBAL) && 
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
            return -1;
          return 1212; /* reg_stack_protect_address_di */

        default:
          return -1;
        }

    case 22:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1242; /* aarch64_frint32zv2sf */

        case 1:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1246; /* aarch64_frint32zv4sf */

        case 2:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1250; /* aarch64_frint32zv2df */

        case 3:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1254; /* aarch64_frint32zdf */

        case 4:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1258; /* aarch64_frint32zsf */

        default:
          return -1;
        }

    case 23:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1243; /* aarch64_frint32xv2sf */

        case 1:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1247; /* aarch64_frint32xv4sf */

        case 2:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1251; /* aarch64_frint32xv2df */

        case 3:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1255; /* aarch64_frint32xdf */

        case 4:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1259; /* aarch64_frint32xsf */

        default:
          return -1;
        }

    case 24:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1244; /* aarch64_frint64zv2sf */

        case 1:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1248; /* aarch64_frint64zv4sf */

        case 2:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1252; /* aarch64_frint64zv2df */

        case 3:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1256; /* aarch64_frint64zdf */

        case 4:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1260; /* aarch64_frint64zsf */

        default:
          return -1;
        }

    case 25:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1245; /* aarch64_frint64xv2sf */

        case 1:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1249; /* aarch64_frint64xv4sf */

        case 2:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1253; /* aarch64_frint64xv2df */

        case 3:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1257; /* aarch64_frint64xdf */

        case 4:
          if (!
#line 8477 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1261; /* aarch64_frint64xsf */

        default:
          return -1;
        }

    case 179:
      if (pattern60 (x2, 
E_CCmode, 
66, 
E_DImode) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1279; /* aarch64_save_nzcv */

    case 180:
      if (GET_MODE (x2) != E_CCmode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 66
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1280; /* aarch64_restore_nzcv */

    case 111:
      return recog_17 (x1, insn, pnum_clobbers);

    case 187:
      return recog_29 (x1, insn, pnum_clobbers);

    case 203:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 2711 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2447; /* aarch64_fnegv2di2 */

    case 588:
      return recog_49 (x1, insn, pnum_clobbers);

    case 205:
      return recog_16 (x1, insn, pnum_clobbers);

    case 202:
      return recog_48 (x1, insn, pnum_clobbers);

    case 208:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2888; /* aarch64_reduc_umax_internalv8qi */

        case 1:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2892; /* aarch64_reduc_umax_internalv16qi */

        case 2:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2896; /* aarch64_reduc_umax_internalv4hi */

        case 3:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2900; /* aarch64_reduc_umax_internalv8hi */

        case 4:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2904; /* aarch64_reduc_umax_internalv4si */

        case 5:
          if (!
#line 3707 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2908; /* aarch64_reduc_umax_internalv2si */

        default:
          return -1;
        }

    case 209:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2889; /* aarch64_reduc_umin_internalv8qi */

        case 1:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2893; /* aarch64_reduc_umin_internalv16qi */

        case 2:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2897; /* aarch64_reduc_umin_internalv4hi */

        case 3:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2901; /* aarch64_reduc_umin_internalv8hi */

        case 4:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2905; /* aarch64_reduc_umin_internalv4si */

        case 5:
          if (!
#line 3707 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2909; /* aarch64_reduc_umin_internalv2si */

        default:
          return -1;
        }

    case 206:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2890; /* aarch64_reduc_smax_internalv8qi */

        case 1:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2894; /* aarch64_reduc_smax_internalv16qi */

        case 2:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2898; /* aarch64_reduc_smax_internalv4hi */

        case 3:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2902; /* aarch64_reduc_smax_internalv8hi */

        case 4:
          if (!
#line 3698 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2906; /* aarch64_reduc_smax_internalv4si */

        case 5:
          if (!
#line 3707 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2910; /* aarch64_reduc_smax_internalv2si */

        default:
          return -1;
        }

    case 207:
      return recog_58 (x1, insn, pnum_clobbers);

    case 198:
      switch (pattern62 (x1))
        {
        case 0:
          if (!(
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2912; /* aarch64_reduc_smax_nan_internalv4hf */

        case 1:
          if (!(
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2916; /* aarch64_reduc_smax_nan_internalv8hf */

        case 2:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2920; /* aarch64_reduc_smax_nan_internalv2sf */

        case 3:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2924; /* aarch64_reduc_smax_nan_internalv4sf */

        case 4:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2928; /* aarch64_reduc_smax_nan_internalv2df */

        default:
          return -1;
        }

    case 201:
      switch (pattern62 (x1))
        {
        case 0:
          if (!(
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2913; /* aarch64_reduc_smin_nan_internalv4hf */

        case 1:
          if (!(
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2917; /* aarch64_reduc_smin_nan_internalv8hf */

        case 2:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2921; /* aarch64_reduc_smin_nan_internalv2sf */

        case 3:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2925; /* aarch64_reduc_smin_nan_internalv4sf */

        case 4:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2929; /* aarch64_reduc_smin_nan_internalv2df */

        default:
          return -1;
        }

    case 197:
      switch (pattern62 (x1))
        {
        case 0:
          if (!(
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2914; /* aarch64_reduc_smax_internalv4hf */

        case 1:
          if (!(
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2918; /* aarch64_reduc_smax_internalv8hf */

        case 2:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2922; /* aarch64_reduc_smax_internalv2sf */

        case 3:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2926; /* aarch64_reduc_smax_internalv4sf */

        case 4:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2930; /* aarch64_reduc_smax_internalv2df */

        default:
          return -1;
        }

    case 200:
      switch (pattern62 (x1))
        {
        case 0:
          if (!(
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2915; /* aarch64_reduc_smin_internalv4hf */

        case 1:
          if (!(
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2919; /* aarch64_reduc_smin_internalv8hf */

        case 2:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2923; /* aarch64_reduc_smin_internalv2sf */

        case 3:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2927; /* aarch64_reduc_smin_internalv4sf */

        case 4:
          if (!
#line 3716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2931; /* aarch64_reduc_smin_internalv2df */

        default:
          return -1;
        }

    case 51:
      return recog_28 (x1, insn, pnum_clobbers);

    case 53:
      return recog_20 (x1, insn, pnum_clobbers);

    case 91:
      return recog_15 (x1, insn, pnum_clobbers);

    case 54:
      return recog_27 (x1, insn, pnum_clobbers);

    case 56:
      return recog_19 (x1, insn, pnum_clobbers);

    case 92:
      return recog_14 (x1, insn, pnum_clobbers);

    case 57:
      return recog_26 (x1, insn, pnum_clobbers);

    case 59:
      return recog_18 (x1, insn, pnum_clobbers);

    case 93:
      return recog_13 (x1, insn, pnum_clobbers);

    case 46:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      return recog_10 (x1, insn, pnum_clobbers);

    case 86:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      return recog_11 (x1, insn, pnum_clobbers);

    case 52:
      return recog_25 (x1, insn, pnum_clobbers);

    case 55:
      return recog_24 (x1, insn, pnum_clobbers);

    case 58:
      return recog_23 (x1, insn, pnum_clobbers);

    case 254:
      return recog_34 (x1, insn, pnum_clobbers);

    case 255:
      return recog_32 (x1, insn, pnum_clobbers);

    case 256:
      return recog_33 (x1, insn, pnum_clobbers);

    case 27:
      return recog_21 (x1, insn, pnum_clobbers);

    case 29:
      return recog_37 (x1, insn, pnum_clobbers);

    case 26:
      return recog_47 (x1, insn, pnum_clobbers);

    case 257:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 8992 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5220; /* aarch64_crypto_aesev16qi */

        case 1:
          if (!
#line 4131 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 13133; /* aarch64_sve2_aese */

        default:
          return -1;
        }

    case 258:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 8992 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5221; /* aarch64_crypto_aesdv16qi */

        case 1:
          if (!
#line 4131 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 13134; /* aarch64_sve2_aesd */

        default:
          return -1;
        }

    case 259:
      switch (pattern67 (x1, 
257))
        {
        case 0:
          if (!
#line 9001 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5222; /* aarch64_crypto_aesmcv16qi */

        case 1:
          if (!
#line 4142 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 13135; /* aarch64_sve2_aesmc */

        case 2:
          if (!
#line 9020 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES
   && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 5224; /* *aarch64_crypto_aese_fused */

        case 3:
          if (!
#line 4161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 13137; /* *aarch64_sve2_aese_fused */

        default:
          return -1;
        }

    case 260:
      switch (pattern67 (x1, 
258))
        {
        case 0:
          if (!
#line 9001 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5223; /* aarch64_crypto_aesimcv16qi */

        case 1:
          if (!
#line 4142 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 13136; /* aarch64_sve2_aesimc */

        case 2:
          if (!
#line 9041 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES
   && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 5225; /* *aarch64_crypto_aesd_fused */

        case 3:
          if (!
#line 4176 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 13138; /* *aarch64_sve2_aesd_fused */

        default:
          return -1;
        }

    case 264:
      return recog_36 (x1, insn, pnum_clobbers);

    case 585:
      return recog_31 (x1, insn, pnum_clobbers);

    case 587:
      return recog_46 (x1, insn, pnum_clobbers);

    case 586:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8BFmode)
          || !
#line 10084 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
        return -1;
      return 5324; /* aarch64_vbfcvt_highv8bf */

    case 153:
      return recog_22 (x1, insn, pnum_clobbers);

    case 159:
      if (pattern46 (x1, 
86, 
E_VNx16BImode) != 0
          || !
#line 1276 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5790; /* aarch64_update_ffrt */

    case 325:
      return recog_35 (x1, insn, pnum_clobbers);

    case 77:
      return recog_12 (x1, insn, pnum_clobbers);

    case 129:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10896; /* aarch64_sve_sunpkhi_vnx16qi */

        case 1:
          if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10900; /* aarch64_sve_sunpkhi_vnx8hi */

        case 2:
          if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10904; /* aarch64_sve_sunpkhi_vnx4si */

        default:
          return -1;
        }

    case 130:
      return recog_57 (x1, insn, pnum_clobbers);

    case 131:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10898; /* aarch64_sve_sunpklo_vnx16qi */

        case 1:
          if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10902; /* aarch64_sve_sunpklo_vnx8hi */

        case 2:
          if (!
#line 9517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10906; /* aarch64_sve_sunpklo_vnx4si */

        default:
          return -1;
        }

    case 132:
      return recog_56 (x1, insn, pnum_clobbers);

    case 613:
      return recog_30 (x1, insn, pnum_clobbers);

    case 611:
      return recog_55 (x1, insn, pnum_clobbers);

    case 482:
      return recog_54 (x1, insn, pnum_clobbers);

    case 528:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12521; /* aarch64_sve_sqxtnbvnx8hi */

        case 1:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12524; /* aarch64_sve_sqxtnbvnx4si */

        case 2:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12527; /* aarch64_sve_sqxtnbvnx2di */

        default:
          return -1;
        }

    case 530:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12522; /* aarch64_sve_sqxtunbvnx8hi */

        case 1:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12525; /* aarch64_sve_sqxtunbvnx4si */

        case 2:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12528; /* aarch64_sve_sqxtunbvnx2di */

        default:
          return -1;
        }

    case 565:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12523; /* aarch64_sve_uqxtnbvnx8hi */

        case 1:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12526; /* aarch64_sve_uqxtnbvnx4si */

        case 2:
          if (!
#line 2614 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12529; /* aarch64_sve_uqxtnbvnx2di */

        default:
          return -1;
        }

    case 617:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12539; /* aarch64_sve_sqcvtvnx16qivnx16si */

        case 1:
          if (!
#line 3839 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12545; /* aarch64_sve_sqcvtvnx8hivnx8si */

        case 2:
          if (!
#line 2662 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12551; /* aarch64_sve_sqcvtvnx8hivnx8di */

        default:
          return -1;
        }

    case 618:
      switch (pattern73 (x1))
        {
        case 0:
          if (!(
#line 2644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3840 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12540; /* aarch64_sve_sqcvtnvnx16qivnx16si */

        case 1:
          if (!
#line 3840 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12546; /* aarch64_sve_sqcvtnvnx8hivnx8si */

        case 2:
          if (!(
#line 2662 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3840 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12552; /* aarch64_sve_sqcvtnvnx8hivnx8di */

        default:
          return -1;
        }

    case 619:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12541; /* aarch64_sve_sqcvtuvnx16qivnx16si */

        case 1:
          if (!
#line 3841 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12547; /* aarch64_sve_sqcvtuvnx8hivnx8si */

        case 2:
          if (!
#line 2662 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12553; /* aarch64_sve_sqcvtuvnx8hivnx8di */

        default:
          return -1;
        }

    case 620:
      switch (pattern73 (x1))
        {
        case 0:
          if (!(
#line 2644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3842 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12542; /* aarch64_sve_sqcvtunvnx16qivnx16si */

        case 1:
          if (!
#line 3842 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12548; /* aarch64_sve_sqcvtunvnx8hivnx8si */

        case 2:
          if (!(
#line 2662 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3842 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12554; /* aarch64_sve_sqcvtunvnx8hivnx8di */

        default:
          return -1;
        }

    case 626:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12543; /* aarch64_sve_uqcvtvnx16qivnx16si */

        case 1:
          if (!
#line 3843 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12549; /* aarch64_sve_uqcvtvnx8hivnx8si */

        case 2:
          if (!
#line 2662 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12555; /* aarch64_sve_uqcvtvnx8hivnx8di */

        default:
          return -1;
        }

    case 627:
      switch (pattern73 (x1))
        {
        case 0:
          if (!(
#line 2644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12544; /* aarch64_sve_uqcvtnvnx16qivnx16si */

        case 1:
          if (!
#line 3844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12550; /* aarch64_sve_uqcvtnvnx8hivnx8si */

        case 2:
          if (!(
#line 2662 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3844 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12556; /* aarch64_sve_uqcvtnvnx8hivnx8di */

        default:
          return -1;
        }

    case 604:
      if (GET_MODE (x2) != E_VNx8SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!aligned_register_operand (operands[0], E_VNx8SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3332 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME_F16F16))
        return -1;
      return 12804; /* aarch64_sve_cvtlvnx8sf */

    case 605:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!aligned_register_operand (operands[1], E_VNx8SFmode))
        return -1;
      switch (pattern136 (x2))
        {
        case 0:
          if (!
#line 3361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12807; /* aarch64_sve_cvtnvnx8bf */

        case 1:
          if (!
#line 3361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12808; /* aarch64_sve_cvtnvnx8hf */

        default:
          return -1;
        }

    case 576:
      return recog_45 (x1, insn, pnum_clobbers);

    case 574:
      return recog_44 (x1, insn, pnum_clobbers);

    case 577:
      return recog_43 (x1, insn, pnum_clobbers);

    case 575:
      return recog_42 (x1, insn, pnum_clobbers);

    case 683:
      if (pattern46 (x1, 
67, 
E_DImode) != 0)
        return -1;
      return 13143; /* aarch64_update_vg */

    case 694:
      if (pattern55 (x1, 
88) != 0
          || !memory_operand (operands[0], E_V16QImode))
        return -1;
      return 13152; /* aarch64_setup_local_tpidr2 */

    case 696:
      if (pattern46 (x1, 
87, 
E_DImode) != 0)
        return -1;
      return 13160; /* aarch64_start_private_za_call */

    case 697:
      if (pattern46 (x1, 
87, 
E_DImode) != 0)
        return -1;
      return 13161; /* aarch64_end_private_za_call */

    default:
      return -1;
    }
}

 int
recog_465 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern610 (x2, 
E_SImode))
                {
                case 0:
                  return 255; /* *add_extendqi_si */

                case 1:
                  return 259; /* *add_extendhi_si */

                case 2:
                  return 263; /* *add_extendsi_si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern610 (x2, 
E_DImode))
                {
                case 0:
                  return 257; /* *add_extendqi_di */

                case 1:
                  return 261; /* *add_extendhi_di */

                case 2:
                  return 265; /* *add_extendsi_di */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern611 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4723 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3106; /* aarch64_saddwv8qi */

            case E_V4SImode:
              if (pattern611 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4723 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3108; /* aarch64_saddwv4hi */

            case E_V2DImode:
              if (pattern611 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4723 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3110; /* aarch64_saddwv2si */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern296 (x2))
            {
            case 0:
              if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3076; /* aarch64_saddlv8qi */

            case 1:
              if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3080; /* aarch64_saddlv4hi */

            case 2:
              if (!
#line 4621 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3084; /* aarch64_saddlv2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern612 (x2))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3052; /* aarch64_saddlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3064; /* aarch64_saddlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3056; /* aarch64_saddlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3068; /* aarch64_saddlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 4501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3060; /* aarch64_saddlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 4514 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3072; /* aarch64_saddlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern614 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4736 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3112; /* aarch64_saddwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4749 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3118; /* aarch64_saddw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4736 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3114; /* aarch64_saddwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4749 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3120; /* aarch64_saddw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4736 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3116; /* aarch64_saddwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4749 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3122; /* aarch64_saddw2v4si_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_472 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern649 (x2, 
E_V8QImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2932; /* aarch64_simd_bslv8qi_internal */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2945; /* *aarch64_simd_bslv8qi_alt */

        case E_V16QImode:
          if (pattern649 (x2, 
E_V16QImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2935; /* aarch64_simd_bslv16qi_internal */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2948; /* *aarch64_simd_bslv16qi_alt */

        case E_V4HImode:
          if (pattern649 (x2, 
E_V4HImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2936; /* aarch64_simd_bslv4hi_internal */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2949; /* *aarch64_simd_bslv4hi_alt */

        case E_V8HImode:
          if (pattern649 (x2, 
E_V8HImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2939; /* aarch64_simd_bslv8hi_internal */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2952; /* *aarch64_simd_bslv8hi_alt */

        case E_V2SImode:
          if (pattern649 (x2, 
E_V2SImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2940; /* aarch64_simd_bslv2si_internal */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2953; /* *aarch64_simd_bslv2si_alt */

        case E_V4SImode:
          if (pattern649 (x2, 
E_V4SImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2943; /* aarch64_simd_bslv4si_internal */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2956; /* *aarch64_simd_bslv4si_alt */

        case E_V2DImode:
          if (pattern649 (x2, 
E_V2DImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2944; /* aarch64_simd_bslv2di_internal */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2957; /* *aarch64_simd_bslv2di_alt */

        case E_DImode:
          if (pattern649 (x2, 
E_DImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 3804 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2958; /* aarch64_simd_bsldi_internal */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 3845 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2959; /* aarch64_simd_bsldi_alt */

        case E_VNx16QImode:
          if (pattern650 (x2, 
E_VNx16QImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1684 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 12100; /* *aarch64_sve2_bslvnx16qi */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1684 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12101; /* *aarch64_sve2_bslvnx16qi */

        case E_VNx8HImode:
          if (pattern650 (x2, 
E_VNx8HImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1684 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 12102; /* *aarch64_sve2_bslvnx8hi */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1684 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12103; /* *aarch64_sve2_bslvnx8hi */

        case E_VNx4SImode:
          if (pattern650 (x2, 
E_VNx4SImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1684 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 12104; /* *aarch64_sve2_bslvnx4si */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1684 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12105; /* *aarch64_sve2_bslvnx4si */

        case E_VNx2DImode:
          if (pattern650 (x2, 
E_VNx2DImode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1684 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 12106; /* *aarch64_sve2_bslvnx2di */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1684 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12107; /* *aarch64_sve2_bslvnx2di */

        default:
          return -1;
        }

    case NOT:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern520 (x2, 
E_V16QImode) != 0
                  || !
#line 9250 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
                return -1;
              return 5248; /* bcaxqv16qi4 */

            case E_V8HImode:
              if (pattern520 (x2, 
E_V8HImode) != 0
                  || !
#line 9250 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
                return -1;
              return 5249; /* bcaxqv8hi4 */

            case E_V4SImode:
              if (pattern520 (x2, 
E_V4SImode) != 0
                  || !
#line 9250 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
                return -1;
              return 5250; /* bcaxqv4si4 */

            case E_V2DImode:
              if (pattern520 (x2, 
E_V2DImode) != 0
                  || !
#line 9250 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
                return -1;
              return 5251; /* bcaxqv2di4 */

            default:
              return -1;
            }

        case XOR:
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern897 (x2, 
E_V8QImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && 
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 12138; /* *aarch64_sve2_bsl1n_unpredv8qi */
              if (!rtx_equal_p (x6, operands[2])
                  || !
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12139; /* *aarch64_sve2_bsl1n_unpredv8qi */

            case E_V16QImode:
              if (pattern897 (x2, 
E_V16QImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && 
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 12140; /* *aarch64_sve2_bsl1n_unpredv16qi */
              if (!rtx_equal_p (x6, operands[2])
                  || !
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12141; /* *aarch64_sve2_bsl1n_unpredv16qi */

            case E_V4HImode:
              if (pattern897 (x2, 
E_V4HImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && 
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 12142; /* *aarch64_sve2_bsl1n_unpredv4hi */
              if (!rtx_equal_p (x6, operands[2])
                  || !
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12143; /* *aarch64_sve2_bsl1n_unpredv4hi */

            case E_V8HImode:
              if (pattern897 (x2, 
E_V8HImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && 
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 12144; /* *aarch64_sve2_bsl1n_unpredv8hi */
              if (!rtx_equal_p (x6, operands[2])
                  || !
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12145; /* *aarch64_sve2_bsl1n_unpredv8hi */

            case E_V2SImode:
              if (pattern897 (x2, 
E_V2SImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && 
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 12146; /* *aarch64_sve2_bsl1n_unpredv2si */
              if (!rtx_equal_p (x6, operands[2])
                  || !
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12147; /* *aarch64_sve2_bsl1n_unpredv2si */

            case E_V4SImode:
              if (pattern897 (x2, 
E_V4SImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && 
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 12148; /* *aarch64_sve2_bsl1n_unpredv4si */
              if (!rtx_equal_p (x6, operands[2])
                  || !
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12149; /* *aarch64_sve2_bsl1n_unpredv4si */

            case E_V2DImode:
              if (pattern897 (x2, 
E_V2DImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && 
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 12150; /* *aarch64_sve2_bsl1n_unpredv2di */
              if (!rtx_equal_p (x6, operands[2])
                  || !
#line 1808 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12151; /* *aarch64_sve2_bsl1n_unpredv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern407 (x2))
        {
        case 0:
          if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12084; /* *aarch64_sve2_bcaxvnx16qi */

        case 1:
          if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12085; /* *aarch64_sve2_bcaxvnx8hi */

        case 2:
          if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12086; /* *aarch64_sve2_bcaxvnx4si */

        case 3:
          if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12087; /* *aarch64_sve2_bcaxvnx2di */

        case 4:
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 12130; /* *aarch64_sve2_bsl1nvnx16qi */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12131; /* *aarch64_sve2_bsl1nvnx16qi */

        case 5:
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 12132; /* *aarch64_sve2_bsl1nvnx8hi */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12133; /* *aarch64_sve2_bsl1nvnx8hi */

        case 6:
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 12134; /* *aarch64_sve2_bsl1nvnx4si */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12135; /* *aarch64_sve2_bsl1nvnx4si */

        case 7:
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 12136; /* *aarch64_sve2_bsl1nvnx2di */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1787 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12137; /* *aarch64_sve2_bsl1nvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != FLOAT_EXTEND)
    return -1;
  x4 = XEXP (x2, 2);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case VEC_SELECT:
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x6, 1);
      operands[4] = x8;
      x9 = XEXP (x3, 0);
      switch (pattern822 (x9))
        {
        case 0:
          if (pattern1077 (x2, 
E_V2SFmode, 
E_V4HFmode, 
E_V2HFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[4], E_V4HFmode)
              && vect_par_cnst_lo_half (operands[5], E_V4HFmode)
              && 
#line 9371 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
            return 5261; /* aarch64_simd_fmlal_lowv2sf */
          if (!vect_par_cnst_hi_half (operands[4], E_V4HFmode)
              || !vect_par_cnst_hi_half (operands[5], E_V4HFmode)
              || !
#line 9406 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
            return -1;
          return 5265; /* aarch64_simd_fmlal_highv2sf */

        case 1:
          if (pattern1077 (x2, 
E_V4SFmode, 
E_V8HFmode, 
E_V4HFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[4], E_V8HFmode)
              && vect_par_cnst_lo_half (operands[5], E_V8HFmode)
              && 
#line 9371 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
            return 5262; /* aarch64_simd_fmlalq_lowv4sf */
          if (!vect_par_cnst_hi_half (operands[4], E_V8HFmode)
              || !vect_par_cnst_hi_half (operands[5], E_V8HFmode)
              || !
#line 9406 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
            return -1;
          return 5266; /* aarch64_simd_fmlalq_highv4sf */

        case 2:
          if (pattern1236 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V4HFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[4], E_V4HFmode))
            {
              switch (pattern1352 ())
                {
                case 0:
                  if (
#line 9483 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                    return 5269; /* aarch64_simd_fmlal_lane_lowv2sf */
                  break;

                case 1:
                  if (
#line 9713 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                    return 5277; /* aarch64_simd_fmlal_laneq_lowv2sf */
                  break;

                default:
                  break;
                }
            }
          if (!vect_par_cnst_hi_half (operands[4], E_V4HFmode))
            return -1;
          switch (pattern1352 ())
            {
            case 0:
              if (!
#line 9520 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                return -1;
              return 5271; /* aarch64_simd_fmlal_lane_highv2sf */

            case 1:
              if (!
#line 9750 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                return -1;
              return 5279; /* aarch64_simd_fmlal_laneq_highv2sf */

            default:
              return -1;
            }

        case 3:
          if (pattern1236 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[4], E_V8HFmode))
            {
              switch (pattern1353 ())
                {
                case 0:
                  if (
#line 9597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                    return 5273; /* aarch64_simd_fmlalq_laneq_lowv4sf */
                  break;

                case 1:
                  if (
#line 9827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                    return 5281; /* aarch64_simd_fmlalq_lane_lowv4sf */
                  break;

                default:
                  break;
                }
            }
          if (!vect_par_cnst_hi_half (operands[4], E_V8HFmode))
            return -1;
          switch (pattern1353 ())
            {
            case 0:
              if (!
#line 9634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                return -1;
              return 5275; /* aarch64_simd_fmlalq_laneq_highv4sf */

            case 1:
              if (!
#line 9864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                return -1;
              return 5283; /* aarch64_simd_fmlalq_lane_highv4sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != VEC_SELECT)
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      x11 = XEXP (x7, 1);
      operands[4] = x11;
      x9 = XEXP (x3, 0);
      switch (pattern822 (x9))
        {
        case 0:
          if (pattern1145 (x2, 
E_V2SFmode, 
E_V4HFmode, 
E_V2HFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[4], E_V4HFmode)
              && vect_par_cnst_lo_half (operands[5], E_V4HFmode)
              && 
#line 9389 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
            return 5263; /* aarch64_simd_fmlsl_lowv2sf */
          if (!vect_par_cnst_hi_half (operands[4], E_V4HFmode)
              || !vect_par_cnst_hi_half (operands[5], E_V4HFmode)
              || !
#line 9424 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
            return -1;
          return 5267; /* aarch64_simd_fmlsl_highv2sf */

        case 1:
          if (pattern1145 (x2, 
E_V4SFmode, 
E_V8HFmode, 
E_V4HFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[4], E_V8HFmode)
              && vect_par_cnst_lo_half (operands[5], E_V8HFmode)
              && 
#line 9389 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
            return 5264; /* aarch64_simd_fmlslq_lowv4sf */
          if (!vect_par_cnst_hi_half (operands[4], E_V8HFmode)
              || !vect_par_cnst_hi_half (operands[5], E_V8HFmode)
              || !
#line 9424 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
            return -1;
          return 5268; /* aarch64_simd_fmlslq_highv4sf */

        case 2:
          if (pattern1264 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V4HFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[4], E_V4HFmode))
            {
              switch (pattern1352 ())
                {
                case 0:
                  if (
#line 9502 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                    return 5270; /* aarch64_simd_fmlsl_lane_lowv2sf */
                  break;

                case 1:
                  if (
#line 9732 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                    return 5278; /* aarch64_simd_fmlsl_laneq_lowv2sf */
                  break;

                default:
                  break;
                }
            }
          if (!vect_par_cnst_hi_half (operands[4], E_V4HFmode))
            return -1;
          switch (pattern1352 ())
            {
            case 0:
              if (!
#line 9539 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                return -1;
              return 5272; /* aarch64_simd_fmlsl_lane_highv2sf */

            case 1:
              if (!
#line 9769 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                return -1;
              return 5280; /* aarch64_simd_fmlsl_laneq_highv2sf */

            default:
              return -1;
            }

        case 3:
          if (pattern1264 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[4], E_V8HFmode))
            {
              switch (pattern1353 ())
                {
                case 0:
                  if (
#line 9616 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                    return 5274; /* aarch64_simd_fmlslq_laneq_lowv4sf */
                  break;

                case 1:
                  if (
#line 9846 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                    return 5282; /* aarch64_simd_fmlslq_lane_lowv4sf */
                  break;

                default:
                  break;
                }
            }
          if (!vect_par_cnst_hi_half (operands[4], E_V8HFmode))
            return -1;
          switch (pattern1353 ())
            {
            case 0:
              if (!
#line 9653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                return -1;
              return 5276; /* aarch64_simd_fmlslq_laneq_highv4sf */

            case 1:
              if (!
#line 9883 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_F16FML))
                return -1;
              return 5284; /* aarch64_simd_fmlslq_lane_highv4sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 405:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 1444; /* aarch64_fcadd90v4hf_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
            return -1;
          return 1452; /* aarch64_fcadd90v2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 406:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 1447; /* aarch64_fcadd270v4hf_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
            return -1;
          return 1455; /* aarch64_fcadd270v2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 186:
      switch (pattern767 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1416 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2000; /* aarch64_simd_reg_shlv8qi_unsigned_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1416 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2004; /* aarch64_simd_reg_shlv4hi_unsigned_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1416 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2008; /* aarch64_simd_reg_shlv2si_unsigned_vec_concatz_be */

        default:
          return -1;
        }

    case 185:
      switch (pattern767 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2013; /* aarch64_simd_reg_shlv8qi_signed_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2017; /* aarch64_simd_reg_shlv4hi_signed_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1426 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2021; /* aarch64_simd_reg_shlv2si_signed_vec_concatz_be */

        default:
          return -1;
        }

    case 274:
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern1017 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2026; /* vec_shr_v8qi_vec_concatz_be */

        case E_V8HImode:
          if (pattern1017 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2029; /* vec_shr_v4hi_vec_concatz_be */

        case E_V8HFmode:
          if (pattern1017 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2032; /* vec_shr_v4hf_vec_concatz_be */

        case E_V4SImode:
          if (pattern1017 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2035; /* vec_shr_v2si_vec_concatz_be */

        case E_V4SFmode:
          if (pattern1017 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2038; /* vec_shr_v2sf_vec_concatz_be */

        case E_V8BFmode:
          if (pattern1017 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1608 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2041; /* vec_shr_v4bf_vec_concatz_be */

        default:
          return -1;
        }

    case 208:
      switch (pattern767 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2164; /* aarch64_umaxpv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2180; /* aarch64_umaxpv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2196; /* aarch64_umaxpv2si_vec_concatz_be */

        default:
          return -1;
        }

    case 209:
      switch (pattern767 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2167; /* aarch64_uminpv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2183; /* aarch64_uminpv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2199; /* aarch64_uminpv2si_vec_concatz_be */

        default:
          return -1;
        }

    case 206:
      switch (pattern767 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2170; /* aarch64_smaxpv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2186; /* aarch64_smaxpv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2202; /* aarch64_smaxpv2si_vec_concatz_be */

        default:
          return -1;
        }

    case 207:
      switch (pattern767 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2173; /* aarch64_sminpv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2189; /* aarch64_sminpv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1820 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2205; /* aarch64_sminpv2si_vec_concatz_be */

        default:
          return -1;
        }

    case 198:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2212; /* aarch64_smax_nanpv4hf_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2228; /* aarch64_smax_nanpv2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 201:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2215; /* aarch64_smin_nanpv4hf_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2231; /* aarch64_smin_nanpv2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 197:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2218; /* aarch64_smaxpv4hf_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2234; /* aarch64_smaxpv2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 200:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2221; /* aarch64_sminpv4hf_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1831 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2237; /* aarch64_sminpv2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 196:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2724; /* fmax_nanv4hf3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2740; /* fmax_nanv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case 199:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2727; /* fmin_nanv4hf3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2743; /* fmin_nanv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case 277:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2730; /* fmaxv4hf3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2746; /* fmaxv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case 278:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2733; /* fminv4hf3_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2749; /* fminv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case 202:
      switch (pattern766 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3393 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2760; /* aarch64_faddpv4hf_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3393 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2764; /* aarch64_faddpv2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 221:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3357; /* aarch64_suqaddv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3365; /* aarch64_suqaddv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3373; /* aarch64_suqaddv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3389; /* aarch64_suqadddi_vec_concatz_be */

        default:
          return -1;
        }

    case 220:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3360; /* aarch64_usqaddv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3368; /* aarch64_usqaddv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3376; /* aarch64_usqaddv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3392; /* aarch64_usqadddi_vec_concatz_be */

        default:
          return -1;
        }

    case 216:
      switch (pattern770 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5605 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3487; /* aarch64_sqdmulhv4hi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5605 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3495; /* aarch64_sqdmulhv2si_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5617 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3507; /* aarch64_sqdmulh_nv4hi_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5617 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3515; /* aarch64_sqdmulh_nv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5632 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3523; /* aarch64_sqdmulh_lanev4hi_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5647 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3539; /* aarch64_sqdmulh_laneqv4hi_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5632 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3531; /* aarch64_sqdmulh_lanev2si_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5647 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3547; /* aarch64_sqdmulh_laneqv2si_vec_concatz_be */

        default:
          return -1;
        }

    case 217:
      switch (pattern770 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5605 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3490; /* aarch64_sqrdmulhv4hi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5605 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3498; /* aarch64_sqrdmulhv2si_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5617 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3510; /* aarch64_sqrdmulh_nv4hi_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5617 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3518; /* aarch64_sqrdmulh_nv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5632 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3526; /* aarch64_sqrdmulh_lanev4hi_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5647 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3542; /* aarch64_sqrdmulh_laneqv4hi_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5632 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3534; /* aarch64_sqrdmulh_lanev2si_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5647 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3550; /* aarch64_sqrdmulh_laneqv2si_vec_concatz_be */

        default:
          return -1;
        }

    case 229:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3689; /* aarch64_sshlv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3705; /* aarch64_sshlv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3721; /* aarch64_sshlv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3741; /* aarch64_sshldi_vec_concatz_be */

        default:
          return -1;
        }

    case 230:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3692; /* aarch64_ushlv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3708; /* aarch64_ushlv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3724; /* aarch64_ushlv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3744; /* aarch64_ushldi_vec_concatz_be */

        default:
          return -1;
        }

    case 231:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3695; /* aarch64_srshlv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3711; /* aarch64_srshlv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3727; /* aarch64_srshlv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3747; /* aarch64_srshldi_vec_concatz_be */

        default:
          return -1;
        }

    case 232:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3698; /* aarch64_urshlv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3714; /* aarch64_urshlv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3730; /* aarch64_urshlv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3750; /* aarch64_urshldi_vec_concatz_be */

        default:
          return -1;
        }

    case 227:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3753; /* aarch64_sqshlv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3769; /* aarch64_sqshlv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3785; /* aarch64_sqshlv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3817; /* aarch64_sqshldi_vec_concatz_be */

        default:
          return -1;
        }

    case 228:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3756; /* aarch64_uqshlv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3772; /* aarch64_uqshlv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3788; /* aarch64_uqshlv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3820; /* aarch64_uqshldi_vec_concatz_be */

        default:
          return -1;
        }

    case 233:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3759; /* aarch64_sqrshlv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3775; /* aarch64_sqrshlv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3791; /* aarch64_sqrshlv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3823; /* aarch64_sqrshldi_vec_concatz_be */

        default:
          return -1;
        }

    case 234:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3762; /* aarch64_uqrshlv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3778; /* aarch64_uqrshlv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3794; /* aarch64_uqrshlv2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6571 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3826; /* aarch64_uqrshldi_vec_concatz_be */

        default:
          return -1;
        }

    case 247:
      switch (pattern771 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4891; /* aarch64_zip1v8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4915; /* aarch64_zip1v4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4939; /* aarch64_zip1v2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4969; /* aarch64_zip1v4hf_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4993; /* aarch64_zip1v4bf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5017; /* aarch64_zip1v2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 248:
      switch (pattern771 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4894; /* aarch64_zip2v8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4918; /* aarch64_zip2v4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4942; /* aarch64_zip2v2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4972; /* aarch64_zip2v4hf_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4996; /* aarch64_zip2v4bf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5020; /* aarch64_zip2v2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 251:
      switch (pattern771 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4897; /* aarch64_trn1v8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4921; /* aarch64_trn1v4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4945; /* aarch64_trn1v2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4975; /* aarch64_trn1v4hf_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4999; /* aarch64_trn1v4bf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5023; /* aarch64_trn1v2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 252:
      switch (pattern771 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4900; /* aarch64_trn2v8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4924; /* aarch64_trn2v4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4948; /* aarch64_trn2v2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4978; /* aarch64_trn2v4hf_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5002; /* aarch64_trn2v4bf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5026; /* aarch64_trn2v2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 249:
      switch (pattern771 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4903; /* aarch64_uzp1v8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4927; /* aarch64_uzp1v4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4951; /* aarch64_uzp1v2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4981; /* aarch64_uzp1v4hf_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5005; /* aarch64_uzp1v4bf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5029; /* aarch64_uzp1v2sf_vec_concatz_be */

        default:
          return -1;
        }

    case 250:
      switch (pattern771 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4906; /* aarch64_uzp2v8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4930; /* aarch64_uzp2v4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4954; /* aarch64_uzp2v2si_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4984; /* aarch64_uzp2v4hf_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5008; /* aarch64_uzp2v4bf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8684 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5032; /* aarch64_uzp2v2sf_vec_concatz_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          switch (pattern559 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3403; /* aarch64_uqmovnv8hi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3409; /* aarch64_uqmovnv4si_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3415; /* aarch64_uqmovnv2di_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern557 (x2))
            {
            case 0:
              if (!
#line 5472 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3424; /* aarch64_uqxtn2v8hi_be */

            case 1:
              if (!
#line 5472 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3426; /* aarch64_uqxtn2v4si_be */

            case 2:
              if (!
#line 5472 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3428; /* aarch64_uqxtn2v2di_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          switch (pattern435 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3951; /* *aarch64_uqsshrn_nv8hi_insn_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3969; /* *aarch64_uqsshrn_nv4si_insn_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3987; /* *aarch64_uqsshrn_nv2di_insn_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern436 (x2))
            {
            case 0:
              if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4075; /* aarch64_uqsshrn2_nv8hi_insn_be */

            case 1:
              if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4081; /* aarch64_uqsshrn2_nv4si_insn_be */

            case 2:
              if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4087; /* aarch64_uqsshrn2_nv2di_insn_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern444 (x2, 
ZERO_EXTEND))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT))))
            return -1;
          return 3954; /* *aarch64_uqshrn_nv8hi_insn_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT))))
            return -1;
          return 3972; /* *aarch64_uqshrn_nv4si_insn_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT))))
            return -1;
          return 3990; /* *aarch64_uqshrn_nv2di_insn_vec_concatz_le */

        case 3:
          if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
            return -1;
          return 4076; /* aarch64_uqushrn2_nv8hi_insn_be */

        case 4:
          if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
            return -1;
          return 4082; /* aarch64_uqushrn2_nv4si_insn_be */

        case 5:
          if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
            return -1;
          return 4088; /* aarch64_uqushrn2_nv2di_insn_be */

        case 6:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
            return -1;
          return 4002; /* *aarch64_uqrshrn_nv8hi_insn_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
            return -1;
          return 4011; /* *aarch64_uqrshrn_nv4si_insn_vec_concatz_le */

        case 8:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
            return -1;
          return 4020; /* *aarch64_uqrshrn_nv2di_insn_vec_concatz_le */

        case 9:
          if (!
#line 7061 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
            return -1;
          return 4101; /* aarch64_uqrshrn2_nv8hi_insn_be */

        case 10:
          if (!
#line 7061 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
            return -1;
          return 4104; /* aarch64_uqrshrn2_nv4si_insn_be */

        case 11:
          if (!
#line 7061 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
            return -1;
          return 4107; /* aarch64_uqrshrn2_nv2di_insn_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_508 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_453 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_458 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_455 (x1, insn, pnum_clobbers);

    case NEG:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 394; /* *negsi2_uxtw */

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!aarch64_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 413; /* *neg_lsl_si2_uxtw */

        case ASHIFTRT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!aarch64_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 414; /* *neg_asr_si2_uxtw */

        case LSHIFTRT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!aarch64_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 415; /* *neg_lsr_si2_uxtw */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[1] = x5;
          if (!aarch64_comparison_operator_mode (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return -1;
          return 496; /* *cstoresi_neg_uxtw */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 419; /* *mulsi3_uxtw */

        case NEG:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 428; /* *mulsi_neg_uxtw */

        default:
          return -1;
        }

    case DIV:
      if (pattern27 (x1) != 0)
        return -1;
      return 443; /* *divsi3_uxtw */

    case UDIV:
      if (pattern27 (x1) != 0)
        return -1;
      return 444; /* *udivsi3_uxtw */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      if (!aarch64_comparison_operator_mode (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      return 491; /* *cstoresi_insn_uxtw */

    case IF_THEN_ELSE:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[1] = x5;
          if (aarch64_comparison_operator (operands[1], E_VOIDmode))
            {
              res = recog_452 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (!aarch64_comparison_operation (operands[1], E_VOIDmode))
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x3, 2);
          operands[3] = x9;
          if (!aarch64_reg_or_zero (operands[3], E_SImode))
            return -1;
          switch (GET_CODE (x8))
            {
            case NEG:
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              return 521; /* *csneg3_uxtw_insn4 */

            case NOT:
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              return 522; /* *csinv3_uxtw_insn4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_457 (x1, insn, pnum_clobbers);

    case AND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!aarch64_logical_operand (operands[2], E_SImode))
            return -1;
          return 552; /* *andsi3_uxtw */

        case ASHIFT:
          if (pattern736 (x3) != 0)
            return -1;
          return 603; /* *and_ashlsi3_uxtw */

        case ASHIFTRT:
          if (pattern736 (x3) != 0)
            return -1;
          return 606; /* *and_ashrsi3_uxtw */

        case LSHIFTRT:
          if (pattern736 (x3) != 0)
            return -1;
          return 609; /* *and_lshrsi3_uxtw */

        case ROTATERT:
          if (pattern736 (x3) != 0)
            return -1;
          return 612; /* *and_rotrsi3_uxtw */

        case ROTATE:
          if (pattern736 (x3) != 0)
            return -1;
          return 615; /* *and_rotlsi3_uxtw */

        case NOT:
          switch (pattern740 (x3))
            {
            case 0:
              return 635; /* *andnsidi3_ze */

            case 1:
              return 675; /* and_one_cmpl_ashlsidi_uxtw */

            case 2:
              return 678; /* and_one_cmpl_ashrsidi_uxtw */

            case 3:
              return 681; /* and_one_cmpl_lshrsidi_uxtw */

            case 4:
              return 684; /* and_one_cmpl_rotrsidi_uxtw */

            case 5:
              return 687; /* and_one_cmpl_rotlsidi_uxtw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!aarch64_logical_operand (operands[2], E_SImode))
            return -1;
          return 553; /* *iorsi3_uxtw */

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          switch (pattern810 (x3))
            {
            case 0:
              return 604; /* *ior_ashlsi3_uxtw */

            case 1:
              if (!
#line 6398 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)))
                return -1;
              return 832; /* *extrsi5_insn_uxtw */

            default:
              return -1;
            }

        case ASHIFTRT:
          if (pattern736 (x3) != 0)
            return -1;
          return 607; /* *ior_ashrsi3_uxtw */

        case LSHIFTRT:
          switch (pattern737 (x3))
            {
            case 0:
              return 610; /* *ior_lshrsi3_uxtw */

            case 1:
              if (!
#line 6412 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)))
                return -1;
              return 835; /* *extrsi5_insn_uxtw_alt */

            default:
              return -1;
            }

        case ROTATERT:
          if (pattern736 (x3) != 0)
            return -1;
          return 613; /* *ior_rotrsi3_uxtw */

        case ROTATE:
          if (pattern736 (x3) != 0)
            return -1;
          return 616; /* *ior_rotlsi3_uxtw */

        case NOT:
          switch (pattern740 (x3))
            {
            case 0:
              return 636; /* *iornsidi3_ze */

            case 1:
              return 676; /* ior_one_cmpl_ashlsidi_uxtw */

            case 2:
              return 679; /* ior_one_cmpl_ashrsidi_uxtw */

            case 3:
              return 682; /* ior_one_cmpl_lshrsidi_uxtw */

            case 4:
              return 685; /* ior_one_cmpl_rotrsidi_uxtw */

            case 5:
              return 688; /* ior_one_cmpl_rotlsidi_uxtw */

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != AND
              || GET_MODE (x8) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x8, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_SImode)
              || !
#line 6913 "../../gcc/config/aarch64/aarch64.md"
((INTVAL (operands[3]) == ~INTVAL (operands[4]))
  && (aarch64_high_bits_all_ones_p (INTVAL (operands[3]))
    || aarch64_high_bits_all_ones_p (INTVAL (operands[4])))))
            return -1;
          return 931; /* *aarch64_bfxilsi_uxtw */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 620; /* *one_cmpl_zero_extend */

        case XOR:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 1);
          if (!register_operand (x7, E_SImode))
            return -1;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              operands[2] = x7;
              return 637; /* *xor_one_cmplsidi3_ze */

            case ASHIFT:
              if (GET_MODE (x6) != E_SImode)
                return -1;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x6, 1);
              operands[2] = x13;
              if (!aarch64_shift_imm_si (operands[2], E_QImode))
                return -1;
              operands[3] = x7;
              return 700; /* *eor_one_cmpl_ashlsidi3_alt_ze */

            case ASHIFTRT:
              if (GET_MODE (x6) != E_SImode)
                return -1;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x6, 1);
              operands[2] = x13;
              if (!aarch64_shift_imm_si (operands[2], E_QImode))
                return -1;
              operands[3] = x7;
              return 701; /* *eor_one_cmpl_ashrsidi3_alt_ze */

            case LSHIFTRT:
              if (GET_MODE (x6) != E_SImode)
                return -1;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x6, 1);
              operands[2] = x13;
              if (!aarch64_shift_imm_si (operands[2], E_QImode))
                return -1;
              operands[3] = x7;
              return 702; /* *eor_one_cmpl_lshrsidi3_alt_ze */

            case ROTATERT:
              if (GET_MODE (x6) != E_SImode)
                return -1;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x6, 1);
              operands[2] = x13;
              if (!aarch64_shift_imm_si (operands[2], E_QImode))
                return -1;
              operands[3] = x7;
              return 703; /* *eor_one_cmpl_rotrsidi3_alt_ze */

            case ROTATE:
              if (GET_MODE (x6) != E_SImode)
                return -1;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x6, 1);
              operands[2] = x13;
              if (!aarch64_shift_imm_si (operands[2], E_QImode))
                return -1;
              operands[3] = x7;
              return 704; /* *eor_one_cmpl_rotlsidi3_alt_ze */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern28 (x1))
        {
        case 0:
          return 808; /* *ashlsi3_insn_uxtw */

        case 1:
          if (!
#line 6439 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 843; /* *zero_extenddi_ashlqi */

        case 2:
          if (!
#line 6439 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 847; /* *zero_extenddi_ashlhi */

        case 3:
          if (!
#line 6439 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 841; /* *zero_extendsi_ashlqi */

        case 4:
          if (!
#line 6439 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 845; /* *zero_extendsi_ashlhi */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!aarch64_reg_or_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 809; /* *ashrsi3_insn_uxtw */

    case LSHIFTRT:
      switch (pattern28 (x1))
        {
        case 0:
          return 810; /* *lshrsi3_insn_uxtw */

        case 1:
          if (!
#line 6452 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 849; /* *zero_extenddi_lshrqi */

        case 2:
          if (!
#line 6452 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 851; /* *zero_extenddi_lshrhi */

        case 3:
          if (!
#line 6452 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 848; /* *zero_extendsi_lshrqi */

        case 4:
          if (!
#line 6452 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 850; /* *zero_extendsi_lshrhi */

        default:
          return -1;
        }

    case ROTATERT:
      if (pattern29 (x1) != 0
          || !
#line 6329 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
        return -1;
      return 811; /* *rorsi3_insn_uxtw */

    case ROTATE:
      if (pattern29 (x1) != 0
          || !
#line 6340 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
        return -1;
      return 812; /* *rolsi3_insn_uxtw */

    case BSWAP:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 937; /* *bswapsi2_uxtw */

    case UNSIGNED_FIX:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 7227 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1057; /* *fix_to_zero_extendsfdi2 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 7227 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1058; /* *fix_to_zero_extenddfdi2 */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x2) != E_TImode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_TImode)
          || !
#line 7790 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
        return -1;
      return 1166; /* aarch64_movtilow_tilow */

    case UNSPEC:
      return recog_454 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != PARALLEL)
        return -1;
      operands[2] = x8;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern365 (x2, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) == 0
              && 
#line 1988 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2271; /* aarch64_simd_vec_unpacku_hi_v16qi */
          break;

        case E_V4SImode:
          if (pattern365 (x2, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) == 0
              && 
#line 1988 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2273; /* aarch64_simd_vec_unpacku_hi_v8hi */
          break;

        case E_V2DImode:
          if (pattern365 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) == 0
              && 
#line 1988 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2275; /* aarch64_simd_vec_unpacku_hi_v4si */
          break;

        default:
          break;
        }
      if (XVECLEN (x8, 0) != 1)
        return -1;
      operands[0] = x4;
      switch (pattern492 (x2))
        {
        case 0:
          if (!
#line 4264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2968; /* *aarch64_get_lane_zero_extendsiv8qi */

        case 1:
          if (!
#line 4264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2970; /* *aarch64_get_lane_zero_extendsiv16qi */

        case 2:
          if (!
#line 4264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2972; /* *aarch64_get_lane_zero_extendsiv4hi */

        case 3:
          if (!
#line 4264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2974; /* *aarch64_get_lane_zero_extendsiv8hi */

        case 4:
          if (!
#line 4264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2969; /* *aarch64_get_lane_zero_extenddiv8qi */

        case 5:
          if (!
#line 4264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2971; /* *aarch64_get_lane_zero_extenddiv16qi */

        case 6:
          if (!
#line 4264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2973; /* *aarch64_get_lane_zero_extenddiv4hi */

        case 7:
          if (!
#line 4264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2975; /* *aarch64_get_lane_zero_extenddiv8hi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_456 (x1, insn, pnum_clobbers);

    case US_PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern603 (x2))
        {
        case 0:
          if (!
#line 10691 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11189; /* aarch64_sve_uqincsi_pat */

        case 1:
          if (!
#line 11045 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11235; /* *aarch64_sve_uqincsivnx16bi_cntp */

        case 2:
          if (!
#line 11045 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11237; /* *aarch64_sve_uqincsivnx8bi_cntp */

        case 3:
          if (!
#line 11045 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11239; /* *aarch64_sve_uqincsivnx4bi_cntp */

        case 4:
          if (!
#line 11045 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11241; /* *aarch64_sve_uqincsivnx2bi_cntp */

        default:
          return -1;
        }

    case US_MINUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern605 (x2))
        {
        case 0:
          if (!
#line 10841 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11204; /* aarch64_sve_uqdecsi_pat */

        case 1:
          if (!
#line 11278 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11268; /* *aarch64_sve_uqdecsivnx16bi_cntp */

        case 2:
          if (!
#line 11278 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11270; /* *aarch64_sve_uqdecsivnx8bi_cntp */

        case 3:
          if (!
#line 11278 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11272; /* *aarch64_sve_uqdecsivnx4bi_cntp */

        case 4:
          if (!
#line 11278 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11274; /* *aarch64_sve_uqdecsivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_517 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 2);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case VEC_DUPLICATE:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern915 (x3, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1857; /* aarch64_simd_vec_setv8qi */

            case E_V16QImode:
              if (pattern915 (x3, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1858; /* aarch64_simd_vec_setv16qi */

            case E_V4HImode:
              if (pattern915 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1859; /* aarch64_simd_vec_setv4hi */

            case E_V8HImode:
              if (pattern915 (x3, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1860; /* aarch64_simd_vec_setv8hi */

            case E_V2SImode:
              if (pattern915 (x3, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1861; /* aarch64_simd_vec_setv2si */

            case E_V4SImode:
              if (pattern915 (x3, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1862; /* aarch64_simd_vec_setv4si */

            case E_V2DImode:
              if (pattern915 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1863; /* aarch64_simd_vec_setv2di */

            case E_V4HFmode:
              if (pattern915 (x3, 
E_V4HFmode, 
E_HFmode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1864; /* aarch64_simd_vec_setv4hf */

            case E_V8HFmode:
              if (pattern915 (x3, 
E_V8HFmode, 
E_HFmode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1865; /* aarch64_simd_vec_setv8hf */

            case E_V4BFmode:
              if (pattern915 (x3, 
E_V4BFmode, 
E_BFmode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1866; /* aarch64_simd_vec_setv4bf */

            case E_V8BFmode:
              if (pattern915 (x3, 
E_V8BFmode, 
E_BFmode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1867; /* aarch64_simd_vec_setv8bf */

            case E_V2SFmode:
              if (pattern915 (x3, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1868; /* aarch64_simd_vec_setv2sf */

            case E_V4SFmode:
              if (pattern915 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1869; /* aarch64_simd_vec_setv4sf */

            case E_V2DFmode:
              if (pattern915 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 1174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1870; /* aarch64_simd_vec_setv2df */

            default:
              return -1;
            }

        case VEC_SELECT:
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 1)
            return -1;
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          x10 = XVECEXP (x8, 0, 0);
          operands[4] = x10;
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern1149 (x3, 
E_V8QImode, 
E_QImode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V8QImode:
                  if (!register_operand (operands[3], E_V8QImode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1885; /* aarch64_simd_vec_copy_lanev8qi */

                case E_V16QImode:
                  if (!register_operand (operands[3], E_V16QImode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1899; /* aarch64_simd_vec_copy_lane_to_128v8qi */

                default:
                  return -1;
                }

            case E_V16QImode:
              if (pattern1149 (x3, 
E_V16QImode, 
E_QImode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[3], E_V16QImode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1886; /* aarch64_simd_vec_copy_lanev16qi */

                case E_V8QImode:
                  if (!register_operand (operands[3], E_V8QImode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1900; /* aarch64_simd_vec_copy_lane_to_64v16qi */

                default:
                  return -1;
                }

            case E_V4HImode:
              if (pattern1149 (x3, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V4HImode:
                  if (!register_operand (operands[3], E_V4HImode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1887; /* aarch64_simd_vec_copy_lanev4hi */

                case E_V8HImode:
                  if (!register_operand (operands[3], E_V8HImode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1901; /* aarch64_simd_vec_copy_lane_to_128v4hi */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern1149 (x3, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[3], E_V8HImode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1888; /* aarch64_simd_vec_copy_lanev8hi */

                case E_V4HImode:
                  if (!register_operand (operands[3], E_V4HImode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1902; /* aarch64_simd_vec_copy_lane_to_64v8hi */

                default:
                  return -1;
                }

            case E_V2SImode:
              if (pattern1149 (x3, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V2SImode:
                  if (!register_operand (operands[3], E_V2SImode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1889; /* aarch64_simd_vec_copy_lanev2si */

                case E_V4SImode:
                  if (!register_operand (operands[3], E_V4SImode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1903; /* aarch64_simd_vec_copy_lane_to_128v2si */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (pattern1149 (x3, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[3], E_V4SImode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1890; /* aarch64_simd_vec_copy_lanev4si */

                case E_V2SImode:
                  if (!register_operand (operands[3], E_V2SImode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1904; /* aarch64_simd_vec_copy_lane_to_64v4si */

                default:
                  return -1;
                }

            case E_V2DImode:
              if (pattern1150 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1891; /* aarch64_simd_vec_copy_lanev2di */

            case E_V4HFmode:
              if (pattern1149 (x3, 
E_V4HFmode, 
E_HFmode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V4HFmode:
                  if (!register_operand (operands[3], E_V4HFmode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1892; /* aarch64_simd_vec_copy_lanev4hf */

                case E_V8HFmode:
                  if (!register_operand (operands[3], E_V8HFmode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1905; /* aarch64_simd_vec_copy_lane_to_128v4hf */

                default:
                  return -1;
                }

            case E_V8HFmode:
              if (pattern1149 (x3, 
E_V8HFmode, 
E_HFmode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V8HFmode:
                  if (!register_operand (operands[3], E_V8HFmode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1893; /* aarch64_simd_vec_copy_lanev8hf */

                case E_V4HFmode:
                  if (!register_operand (operands[3], E_V4HFmode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1906; /* aarch64_simd_vec_copy_lane_to_64v8hf */

                default:
                  return -1;
                }

            case E_V4BFmode:
              if (pattern1150 (x3, 
E_V4BFmode, 
E_BFmode) != 0
                  || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1894; /* aarch64_simd_vec_copy_lanev4bf */

            case E_V8BFmode:
              if (pattern1150 (x3, 
E_V8BFmode, 
E_BFmode) != 0
                  || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1895; /* aarch64_simd_vec_copy_lanev8bf */

            case E_V2SFmode:
              if (pattern1149 (x3, 
E_V2SFmode, 
E_SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V2SFmode:
                  if (!register_operand (operands[3], E_V2SFmode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1896; /* aarch64_simd_vec_copy_lanev2sf */

                case E_V4SFmode:
                  if (!register_operand (operands[3], E_V4SFmode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1907; /* aarch64_simd_vec_copy_lane_to_128v2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (pattern1149 (x3, 
E_V4SFmode, 
E_SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V4SFmode:
                  if (!register_operand (operands[3], E_V4SFmode)
                      || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1897; /* aarch64_simd_vec_copy_lanev4sf */

                case E_V2SFmode:
                  if (!register_operand (operands[3], E_V2SFmode)
                      || !
#line 1240 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                    return -1;
                  return 1908; /* aarch64_simd_vec_copy_lane_to_64v4sf */

                default:
                  return -1;
                }

            case E_V2DFmode:
              if (pattern1150 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 1219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && exact_log2 (INTVAL (operands[2])) >= 0))
                return -1;
              return 1898; /* aarch64_simd_vec_copy_lanev2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern844 (x3, 
E_V8QImode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (8, operands[2]) >= 0))
            return -1;
          return 1871; /* aarch64_simd_vec_set_zerov8qi */

        case E_V16QImode:
          if (pattern844 (x3, 
E_V16QImode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (16, operands[2]) >= 0))
            return -1;
          return 1872; /* aarch64_simd_vec_set_zerov16qi */

        case E_V4HImode:
          if (pattern844 (x3, 
E_V4HImode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (4, operands[2]) >= 0))
            return -1;
          return 1873; /* aarch64_simd_vec_set_zerov4hi */

        case E_V8HImode:
          if (pattern844 (x3, 
E_V8HImode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (8, operands[2]) >= 0))
            return -1;
          return 1874; /* aarch64_simd_vec_set_zerov8hi */

        case E_V2SImode:
          if (pattern844 (x3, 
E_V2SImode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (2, operands[2]) >= 0))
            return -1;
          return 1875; /* aarch64_simd_vec_set_zerov2si */

        case E_V4SImode:
          if (pattern844 (x3, 
E_V4SImode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (4, operands[2]) >= 0))
            return -1;
          return 1876; /* aarch64_simd_vec_set_zerov4si */

        case E_V2DImode:
          if (pattern844 (x3, 
E_V2DImode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (2, operands[2]) >= 0))
            return -1;
          return 1877; /* aarch64_simd_vec_set_zerov2di */

        case E_V4HFmode:
          if (pattern844 (x3, 
E_V4HFmode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (4, operands[2]) >= 0))
            return -1;
          return 1878; /* aarch64_simd_vec_set_zerov4hf */

        case E_V8HFmode:
          if (pattern844 (x3, 
E_V8HFmode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (8, operands[2]) >= 0))
            return -1;
          return 1879; /* aarch64_simd_vec_set_zerov8hf */

        case E_V4BFmode:
          if (pattern844 (x3, 
E_V4BFmode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (4, operands[2]) >= 0))
            return -1;
          return 1880; /* aarch64_simd_vec_set_zerov4bf */

        case E_V8BFmode:
          if (pattern844 (x3, 
E_V8BFmode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (8, operands[2]) >= 0))
            return -1;
          return 1881; /* aarch64_simd_vec_set_zerov8bf */

        case E_V2SFmode:
          if (pattern844 (x3, 
E_V2SFmode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (2, operands[2]) >= 0))
            return -1;
          return 1882; /* aarch64_simd_vec_set_zerov2sf */

        case E_V4SFmode:
          if (pattern844 (x3, 
E_V4SFmode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (4, operands[2]) >= 0))
            return -1;
          return 1883; /* aarch64_simd_vec_set_zerov4sf */

        case E_V2DFmode:
          if (pattern844 (x3, 
E_V2DFmode) != 0
              || !
#line 1199 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && aarch64_exact_log2_inverse (2, operands[2]) >= 0))
            return -1;
          return 1884; /* aarch64_simd_vec_set_zerov2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern9 (x1))
    {
    case 0:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 959; /* lbtrunchfsi2 */

    case 1:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 979; /* lbtruncsfsi2 */

    case 2:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 999; /* lbtruncdfsi2 */

    case 3:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 969; /* lbtrunchfdi2 */

    case 4:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 989; /* lbtruncsfdi2 */

    case 5:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1009; /* lbtruncdfdi2 */

    case 6:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2592; /* lbtruncv4hfv4hi2 */

    case 7:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2602; /* lbtruncv8hfv8hi2 */

    case 8:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2612; /* lbtruncv2sfv2si2 */

    case 9:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2622; /* lbtruncv4sfv4si2 */

    case 10:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2632; /* lbtruncv2dfv2di2 */

    case 11:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2642; /* lbtrunchfhi2 */

    case 12:
      if (!
#line 3075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2SFmode)))))
        return -1;
      return 2656; /* *aarch64_fcvtv2sfv2si2_mult */

    case 13:
      if (!
#line 3075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V4SFmode)))))
        return -1;
      return 2658; /* *aarch64_fcvtv4sfv4si2_mult */

    case 14:
      if (!
#line 3075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2DFmode)))))
        return -1;
      return 2660; /* *aarch64_fcvtv2dfv2di2_mult */

    case 15:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 960; /* lceilhfsi2 */

    case 16:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 980; /* lceilsfsi2 */

    case 17:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1000; /* lceildfsi2 */

    case 18:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 970; /* lceilhfdi2 */

    case 19:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 990; /* lceilsfdi2 */

    case 20:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1010; /* lceildfdi2 */

    case 21:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2593; /* lceilv4hfv4hi2 */

    case 22:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2603; /* lceilv8hfv8hi2 */

    case 23:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2613; /* lceilv2sfv2si2 */

    case 24:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2623; /* lceilv4sfv4si2 */

    case 25:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2633; /* lceilv2dfv2di2 */

    case 26:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2643; /* lceilhfhi2 */

    case 27:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 961; /* lfloorhfsi2 */

    case 28:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 981; /* lfloorsfsi2 */

    case 29:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1001; /* lfloordfsi2 */

    case 30:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 971; /* lfloorhfdi2 */

    case 31:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 991; /* lfloorsfdi2 */

    case 32:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1011; /* lfloordfdi2 */

    case 33:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2594; /* lfloorv4hfv4hi2 */

    case 34:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2604; /* lfloorv8hfv8hi2 */

    case 35:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2614; /* lfloorv2sfv2si2 */

    case 36:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2624; /* lfloorv4sfv4si2 */

    case 37:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2634; /* lfloorv2dfv2di2 */

    case 38:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2644; /* lfloorhfhi2 */

    case 39:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 962; /* lroundhfsi2 */

    case 40:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 982; /* lroundsfsi2 */

    case 41:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1002; /* lrounddfsi2 */

    case 42:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 972; /* lroundhfdi2 */

    case 43:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 992; /* lroundsfdi2 */

    case 44:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1012; /* lrounddfdi2 */

    case 45:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2595; /* lroundv4hfv4hi2 */

    case 46:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2605; /* lroundv8hfv8hi2 */

    case 47:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2615; /* lroundv2sfv2si2 */

    case 48:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2625; /* lroundv4sfv4si2 */

    case 49:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2635; /* lroundv2dfv2di2 */

    case 50:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2645; /* lroundhfhi2 */

    case 51:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 963; /* lfrintnhfsi2 */

    case 52:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 983; /* lfrintnsfsi2 */

    case 53:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1003; /* lfrintndfsi2 */

    case 54:
      if (!(
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 973; /* lfrintnhfdi2 */

    case 55:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 993; /* lfrintnsfdi2 */

    case 56:
      if (!
#line 7021 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1013; /* lfrintndfdi2 */

    case 57:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2596; /* lfrintnv4hfv4hi2 */

    case 58:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2606; /* lfrintnv8hfv8hi2 */

    case 59:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2616; /* lfrintnv2sfv2si2 */

    case 60:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2626; /* lfrintnv4sfv4si2 */

    case 61:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2636; /* lfrintnv2dfv2di2 */

    case 62:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2646; /* lfrintnhfhi2 */

    case 63:
      if (!
#line 7032 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1019; /* *aarch64_fcvtsfsi2_mult */

    case 64:
      if (!
#line 7032 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1023; /* *aarch64_fcvtdfsi2_mult */

    case 65:
      if (!
#line 7032 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 1021; /* *aarch64_fcvtsfdi2_mult */

    case 66:
      if (!
#line 7032 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 1025; /* *aarch64_fcvtdfdi2_mult */

    case 67:
      if (!
#line 7194 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1045; /* fix_truncsfsi2 */

    case 68:
      if (!
#line 7206 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1049; /* fix_trunchfsi2 */

    case 69:
      if (!
#line 7217 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1053; /* fix_truncdfsi2 */

    case 70:
      if (!
#line 7194 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1047; /* fix_truncdfdi2 */

    case 71:
      if (!
#line 7206 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1051; /* fix_trunchfdi2 */

    case 72:
      if (!
#line 7217 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1055; /* fix_truncsfdi2 */

    case 73:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2652; /* fix_trunchfhi2 */

    case 74:
      if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12817; /* fixvnx8sfvnx8si2 */

    case 75:
      if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12819; /* fixvnx16sfvnx16si2 */

    default:
      return -1;
    }
}

 int
recog_544 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 7167 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1042; /* truncdfsf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 7175 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1043; /* truncsfhf2 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 7183 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1044; /* truncdfhf2 */

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 3273 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2702; /* truncv2dfv2sf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 3273 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2705; /* truncv4sfv4hf2 */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x3) != E_VNx8BFmode
          || !aligned_register_operand (operands[1], E_VNx8SFmode)
          || !
#line 3352 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12805; /* truncvnx8sfvnx8bf2 */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !aligned_register_operand (operands[1], E_VNx8SFmode)
          || !
#line 3352 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12806; /* truncvnx8sfvnx8hf2 */

    default:
      return -1;
    }
}

 int
recog_551 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10182; /* *while_wrsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10192; /* *while_wrdivnx2bi_cc */
}

 int
recog_556 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10241; /* while_rwsivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10251; /* while_rwdivnx4bi_ptest */
}

 int
recog_561 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10141; /* *while_rwsivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10151; /* *while_rwdivnx8bi_cc */
}

 int
recog_569 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10140; /* *while_ugesivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10150; /* *while_ugedivnx8bi_cc */
}

 int
recog_578 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10119; /* *while_ugtsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10129; /* *while_ugtdivnx16bi_cc */
}

 int
recog_588 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10237; /* while_gesivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10247; /* while_gedivnx4bi_ptest */
}

 int
recog_598 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1337 (x1, 
GTU))
    {
    case 0:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9652; /* *cmphivnx16qi_cc */

    case 1:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9662; /* *cmphivnx8qi_cc */

    case 2:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9692; /* *cmphivnx8hi_cc */

    case 3:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9672; /* *cmphivnx4qi_cc */

    case 4:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9702; /* *cmphivnx4hi_cc */

    case 5:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9722; /* *cmphivnx4si_cc */

    case 6:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9682; /* *cmphivnx2qi_cc */

    case 7:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9712; /* *cmphivnx2hi_cc */

    case 8:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9732; /* *cmphivnx2si_cc */

    case 9:
      if (!
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9742; /* *cmphivnx2di_cc */

    case 10:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9752; /* *cmphivnx16qi_ptest */

    case 11:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9762; /* *cmphivnx8qi_ptest */

    case 12:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9792; /* *cmphivnx8hi_ptest */

    case 13:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9772; /* *cmphivnx4qi_ptest */

    case 14:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9802; /* *cmphivnx4hi_ptest */

    case 15:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9822; /* *cmphivnx4si_ptest */

    case 16:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9782; /* *cmphivnx2qi_ptest */

    case 17:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9812; /* *cmphivnx2hi_ptest */

    case 18:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9832; /* *cmphivnx2si_ptest */

    case 19:
      if (!
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
        return -1;
      return 9842; /* *cmphivnx2di_ptest */

    default:
      return -1;
    }
}

 int
recog_609 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (pattern1270 (x6, 
E_SImode) != 0
          || !
#line 3715 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == -UINTVAL (operands[3])))
        return -1;
      return 323; /* subsi3_compare1_imm */

    case E_DImode:
      if (pattern1270 (x6, 
E_DImode) != 0
          || !
#line 3715 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == -UINTVAL (operands[3])))
        return -1;
      return 324; /* subdi3_compare1_imm */

    default:
      return -1;
    }
}

 int
recog_611 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_TImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LTU
          || GET_MODE (x6) != E_TImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 66
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_TImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != SIGN_EXTEND
          || GET_MODE (x10) != E_TImode)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != NEG
          || GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != LTU
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 66
          || GET_MODE (x14) != E_CCmode)
        return -1;
      x15 = XEXP (x13, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != NEG
          || GET_MODE (x17) != E_DImode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != E_DImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != LTU
          || GET_MODE (x19) != E_DImode)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 66
          || GET_MODE (x20) != E_CCmode)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x2, 0);
      if (GET_MODE (x22) != E_CC_Vmode
          || GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x4) != E_TImode)
        return -1;
      x23 = XEXP (x9, 0);
      operands[1] = x23;
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x24 = XEXP (x12, 1);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x25 = XEXP (x18, 1);
      if (!rtx_equal_p (x25, operands[1]))
        return -1;
      return 319; /* negvdi_carryinV */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x10 = XEXP (x3, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x2, 0);
      if (GET_MODE (x22) != E_CC_NZmode
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      x17 = XEXP (x16, 1);
      switch (GET_CODE (x17))
        {
        case NEG:
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode)
                return -1;
              return 398; /* negsi2_compare0 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode)
                return -1;
              return 399; /* negdi2_compare0 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern1191 (x1, 
NEG) != 0
              || !register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          return 400; /* *negsi2_compare0_uxtw */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern922 (x1, 
ASHIFT))
        {
        case 0:
          return 401; /* *neg_lslsi3_compare0 */

        case 1:
          return 404; /* *neg_lsldi3_compare0 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern922 (x1, 
ASHIFTRT))
        {
        case 0:
          return 402; /* *neg_asrsi3_compare0 */

        case 1:
          return 405; /* *neg_asrdi3_compare0 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern922 (x1, 
LSHIFTRT))
        {
        case 0:
          return 403; /* *neg_lsrsi3_compare0 */

        case 1:
          return 406; /* *neg_lsrdi3_compare0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_613 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  switch (REGNO (x3))
    {
    case 85:
      if (GET_MODE (x3) != E_VNx16BImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern786 (x4, 
E_VNx16BImode, 
161, 
1, 
UNSPEC) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 86
          || GET_MODE (x5) != E_VNx16BImode
          || !aarch64_simd_reg_or_minus_one (operands[0], E_VNx16BImode))
        return -1;
      x6 = XEXP (x4, 1);
      x7 = XVECEXP (x6, 0, 0);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 1129 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5781; /* aarch64_wrffr */

    case 94:
      if (GET_MODE (x3) != E_V8DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern454 (x4, 
89, 
E_DImode, 
USE) != 0
          || !aarch64_sync_memory_operand (operands[0], E_V8DImode)
          || !
#line 549 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME2))
        return -1;
      return 13185; /* aarch64_sme_ldr_zt0 */

    default:
      return -1;
    }
}

 int
recog_614 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case PLUS:
      return recog_610 (x1, insn, pnum_clobbers);

    case MINUS:
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_NZmode
              || GET_MODE (x6) != E_CC_NZmode)
            return -1;
          x10 = XEXP (x7, 1);
          switch (GET_CODE (x10))
            {
            case ASHIFT:
              x11 = XEXP (x4, 1);
              if (GET_CODE (x11) != MINUS)
                return -1;
              x12 = XEXP (x11, 1);
              if (GET_CODE (x12) != ASHIFT)
                return -1;
              x13 = XEXP (x10, 1);
              operands[3] = x13;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x12, 1);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              x16 = XEXP (x10, 0);
              switch (GET_CODE (x16))
                {
                case REG:
                case SUBREG:
                  operands[2] = x16;
                  x17 = XEXP (x12, 0);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  switch (pattern1187 (x1))
                    {
                    case 0:
                      return 186; /* *subs_shift_imm_si */

                    case 1:
                      return 189; /* *subs_shift_imm_di */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  switch (pattern1315 (x1, 
SIGN_EXTEND))
                    {
                    case 0:
                      return 228; /* *subs_extendqi_shift_si */

                    case 1:
                      return 232; /* *subs_extendhi_shift_si */

                    case 2:
                      return 236; /* *subs_extendsi_shift_si */

                    case 3:
                      return 230; /* *subs_extendqi_shift_di */

                    case 4:
                      return 234; /* *subs_extendhi_shift_di */

                    case 5:
                      return 238; /* *subs_extendsi_shift_di */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern1315 (x1, 
ZERO_EXTEND))
                    {
                    case 0:
                      return 229; /* *subs_zero_extendqi_shift_si */

                    case 1:
                      return 233; /* *subs_zero_extendhi_shift_si */

                    case 2:
                      return 237; /* *subs_zero_extendsi_shift_si */

                    case 3:
                      return 231; /* *subs_zero_extendqi_shift_di */

                    case 4:
                      return 235; /* *subs_zero_extendhi_shift_di */

                    case 5:
                      return 239; /* *subs_zero_extendsi_shift_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1188 (x1, 
ASHIFTRT))
                {
                case 0:
                  return 187; /* *subs_shift_imm_si */

                case 1:
                  return 190; /* *subs_shift_imm_di */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1188 (x1, 
LSHIFTRT))
                {
                case 0:
                  return 188; /* *subs_shift_imm_si */

                case 1:
                  return 191; /* *subs_shift_imm_di */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern1190 (x1, 
SIGN_EXTEND))
                {
                case 0:
                  return 204; /* *subs_extendqi_si */

                case 1:
                  return 208; /* *subs_extendhi_si */

                case 2:
                  return 212; /* *subs_extendsi_si */

                case 3:
                  return 206; /* *subs_extendqi_di */

                case 4:
                  return 210; /* *subs_extendhi_di */

                case 5:
                  return 214; /* *subs_extendsi_di */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern1190 (x1, 
ZERO_EXTEND))
                {
                case 0:
                  return 205; /* *subs_zero_extendqi_si */

                case 1:
                  return 209; /* *subs_zero_extendhi_si */

                case 2:
                  return 213; /* *subs_zero_extendsi_si */

                case 3:
                  return 207; /* *subs_zero_extendqi_di */

                case 4:
                  return 211; /* *subs_zero_extendhi_di */

                case 5:
                  return 215; /* *subs_zero_extendsi_di */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[2] = x10;
              x11 = XEXP (x4, 1);
              switch (GET_CODE (x11))
                {
                case MINUS:
                  x14 = XEXP (x11, 0);
                  if (!rtx_equal_p (x14, operands[1]))
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (!rtx_equal_p (x12, operands[2]))
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_SImode:
                      if (pattern1302 (x11, 
E_SImode) != 0)
                        return -1;
                      return 320; /* *subsi3_compare0 */

                    case E_DImode:
                      if (pattern1302 (x11, 
E_DImode) != 0)
                        return -1;
                      return 321; /* *subdi3_compare0 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (pattern1224 (x1, 
MINUS) != 0
                      || !register_operand (operands[1], E_SImode)
                      || !register_operand (operands[2], E_SImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x14 = XEXP (x11, 0);
                  x18 = XEXP (x14, 0);
                  if (!rtx_equal_p (x18, operands[1]))
                    return -1;
                  x19 = XEXP (x14, 1);
                  if (!rtx_equal_p (x19, operands[2]))
                    return -1;
                  return 322; /* *subsi3_compare0_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != MINUS)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x3) != E_CC_Vmode
              || GET_MODE (x6) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x10 = XEXP (x7, 1);
          switch (GET_CODE (x10))
            {
            case GEU:
            case LTU:
              operands[2] = x10;
              x23 = XEXP (x20, 1);
              operands[3] = x23;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1342 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 383; /* *subsi3_carryinV_z2 */

                case E_TImode:
                  if (pattern1342 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 384; /* *subdi3_carryinV_z2 */

                default:
                  return -1;
                }

            case PLUS:
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x23 = XEXP (x20, 1);
              if (GET_CODE (x23) != PLUS)
                return -1;
              x14 = XEXP (x11, 0);
              if (GET_CODE (x14) != MINUS)
                return -1;
              x24 = XEXP (x16, 0);
              operands[2] = x24;
              x13 = XEXP (x10, 1);
              operands[3] = x13;
              x25 = XEXP (x23, 0);
              operands[4] = x25;
              x26 = XEXP (x23, 1);
              if (!rtx_equal_p (x26, operands[2]))
                return -1;
              x18 = XEXP (x14, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[2]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[4]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1371 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 385; /* *subsi3_carryinV */

                case E_TImode:
                  if (pattern1371 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 386; /* *subdi3_carryinV */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x6) != E_CC_Vmode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case MINUS:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != MINUS)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x27 = XEXP (x8, 1);
          operands[2] = x27;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x12 = XEXP (x11, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              x28 = XEXP (x9, 1);
              if (GET_CODE (x28) != SIGN_EXTEND)
                return -1;
              x29 = XEXP (x28, 0);
              if (!rtx_equal_p (x29, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1346 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 308; /* subvsi_insn */

                case E_TImode:
                  if (pattern1346 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 309; /* subvdi_insn */

                default:
                  return -1;
                }

            case CONST_INT:
              x28 = XEXP (x9, 1);
              if (!rtx_equal_p (x28, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1343 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 310; /* subvsi_imm */

                case E_TImode:
                  if (pattern1343 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 311; /* subvdi_imm */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != NEG)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != NEG)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1293 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 312; /* negvsi_insn */

            case E_TImode:
              if (pattern1293 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 313; /* negvdi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_611 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (GET_MODE (x3) != E_CCmode
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          res = recog_608 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_609 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != MINUS)
        return -1;
      operands[1] = x7;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (aarch64_reg_or_zero (operands[2], E_SImode)
          && pattern1192 (x11, 
E_SImode) == 0)
        return 325; /* subsi3_compare1 */
      if (!aarch64_reg_or_zero (operands[2], E_DImode)
          || pattern1192 (x11, 
E_DImode) != 0)
        return -1;
      return 326; /* subdi3_compare1 */

    case ZERO_EXTEND:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      switch (GET_CODE (x9))
        {
        case GEU:
        case LTU:
          operands[2] = x9;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x12 = XEXP (x11, 1);
          operands[3] = x12;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1271 (x11, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 379; /* *usubsi3_carryinC_z2 */

            case E_TImode:
              if (pattern1271 (x11, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 380; /* *usubdi3_carryinC_z2 */

            default:
              return -1;
            }

        case PLUS:
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != ZERO_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS)
            return -1;
          x14 = XEXP (x11, 0);
          if (GET_CODE (x14) != MINUS
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x22 = XEXP (x20, 0);
          operands[2] = x22;
          x28 = XEXP (x9, 1);
          operands[3] = x28;
          x12 = XEXP (x11, 1);
          operands[4] = x12;
          x18 = XEXP (x14, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          x19 = XEXP (x14, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1324 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 381; /* *usubsi3_carryinC */

            case E_TImode:
              if (pattern1324 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 382; /* *usubdi3_carryinC */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x9, 0) != 0L)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != ZERO_EXTEND
              || GET_MODE (x3) != E_CC_Zmode
              || GET_MODE (x6) != E_CC_Zmode)
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_SImode:
              switch (pattern1254 (x11, 
E_SImode))
                {
                case 0:
                  return 742; /* *andssi_compare0 */

                case 1:
                  return 744; /* *andssi_compare0 */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1254 (x11, 
E_DImode))
                {
                case 0:
                  return 743; /* *andsdi_compare0 */

                case 1:
                  return 745; /* *andsdi_compare0 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_CC_NZVmode
          || GET_MODE (x6) != E_CC_NZVmode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          switch (GET_CODE (x11))
            {
            case AND:
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_SImode:
                  if (pattern1294 (x11, 
E_SImode) != 0)
                    return -1;
                  return 555; /* *andsi3_compare0 */

                case E_DImode:
                  if (pattern1294 (x11, 
E_DImode) != 0)
                    return -1;
                  return 556; /* *anddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1224 (x1, 
AND) != 0
                  || !register_operand (operands[1], E_SImode)
                  || !aarch64_logical_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x14 = XEXP (x11, 0);
              x18 = XEXP (x14, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[2]))
                return -1;
              return 557; /* *andsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern1102 (x1, 
ASHIFT))
            {
            case 0:
              return 558; /* *and_ashlsi3_compare0 */

            case 1:
              return 563; /* *and_ashldi3_compare0 */

            case 2:
              return 568; /* *and_ashlsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern1102 (x1, 
ASHIFTRT))
            {
            case 0:
              return 559; /* *and_ashrsi3_compare0 */

            case 1:
              return 564; /* *and_ashrdi3_compare0 */

            case 2:
              return 569; /* *and_ashrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern1102 (x1, 
LSHIFTRT))
            {
            case 0:
              return 560; /* *and_lshrsi3_compare0 */

            case 1:
              return 565; /* *and_lshrdi3_compare0 */

            case 2:
              return 570; /* *and_lshrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern1102 (x1, 
ROTATERT))
            {
            case 0:
              return 561; /* *and_rotrsi3_compare0 */

            case 1:
              return 566; /* *and_rotrdi3_compare0 */

            case 2:
              return 571; /* *and_rotrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern1102 (x1, 
ROTATE))
            {
            case 0:
              return 562; /* *and_rotlsi3_compare0 */

            case 1:
              return 567; /* *and_rotldi3_compare0 */

            case 2:
              return 572; /* *and_rotlsi3_compare0_uxtw */

            default:
              return -1;
            }

        case NOT:
          x21 = XEXP (x8, 0);
          switch (GET_CODE (x21))
            {
            case REG:
            case SUBREG:
              operands[1] = x21;
              x10 = XEXP (x7, 1);
              operands[2] = x10;
              x11 = XEXP (x4, 1);
              switch (GET_CODE (x11))
                {
                case AND:
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != NOT)
                    return -1;
                  x18 = XEXP (x14, 0);
                  if (!rtx_equal_p (x18, operands[1]))
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (!rtx_equal_p (x12, operands[2]))
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_SImode:
                      if (pattern1316 (x1, 
E_SImode) != 0)
                        return -1;
                      return 640; /* *and_one_cmplsi3_compare0 */

                    case E_DImode:
                      if (pattern1316 (x1, 
E_DImode) != 0)
                        return -1;
                      return 641; /* *and_one_cmpldi3_compare0 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != AND
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x18 = XEXP (x14, 0);
                  if (GET_CODE (x18) != NOT
                      || GET_MODE (x18) != E_SImode
                      || GET_MODE (x7) != E_SImode
                      || GET_MODE (x8) != E_SImode
                      || !register_operand (operands[1], E_SImode)
                      || !register_operand (operands[2], E_SImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x30 = XEXP (x18, 0);
                  if (!rtx_equal_p (x30, operands[1]))
                    return -1;
                  x19 = XEXP (x14, 1);
                  if (!rtx_equal_p (x19, operands[2]))
                    return -1;
                  return 642; /* *and_one_cmplsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern1156 (x1, 
ASHIFT))
                {
                case 0:
                  return 705; /* *and_one_cmpl_ashlsi3_compare0 */

                case 1:
                  return 710; /* *and_one_cmpl_ashldi3_compare0 */

                case 2:
                  return 715; /* *and_one_cmpl_ashlsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1156 (x1, 
ASHIFTRT))
                {
                case 0:
                  return 706; /* *and_one_cmpl_ashrsi3_compare0 */

                case 1:
                  return 711; /* *and_one_cmpl_ashrdi3_compare0 */

                case 2:
                  return 716; /* *and_one_cmpl_ashrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1156 (x1, 
LSHIFTRT))
                {
                case 0:
                  return 707; /* *and_one_cmpl_lshrsi3_compare0 */

                case 1:
                  return 712; /* *and_one_cmpl_lshrdi3_compare0 */

                case 2:
                  return 717; /* *and_one_cmpl_lshrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ROTATERT:
              switch (pattern1156 (x1, 
ROTATERT))
                {
                case 0:
                  return 708; /* *and_one_cmpl_rotrsi3_compare0 */

                case 1:
                  return 713; /* *and_one_cmpl_rotrdi3_compare0 */

                case 2:
                  return 718; /* *and_one_cmpl_rotrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ROTATE:
              switch (pattern1156 (x1, 
ROTATE))
                {
                case 0:
                  return 709; /* *and_one_cmpl_rotlsi3_compare0 */

                case 1:
                  return 714; /* *and_one_cmpl_rotldi3_compare0 */

                case 2:
                  return 719; /* *and_one_cmpl_rotlsi3_compare0_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_580 (insn, operands);

    case 1:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_582 (insn, operands);

    case 2:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_584 (insn, operands);

    case 3:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_586 (insn, operands);

    case 4:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_588 (insn, operands);

    case 5:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_590 (insn, operands);

    case 6:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_592 (insn, operands);

    case 7:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_594 (insn, operands);

    case 8:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_596 (insn, operands);

    case 9:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_598 (insn, operands);

    case 10:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_600 (insn, operands);

    case 11:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_602 (insn, operands);

    case 12:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_604 (insn, operands);

    case 13:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_606 (insn, operands);

    case 14:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_608 (insn, operands);

    case 15:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_610 (insn, operands);

    case 16:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_612 (insn, operands);

    case 17:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_614 (insn, operands);

    case 18:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_616 (insn, operands);

    case 19:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_618 (insn, operands);

    case 20:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_620 (insn, operands);

    case 21:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_622 (insn, operands);

    case 22:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_624 (insn, operands);

    case 23:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_626 (insn, operands);

    case 24:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_628 (insn, operands);

    case 25:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_630 (insn, operands);

    case 26:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_632 (insn, operands);

    case 27:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_634 (insn, operands);

    case 28:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_636 (insn, operands);

    case 29:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_638 (insn, operands);

    case 30:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_640 (insn, operands);

    case 31:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_642 (insn, operands);

    case 32:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_644 (insn, operands);

    case 33:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_646 (insn, operands);

    case 34:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_648 (insn, operands);

    case 35:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0) && 
#line 1389 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_650 (insn, operands);

    case 36:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_725 (insn, operands);

    case 37:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_729 (insn, operands);

    case 38:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_733 (insn, operands);

    case 39:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_737 (insn, operands);

    case 40:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_741 (insn, operands);

    case 41:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_745 (insn, operands);

    case 42:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_749 (insn, operands);

    case 43:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_753 (insn, operands);

    case 44:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_757 (insn, operands);

    case 45:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_761 (insn, operands);

    case 46:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_765 (insn, operands);

    case 47:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_769 (insn, operands);

    case 48:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_773 (insn, operands);

    case 49:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_777 (insn, operands);

    case 50:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_781 (insn, operands);

    case 51:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_785 (insn, operands);

    case 52:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_789 (insn, operands);

    case 53:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_793 (insn, operands);

    case 54:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_797 (insn, operands);

    case 55:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_801 (insn, operands);

    case 56:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_805 (insn, operands);

    case 57:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_809 (insn, operands);

    case 58:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_813 (insn, operands);

    case 59:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_817 (insn, operands);

    case 60:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_821 (insn, operands);

    case 61:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_825 (insn, operands);

    case 62:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_829 (insn, operands);

    case 63:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_833 (insn, operands);

    case 64:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_837 (insn, operands);

    case 65:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_841 (insn, operands);

    case 66:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_845 (insn, operands);

    case 67:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_849 (insn, operands);

    case 68:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_853 (insn, operands);

    case 69:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_857 (insn, operands);

    case 70:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_861 (insn, operands);

    case 71:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_865 (insn, operands);

    case 72:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_726 (insn, operands);

    case 73:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_730 (insn, operands);

    case 74:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_734 (insn, operands);

    case 75:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_738 (insn, operands);

    case 76:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_742 (insn, operands);

    case 77:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_746 (insn, operands);

    case 78:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_750 (insn, operands);

    case 79:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_754 (insn, operands);

    case 80:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_758 (insn, operands);

    case 81:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_762 (insn, operands);

    case 82:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_766 (insn, operands);

    case 83:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_770 (insn, operands);

    case 84:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_774 (insn, operands);

    case 85:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_778 (insn, operands);

    case 86:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_782 (insn, operands);

    case 87:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_786 (insn, operands);

    case 88:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_790 (insn, operands);

    case 89:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_794 (insn, operands);

    case 90:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_798 (insn, operands);

    case 91:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_802 (insn, operands);

    case 92:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_806 (insn, operands);

    case 93:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_810 (insn, operands);

    case 94:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_814 (insn, operands);

    case 95:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_818 (insn, operands);

    case 96:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_822 (insn, operands);

    case 97:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_826 (insn, operands);

    case 98:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_830 (insn, operands);

    case 99:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_834 (insn, operands);

    case 100:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_838 (insn, operands);

    case 101:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_842 (insn, operands);

    case 102:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_846 (insn, operands);

    case 103:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_850 (insn, operands);

    case 104:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_854 (insn, operands);

    case 105:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_858 (insn, operands);

    case 106:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_862 (insn, operands);

    case 107:
      if (!(
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1475 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_866 (insn, operands);

    case 108:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_652 (insn, operands);

    case 109:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_654 (insn, operands);

    case 110:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_656 (insn, operands);

    case 111:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_658 (insn, operands);

    case 112:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_660 (insn, operands);

    case 113:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_662 (insn, operands);

    case 114:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_664 (insn, operands);

    case 115:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_666 (insn, operands);

    case 116:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_668 (insn, operands);

    case 117:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_670 (insn, operands);

    case 118:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_672 (insn, operands);

    case 119:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_674 (insn, operands);

    case 120:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_676 (insn, operands);

    case 121:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_678 (insn, operands);

    case 122:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_680 (insn, operands);

    case 123:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_682 (insn, operands);

    case 124:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_684 (insn, operands);

    case 125:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_686 (insn, operands);

    case 126:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_688 (insn, operands);

    case 127:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_690 (insn, operands);

    case 128:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_692 (insn, operands);

    case 129:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_694 (insn, operands);

    case 130:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_696 (insn, operands);

    case 131:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_698 (insn, operands);

    case 132:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_700 (insn, operands);

    case 133:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_702 (insn, operands);

    case 134:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_704 (insn, operands);

    case 135:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_706 (insn, operands);

    case 136:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_708 (insn, operands);

    case 137:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_710 (insn, operands);

    case 138:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_712 (insn, operands);

    case 139:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_714 (insn, operands);

    case 140:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_716 (insn, operands);

    case 141:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_718 (insn, operands);

    case 142:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_720 (insn, operands);

    case 143:
      if (!(
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0) && 
#line 1409 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_722 (insn, operands);

    case 144:
      if (!(
#line 1699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_892 (insn, operands);

    case 145:
      if (!(
#line 1699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_896 (insn, operands);

    case 146:
      if (!(
#line 1699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_894 (insn, operands);

    case 147:
      if (!(
#line 1699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_898 (insn, operands);

    case 148:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_900 (insn, operands);

    case 149:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_906 (insn, operands);

    case 150:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_912 (insn, operands);

    case 151:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_902 (insn, operands);

    case 152:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_908 (insn, operands);

    case 153:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_914 (insn, operands);

    case 154:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_904 (insn, operands);

    case 155:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_910 (insn, operands);

    case 156:
      if (!(
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1752 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_916 (insn, operands);

    case 157:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_918 (insn, operands);

    case 158:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_930 (insn, operands);

    case 159:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_942 (insn, operands);

    case 160:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_922 (insn, operands);

    case 161:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_934 (insn, operands);

    case 162:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_946 (insn, operands);

    case 163:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_926 (insn, operands);

    case 164:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_938 (insn, operands);

    case 165:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_950 (insn, operands);

    case 166:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_954 (insn, operands);

    case 167:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_960 (insn, operands);

    case 168:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_966 (insn, operands);

    case 169:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_956 (insn, operands);

    case 170:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_962 (insn, operands);

    case 171:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_968 (insn, operands);

    case 172:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_958 (insn, operands);

    case 173:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_964 (insn, operands);

    case 174:
      if (!(
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1825 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_970 (insn, operands);

    case 175:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_920 (insn, operands);

    case 176:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_932 (insn, operands);

    case 177:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_944 (insn, operands);

    case 178:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_924 (insn, operands);

    case 179:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_936 (insn, operands);

    case 180:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_948 (insn, operands);

    case 181:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_928 (insn, operands);

    case 182:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_940 (insn, operands);

    case 183:
      if (!(
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_952 (insn, operands);

    case 184:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_972 (insn, operands);

    case 185:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_978 (insn, operands);

    case 186:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_984 (insn, operands);

    case 187:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_974 (insn, operands);

    case 188:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_980 (insn, operands);

    case 189:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_986 (insn, operands);

    case 190:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_976 (insn, operands);

    case 191:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_982 (insn, operands);

    case 192:
      if (!(
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1860 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_988 (insn, operands);

    case 193:
      if (!(
#line 2088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2095 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_1002 (insn, operands);

    case 194:
      if (!(
#line 2088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2095 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_1004 (insn, operands);

    case 195:
      if (!(
#line 2088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2095 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_1006 (insn, operands);

    case 196:
      if (!(
#line 2120 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2127 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_1008 (insn, operands);

    case 197:
      if (!(
#line 2120 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2127 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_1010 (insn, operands);

    case 198:
      if (!(
#line 2120 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2127 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_1012 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_74 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 299:
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          return split_69 (x1, insn);

        case PLUS:
          return split_73 (x1, insn);

        case MINUS:
          return split_70 (x1, insn);

        case MULT:
          switch (pattern702 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1262 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1279 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1296 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1313 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1330 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1347 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1364 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1381 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1398 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1415 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          switch (pattern702 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1263 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1280 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1297 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1314 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1331 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1348 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1365 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1382 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1399 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1416 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern702 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1264 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1281 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1298 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1315 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1332 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1349 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1366 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1383 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1400 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1417 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern702 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1265 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1282 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1299 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1316 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1333 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1350 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1367 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1384 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1401 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1418 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern702 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1266 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1283 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1300 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1317 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1334 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1351 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1368 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1385 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1402 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1419 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          return split_72 (x1, insn);

        case ASHIFTRT:
          switch (pattern704 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1268 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1285 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1302 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1319 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1336 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1353 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1370 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1387 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1404 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1421 (insn, operands);

            case 10:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1547 (insn, operands);

            case 11:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1550 (insn, operands);

            case 12:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1553 (insn, operands);

            case 13:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1556 (insn, operands);

            case 14:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1559 (insn, operands);

            case 15:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1562 (insn, operands);

            case 16:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1565 (insn, operands);

            case 17:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1568 (insn, operands);

            case 18:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1571 (insn, operands);

            case 19:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1574 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern704 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1269 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1286 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1303 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1320 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1337 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1354 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1371 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1388 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1405 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1422 (insn, operands);

            case 10:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1548 (insn, operands);

            case 11:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1551 (insn, operands);

            case 12:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1554 (insn, operands);

            case 13:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1557 (insn, operands);

            case 14:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1560 (insn, operands);

            case 15:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1563 (insn, operands);

            case 16:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1566 (insn, operands);

            case 17:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1569 (insn, operands);

            case 18:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1572 (insn, operands);

            case 19:
              if (!(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1575 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          return split_71 (x1, insn);

        case IOR:
          switch (pattern702 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1271 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1288 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1305 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1322 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1339 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1356 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1373 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1390 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1407 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1424 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern702 (x3))
            {
            case 0:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1272 (insn, operands);

            case 1:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1289 (insn, operands);

            case 2:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1306 (insn, operands);

            case 3:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1323 (insn, operands);

            case 4:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1340 (insn, operands);

            case 5:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1357 (insn, operands);

            case 6:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1374 (insn, operands);

            case 7:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1391 (insn, operands);

            case 8:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1408 (insn, operands);

            case 9:
              if (!(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1425 (insn, operands);

            default:
              return NULL;
            }

        case SS_PLUS:
          switch (pattern702 (x3))
            {
            case 0:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1273 (insn, operands);

            case 1:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1290 (insn, operands);

            case 2:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1307 (insn, operands);

            case 3:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1324 (insn, operands);

            case 4:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1341 (insn, operands);

            case 5:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1358 (insn, operands);

            case 6:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1375 (insn, operands);

            case 7:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1392 (insn, operands);

            case 8:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1409 (insn, operands);

            case 9:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2851 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1426 (insn, operands);

            default:
              return NULL;
            }

        case US_PLUS:
          switch (pattern702 (x3))
            {
            case 0:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1274 (insn, operands);

            case 1:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1291 (insn, operands);

            case 2:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1308 (insn, operands);

            case 3:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1325 (insn, operands);

            case 4:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1342 (insn, operands);

            case 5:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1359 (insn, operands);

            case 6:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1376 (insn, operands);

            case 7:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1393 (insn, operands);

            case 8:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1410 (insn, operands);

            case 9:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2852 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1427 (insn, operands);

            default:
              return NULL;
            }

        case SS_MINUS:
          switch (pattern702 (x3))
            {
            case 0:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1275 (insn, operands);

            case 1:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1292 (insn, operands);

            case 2:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1309 (insn, operands);

            case 3:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1326 (insn, operands);

            case 4:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1343 (insn, operands);

            case 5:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1360 (insn, operands);

            case 6:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1377 (insn, operands);

            case 7:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1394 (insn, operands);

            case 8:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1411 (insn, operands);

            case 9:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2853 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1428 (insn, operands);

            default:
              return NULL;
            }

        case US_MINUS:
          switch (pattern702 (x3))
            {
            case 0:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1276 (insn, operands);

            case 1:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1293 (insn, operands);

            case 2:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1310 (insn, operands);

            case 3:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1327 (insn, operands);

            case 4:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1344 (insn, operands);

            case 5:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1361 (insn, operands);

            case 6:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1378 (insn, operands);

            case 7:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1395 (insn, operands);

            case 8:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1412 (insn, operands);

            case 9:
              if (!((
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2854 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1429 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          switch (pattern705 (x3))
            {
            case 0:
              if (!(
#line 4802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4812 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1492 (insn, operands);

            case 1:
              if (!(
#line 4802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4812 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1494 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          switch (pattern705 (x3))
            {
            case 0:
              if (!(
#line 4802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4812 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1493 (insn, operands);

            case 1:
              if (!(
#line 4802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4812 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1495 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 351:
      x6 = XVECEXP (x3, 0, 2);
      if (pattern488 (x6, 
393) != 0)
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[2] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1227 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !(
#line 6377 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6382 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1984 (insn, operands);

        case E_VNx4SFmode:
          if (pattern1227 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !(
#line 6377 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6382 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1985 (insn, operands);

        case E_VNx2DFmode:
          if (pattern1227 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !(
#line 6377 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6382 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1986 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
